import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.serial.*; 
import processing.video.*; 
import javax.swing.ImageIcon; 
import java.awt.Dimension; 
import java.io.BufferedWriter; 
import java.io.FileWriter; 
import processing.net.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class NLEDAurora extends PApplet {

/*
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES 
PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
NECESSARY SERVICING, REPAIR OR CORRECTION.

 Original Author: Jeffrey Nygaard
 Company: Northern Lights Electronic Design, LLC
 Date: October 3, 2017
 Contact: JNygaard@NLEDshop.com
 Written in Processing v3.3.6
 NLED Aurora Control Software Version: 2d
 Copyright© 2017 by Northern Lights Electronic Design, LLC. All Rights Reserved


This is proprietary software and the source code is not available. If you have any questions on customization or bug fixes
please contact above author.

Code is mostly obfuscated so don't even try to reverse engineer it! Why are you even reading this?
*/




java.awt.Insets insets;




BufferedWriter bw = null;

 


/*

Specs:  =========================================================================================
	Max Frames: 65,535(not quite)
	Max Channels: 768
	Max USB Live Control Through GUI: 233 channels
	Max Index Sequences: 256
	Max Sequences In Software: 256

	
Hotkeys: =========================================================================================
	s - autosaves
	m - empty command request, test if alive
	left and right arrows - adjust previously slected slider	
	Escape - Closes Color Picker & Overlay Menus
	Enter/Return: 
		- If textfield is selected it commits the change
		- If color picker is open it applies the color selection
		- While Resizing Graphic Layout Image - Press Enter/Return to apply
		- Closes Technical mode radial menu

Sub Menus: =========================================================================================

	Stand alone control, USB live control sliders, live control rects, sequence select, gamma correction, tech radials
	
Version 2 Misc: =========================================================================================

	- New ReDraw method, any draws(rect/fill/line/etc) to the main buffer can cause a non-recoverable GUI graphical glitch
		- having full GUI freezes, but otherwise seems to keep working just not updating...	
	- Keep looking for redraw glitches, haven't seen any in a long while

	- Left development input keys for v2e
	
	- Remove a handful of printlns like draw()
	



	Tried to duplicate a sequence - gradient 768 channels RGB - did not work - before or after I changed the cmaxchannels to 768?
		- just worked, found no issue in the code either

	After loading a file play file it didn't update the timeline buffer
		- frames label is base 0, add 1
	

	- Can't get back on TCP connection if lost or whatever... doesn't even list IP and try it seems	


	- PlaceTile() - whats the issue?


	- Is gradient generation ingoring grouping?

	
	- Sent a HWPV to electron DMX thing and it froze, still responds to commands. No function.
		a power cycle started it again. tried hwpv and indexed
	- Same with Ion DMX one, doesn't start sequences after upload. Either indexed or HWPV.
		- Think it was macrodisablepix, but look into it
		
	
	- At least once the GUI stopped responding, but console printouts seemed correct
		- and again, no correlation

	- Aurora froze trying to send stand-alone command, controller continued


Fix:

	- Can't load sequences file without a device connected first, then it can reload
		during testing it has teh out of data firmware 0 vs 0, any issue with that?
		always errored on the 13th sequence, they all even have that many?
		

	- placing pixel icons places the icon but doesn't display it until +1


	file play should display the icon as the color, since there is no start
	

SendLiveControlData
updateTechnical or something
	- for obfuscation
	


Add:

	- redraw the color picker so it can't pick the indicator boxes - USE NEW COLOR PICKER

	- make linked icon for seqicons

	- Add confirm when standalone command is executed

 	- Add software baud rate selection - not device- sidebar under Serial ports

	- DMXAutoRelease module - fDMXAutoRelease and idle or previous sequence

	- Thread all serial output so software doesn't stall until missing usb device is unplugged

	- Fix playback preview  mode or expand it whatever

	
Waiting:

	- Add mTechnical
		- Change mTechnical to something, wanted timeline but that is redundant


	
	- RGBW reverse gradients not even attempted to implement

	
Upgrade/Update: =========================================================================================


	- mouse button hold code works but could be better
		
	- Pressed Yes on ID#: 16
		Are you sure you want to reset the Start Values?
		ResetStartValuesCommon()
		java.lang.ArrayIndexOutOfBoundsException: 2
			at NLEDAurora.ResetStartValuesCommon(NLEDAurora.java:5397)
			at NLEDAurora.pressHandlerConfirmBox(NLEDAurora.java:16580)	
				- added try, whatever
	
	- Should be able to fit a patch coord file in a grid with large icons, as in a matrix
		- works but could be better
	
	- Add play preview
		- works with no speed usage,
		- tested with file play	and instants			

	- fix issue with linux COM port listings
	
	- with packet cloning enabled and lots of pixels the gradient graphic tools don't work at all, have to disable cloning
		" You had packet cloning set to x1, that made the graphic tools not work at all. That is a bug and I noted it for patching. It should have worked or displayed a message indicating why."

Legacy: =========================================================================================


	- Remove Electron rules, for zAck usage in USB mode.... should be gone, legacy is fucked
		- Same rule for new 4 chan but in legacy
		- Also for ion v.1f	
	- At least for basic version if I define versions in the -contr-revs file, it needs to be there otherwise leave as 1 0	
	
	
Move them to TXT: ===============================================================================================


Aurora Software Changes v.2e to v.2f:
	- Fixed Advanced layout mode GUI when loading a sequence file
	- Other misc Advanced layout mode fixes and updates
	
	
Known Issues v.2d:
    - Technical mode still not implemented
    - DMX Sequence control has limited functionality on some devices, no function yet on others
    - RGBW gradient generation does not work in reverse  
	- Software Sequence Previewing doesn't work with Fades, Gradients, and others

	
===============================================================================================
	
	
Optimization:
	- Using a lot of RAM, CPU usage 0 unless drawing
		- Dispose objects not being used to null?
		- use VisualVM to slim down the memory usage
			- can't do much without a JMX connection, can not figure it out
	
===============================================================================================
	

DONE:
	- pixel display issue persists, in RGB will only show 170 pixel icons, but mouseover works on more
		- same in advanced mode, but switch to single and it shows more pixels
		- was a problem with IDoffset
	- white color selector slider 16-bit - fixed
	- Text field and checkbox mouseover 
	- Line shape is reversed, WTF....
	- Can't type 16-bit numbers into the live control value box
	- Make sure checkboxes or text filds aren't get built infinitly for new mouseover usage
	- Double check all sequence add/duplicate/delete/etc functions - update done, but not optimized
		- Finish Revamp datastorage, type casting and array definitions	
		- Optimizations seem to be finished, but want to double check everything			
	- Close COM port if enter bootloader	
	- Instant 16-bit start value LED icon not showing correctly
		- cause there is none for instants I would think..... handle that
			- soon as I adjust start indicator it will fill, or if I reset start values
		- also does not update graphic layout when moving start values, does when resetting. 
	- File play will change channel amount for the sequence even if it should be locked
		- made a fix to set it to maximum channels
	- add pitch between pixels options would work for all shapes, rather than using the predetermined size
	- Option to display a matrix of squares with no pitch
	- File play on timeline scroll bar doesn't work, it should
	- Add more info to file play, at least frame number
	- Added method to update start values for instants when it draws the pixel icon, not great but whatever
	- had Paint Tool selected and clicked timeline cell, it wouldn't apply color since it was thinking it should fill paint tool - fixed
	- pixel icon color value should always show unless turned off - done
	- Generate gradient with 1 step should just do a Reset start values - test
	- icon spacing for circle between Large and mediun is no change, plenty of room before small
	- Issue display live control overlay menu
		clicked the 16-bit checkbox	
		using: 1.0 with 30 sliders
		Sliders Built, Total: 30
		overlaymenu.pde:409:0:409:0: NullPointerException	- OUT OF DATE
		&
		Changed Menu Tabs, SelectedMenuTab =2
		REFRESHED =========== 2
		OpenLiveControlMenu()
		EnableTransmissionTimeOut()
		using: 0.5 with 510 sliders
		Sliders Built, Total: 510
		overlaymenu.pde:409:0:409:0: NullPointerException	
		- not sure must be LiveConTotalColChan issue or something, just added a try to the display() loop	
	- updated LoadDeviceFile() to properly load device files for older firmware

	
Test More:
	- Fix file separator for linux/Mac
		- Windows, 	MacOS
	- have GUI elemnts Selected in over()
		- should be done but found few problems right away, look for more
		- GraphicImageResize usage - might cause graphic glitch
			- couldn't get it to glitch
		
	Gradient Generation Issue: - Based on sample red sequnce, 24 chans, 12 frames
		- lots of blackspace frames is a bit unpredictable
			- fucked with it a lot, couldn't make it better, then it started working seemingly normally... so wtf
			- for sure it will save larger than 0xFF numbers, &ing off the LSBs causes it to skip the first step position, its fucked
		- otherwise works fine for other sequences
		- issue lies with gradient steps vs color channels
			- if frames and steps are the same it works with a smaller than color channel amount of steps	
		- if the steps  are so low doesn't make a full sequence is when it errors	
			- rather if the steps is lower than the frame amount
		- can not intercept StartValue error, disabled all true statements and it still turns purple, disabled withinstartlimtis, nothing disables or errors
			- it is not out of range say it is 255,255,255, frame7, which would be accepted in that case
	
	
Errors:		
	
		
		

Far Off Upgrades:	

	- if start values are bad, do a reset on a per channel basis - later
	
	- if group is not populated skip it when cycling through viewing groups
	
	- When manually placing icons it should display under the cursor
		- Same they should be able to dragged around rather than deleted and re-placed
		
	- Add timer for after an upload that redraws, frequently misses it or something
		- not a big deal, rarely happens, and now with mouse over it would quickly resolve itself
		
	- Need to add EPS or SVG layouts
		- How to select?
		- Change drop down to shape, manual, PixelMap, SVG. With second drop down for shape options?
		- or have PixelMap/SVG and auto-detect file extension? gotta save data in file though

	- Group Shift Up/Down, Clear group button
	
	- Add hold shift to snap to angles for gradient tools
	
	- Detect Icons overlaying other icons at same coords

	- Add undo paint/color pick and stuff, with hot keye
		- Save previous color and action and re-run it

	- Import sequence from other file with preview and such	
	
	- Save color palette to save file
		
	- Maybe add a reset sliders button to live control tab, but there is no room
	
	- Add ability to tab between textfields at least on Live Control Window
	
MacOS vs standard:

	- mac os has long serial.list() strings, have to crop them
	- mac also lists 2 ports for every serial decvice, cu and tty, only want to use tty apparently
	- File separators
	- enter/return usage
	- The weblink feature doesn't work for device links, but does for aurora, same fucking string, loaded differently, tried to test it no luck	

	
Graphic Layout Notes:	

	- Default setup, no icons -> user selects a shape, group ID -> user selects pixel amount -> adds to layout, creates icon objects sets xpos, ypos, sets group ID - keeps 
			track of next pixel ID num ->
		User selects another layout and ID -> Adds to layout - starts on last icon and fills out upwards, setting groupIDs ->
		User can then use mouse select to move icons from group to group*
		
	- Basic Mode: User selects shape, thats it, software rebuilds shape and patches as needed, saves to file
		
Bugs And Work Arounds:
	
	- Append logfile calls itself, at least after repleaces printlns!!!!	
	
	- it seems every array within the object needs to be the same size or they overlap, tested and that is how it is
		- redeclaring them / resize made it work fine
			
Style I like is Monoaki, it doesn't save it is very awkard to use notepad++
*/

final int cColorNLEDBlue = color(0x2A,0xAC,0xE3);
final int cColButtonsBG = color(43, 55, 144);
final int cColButtonsHL = color(204,0,0);///color(180, 20, 20);
final int cColButtonsOut = color(255);
//final color cFocusedColor = color(0, 0, 255);
final int cBackgroundColor = color(65);
final int cBorderColor = color(190);
final int cStrokeColor = color(200);
final int cMenuColor = color(120);
//final color cBorderHighlight = color(190, 45, 30);
final int cScrollBoxColor = color(100);
final int cWorkspaceFontColor = color(255);
final int cOverlayFontColor = color(0);
final int cButtonBG2 = color(0, 104, 55);
final int cWorkspaceFont = color(255);
final int cPurpleColor = color(90,0,255);

final String[] cPixelChipsetStrings = {"DEFAULT", "WS2801", "WS2811", "WS2812", "WS2812B", "LPD1886", "LPD6803", "LPD8806", "TM1803", "TM1814", "APA102", "APA104", "SK6812","DMX-512", "APA106"};
final String[] cPixelChipsetColorID = {"varies / unknown", "varies / R>G>B", "varies", "G>R>B", "G>R>B", "TEST", "TEST", "TEST", "varies / G>B>R", "TEST", "B>G>R", "TEST", "G>R>B>W","R>G>B","R>G>B"};
final String cModeString[] = {"Stall", "Fade", "Gradient", "Instant", "Technical", "POV", "File Play", "Linked", "DMX", "Serial", "USB"};
final String cPixelIDStr[] = {"Single", "RGB", "RGBW"};
final String cNoneStr[] = {"None"};
final String cColorSwapStr[] = {"None", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B"};
final String cGlobalColSwapStr[] = {"R>G>B(>W)", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B","G>R>B>W"};
final String cDDBaudstring[] = {"9600", "19200", "38400", "57600", "115200", "230400", "250000", "460800", "500000", "1Mbit"}; //fix these, there is no 250k without custom FTDI driver, but maybe make one for 500k and 1Mb and 250k
final String cDDLEDMstring[] = {"Both", "Stand-Alone", "RX", "Disabled"};
final String cDDPOVModeString[] = {"Normal Mode", "Mode 1mS", "Mode 2mS", "Mode 3mS", "Mode 4mS", "Mode 5mS", "Mode 6mS", "Mode 8mS", "Mode 16mS"};
final int cDDPOVModeValues[] = {0, 1, 2, 3, 4, 5, 6, 8, 16};
final String cRevisionIDstr[] = {"a", "b", "c", "d", "e", "f", "g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"};
final String cDDAutoDetectModesT1[] = {"None/Disabled", "Auto-Detect DMX", "Auto-Detect Serial"};
final String cDDAutoDetectModesT2[] = {"None/Disabled", "Auto-Detect DMX"};
final String cDDAutoDetectModesT3[] = {"None/Disabled", "Auto-Detect"};
final String cDDMasterModes8Bit[] = {"None/Slave", "Master Full Pkts", "Master Partial Pkts"};
final String cDDMasterModesMultiBit[] = {"None/Slave", "Master Full Pkts 8-Bit", "Master Full Pkts 16-Bit", "Master Partial Pkts 8-Bit", "Master Partial Pkts 16-Bit"};
final String cDDDisplayModes[] = {"Always On", "Countdown", "Dim", "Countdown+Dim"};
final String cDDShapeOptions[] = {"Round", "Square", "Spiral", "Line", "Pixel Map", "Manual"};
final String cDDAccMeterShutOff[] = {"Disabled", "5 Sec.", "10 Sec.", "20 Sec.", "30 Sec", "40 Sec.", "60 Sec.","80 Sec."};
final String cDDAccMeterShutOffMode[] = {"Blank","Idle Sequence"};

final int cAccMeterShutOffVals[] = {0,16,32,64,96,128,192,250};
final String cDDPowerTimeOut[] = {"Disabled", "5 Min.", "10 Min.", "15 Min."};
final String cDDAccMeterTapMode[] = {"Disabled", "Sensitive", "Normal", "Strong"};

final String cDDSequenceMode[] = {"Fade", "Gradient", "Instant", "Technical", "POV", "File Play", "Linked"}; 
final String cDDSequenceModeBasic1[] = {"Fade", "Instant", "Gradient", "-----", "-----", "-----"};
final String cDDSequenceModeBasic2[] = {"Fade", "Instant", "Gradient", "-----", "Linked", "-----"};

final String cDDPacketClone[] = {"No Clone","Clone x1","Clone x2","Clone x3","Clone x4","Clone x5","Clone x6","Clone x7","Clone x8"};
final String cDDGroupSelect[] = {"1","2","3","4","5","6","7","8"};
final String cDDFrameSeqTech[] = {"Ramp", "Solid"};
final String cDDFrameSeqInstant[] = {"Instant", "Slide Up", "Slide Down"};

final String cDDPWMFreqA[] = {"31 KHz", "7.8 KHz", "1.95 KHz", "488 Hz"};
final String cDDPWMProfileA[] = {"16-Bit, 244Hz", "12-Bit, 3.9KHz", "12-Bit, 478Hz", "8-Bit, 62.5Khz","8-Bit, 976Hz"};
final String cDDIRRemote[] = {"Disabled","Enabled, 19200 baud","Enabled 250k baud"};
final String cDDStandAloneA[] = {"Hold", "Blank", "Fade Out", "Stand-Alone"};


final String cDDSeqTransistion[] = {"Instant", "Fast Fade In", "Slow Fade In"}; //add slide in, random in, flicker in? whatever
final String cDDSeqPlayMode[] = {"Loop", "One-Shot Next", "One-Shot Start", "One-Shot End", "One-Shot Blank", "One-Shot Idle"};
//- One shot and stop at end values, one shot and stop at start values, one shot and blank, one shot and go to next sequence, standard loop

final String cConfirmBoxText[] = {"Null-Bad ID Number",
	"Confirm Full Upload to connected device. Device sequence data will be erased and new data uploaded",
	"Are you sure you would like to delete ", 
	"Are you sure you want to delete all sequences?",
	"Are you sure you would like to reset the index and clear it?", 
	"Would you like to update the utilized Channel amount? Doing so may make some sequences not work til updated.",
	"The selected Sequences file is corrupt or errored. Either load a different file, contact support for help recovering the file. Or try restarting the software.",
	"Bad Start Values have been detected, various issues can occur, recommend fixing them. Ignore and Send Anyway?",
	"This device has a firmware update available, see the included 'Update' folder for details", //8
	"This will enter the device into bootloader mode, you wil need to close the software and open the bootloader software.",
	"The selected file is for a different device, errors may occur. Continue to load sequence file?",		//10	
	"Device has responded with unverified firmware, functions disabled. Contact Support.", //11
	"Are you sure you would like to upload the configuration settings currently shown the the hardware tab?", //12
	"Are you sure you would like to add this layout to the current group ID? This cannot be undone", //13
	"Are you sure you would like to merge all groups to current ID? This cannot be undone", //14
	"Are you sure you would like to clear all icons from the current group ID? This cannot be undone", //15
	"Are you sure you want to reset the Start Values?", //16	
	"This will overwrite the current Gamma table with the default. Continue?",
	"This will overwrite the current Gamma table with the user selected. Ensure user data has been loaded. Continue?",	//18
	"Request configurations from device? It will overwrite software settings."
};


final String cNotificationText[] = {"none", "Command Successful","Start Values Reset","QuickSave Successful","Not Enough Memory","Sequence to Large to Preview","Device Timeout",
	//7
	"Command Timeout","Port Not Open","Not Yet Added","Frame Data Copied","No Painting Gradients","Disable Paint Before Closing", //13
	"Can Not Change Channel Amount","Reached Maximum Linked Sequences","Cannot Send With 0 Sequences On Index","Bad ID's or Device File, Attempt Reconnect",
	"Coordinates Missing, Check Pixel Map", "Sequence Duplicated","Sequence User ID Changed", //19
	"No More Sequences Can Be Added", "Upload Cancelled", "Serial Port In Use", "Software Update Available", //23
	"Graphic Layout Image Not Found","Deleted, a Linked Sequence Requires Updating", //25
	"The POV file that was loaded is too large,\n please check settings", "Video file must be reloaded to change config", //27
	"Configurations Uploaded","Max pixel icons reached, setting to max", "Controller is version 1 & requires upgrade to V2" //30
};		


final String cPOVDescriptions[] = {"First Pixel Is On The Left. Rows Are Displayed Top To Bottom.",
	"First Pixel Is Bottom Left. Columns Are Displayed Left To Right.",								   
	"First Pixel Is On The Right. Rows Are Displayed Top To Bottom.",
	"First Pixel Is Top Left. Columns Are Displayed Left To Right."								 									
};		

final String cPOVDescriptionsSecond[] = {"Width Is Amount Of Pixels, Height Is Frames.",
	"Height is Amount Of Pixels, Width is Frames",
	"Width Is Amount Of Pixels, Height Is Frames.",
	"Height is Amount Of Pixels, Width is Frames"								 									
};										

//"First LED Pixel Is Bottom Left. Rows are Frames. Images Displayed Left to Right, Top to Bottom.",
//"First LED Pixel Is Bottom Left. Columns are Frames. Images Displayed Bottom to Top, Left to Right.",

//================================== Aurora Constants ====================================================
final int mStall = 0;
final int mFade = 1;
final int mGradient = 2;
final int mInstant = 3;
final int mTech = 4;
final int mPOV = 5;
final int mFilePlay = 6;
final int mLinked = 7;

final int mUSB = 100;
final int mDMX = 101;
final int mSerial = 102;

final int cSoftwareMaxFrames = 0xFFFF;	
final int cSoftwareMaxChans = 768;	
final int cSoftwareMaxSequences = 256;

final int cSoftwareV = 2;
final int cSoftwareR = 5;

//================================== GUI Constants ====================================================

final int cLEDSize = 20;
final int cGroupOutOfBounds = 100; //any number higher than the max amount of groups

final int cTLChBufY = 65;  
final int cTLChBufX = 135;  
final int cTLChBufViewH = 475;  //viewable height on screen
final int cTLChBufH = 30;//space of each line with margins
final int cTLGraphBufH = 20; //height of gradients
final int cTLGraphBufW = 670; //height of gradients

final int cTechnicalBufW = 670;
final int cTechnicalBufH = 510; 

final int cSeqTileW = 110;
final int cSeqTileH = 85;
final int cSeqTileVertSpace = 95;
final int cSeqTileHorizSpace = 120;

final int cGLBufViewH = 500;
final int cGLBufWidth = 670;
final int cGLBufx = 130;

final int cPOVBufWidth = 665;
final int cPOVBufHeight = 400;
final int cPOVBufY = 150;
final int cPOVBufX = 130;

final int cWorkspaceX = 125;  
final int cWorkspaceY = 35;  

final int cLinkedRoWHeight = 95;

final int cTabGraphic = 0;	
final int cTabTimeline = 1;	
final int cTabConnection = 2;	

final int cIndexEmptyID = 8888;
final int cIndexSerialID = 19999;
final int cIndexDMXID = 29999;

final int cTransmissionTimeOutVal = 3000; //time in miliseconds

final int cHeaderByteLen = 16;

//================================== Various Constants ====================================================

final int[] IconGroupColors = {color(255,0,0), color(0,255,0), color(0,0,255), color(255,0,255), color(255,255,0), color(0,255,255), color(255,255,255), color(0,0,0)};

final String cTextFieldMethods[] = {"txtHandleSeqSpeed", "txtHandleChannels","txtHandlePixelIcon","txtGradientSteps","txtHandleMultiplier","txtHandleGenericNumber","txtHandleGenericNumber"};

final int[] cDefaultGammaTable = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2,
	2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5,
	6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10, 11, 11,
	11, 12, 12, 13, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18,
	19, 19, 20, 21, 21, 22, 22, 23, 23, 24, 25, 25, 26, 27, 27, 28,
	29, 29, 30, 31, 31, 32, 33, 34, 34, 35, 36, 37, 37, 38, 39, 40,
	40, 41, 42, 43, 44, 45, 46, 46, 47, 48, 49, 50, 51, 52, 53, 54,
	55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
	71, 72, 73, 74, 76, 77, 78, 79, 80, 81, 83, 84, 85, 86, 88, 89,
	90, 91, 93, 94, 95, 96, 98, 99,100,102,103,104,106,107,109,110,
	111,113,114,116,117,119,120,121,123,124,126,128,129,131,132,134,
	135,137,138,140,142,143,145,146,148,150,151,153,155,157,158,160,
	162,163,165,167,169,170,172,174,176,178,179,181,183,185,187,189,
	191,193,194,196,198,200,202,204,206,208,210,212,214,216,218,220,
	222,224,227,229,231,233,235,237,239,241,244,246,248,250,252,255};

//============================END CONSTANTS	=========================================
//============================ START RAM ===================================

//GUI Variables
int PrevHeight = height;  //used to monitor if the grid window's size is changed
int PrevWidth = width;
float SF = 1;

int TLScrollValue = 0; //scrollbar value for movign the timeline buffer

int ConfigShape = 0;
int UserChannelAmt = 0;

int mouseXS = 0;
int mouseYS = 0;

boolean GlobalDragging = false;
boolean TextFieldActive = false;
boolean ColorPickerOpen = false;

boolean LiveControlUpdate = false;
boolean GlobalDDOpen = false;

int confirmPassedID = 0;
boolean UserIgnoredAlert = false;

int sEnableMouseOver = 0;

int OverlayMenuID = 0;
int SequenceSelectState = 0;
int GlobalSequenceSelectID = 0;	

String SequenceSelectMenuString = "";	
String GlobalLabel = "";	

int SideBarMenuState = 0;	

String portName = "None";
String devStatus = "Unconnected";
String TCPip = "192.168.4.1"; //default IP
int TCPport = 23;

int[] PaintColor = {0,0,0,0};
int[][] paletteColors = new int[6][4];
int paletteColorsVar = 0;	

int FrameScrollBarView = 0;	
int PrevScrollBarValue = 0;

int SelectedLinkedID = 0;
int SequenceIDNum = 0; //rename and delete?


boolean InitializedWindowSize = false;

//System Variables
int SelectedSequence = 0;
int SelectedFrame = 0;
int SelectedMenuTab = 1;
int SelectedTextField = 0;

int TotalColorChannels = 0;

int CurrentDataTypeMult = 3; //used in conjuction with obect DataType
int PixelDataType = 1; //Single/RGB/RBW

int myColor = color(0);
float myRed  = 0;
float myGreen = 0;//moving variables out of loop should make it faster
float myBlue = 0;
float myWhite = 0;

String SessionLogFileName = "";
String SelectedFilePath = "";
String SelectedFilePathCondensed = "";
String PixelMapFilePath = "";

int FileBrowserAction = 0;

int[] IndexMapArray = new int[257]; //one more than maximim
int IndexMapPointer = -1;

int SequenceLength = 0; //global variable for monitoring total length including index, or just for scratch
int IndexedSequenceLength = 0; //Indexed Sequence length only, no Index

int TimeLineCellSize = 0;

//============================= Communication Variables =====================================

int RXByte1 = -1;    // Incoming serial data
int RXByte2 = 0;
int RXByte3 = 0;
int RXByte4 = 0;
int RXByte5 = 0;

boolean CloseCOMFlag = false; 	//can't close from serial event or other threads,

int SendCounter = 0;
int SendCounterB = 0;
int USBpacketCount = 0;

byte[] USBPacket = new byte[64];
int PacketPointer = 0;

boolean devConnected = false;
boolean RecievedOpenAck = false;
boolean SentCmdRequest = false;
boolean SentOpenRequest = false;
boolean SentConfigRequest = false;
boolean LiveControlEnabled = false;
boolean UploadInProgress = false;
boolean WaitForAckFlag = false;	
boolean TerminateUpload = false;


int CommunicationMode = 0; //0 = serial port, 1 = TCP Client
int ProgramBaudRate = 0;	//updated from software.ini
float UploadProgressVar = 0;

int ExpectedRecieved = 0;
int ReceiveCounter = 0;
int cmdFlags = 0;
int cmdByte = 4; //open connection default
int cmdData[] = {0, 0, 0, 0};

int RecievedDeviceConfigsMSB = 0;
int RecievedDeviceConfigsLSB = 0;

int ShowNotification = 0; //0 is off, 1 and up is used for string pointer
int ShowNotificationCounter = 0;
int ConfirmBoxIDNum = 0; //0 is no message, greater than 0 is the ID number
int RequestCmdTimeOut = 0;
boolean ShowNotificationMinFlag = false;

//Live Control Variables
int LiveConTotalColChan = 0; //calculated later
int LiveConDataMult = 3; //RGB
int LiveConDataType = 1; //RGB
byte[] tempBytes;

//Icon Variables
int[] LEDIconCoordX = new int[10];
int[] LEDIconCoordY = new int[10];

int DefinedPixelUsage = 0;
int CurrentPixelUsage = 0;

int OpenedColorLEDIconID = 0;
int RemoveLEDIconNum = -1000; //starts as out of bounds value
byte FunctionGroupIDNum = 0;
int ViewGroupIDNum = 0;

byte LEDSize = cLEDSize;
int LEDSizeID = 2;
int LEDSpacingID = 3;

int PixelIconAmount = 0;
int TempDefinedPixelUsage = 0;

//Gradient Build Variables
int GradientDrawState = 0; //0=off, 1=radial, 2=linear	
int GradientDrawStartX = 0;	
int GradientDrawStartY = 0;	
int GradientDrawEndX = 0;	
int GradientDrawEndY = 0;	
int[] GradientDrawID = new int[10];

//Image Layout Variables	
boolean GraphicImageEnabled =  false;	
boolean GraphicImageResize = false;

int ImageDraggingState = 0; //0 is off,	
int GraphicImageX = 0;	
int GraphicImageY = 0;		

int GraphicImageInitX = 0;	
int GraphicImageInitY = 0;	

int GraphicImageWidth = 0;
int GraphicImageHeight = 0;


//Global Tech Variables
int SelectedTechID = 0;
int SelectedTechFrame = 0;
int tempTotalColorChannels = 0;

int UserGammaTableArray[] = new int[256];

//Global POV video Variables
int POVVidFrame = 0;
boolean HoldMovieTranscribe = true;
boolean PlayVideoFlag = false;
int MovieFrameCount = 0;
boolean TranscribingFinished = false;
int CurrentPOVW = 1;		
int CurrentPOVH = 1;

//NEW VARS ==================================================

boolean GraphicLayoutPreview = false;

int pressHeldID = 0;
boolean mousePressHoldThread = false;


//Temp and other variables
//int temp = 0; //this wil lcause save file name to get messed up!

int modulePosX = 90;
int modulePosY = 380;
int moduleHoldX = 0;
int moduleHoldY = 0;
int moduleHoldSz = 0;

String graphicImgFilePath = "imagelayouts/default.png";

int[] CopyBuffer = new int[10];

int PaintRectID = 0;
boolean PaintColorPick = false;
boolean GradientDrawInit = false;	
int MultiplierToolValue = 10; //uses 0 - 100 instead of a 0.0 to 10.0 float

int prevSliderSetNum = 1000;

int X1, X2, Y1, Y2, X3, Y3, X4, Y4;
int[] PixelChipsetID  = new int[2];

int SequenceScrollVar = 0;	

int PassedSequenceID = 0;	
boolean DraggingIndicator = false;
int DraggedIndicatorID = 0;	

int IndexSerialAssignedIDNum = cIndexEmptyID;		
int IndexDMXAssignedIDNum = cIndexEmptyID;
int tempDMXAdr = 0;
int tempSerialAdr = 0;

String[] DevStrArray = new String[16];
int ConfigFlags = 0;	

//New Version 2 Commands
int	holdHardwareID = 1000; //can never be that, so won't interfere

int cmdHWPV = 99;
int cmdFullSeqUpload = 100;
int cmdUploadConfigurations = 101;
int cmdGammaTableUpload = 102;
int cmdEnterBootloader = 140;

int cmdOpen = 4;
int cmdSpeed = 70;
int cmdSpeedIncrease = 72;
int cmdSpeedDecrease = 71;
int cmdTogglePause = 75;

int cmdSelSeq = 90;
int cmdSeqUp = 92;
int cmdSeqDown = 91;
int cmdInstStep = 82;
int cmdFadeControl = 85;
int cmdColShift = 81;
int cmdBulkLiveControl = 60;
int cmdRequestConfigurations = 120;

//command variables
int CMDTimeOutVal = 3000; //time in miliseconds default
boolean CmdIssued = false;

int HoldMiliSec = 0; //hold for serialevent timer


//Fonts
PFont fNormal, fDigital;

//Graphic Variables
PImage[] povButtonsImgs = new PImage[4];
PImage sequencesImg, fullNameImg, gradientImg, auroraLogoImg, fullNameRGB;
PImage POVImg, graphicImg, TempImgTimeLine, TempImgIndex;

PGraphics TimeLineBuffer, IndexScrollBuffer, GraphicLayoutBuffer, LinkedScrollBuffer, SeqIconBuffer, POVBuffer;
PGraphics TechnicalBuffer, FilePlayBuffer;
PGraphics[] PreviewBuffer = new PGraphics[cSoftwareMaxChans]; //one for each color channel, plus one extra for icon previews

PGraphics POVGraphicBuffer;

//Non-GUI Objects
Client TCPClient; 

Serial myPort;      // The serial port
DeviceObj device;

//Color Sequence Object
UserSequenceObj[] UserSequences;

// ==============  GUI objects ============================

SpecHWModules[] InputModule;  //Configuration Modules

ColorPickerObj ColorSelector;

DropDown DMXModesDD, PixelChipsetDD, AutoDetectDD, MasterModeDD, HardwareColSwapDD;
DropDown BaudRateDD, LEDIndicatorModeADD, LEDIndicatorModeBDD, DropDownPointer, POVModeDD;
DropDown StandAloneDD, DisplayModeDD, DisplayModeBDD, ShapeOptionsDD;
DropDown AccMeterAutoDetectDD, AccMeterAutoDetectModeDD, AccMeterTapDD, PowerDownTimeOutDD;
DropDown SequenceModeDD, PacketCloneDD, FrameSeqToolInsantDD, FrameSeqToolTechDD, StandAloneADD, PWMFreqADD;
DropDown SeqTransistionDD, PlayModeDD, PWMProfileADD, IRRemoteModeDD;

ArrayList<DropDown> DropDownList; //makes list to make it easier to mouseover
DropDown DropDownListPointer;
int DropDownMouseOverID = 0;

TabButton[] MenuTabs, ToolTabs;
TLTriangle[] TLStartIndicators;

ColorRect[] GradientRects, ControlRects, PaintRects;
ColorRect TechnicalColorStart, TechnicalColorEnd;

OverlayMenu[] OverlayMenus;

LEDgraphic[] PixelIcon;

//========= Start Button Objects ==============

Button[] TimeLineLabelButtons, TechChanLabelButtons, TechColorModeButton, TechAddFrameButtons;
Button[] COMButtons, FrameButtons;
Button[] HardwareButtons, SoftwareButtons, ConnectionButtons;
Button[] StandaloneButtons, POVOptionButtons;
Button[] TimeLineFrameButtons;
Button[] RadialMenuTechColorMode;

Button RadialTechFadeButton, RadialTechSolidButton;
Button LiveControlClose, LiveControlToggle, LiveControlApply, HardwarePrevIcon, DMXSequenceIcon, SerialSequenceIcon, IdleSequenceIcon, StartValReset;
Button DeviceConnect, ConfirmButtonYes, ConfirmButtonNo, StandAloneClose, GraphicLayoutExpandOpt;
Button GroupIDDecf, GroupIDIncf, GammaOverlayCloseButton, GammaLoadFileButton, GammaUploadButton, GammaUploadDefaultButton;
Button FilePlayLoadButton;
Button AddFrame, RemoveFrame, IncFrameBar,DecFrameBar, SequenceMenuButton, SequenceSelectAdd;
Button ColorSelectorApply, ColorSelectorCancel, MainToolsAllSame, DeviceWebpage;
Button GradientGenerate, POVModeButton, GraphicFuncPaintButton, EnableGroupMode;
Button RequestConfigurations, CopyFrameButton, PasteFrameButton, EnterBootloaderButton, SequenceSelectClose;
Button GradientDrawRadialButton, GradientDrawLinearButton, OpenTCPButton, HardwareTabUploadConfigurations;
Button ImageRemoveButton, ImagePlaceButton, ImageResizeButton, ImageResetButton;
Button ImageHandleTR, ImageHandleTL, ImageHandleBR, ImageHandleBL, ImageHandleCenter;
Button MouseIconPlace, MouseIconReset,  MouseIconRemove;
Button IconToolGroupIDDec, IconToolGroupIDInc, LayoutGroupInc, LayoutGroupDec;
Button MainToolsColorGroup, UploadProgressCancel, MainToolsShowStartValues;
Button POVPlay, POVPause, POVRestart;
Button GraphicPreviewPlayPause;

//Movie Object for Video POVs and File Play....
Movie moviePOV;

//Verticle Sliders
SliderBar TimeLineScrollBar, IndexScrollBar, LinkedScrollBar, SequenceSelectScrollBar;
SliderBar TechnicalScrollHoriz, TechnicalScrollVert;

//Horiz Sliders
SliderBar GradientDrawSlider;
SliderBar[] ColorSelectorSliders, ControlSliders, StandaloneSliders; 

SliderBar SliderPointer;

//Check Boxes
CheckBox[] SeqCheckBoxes, FrameCheckBoxes;
CheckBox[] HardwareCheckBox, SoftwareCheckBox;
CheckBox[] LiveControlCheckBox;
CheckBox[] StandaloneCheckBox;
CheckBox[] LinkedCheckBox;
CheckBox[] LinkedTimerCheckBox;

CheckBox IntensityOverrideCheckBox, IconLayoutAdvancedMode, POVVideoModeCheckBox;

//================================== Textfield Objects ====================================================

TextField[] TextFields;
TextField TXTFSeqIntensity, TXTFTechTime, textFieldPtr;

//Inc/Dec Objects
TextFieldObject SequenceChannelObject, SequenceSpeedObject, PixelAmountObject,GradientStepsObject,GradientMultiplierObject;
Button[] ObjButtonPlus, ObjButtonMinus, LObjButtonPlus, LObjButtonMinus;
TextField[] ObjTextField, LObjTextField;
TextFieldObjectL[] LinkedTextFieldObject;

//================================== ArrayList for GUI MouseOver Elements ====================================================

ArrayList<Button> ButtonList; //makes list to make it easier to mouseover
Button PointerButton;

ArrayList<TextField> TextFieldList;
TextField TextFieldListPointer;

ArrayList<CheckBox> CheckBoxList;
CheckBox CheckBoxListPointer;

//=========================== START MAIN ======================================


//===================================================================================================	

public void LoadDeviceFile()
{
	//Called when device responds to a Connection Request
	//Loads a TXT file with the device specific defines and variables, loads into the device object
	String BuildString = "devices"+File.separator+""+device.HardwareID+"-nled-contr-revs.txt"; 	//loads file with current firmware rev info

	String[] lines = loadStrings(BuildString); 
	String[] WorkString = new String[30]; //may need to up this	
	
	BuildString = "";	
	
	
	int VerH = 0;
	int RevH = 0;
	
	
	for(int i = 0; i != lines.length;i++)
	{
	WorkString = split(lines[i], '\t');
		
	println(PApplet.parseInt(WorkString[0])+" : "+PApplet.parseInt(WorkString[1]));	
	
	
	if(PApplet.parseInt(WorkString[0]) > VerH) VerH = PApplet.parseInt(WorkString[0]);
	if(PApplet.parseInt(WorkString[1]) > RevH) RevH = PApplet.parseInt(WorkString[1]);
	} //end for()
		
	
	if(VerH != device.FirmwareVersion)
	{
		println("FIRMWARE VERSION OUTDATED "+PApplet.parseInt(WorkString[1])+" vs "+device.FirmwareVersion);
		if(devConnected == true) //if no device is connected don't show the message
		{	
			ConfirmBoxIDNum = 8;
		}
		return; //can't load then, version 2 only
	}
	
	
	if(RevH == device.FirmwareRevision)
	{
		println("REVISION FOUND with "+RevH);
		BuildString = "devices"+File.separator+""+device.HardwareID+"-"+device.FirmwareVersion+"-"+device.FirmwareRevision+"-nled-contr.txt";
	}
	else if(RevH > device.FirmwareRevision)
	{
		println("FIRMWARE REVISION OUTDATED "+RevH+" vs "+device.FirmwareRevision);
		if(devConnected == true) //if no device is connected don't show the message
		{
			ConfirmBoxIDNum = 8;
		}
		
		//scan list for next viable device file
		
		int x = 0;
		
		for(int i = 0; i != lines.length;i++)
		{
			WorkString = split(lines[i], '\t');
			
			if(PApplet.parseInt(WorkString[1]) == device.FirmwareRevision)  
			{
			//Found a lower revision that has an available device file, use it
			println("Device File For V. & Rev. Found - Firmware Revision Outdated");	
			BuildString = "devices"+File.separator+""+device.HardwareID+"-"+device.FirmwareVersion+"-"+device.FirmwareRevision+"-nled-contr.txt";
			break;
			}
			else
			{
				//otherwise keep track the of the next available device file that is lower than the revision
				if(PApplet.parseInt(WorkString[1]) < device.FirmwareRevision && PApplet.parseInt(WorkString[1]) > x) 
				{	
				x = PApplet.parseInt(WorkString[1]);	 //update variable	
				}
				BuildString = "devices"+File.separator+""+device.HardwareID+"-"+device.FirmwareVersion+"-"+x+"-nled-contr.txt"; //build the string regardless
			}
		} //end for()		
	} //end else if()
	else if(RevH < device.FirmwareRevision)
	{
	BuildString = "devices"+File.separator+""+device.HardwareID+"-"+device.FirmwareVersion+"-"+RevH+"-nled-contr.txt"; //build the string regardless
	}
	//no way there can be an else
		
	//-----------------------------------------------------------------------------------------------------------------
		
	
	println("LoadDeviceFile() - "+BuildString);	
	
	int LinePointer = 1;
	
	lines = loadStrings(BuildString); 
	
	
	//WorkString[0] is HardwareID, already checked....
	WorkString = split(lines[LinePointer++], '\t');
	device.Name = WorkString[1]; //String Name
	
	WorkString = split(lines[LinePointer++], '\t');
	device.WebpageURL = WorkString[1];  	//String URL
	
	
	LinePointer++; //version - always same as file name
	LinePointer++; //revision - always same as file name


	//device.HardwareVersion = int(WorkString[1]);
	LinePointer++;	//for hardwareversion which is not read

	WorkString = split(lines[LinePointer++], '\t');
	device.Channels = PApplet.parseInt(WorkString[1]);   
	
	WorkString = split(lines[LinePointer++], '\t');
	device.LockChannelAmt = PApplet.parseBoolean(WorkString[1]);   
	
	WorkString = split(lines[LinePointer++], '\t');
	device.DataSpace = PApplet.parseInt(WorkString[1]);   
	
	WorkString = split(lines[LinePointer++], '\t');
	device.IndexBlockSize = PApplet.parseInt(WorkString[1]);
	try { 	
		device.HPVBlockSize = PApplet.parseInt(WorkString[2]);   
		device.SeqMemoryBlockSize = PApplet.parseInt(WorkString[3]);   
	}
	catch(Exception e) 
	{
		println("Error loading block sizes, using single value");
		device.CurrentBlockSize	= device.IndexBlockSize;
		device.HPVBlockSize = device.CurrentBlockSize;   
		device.SeqMemoryBlockSize = device.CurrentBlockSize;  	
	}
	
	WorkString = split(lines[LinePointer++], '\t');
	device.EraseBlockSize = PApplet.parseInt(WorkString[1]);  
	
	WorkString = split(lines[LinePointer++], '\t');
	device.HWPVSpace = PApplet.parseInt(WorkString[1]);    

	WorkString = split(lines[LinePointer++], '\t');
	device.MaxIndexedSequences = PApplet.parseInt(WorkString[1]);  
	
	WorkString = split(lines[LinePointer++], '\t');
	device.IndexMemoryModel = PApplet.parseInt(WorkString[1]);  		
	
	WorkString = split(lines[LinePointer++], '\t');
	device.FillUpperData = PApplet.parseBoolean(WorkString[1]); 

	WorkString = split(lines[LinePointer++], '\t');
	device.Bit16Processor = PApplet.parseBoolean(WorkString[1]);  	

	WorkString = split(lines[LinePointer++], '\t');
	device.Bit16Mode = PApplet.parseBoolean(WorkString[1]);    

	WorkString = split(lines[LinePointer++], '\t');
	device.BasicVersion = PApplet.parseInt(WorkString[1]);      
	
	WorkString = split(lines[LinePointer++], '\t');
	device.LinkedSupport = PApplet.parseBoolean(WorkString[1]);   
	
	WorkString = split(lines[LinePointer++], '\t');
	device.GammaCorrection = PApplet.parseInt(WorkString[1]);  //0=none, 1=8-bit gamma table, 2=16-bit calculation

	WorkString = split(lines[LinePointer++], '\t');
	device.AccelerometerMode = PApplet.parseInt(WorkString[1]);

	WorkString = split(lines[LinePointer++], '\t');
	device.MaxSpeed = PApplet.parseInt(WorkString[1]);  	

	WorkString = split(lines[LinePointer++], '\t');
	device.MaxFrames = PApplet.parseInt(WorkString[1]); 		//Max Frames for sequences that use DataFrameVar[] on device
	device.MaxFramesGlobal = PApplet.parseInt(WorkString[2]);  //max frames for POVs currently and anything that uses GlobalFrameVar
	
	WorkString = split(lines[LinePointer++], '\t');
	device.ConfigFlagsStr = WorkString[1];  	

	WorkString = split(lines[LinePointer++], '\t');
	device.ConfigBytesStr = WorkString[1];  	

	WorkString = split(lines[LinePointer++], '\t');
	device.DMXModeLabels = new String[16];
	device.DMXModeLabels = split(WorkString[1], ',');

	//println("DMXLables: "+device.DMXModeLabels.length+"    "+device.DMXModeLabels[0]+" "+device.DMXModeLabels[1]);

	device.DMXModeAmt = device.DMXModeLabels.length;   	
	
	//Init GUI Elements
	DMXModesDD.Labels = device.DMXModeLabels; 	//drop down
	DMXModesDD.numStrs = device.DMXModeAmt; 	//drop down
	
	//Pixel Type Modes if applicable
	WorkString = split(lines[LinePointer++], '\t');
	device.ListedChipsets = PApplet.parseInt( WorkString[1]);   
	
	if(device.ListedChipsets > 0)
	{	
		String[] tempPixLables = new String[16];

		tempPixLables = new String[device.ListedChipsets]; //use same array as DMX	
		PixelChipsetID = new int[device.ListedChipsets];
		
		//pixel Type Compatibility
		for (int i = LinePointer; i != (LinePointer+device.ListedChipsets);i++)
		{
			WorkString = split(lines[i], '\t');
			tempPixLables[i-LinePointer] = WorkString[1];
			PixelChipsetID[i-LinePointer] = PApplet.parseInt(WorkString[2]);
		}

		PixelChipsetDD.Labels = tempPixLables;
		PixelChipsetDD.numStrs = device.ListedChipsets;	
	}	//end if()

	//added v.2c for linked double duty variables
	device.ArrayCastSize = device.Channels; //cSoftwareMaxFrames
	if(device.MaxFrames > device.Channels) device.ArrayCastSize = device.MaxFrames;
			
	// =================   END DATA LOAD  =========================================================
	
	if(device.BasicVersion > 0)
	{
		switch(device.BasicVersion)
		{
		case 1: //4chanDMX
			device.BasicMaxSequences = 8;
			device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
			//Misc+(startvals+framevars)+dataspace
			
			println("============"+device.BasicSeqLength+"================");
			
			AutoDetectDD.Labels = cDDAutoDetectModesT2;
			AutoDetectDD.numStrs = cDDAutoDetectModesT2.length;
			break;
		case 2: //octo
		case 3: //four chan
			device.BasicMaxSequences = 32;
			device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
			//Misc+(startvals+framevars)+dataspace
			
			AutoDetectDD.Labels = cDDAutoDetectModesT3;
			AutoDetectDD.numStrs = cDDAutoDetectModesT3.length;
			break;		
		}
	}//end if
	
	//set Memory/DataSpace label
	if(device.DataSpace > 1000000) device.MemorySpaceString = nf((((float)device.DataSpace/1048576)),1,2)+"MB";
	else device.MemorySpaceString = nf((((float)device.DataSpace/1024)),1,2)+"KB";	
	
	//Prevents UserChannelAmt from being reset when reconnecting
	if(holdHardwareID != device.HardwareID)	UserChannelAmt = device.Channels;

	//added, might need to init other sizes here
	if(device.Bit16Mode == true)
	{
		ColorSelectorSliders[0].Maximum = 65535;
		ColorSelectorSliders[1].Maximum = 65535;
		ColorSelectorSliders[2].Maximum = 65535;
		ColorSelectorSliders[3].Maximum = 65535;
		TextFields[5].maxValue = 65535;
	}
	else
	{
		//need to reinit a few things in case 16-bit usage changes then 8-bit device is loaded 
		ColorSelectorSliders[0].Maximum = 255;
		ColorSelectorSliders[1].Maximum = 255;
		ColorSelectorSliders[2].Maximum = 255;
		ColorSelectorSliders[3].Maximum = 255;
		TextFields[5].maxValue = 255;
	}
	
	// Initialize TXTFields
	if(device.LockChannelAmt == true) UserChannelAmt = device.Channels; //just ensure its set
	TextFields[11].maxValue = device.Channels;
	TextFields[11].Label = ""+UserChannelAmt;	
	// Initialize ObjecTXTFields			
	ObjTextField[SequenceSpeedObject.ObjID].maxValue = device.MaxSpeed;
	ObjTextField[SequenceChannelObject.ObjID].maxValue = device.Channels;
	
	//Handle GUI Elements on a per device basis
	if(device.GammaCorrection == 0 || device.GammaCorrection == 2) ConnectionButtons[5].Status = 1;//0=show, 1=grey out, 2=hide	
	else ConnectionButtons[5].Status = 0;	//in case loading differet device
	
	
	println("Device File Successfully Loaded - Starting Configuration Modules");
	
	//================	init Hardware Usage Modules	============================================
	
	modulePosX = 140; //constants
	modulePosY = 190;
	
	moduleHoldX = 0;
	moduleHoldY = 0;
	moduleHoldSz = 0;
	
	for (int i = 0; i != InputModule.length;i++) InputModule[i].Enabled = false; //reset all modules to disabled
	
	//	device.ConfigFlagsStr = "fDisModeMSBa,fDisModeLSBa,fLEDModeMSBa,fLEDModeLSBa,fAutoDetectID,fAutoDetect,f8or16Bit,fRS485Enable,fMasterEnable,fMasterFullPkts,fMaster16Bit,fAccMeterAutoShutOff,fAccMeterMovement,fAccMeterDoubleTap,fDualModeCom,none";
	//	device.ConfigBytesStr = "bDMXAdrMSB,bDMXAdrLSB,bDMXModeID,bBaudRateID,bGlobalColorShift,bPixelChipset,bAccmeterTimeoutVal,bAccmeterDoubleTapVal";

	ConfigFlags = 0; //reset flags here.....
	DevStrArray = split(device.ConfigFlagsStr, ',');
	String[] ModuleString = new String[16];	//reset
	String[] ByteStrArray = new String[16];
	ByteStrArray = split(device.ConfigBytesStr, ',');	
	//Now single delimenated string is an array, the pointer is the bit number in ConfigFlags	
	
	
	//First handle prioritized tiles ====================================================================================
	
	//z counts from high to low, and checks for tiles that are not yet placed and are above that number
	for(int z = 260; z > 0; z-=10)
	{	
		for(int y = 0; y != InputModule.length;y++)
		{	
			if(InputModule[y].Enabled == false && InputModule[y].Priority >= z)
			{
				ModuleString = split(InputModule[y].ModuleFlagStr, ','); //fill with bit string

				for(int q = 0; q != ModuleString.length; q++)
				{	
					for(int i = 0; i != DevStrArray.length; i++)
					{	
						if(DevStrArray[i].equals(ModuleString[q]) == true) //if string matches
						{
							if(InputModule[y].Enabled == false) 
							{
								//println("Bit tile placed priority "+z);
								//println("Module Priority: "+InputModule[y].Priority);							
								InputModule[y].PlaceTile();
							}
						}
					} //end i for()
				} //end q for()	
				
				//==============================================================
				
				ModuleString = split(InputModule[y].ModuleByteStr, ','); //refill with byte string
				
				for(int q = 0; q != ModuleString.length; q++)
				{	
					for(int i = 0; i != ByteStrArray.length; i++)
					{	
						if(ByteStrArray[i].equals(ModuleString[q]) == true) //if string matches
						{
							if(InputModule[y].Enabled == false) 
							{
								//println("Byte tile placed priority "+z);
								//println(InputModule[y].Priority);							
								InputModule[y].PlaceTile();
							}
						}
					} //end i for()
				} //end q for()					
			}
		} //end y for()
	}	//end z for()
	

	///Now place all unprioritized not yet enabled tiles
	for(int y = 0; y != InputModule.length;y++)
	{	
		if(InputModule[y].Enabled == false)
		{
			ModuleString = split(InputModule[y].ModuleFlagStr, ',');

			for(int q = 0; q != ModuleString.length; q++)
			{	
				for(int i = 0; i != DevStrArray.length; i++)
				{	
					if(DevStrArray[i].equals(ModuleString[q]) == true) //if string matches
					{
						if(InputModule[y].Enabled == false) 
						{						
							InputModule[y].PlaceTile();
						}
					}
				} //end i for()
			} //end q for()	
			
			//==============================================================
			
			ModuleString = split(InputModule[y].ModuleByteStr, ',');
			
			for(int q = 0; q != ModuleString.length; q++)
			{	
				for(int i = 0; i != ByteStrArray.length; i++)
				{	
					if(ByteStrArray[i].equals(ModuleString[q]) == true) //if string matches
					{
						if(InputModule[y].Enabled == false) 
						{					
							InputModule[y].PlaceTile();
						}
					}
				} //end i for()
			} //end q for()				
			
		}
	} //end y for()
	//Modules placed and prioritized

	// ================   Set additional define flags that require configurations to be loaded ==============


	//if 16-bit data mode or has 16-bit pack function for serial, live control would also be 16-bit capable
	if(device.Bit16Mode == true || IsOnConfigFlags("f8or16Bit")) 	device.Bit16LiveMode = true;

		
	// ================   grey out unavailable GUI elements ==============


	if(device.BasicVersion > 0)
	{
		if(device.BasicVersion == 1) 
		{
			SequenceModeDD.Labels = cDDSequenceModeBasic1;
			SequenceModeDD.numStrs = cDDSequenceModeBasic1.length;
		}
		//update sequence type options
		if(device.LinkedSupport == true)
		{
			SequenceModeDD.Labels = cDDSequenceModeBasic2;
			SequenceModeDD.numStrs = cDDSequenceModeBasic2.length;
		}	

		IdleSequenceIcon.Status = 1;//0=show, 1=grey out, 2=hide	
		ConnectionButtons[4].Status = 1; //stand-alone menu open button
	} //end basicVersion if()
	else
	{
		IdleSequenceIcon.Status = 0;//0=show, 1=grey out, 2=hide	
		ConnectionButtons[4].Status = 0; //stand-alone menu open button
	}
	
	if(device.HWPVSpace == 0) 	HardwarePrevIcon.Status = 1;
	else 	HardwarePrevIcon.Status = 0;

	
	if(device.LockChannelAmt == true)
	{
		SequenceChannelObject.setStatus(1); //grey out	
		TextFields[11].Status = 1; //Grey out user channel amount on software tab
		SoftwareButtons[10].Status = 1; //grey out apply button
	}
	else
	{
		//incase of file load it needs to revert
		SequenceChannelObject.setStatus(0); //Enable
		TextFields[11].Status = 0; //Enable user channel amount on software tab
		SoftwareButtons[10].Status = 0; //Enable apply button
	}
	
	println("Configuration Modules Successfully Loaded - end LoadDeviceFile()");
}//end func()

//==================================================================================================================================================

public void bitSet(int pointer)
{
	ConfigFlags |= (1 << pointer); 
	//println("BitSet "+pointer+"    "+ConfigFlags);	
} //end func

public void SendConfigurations()
{
	println("SendConfigurations()"); 

	//Debug
	//device.ConfigFlagsStr = "fDisModeMSBa,fDisModeLSBa,fLEDModeMSBa,fLEDModeLSBa,fAutoDetectID,fAutoDetect,f8or16Bit,fRS485Enable,fMasterEnable,fMasterFullPkts,fMaster16Bit,fAccMeterAutoShutOff,fAccMeterMovement,fAccMeterDoubleTap,fDualModeCom,none";
	//device.ConfigBytesStr = "bDMXAdrMSB,bDMXAdrLSB,bDMXModeID,bBaudRateID,bGlobalColorShift,bPixelChipset,bAccmeterTimeoutVal,bAccmeterDoubleTapVal";
	
	String[] ModuleString = new String[16];	
	int[] TransmitByteArray = new int[16];	
	DevStrArray = split(device.ConfigFlagsStr, ',');
	//Now single delimenated string is an array, the pointer is the bit number in ConfigFlags	

	//Module0 with matching string ex: 	"fDisModeMSBa,fDisModeLSBa"
	//Module1 with matching string ex: 	"fAutoDetectID,fAutoDetect"
	//Loop goes through enabled modules, checks the string to the DevStr array	
	//	If a module string matches the list build ConfigFlags

	ConfigFlags = 0; //reset flags here.....

	for(int y = 0; y != InputModule.length;y++)
	{	
		if(InputModule[y].Enabled == true)
		{
			ModuleString = split(InputModule[y].ModuleFlagStr, ',');
			
			for(int q = 0; q != ModuleString.length; q++)
			{	
				for(int i = 0; i != DevStrArray.length; i++)
				{	
					if(DevStrArray[i].equals(ModuleString[q]) == true) //if string matches
					{
						//println("String Matches "+ModuleString[q]+" on Bit ID# "+i+"   StrID: "+q);
						
						if(InputModule[y].GetBitValues(q) == 1) bitSet(i); //this pretty much does it gotta setup modules
					}
				} //end i for()
			} //end q for()	
		} //end if
	} //end y for()

	println("ConfigFlags: "+binary(ConfigFlags,16));
	
	for(int i = 0; i != TransmitByteArray.length;i++) TransmitByteArray[i] = 0; //clear array first
	TransmitByteArray[0] = (ConfigFlags >> 8); //MSB first
	TransmitByteArray[1] = ConfigFlags & 0xFF;	//LSB second
	///NOW RUN CONFIGURATION BYTES	

	DevStrArray = split(device.ConfigBytesStr, ',');	//load device config byte string
	
	for(int y = 0; y != InputModule.length;y++)
	{		
		if(InputModule[y].Enabled == true)
		{
			ModuleString = split(InputModule[y].ModuleByteStr, ',');

			for(int q = 0; q != ModuleString.length; q++)
			{	
				for(int i = 0; i != DevStrArray.length; i++)
				{	
					if(DevStrArray[i].equals(ModuleString[q]) == true) //if string matches
					{
						//println("Set Byte - String Matches "+ModuleString[q]+" on BYTE# "+(i+2));
						TransmitByteArray[i+2] = InputModule[y].GetByteValues(q);
					}
				} //end i for()
			} //end q for()	
		} //end if
	} //end y for()
	
	printArray(TransmitByteArray);

	//Now Send TransmitByteArray
	for(int i = 0; i != (DevStrArray.length+2); i++)	SendSingleDataByte(TransmitByteArray[i]); //+2 for 2x config bytes

	println("SendConfigurations() finished");	
	ShowNotification(28);
} //end SendConfigurations()	

//===========================================================================	

public boolean IsOnConfigFlags(String passedStr)
{
	for(int i = 0; i != DevStrArray.length; i++)
	{	
		if(DevStrArray[i].equals(passedStr) == true) //if string matches
		{
			println("IsOnConfigFlags() found "+passedStr);
			return true;
		}
	} //end i for()
	return false;
}//end func	

//===========================================================================		

//Send to Device: NLED11 → Device Responds: a9 →  Send to Device: nled99 ->Device Responds: f0

public void BuildUSBPacket(int dataValue)
{
	//THIS DO ANYTHING? ALL DEVICES ERASE AT FIRST PACKET....	
	SendCounter++; //used for 
	SendCounterB++; //counts all bytes
	if (SendCounter >= device.EraseBlockSize)
	{
		delay(5); //delay to allow the device to erase the next block
		SendCounter = 0;
	}
	//end this	
	
	USBPacket[PacketPointer] =  PApplet.parseByte(dataValue);
	PacketPointer++;

//println("= "+dataValue);	
	
	if(PacketPointer == 64)
	{	
		//packet full, send it	
		PacketPointer = 0;
		try {		
			
			if(CommunicationMode == 0) myPort.write(USBPacket); //send a full 64 byte packet all at once
			else if(CommunicationMode == 1) TCPClient.write(USBPacket);		
			
			USBpacketCount++;
			
			//this runs the routine for waiting for "zAck"
			if(SendCounter == device.CurrentBlockSize)
			{
				println("Waiting for ACK, USBPacket: "+USBpacketCount+"    SendCounter: "+SendCounter);
				SendCounter = 0;
				while(WaitForAckFlag == false) 
				{
					delay(1); //runs infinitly til ack flag is set, needs delay to not error, but not locking
					if(TerminateUpload == true) { break; } //once set will force the function to finish and thread to end

				}
				WaitForAckFlag = false; //set back to false
				redraw();
			}
		}
		catch(Exception e)
		{
			println("Unable to Send Packet");	
			redraw();
		}
	}	//end if()	
}	//end BuildUSBPacket()

//===================================================================================================

//separate so one can pass characters, for exchange, other for data/numbers
public void SendSingleDataChar(char passedValue)
{
	try {
		if(CommunicationMode == 0) myPort.write(passedValue);
		else if(CommunicationMode == 1) TCPClient.write(passedValue);
	}
	catch(Exception e) { }
	
}

public void SendSingleDataByte(int passedValue)
{
	try {
		if(CommunicationMode == 0) myPort.write(passedValue);
		else if(CommunicationMode == 1) TCPClient.write(passedValue);
	}
	catch(Exception e) { }
}


public void SendAckedCommand() //threaded
{
	println("Cmd Request Acknowledged, Sending - CmdByte: "+cmdByte+" : "+cmdData[0]+" : "+cmdData[1]+" : "+cmdData[2]+" : "+cmdData[3]);
	RecievedOpenAck = false;
	SendSingleDataByte(cmdByte);
	SendSingleDataByte(cmdData[0]);  
	SendSingleDataByte(cmdData[1]);   
	SendSingleDataByte(cmdData[2]);  
	SendSingleDataByte(cmdData[3]); 

	CmdIssued = true; //set flag to wait for authentication
}

//===================================================================================================

// ClientEvent message is generated when the server 
// sends data to an existing client.
public void clientEvent(Client someClient) //library generated event?
{
	TCPDataRecieved();
}

public void serialEvent(Serial myPort) 
{
	RXByte5 = RXByte4;
	RXByte4 = RXByte3;
	RXByte3 = RXByte2;
	RXByte2 = RXByte1;
	RXByte1 = myPort.read();
	DataRecieved(); //run common function
}	//end serialEvent()

public void TCPDataRecieved()
{
	RXByte5 = RXByte4;	
	RXByte4 = RXByte3;
	RXByte3 = RXByte2;
	RXByte2 = RXByte1;
	RXByte1 = TCPClient.read();
	DataRecieved(); //run common function
	
	//	println("Remaining TCP bytes to handle "+TCPClient.available());
	if(TCPClient.available() > 0) TCPDataRecieved();
}	//end TCPDataRecieved()

//===================================================================================================

public void DataRecieved()	
{
	println("Received: "+RXByte1+"  Char: "+PApplet.parseChar(RXByte1));
	//START TIMER METHOD
	/*
int tempTime = (millis() - HoldMiliSec);
println("Received: "+RXByte1+"/"+char(RXByte1)+" Time: "+tempTime);
HoldMiliSec=millis();  
*/
	//END TIMER METHOD
	
	if (SentCmdRequest == true && RXByte2 == 'a' && RXByte1 == '9')
	{
		RecievedOpenAck = true;
		SentCmdRequest = false;
		EnableTransmissionTimeOut();
		//myPort.write("nled99"); 
		SendSingleDataChar('n'); 
		SendSingleDataChar('l');  
		SendSingleDataChar('e');
		SendSingleDataChar('d');  
		SendSingleDataChar('9');   
		SendSingleDataChar('9');
		
		println("Sent Acknowledge");
	}
	else if (RecievedOpenAck == true  && RXByte2 == 'f' && RXByte1 == '0')
	{
		thread("SendAckedCommand");
	}
	else if(SentConfigRequest == true)
	{
		switch(ReceiveCounter)
		{
		case 0: //MSB
			RecievedDeviceConfigsMSB = RXByte1;
			break;      
		case 1: //LSB
			RecievedDeviceConfigsLSB = RXByte1;		
			SentConfigRequest = false;
			println("Requested and Recieved Configurations "+binary(RecievedDeviceConfigsMSB,8)+" "+binary(RecievedDeviceConfigsLSB,8));
			break;	
		} //end switch
		ReceiveCounter++;
	}
	else if (SentOpenRequest == true)
	{
		println("Counter: "+ReceiveCounter);
		switch(ReceiveCounter)
		{
		case 0: //hardware ID
			holdHardwareID = device.HardwareID; //holds current or old HardwareID
			
			device.HardwareID = RXByte1;
			break;      
		case 1: //hardware version ID, not really used
			device.HardwareVersion = RXByte1;
			break;
		case 2: //Firmware Version
			device.FirmwareVersion = RXByte1;
			break;
		case 3: //Firmware Revision
			device.FirmwareRevision = RXByte1;
			break;
		case 4:	//Bootloader Target HardwareID
			
			break;			
		case 5:	//Bootloader Version Number
			device.BootloaderVersion = RXByte1;
			break;			
		case 6:	//UserID Number Configuration
			device.UserConfiguredIDNum = RXByte1;
			
			//All Device Connection bytes received, now load device file and continue
			SentOpenRequest = false;
			devConnected = true;
			devStatus = "Connected";
			DeviceConnect.Selected = true; //toggle button state
			SaveSoftwareConfigFile();	//save COMPort Name

			//Select correct COM button to highlight			
			for (int x =0; x != Serial.list().length; x++) 
			{
				if(portName.equals(Serial.list()[x]))
				{		
					try {
						for (int q =0; q != COMButtons.length; q++) COMButtons[q].Selected = false;	
						COMButtons[x].Selected = true;
					}
					catch(Exception e)	{	}	
				}

			}			
			//end		
			
			try {
				LoadDeviceFile();
				//String temp = cRevisionIDstr[device.FirmwareRevision]; //to test and catch if valid firmware revision number
			}
			catch(Exception e) { ShowNotification(16); }
			
			if(device.FirmwareVersion > 100) ConfirmBoxIDNum = 11; //unverified firmware
			redraw();
			break;
		}  
		ReceiveCounter++;
	}
	else if(UploadInProgress == true)
	{
		if(RXByte4 == 'z' && RXByte3 == 'A' && RXByte2 == 'c' && RXByte1 == 'k')	
		{
			WaitForAckFlag = true;
			println("ACK RECEIVED FOR PACKET# "+USBpacketCount);
			redraw();
			//also send CRC byte and packet# to maintain continuity
		}
	}
	else if(CmdIssued == true)
	{
		if(RXByte5 == 'c' && RXByte4 == 'm' && RXByte3 == 'd' && RXByte2 == 0)	
		{
			CmdIssued = false;	
			println("COMMAND #"+RXByte1+" AUTHENTICATED");
			redraw(); //to show upload bar
			//run common init
			SendCounter = 0;
			SendCounterB = 0;
			USBpacketCount = 0; //reset counter	
			PacketPointer = 0; //would also get set to 0, since it always sends 64 bytes then clears it.
			
			//this executes the actual command software side once ACKed
			switch(cmdByte)
			{
			case 4: //Request Connection
				SentOpenRequest = true;
				ReceiveCounter = 0;
				break;
			case 60:	//Enter USB Live Control
				if(cmdData[0] == 1) LiveControlEnabled = true; //on
				else if(cmdData[0] == 0) LiveControlEnabled = false; //off
				break;	
			case 99: //HWPV Upload
				UploadInProgress = true;
				SequenceLength = UserSequences[PassedSequenceID].Length;   

				thread("SendHardwarePreview"); //ID# not passed anymore, set in function
				break;		
			case 100: //Full Upload
				UploadInProgress = true;				
				if(device.BasicVersion > 0) thread("SendLegacyData"); //SendLegacyData();
				else thread("FullUpload");
				break;
			case 101:	//Upload Configurations
				UploadInProgress = true;	
				SendConfigurations();	
				UploadInProgress = false;
				break;	
			case 102:	//Upload Gamma Table
				UploadInProgress = true;	
				if(device.FillUpperData == true ) SequenceLength = 384;
				else SequenceLength = 256;
				thread("UploadGammaTable");
				//UploadInProgress = false;
				break;	
			case 120: //Request Configurations
				SentConfigRequest = true;
				ReceiveCounter = 0;
				break;			
			}	//end switch	
		} //end byte check
		//else if(devConnected == false && cmdByte == 4)
	
		else if(RXByte4 > 0 && RXByte3 == 1 && RXByte2 == 1 && RXByte1 < 26)	
		{
			//Detects if version 1, rather than acking the cmd
			//hardwareID,hardwarev, firmwareV, firmwareRev

			println("Version 1 controller detected");
			ShowNotification(30);
			//CloseCommunicationPort(); //can't from here
			CloseCOMFlag = true;
		}
	} //end CmdIssued if()		
} //end func

//=====================================================================================================

public void RequestCommand()
{
	TerminateUpload = false; //reset flag
	WaitForAckFlag = false; 
	
	try {
		// SendSingleDataByte("NLED11"); 
		SendSingleDataChar('N'); 
		SendSingleDataChar('L');  
		SendSingleDataChar('E');   
		SendSingleDataChar('D');  
		SendSingleDataChar('1');   
		SendSingleDataChar('1');
		SentCmdRequest = true; 
		EnableTransmissionTimeOut();
	}
	catch(Exception e)
	{
		println("Port Not Open, Or Unable to Send"); 
		SentCmdRequest = false;

		CloseCommunicationPort();
		ShowNotification(8);
	}
} //end func()

public void OpenConnection()
{
	println("Attempting Connection");

	cmdByte = cmdOpen; //connect to device
	cmdData[0] = 0;
	cmdData[1] = 0; 
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	devConnected = false;

	RequestCommand();
}//end func()


public void RequestDeviceConfigurations()
{
	println("Attempting Connection");

	cmdByte = cmdRequestConfigurations; 
	cmdData[0] = 0;
	cmdData[1] = 0; 
	cmdData[2] = 0;  
	cmdData[3] = 0;  

	RequestCommand();
}//end func()

//==========================================================================================================

//hardware Preview -> Drag and drop Icon(MousePressed) -> RequestToSendPreview(attempts to send request command)

public void RequestToSendPreview(int passedVal)
{
	//first saves the file to build the length variables
	//rejects if mLinked
	//Sends out the command, if it acknowledges
	println("RequestToSendPreview() with "+passedVal);
	SaveUserSequencesFile("saves"+File.separator+"tempSave.txt");
	println("HWPV Sequence Length: "+UserSequences[passedVal].Length+" : Device HWPV Space: "+device.HWPVSpace);
	
	PassedSequenceID = passedVal;

	if(UserSequences[passedVal].SeqMode == mLinked || UserSequences[passedVal].Length > device.HWPVSpace) 
	{	  
		ShowNotification(5); //HWPV Reject as too big	
		return; //rejects if linked, no message
	}
	
	device.CurrentBlockSize = device.HPVBlockSize;
	
	cmdByte = cmdHWPV; //Upload HPV sequence
	cmdData[0] = ((ceil((float)UserSequences[passedVal].Length/device.CurrentBlockSize)+1) >> 8) & 0xFF; //MSB
	cmdData[1] = (ceil((float)UserSequences[passedVal].Length/device.CurrentBlockSize)) & 0xFF; //LSB
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	
	println("Expected HWPV Packets: "+(ceil((float)(UserSequences[passedVal].Length/device.CurrentBlockSize))+1));
	RequestCommand();
}//end func()

//=====================================================================================================

public void RequestConfigurationUploadType2()
{
	println("RequestConfigurationUploadType2() for Basic Version Type 2");

	cmdByte = cmdUploadConfigurations; //Upload Configurations
	cmdData[0] = 0; //MSB
	
	switch(PowerDownTimeOutDD.SelStr) //Power Down Timer Mode
	{
	case 0: //disabled
		cmdData[0] = 0x00;
		break;
	case 1: //5 min
		cmdData[0] = 0x01;
		break;
	case 2: //10 min
		cmdData[0] =  0x02;
		break;
	case 3: //15 min
		cmdData[0] = 0x03;
		break;
	}	
	
	RequestCmdTimeOut = CMDTimeOutVal;	
	
	cmdData[1] = 0; //LSB
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	RequestCommand();
}


public void RequestConfigurationUpload()
{
	println("RequestConfigurationUpload()");

	cmdByte = cmdUploadConfigurations; //Upload Configurations
	cmdData[0] = 0; //MSB
	cmdData[1] = 0; //LSB
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	RequestCommand();
} //end RequestConfigurationUpload

//=====================================================================================================

public void BreakUSBValue(int passedValue)
{
	//breaks address value into properly sized bytes, either 16-bit or 32-bit		
	switch(device.IndexMemoryModel)
	{
	case 0: //standard 16-bit 		
		BuildUSBPacket(passedValue); //LSB, correct order?
		BuildUSBPacket((passedValue>>8)); //MSB  
		if(device.FillUpperData == true)	BuildUSBPacket(0); //fill upper with 0 	
		break;

	case 1: //32-bit	
		BuildUSBPacket(passedValue); 
		BuildUSBPacket((passedValue>>8)); //MSB  
		if(device.FillUpperData == true)	BuildUSBPacket(0); //fill upper with 0 		
		BuildUSBPacket((passedValue>>16)); //MSB 
		BuildUSBPacket((passedValue>>24));	
		if(device.FillUpperData == true)	BuildUSBPacket(0); //fill upper with 0 		
		break;
	} //end switch
} //end BreakUSBValue()	

//=====================================================================================================


public void RequestGammaTableUpload(int passedID)
{
	println("RequestGammaTableUpload() with ID "+passedID);
	//device.EraseBlockSize
	//device.IndexBlockSize
	
	cmdFlags = passedID;
	cmdByte = cmdGammaTableUpload;
	if(device.FillUpperData == true)  	cmdData[0] = 2; //a rule I don't like rules....
	else 	cmdData[0] = ceil(256 / (float)device.IndexBlockSize); 
	cmdData[1] = 0; 
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	RequestCommand();	
} //end RequestGammaTableUpload()


public void UploadGammaTable()
{
	//println("UploadGammaTable()");
	//Send 256 bytes for 8-bit
	int tempCount = 0;
	int i = 0;
	//if(device.FillUpperData == true) device.CurrentBlockSize = 192; // for fill upper
	//else device.CurrentBlockSize = 128;
	device.CurrentBlockSize = device.IndexBlockSize; //assumes internal index model, which all devices should have


	if(cmdFlags == 1)
	{
		println("UploadGammaTable() - User Defined");
		
		for(i = 0; i != 256; i++) 
		{	
			if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
			BuildUSBPacket(UserGammaTableArray[i]);
		}
		if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
	}
	else
	{
		println("UploadGammaTable() - Default");	

		for(i = 0; i != 256; i++) 
		{	
			if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
			BuildUSBPacket(cDefaultGammaTable[i]);
		}
		if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
	}

	UploadInProgress = false;
	redraw();
} //end func()

//=====================================================================================================

public void RequestFullUpload()
{
	//first do a save to a temp file to build the Lengths
	println("RequestFullUpload() "+IndexMapPointer);
	
	if(IndexMapPointer == -1)
	{
		ShowNotification(15); //Cannot Send with 0 Sequences
		return;
	}

	SaveUserSequencesFile("saves"+File.separator+"tempSave.txt");

	//goes through the index and checks for bad start values, only the sequences on the index
	for (int i = 0; i != IndexMapPointer+1; i++) 
	{	
		try { 	
			CheckStartVals(i);
			if(UserSequences[IndexMapArray[i]].StartValError == true && UserIgnoredAlert == false)
			{
				//confirm that start values are bad for X ask to ignore, return, a confirm re-runs
				println("Start Values for "+IndexMapArray[i]+" are bad");
				
				if(UserSequences[IndexMapArray[i]].SeqMode == mPOV || UserSequences[IndexMapArray[i]].SeqMode == mFilePlay) 
				{
					ResetStartValuesCommon(IndexMapArray[i]);	
					println("===================  Sequence Start Values Reset  ==================");	
					break;
				}
				
				if(UserSequences[IndexMapArray[i]].SeqMode == mLinked) break; //added since for legacy, it changes the startvals, which will error sometimes
				
				ConfirmBoxIDNum = 7;	
				confirmPassedID = IndexMapArray[i];
				return;
			} //end if
		} //end try
		catch(Exception e)	{
			println("Some sort of error checking start values for"+IndexMapArray[i]);
		}
	}//end for()
	UserIgnoredAlert = false;
	// END start value test

	RunParseIndex(); //updates IndexedSequenceLength with full length

	int tempExpectedPacketsIndex = 0;
	//IndexMemoryModel: 0 = 16-bit, 1 = 32-bit
	if(device.IndexMemoryModel == 0)
	{
		tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 2;//length of Index Map
		if(device.FillUpperData == true) tempExpectedPacketsIndex +=  device.MaxIndexedSequences;
	}
	else if(device.IndexMemoryModel == 1)
	{
		tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 4;//length of Index Map
		if(device.FillUpperData == true) tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 2;
	}
	
	int tempExpectedPacketsSequence = ceil((float)IndexedSequenceLength/device.SeqMemoryBlockSize); 
	
	SequenceLength = IndexedSequenceLength; //move from IndexSeqLength to 
	SequenceLength += tempExpectedPacketsIndex; // add index length
	
	println("Index Space Length, in Bytes: "+tempExpectedPacketsIndex);

	tempExpectedPacketsIndex =  ceil((float)tempExpectedPacketsIndex/device.IndexBlockSize); 
	
	device.CurrentBlockSize = device.IndexBlockSize;	//start with IndexBlockSize since that is first
	
	println("RequestFullUpload() "+SequenceLength+" : MapPointer: "+IndexMapPointer+"    CurrentBlockSize: "+device.CurrentBlockSize);
	cmdByte = cmdFullSeqUpload; //Upload Sequences
	cmdData[0] = ((tempExpectedPacketsIndex+tempExpectedPacketsSequence) >> 8) & 0xFF; //MSB
	cmdData[1] = (tempExpectedPacketsIndex+tempExpectedPacketsSequence) & 0xFF; //LSB
	cmdData[2] = IndexMapPointer;  //Max Sequences
	cmdData[3] = UserSequences[device.UserIdleSequence].assignedIDNum;   //send idle sequence ID number
	RequestCommand();
	println("ExpectedPackets: "+(tempExpectedPacketsIndex+tempExpectedPacketsSequence)+"    "+tempExpectedPacketsIndex+"     "+tempExpectedPacketsSequence);
}//end func()


public void FullUpload()
{
	//have utilized flag and an assignedID flag, check the flag, if its true the ID should be assigned, which would be its ID in firmware
	//so that way it can check, while its  sending address, if it sends the address, send the ID it is on firmware	
	println("FullUpload()");
	int tempIDnum = 0;
	int tempVal = 0;
	int tempOffset = 0;
	//final int cIndexEmptyID = 8888;
	//final int cIndexSerialID = 19999;
	//final int cIndexDMXID = 29999;
	
	//NOTE: if a sequnce is on the linker twice, it does send the address twice but not data..	
	//for (int q = 1; q != UserSequences.length; q++) UserSequences[q].IDassigned = false;

	
	for (int i = 0; i != device.MaxIndexedSequences; i++) //2 to 6 bytes per index entry
	{	
		tempVal = IndexMapArray[i];
		
		if(cIndexEmptyID == tempVal)
		{
			//now that it is at the end of the index need to scan for outside ones
			//tempIDnum++;
			break; //leave for()
			
		}
		if(cIndexDMXID == tempVal)
		{
			
			BreakUSBValue(tempDMXAdr);	
			tempIDnum++;
			println("Value DMX: "+tempDMXAdr);			
		}
		else if(cIndexSerialID == tempVal)
		{

			BreakUSBValue(tempSerialAdr);		
			tempIDnum++;
			println("Value Serial: "+tempSerialAdr);
		}	
		else
		{
			//intln("Must be a sequence "+tempVal);
			BreakUSBValue(UserSequences[tempVal].mappedROMAdr);	
			println("Value Seq"+tempVal+": "+UserSequences[tempVal].mappedROMAdr+"   "+tempIDnum);
			
			//if(UserSequences[tempVal].IDassigned == false) 	tempIDnum++;	//don't increment if on list more than once
			//else tempOffset++;
			tempIDnum++;
			//UserSequences[tempVal].IDassigned = true;
		}
	}
	println("Start extended index "+tempIDnum);
	
	for (int q = 1; q != UserSequences.length; q++) //starts at 1 since first sequence is ignored
	{
		if(UserSequences[q].assignedIDNum == tempIDnum)
		{	
			println("SEQUENCE "+q+" on extended index");
			BreakUSBValue(UserSequences[q].mappedROMAdr);
			println("Value Exte: "+UserSequences[q].mappedROMAdr);
			tempIDnum++;
			q = 0;				
		}
	}	
	
	println("Done extended index "+tempIDnum);
	
	//Finish off index with 0000s
	for (int i = (tempIDnum+tempOffset); i != device.MaxIndexedSequences; i++) 	BreakUSBValue(0);	

	println("Sent "+SendCounterB+" index bytes");

	//Switch from IndexBlockSize to Seqblocksize
	device.CurrentBlockSize = device.SeqMemoryBlockSize;

	//just for debugging
	for (int q = 1; q != UserSequences.length; q++) println("SoftSeq#: "+q+" - Assigned: "+UserSequences[q].assignedIDNum+" - LinkerAssiD: "+UserSequences[q].assignedLinkedIDNum);

	//========================= End Map Built==============================

	//send data from lowest Assigned ID
	tempIDnum = 0;
	
	//uses the temp var as the number to check for, then loops through all available sequences, looking for a match
	//		the match indicates what order they should be sent in, since that is what order their addresses are in firmware

	for (int q = 0; q != device.MaxIndexedSequences; q++)
	{
		for (int i = 1; i != UserSequences.length; i++) //starts at 1 since first sequence is ignored
		{
			//println("Loop:  Seq: "+i+" : is: "+UserSequences[i].assignedIDNum+" : Looking for:"+tempIDnum);

			if(UserSequences[i].assignedIDNum == tempIDnum)
			{	
				if(UserSequences[i].SeqMode == mLinked)
				{
					PackSendLinked(i);
				}
				else	
				{
					SendSequence(i);				
				}
				
				tempIDnum++;
				i = 0; //reset loop, will increase to 1
			}
			else if(IndexDMXAssignedIDNum == tempIDnum)
			{
				SendSequenceDataModeHeader(mDMX, tempDMXAdr);	
				tempIDnum++;
				i = 0; //reset loop, will increase to 1
			}
			else if(IndexSerialAssignedIDNum == tempIDnum)
			{
				SendSequenceDataModeHeader(mSerial, tempSerialAdr);	
				tempIDnum++;
				i = 0; //reset loop, will increase to 1
			}
		}	//end for()
		tempIDnum++;
	}
	
	println("TotalSent: "+SendCounterB);     
	println("Left to Send: "+(device.CurrentBlockSize - (SendCounter%device.CurrentBlockSize)));

	while((float)(SendCounterB%device.CurrentBlockSize) != 0)
	{  
		BuildUSBPacket(33); //send dummy
	} 
	
	println("Indexed & Sequences Sent");
	UploadInProgress = false;	//do it here not from switch()	
	redraw();
}//end FullUpload()

//=====================================================================================================

public void SendHardwarePreview()
{
	int SelSeq = PassedSequenceID; //don't really need to do this but less work

	println("SendHardwarePreview() with "+SelSeq);
	println("HWPV Length: "+UserSequences[SelSeq].Length);
	println("Data Frames: "+(UserSequences[SelSeq].SeqFrameAmount+1));

	SendSequence(SelSeq);
	
	println("TotalSent: "+SendCounterB);     
	println("Left to Send: "+(device.CurrentBlockSize - (SendCounter%device.CurrentBlockSize)));

	while((float)(SendCounterB%device.CurrentBlockSize) != 0)
	{
		BuildUSBPacket(33); //send dummy
	}
	println("HWPV Sent");
	UploadInProgress = false;	//do it here not from switch()	
	redraw();
} //end func

//=====================================================================================================

public void PackSendLinked(int SelSeq)
{
	println("PackSendLinked() : "+SelSeq+"    with "+UserSequences[SelSeq].SeqFrameAmount+" frames.");
	//data preped start transmission
	SendSequenceHeader(SelSeq);

	//8-Bit and 16-bit usage - 4(1+1+2) bytes per frame
	//Seq IDs
	for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++)
	{
		BuildUSBPacket(UserSequences[UserSequences[SelSeq].SlideFlags[i]].assignedIDNum); 	
		//println("Linked SeqAssignedID: "+(UserSequences[UserSequences[SelSeq].SlideFlags[i]].assignedIDNum)+"    On SoftID#: "+UserSequences[SelSeq].SlideFlags[i]);
	}	
	//LinkedFlags
	for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++)
	{
		BuildUSBPacket((byte)UserSequences[SelSeq].DataFrameVar[i]);
		//println("LinkedFlags: "+UserSequences[UserSequences[SelSeq].SlideFlags[i]].DataFrameVar[i]);	
	}
	//Iteration value
	for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++) 
	{
		BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]);  //iteration amount LSB
		BuildUSBPacket((UserSequences[SelSeq].SlideValues[i])>>8);	 //iteration amount	MSB		
		//println("Iterations: "+UserSequences[SelSeq].SlideValues[i]);
	}		
} //end func()

//=====================================================================================================

public void stop()
{
	try {
		myPort.dispose();
	}
	catch(Exception e) {
	}
}

//===================================================================================================	


public void SendLiveControlData()		
{
	println("SendLiveControlData()");

	if(LiveControlCheckBox[3].Selected == true) //if 16-bit mode
	{
		tempBytes = new byte[UserChannelAmt*2];
		int xx = 0;
		for (int i =0; i != UserChannelAmt; i++) 
		{
			tempBytes[xx] = (byte)((ControlSliders[i].Value >> 8)  & 0xFF); //MSB
			tempBytes[xx+1] = (byte)(ControlSliders[i].Value & 0xFF); //LSB
			xx += 2;
		}
	}
	else
	{
		//8-bit mode	
		tempBytes = new byte[UserChannelAmt];
		for (int i =0; i != UserChannelAmt; i++) 
		{
			tempBytes[i] = PApplet.parseByte(ControlSliders[i].Value);
		}		
	} //end else

	try {
	if(CommunicationMode == 0) myPort.write(tempBytes);
	else if(CommunicationMode == 1) TCPClient.write(tempBytes);	
	}
	catch(Exception e) { println("Problem with SendLiveControlData()"); }
} //end func


public void BreakValueForUSBPacket(int passedValue, int passedType)
{
//breaks address value into properly sized bytes, either 16-bit or 32-bit	
//println("Passed:" +passedValue);
	switch(passedType)
	{
	case 0: //16-bit 
		BuildUSBPacket((passedValue>>8)); //MSB  
		BuildUSBPacket(passedValue); //LSB, correct order?
		break;

	case 1: //32-bit
		BuildUSBPacket((passedValue>>24));
		//println((passedValue>>24));		
		BuildUSBPacket((passedValue>>16)); //MSB 	
		//println((passedValue>>16)); //MSB 	
		BuildUSBPacket((passedValue>>8)); //MSB  		
		//println((passedValue>>8)); //MSB  		
		BuildUSBPacket(passedValue); 
		//println(passedValue& 0xFF); 
		break;
	} //end switch
} //end BreakUSBValue()	

//================================================================================================

public void SendSequenceDataModeHeader(int passedMode,int passedAdr)
{
	println("SendSequenceDataModeHeader() with "+passedMode);
	//doesn't pass adr for checking.....
	BreakValueForUSBPacket(passedAdr, 1);//break 32-bit number into 4 bytes
	BuildUSBPacket(passedMode); //5
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);
	BuildUSBPacket(0);	
	BuildUSBPacket(0x33); //16
}


public void SendSequenceHeader(int SelSeq)
{
	/*
	32-bit(?) First bytes should be length/or address, and that should be double checked against the Index address, make sure they match or bad data
	8-bit Mode, the mode alters the header and data storing methods - Stall - Fade - Gradient - Instant - Technical(Combo)- POV - Video - Linked
	16-bit Max Frames - SeqFrameAmount
	32-bit speed - for long instants
	16-bit Sequence Channels - MSB - LSB - SeqDataSize
	8-bit Sequence Flags (T2-T1-T0-P2-P1-P0-D1-D0)
		- (3-bits) Transistion In/Start: Fade Up/Down, Instant, 6 spots for others
		- (3-bits) One shot and stop at end values, one shot and stop at start values, one shot and blank, one shot and go to next sequence, standard loop	
		- (2-bits) Data Type Single/RGB/RGBW/EXTRA
	8-bit POV Flags OR Seqeunce Transition Speed Value
		- (4-Bits) POV Flag bits 
		- (4-Bits) Enable accmeter option
	8-bit Packet Clone value or hardware specific?
	= 16 bytes	 
	*/

	BreakValueForUSBPacket(UserSequences[SelSeq].mappedROMAdr, 1);//break 32-bit number into 4 bytes
	//BuildUSBPacket(0); //Index ID MSB3
	//BuildUSBPacket(0); //MSB2
	//BuildUSBPacket(0); //LSB1
	//BuildUSBPacket(0); //LSB0
	
	BuildUSBPacket(UserSequences[SelSeq].SeqMode);
	
	//If a Video POV, send POVFramesAmount as SeqFrameAmount, same in firmware
	if(UserSequences[SelSeq].SeqMode == mPOV  && UserSequences[SelSeq].POVVideoMode == true)
		BreakValueForUSBPacket(UserSequences[SelSeq].POVFramesAmount-1, 0); //-1 for base 0, break into 16-bit number
	else BreakValueForUSBPacket(UserSequences[SelSeq].SeqFrameAmount, 0); //break into 16-bit number
	
	BreakValueForUSBPacket(UserSequences[SelSeq].Speed, 1); //break into 32-bit number
	BreakValueForUSBPacket(UserSequences[SelSeq].DataSize, 0);   //break into 16-bit number
	
	//(TF2-TF1-TF0-PM2-PM1-PM0-DT1-DT0)
	//UserSequences[SelectedSequence].SeqPlayMode = PlayModeDD.SelStr; //update to sequence object
	//UserSequences[SelectedSequence].SeqTransitionFlags = SeqTransistionDD.SelStr; //update to sequence object
	
	int tempStorage = 0; //start with all 0s
	tempStorage = UserSequences[SelSeq].DataType;
	tempStorage = (UserSequences[SelSeq].SeqPlayMode << 2) | tempStorage;
	tempStorage = (UserSequences[SelSeq].SeqTransitionFlags << 5) | tempStorage;
	BuildUSBPacket(tempStorage); //Send packed SeqFlags
	//println("SeqFlags: "+tempStorage);
	
	
	if(UserSequences[SelSeq].SeqMode == mPOV) BuildUSBPacket(cDDPOVModeValues[UserSequences[SelSeq].POVUsageMode]); //now holds POVUsageMode and maybe other stuff later....
	else if(UserSequences[SelSeq].SeqMode == mTech)
	{
	tempTotalColorChannels = updateTechTotalColorChannel(SelSeq); //globabl so can be used in send routine
	BuildUSBPacket(tempTotalColorChannels); //send special for mTech
	}
	else BuildUSBPacket(UserSequences[SelSeq].SeqTransSpeed); 	//not used but send
	

	if(device.LockChannelAmt == true)	BuildUSBPacket(0); //if true send 0 for now..
	else BuildUSBPacket(UserSequences[SelSeq].PacketCloneMode); //Packet Cloning or Hardware Specific, seems to work on hardware	
} //end SendSequenceHeader()

//================================================================================================

public void SendSequence(int SelSeq)
{
	println("SendSequence() "+SelSeq+"    Start SendCounterB="+SendCounterB);

	SendSequenceHeader(SelSeq); //send header
	
	//======================  Header Packed  =========================================
		
	//If selected, ignore global field, use sequence one
	float GlobalIntensity = (float)PApplet.parseInt(TextFields[14].Label) / 100;	
	if(IntensityOverrideCheckBox.Selected == true) GlobalIntensity = (float)UserSequences[SelSeq].SequenceIntensity / 100;
	
	int tempData = 0; //used to scale 16-bit data with GlobalIntensity

	int start = 0;
	int end = 0;
	
	println("=========="+GlobalIntensity+"==============");
	
	if(device.Bit16Mode == true)
	{
		println("Sending 16-bit data, SeqDataSize "+UserSequences[SelSeq].DataSize);
		
		//========================================

		if(UserSequences[SelSeq].SeqMode == mFade || UserSequences[SelSeq].SeqMode == mGradient || UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mTech)
		{
			//StartVals
			if(UserSequences[SelSeq].SeqMode == mInstant)
			{	
				//it is an instant or tech, build start values
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
				tempData = PApplet.parseInt(UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i] * GlobalIntensity);
				BuildUSBPacket(tempData & 0xFF); //send LSB
				BuildUSBPacket(tempData>>8); //send MSB	
				}	
			} //end != mInstant
			else if(UserSequences[SelSeq].SeqMode == mTech)
			{
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					//NOT YET ADDED NEED mTECH USAGE
				}
			}				
			else
			{
				//Handles cycleHold preload detection and stuff
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					start = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i];
					
					if(UserSequences[SelSeq].DataFrameVar[i] == UserSequences[SelSeq].SeqFrameAmount) end = UserSequences[SelSeq].DataFrames[0][i]; //wrap
					else end = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]+1][i]; //or just increment by 1 to nextframe
					
					if(start == end) 
					{				
					//BuildUSBPacket(UserSequences[SelSeq].StartValues[i]); //if same, do not scale startvalue
					tempData = PApplet.parseInt(UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i] * GlobalIntensity);
					BuildUSBPacket(tempData & 0xFF); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB						
					}
					else 
					{				
					//BuildUSBPacket(int(UserSequences[SelSeq].StartValues[i] * GlobalIntensity)); //else they are not same scale startvalue	
					tempData = PApplet.parseInt(UserSequences[SelSeq].StartValues[i] * GlobalIntensity);
					BuildUSBPacket(tempData & 0xFF); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB			
					}
				}					
			}
			if(UserSequences[SelSeq].SeqMode == mTech)
			{
				//doesn't send dataframevars always 0

			}
			else
			{
				//DataFrameVars
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
				{	  
					BuildUSBPacket(UserSequences[SelSeq].DataFrameVar[i]);
				}
			}
		} //end if with modes
			
		if(UserSequences[SelSeq].SeqMode == mInstant)
		{
			//slideflags/values are also cycle factor/hold, they are 16-bit RAM, but only send as 8-bit
			//Slide Values
			for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
			{
				BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]); 	    
			}
		
			//Slide Flags/Type
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
			{
				BuildUSBPacket(UserSequences[SelSeq].SlideFlags[i]); 
			}
		} //end SequenceMode == mInstant
		else if(UserSequences[SelSeq].SeqMode == mTech) 
		{      
			//REMOVED TIL IMPLENTED
			
		}   //end if SequenceMode == mTech
		else if(UserSequences[SelSeq].SeqMode == mPOV)
		{
		//nothing else to send other than header and data
		}
		else if(UserSequences[SelSeq].SeqMode == mLinked)
		{
		//caught before it gets here
		}	
	
		//================  START DATA  ================

println("HERE2");		

		if (UserSequences[SelSeq].SeqMode == mGradient)
		{
			//gradients always send 4 data values per frame	
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				for (int i=0; i != 4;i++)
				{
					//BuildUSBPacket(int(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
					tempData = PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity);
					BuildUSBPacket(tempData  & 0xFF); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB							
					
				} //end for()
			}//end for()	
		}
		else if(UserSequences[SelSeq].SeqMode == mTech)
		{
			/*
			for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++)
			{
				//mTech has two dataframes per frame
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					BuildUSBPacket(int(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
				} //end for()
			}//end for()	
			*/
		}
		else if(UserSequences[SelSeq].SeqMode == mPOV && UserSequences[SelSeq].POVVideoMode == true)
		{
			for (int q=0; q != UserSequences[SelSeq].POVFramesAmount;q++)
			{
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					//BuildUSBPacket(int(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
					tempData = PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity);
					BuildUSBPacket(tempData & 0xFF); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB							
				} //end for()
			}//end for()
		}//end else
		else
		{
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				//println("Sending DataFrames, iteration: "+q);
				//printArray(UserSequences[SelSeq].DataFrames[q]);
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					//BuildUSBPacket(int(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
					tempData = PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity);
					BuildUSBPacket(tempData & 0xFF); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB		
				} //end for()
			}//end for()
		}//end else
		
//========================================			
			
/*
		//send startvals for instants and POVs same as thier first frame, Linked Expects startvals, program never will call them	
		if(UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mPOV)
		{
			for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
			{  
			tempData = int(UserSequences[SelSeq].DataFrames[0][i] * GlobalIntensity);
				BuildUSBPacket(tempData); //send LSB
				BuildUSBPacket(tempData>>8); //send MSB
			}
		}
		else
		{
			for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
			{  
			tempData = int(UserSequences[SelSeq].StartValues[i] * GlobalIntensity);			
				BuildUSBPacket(tempData); //send LSB
				BuildUSBPacket(tempData>>8); //send MSB
			}
		}  
		
		//============================================================================
		for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
		{
			BuildUSBPacket(UserSequences[SelSeq].Special FrameVar[i]);//Byte
		}
		//================================
		for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
		{
			BuildUSBPacket(UserSequences[SelSeq].DataFrameVar[i]);//Byte
		}
		//================================
		for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) //integer
		{
			BuildUSBPacket(UserSequences[SelSeq].Frame Special[i]); //send LSB	  
			BuildUSBPacket(UserSequences[SelSeq].Frame Special[i]>>8); //send MSB
		}
		//================================
		if (UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mCombo)
		{
			for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
			{
				BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]); //send LSB 	  
				BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]>>8); //send MSB	  
			}
		}
		//================================
		if (UserSequences[SelSeq].SeqMode == mCombo)
		{
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
			{
				//SpeedValues removed....
			}
		} 
		
		//================================  START DATA  ================================
		
		if (UserSequences[SelSeq].SeqMode == mGradient) //only Combo has speed values for each frame
		{	  
			//gradients always use only 4 bytes per data frame	
			println("16-BIT GRADIENT DATA FRAMES NOT TESTED BUT UPDATED");
			
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				for (int i=0; i != 4;i++)
				{
				tempData = int(UserSequences[SelSeq].DataFrames[q][i]  * GlobalIntensity);			
					BuildUSBPacket(tempData); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB				
				} //end for()
			}//end for()
			
		}
		else if (UserSequences[SelSeq].SeqMode == mCombo || UserSequences[SelSeq].SeqMode == mInstant) //only Combo has speed values for each frame
		{
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				if(UserSequences[SelSeq].Frame Special[q] < 30 ) //then it is a fade or instant
				{
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
					tempData = int(UserSequences[SelSeq].DataFrames[q][i]  * GlobalIntensity);			
						BuildUSBPacket(tempData); //send LSB
						BuildUSBPacket(tempData>>8); //send MSB					  
					} //end for()
				} //end frame special if()  
			}//end for()
		}
		else
		{
			println("Sending 16-bit dataframes: "+(UserSequences[SelSeq].SeqFrameAmount+1)+" : "+UserSequences[SelSeq].DataSize);
			
		//	int x = 0;
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
				tempData = int(UserSequences[SelSeq].DataFrames[q][i]  * GlobalIntensity);			
					BuildUSBPacket(tempData); //send LSB
					BuildUSBPacket(tempData>>8); //send MSB		
				} //end for()
			}//end for()
		}//end else 
	*/
			
		println("Sent 16-bit data");
	} //end 16-bit if()
	//================================ END 16-BIT =====================================================
	else //both 8-bit and 16-bit processors run the same
	{
		//16-bit processor using 8-bit data, all frame length variables need to be sent as ints(frame special, slide, speed)
		println("Sending 8-bit data, SeqDataSize: "+UserSequences[SelSeq].DataSize);
		println("Using Intensity: "+GlobalIntensity);

		if(UserSequences[SelSeq].SeqMode == mFade || UserSequences[SelSeq].SeqMode == mGradient || UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mTech)
		{
			//StartVals
			if(UserSequences[SelSeq].SeqMode == mInstant)
			{	
				//it is an instant or tech, build start values
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i] * GlobalIntensity));			
				}	
			} //end != mInstant
			else if(UserSequences[SelSeq].SeqMode == mTech)
			{
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[0][i] * GlobalIntensity));	//builds from dataframes[][]		
				}
			}				
			else
			{
				//Handles cycleHold preload detection and stuff
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					start = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i];
					
					if(UserSequences[SelSeq].DataFrameVar[i] == UserSequences[SelSeq].SeqFrameAmount) end = UserSequences[SelSeq].DataFrames[0][i]; //wrap
					else end = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]+1][i]; //or just increment by 1 to nextframe
					
					if(start == end) BuildUSBPacket(UserSequences[SelSeq].StartValues[i]); //if same, do not scale startvalue
					else BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].StartValues[i] * GlobalIntensity)); //else they are not same scale startvalue
					
					//println("Preload: "+i+"    "+UserSequences[SelSeq].StartValues[i]+"       "+start+"     "+end);
				}					
			}
			
			if(UserSequences[SelSeq].SeqMode == mTech)
			{
				//doesn't send dataframevars always 0

			}
			else
			{
				//DataFrameVars
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
				{	  
					BuildUSBPacket(UserSequences[SelSeq].DataFrameVar[i]);
				}
			}
		} //end if with modes
			
		if(UserSequences[SelSeq].SeqMode == mInstant)
		{
			//Slide Values
			for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
			{
				BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]); 	  
			}
		
			//Slide Flags/Type
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
			{
				BuildUSBPacket(UserSequences[SelSeq].SlideFlags[i]); 
			}
		} //end SequenceMode == mInstant
		else if(UserSequences[SelSeq].SeqMode == mTech) 
		{      
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++) 
			{
				//Per ColorChannel[i] per frame[q]
				for (int i=0; i != tempTotalColorChannels;i++) 
				{
					BuildUSBPacket(UserSequences[SelSeq].TechFlags[q][i]); 	  
				} 	  
			}
		
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++) 
			{
				//Per color channel, perframe 16-bit speed values
				for (int i=0; i != tempTotalColorChannels;i++) 
				{
					BuildUSBPacket(UserSequences[SelSeq].TechTime[q][i]>>8); //send MSB
					BuildUSBPacket(UserSequences[SelSeq].TechTime[q][i]); //send LSB  	  
				}	
			}
		}   //end if SequenceMode == mTech
		else if(UserSequences[SelSeq].SeqMode == mPOV)
		{
		//nothing else to send other than header and data
		}
		else if(UserSequences[SelSeq].SeqMode == mLinked)
		{
		//caught before it gets here
		}	
	
		//================  START DATA  ================

		if (UserSequences[SelSeq].SeqMode == mGradient)
		{
			//gradients always send 4 data values per frame	
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				for (int i=0; i != 4;i++)
				{
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
				} //end for()
			}//end for()	
		}
		else if(UserSequences[SelSeq].SeqMode == mTech)
		{
			for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++)
			{
				//mTech has two dataframes per frame
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
				} //end for()
			}//end for()	
		}
		else if(UserSequences[SelSeq].SeqMode == mPOV && UserSequences[SelSeq].POVVideoMode == true)
		{
			for (int q=0; q != UserSequences[SelSeq].POVFramesAmount;q++)
			{
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
				} //end for()
			}//end for()
		}//end else
		else
		{
			for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
			{
				//println("Sending DataFrames, iteration: "+q);
				//printArray(UserSequences[SelSeq].DataFrames[q]);
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{	
					BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
				} //end for()
			}//end for()
		}//end else
	}	
} //end SendSequence()

//=====================================================================================================


public String trimString(String passedStr, int passedAmt)
{
	//quick fix function, can't change portName directly as its needed for referencing, only draw
	//	 does it need to be trimmed
	//shorten, similar as initcomports
	if (passedStr.length()  > passedAmt) //7 chars long max....
	{ 
		int varStart = passedStr.length()  - passedAmt; 
		int varEnd =  passedStr.length() ;
		passedStr = passedStr.substring(varStart, varEnd);
	}	
	return passedStr;
}


public void draw() 
{
	scale(SF, SF);
	//println("draw()");
	
	/*
	//was trying to drop USB during reprograms
	try {
myPort.setDTR(false); //DEBUG	
	}
	catch(Exception e)
	{
		CloseCommunicationPort();
	}
	*/
	
	//can't close from serial event or other threads, so do it here
	if(CloseCOMFlag == true) { CloseCOMFlag = false; CloseCommunicationPort(); }
	
	//start play mode
	if(GraphicLayoutPreview == true)
	{	
		if(SelectedMenuTab != 0) 
		{	
			GraphicLayoutPreview = false;

			println("Preview Playback Cancelled");
			GraphicLayoutPreview = false;
			SetSelectedFrame(0); 		
			MenuTabs[0].refresh();	
		}
		else
		{
			if(SelectedFrame < UserSequences[SelectedSequence].SeqFrameAmount)
			{
				
				SetSelectedFrame(SelectedFrame+1); 			
				MenuTabs[0].refresh(); //will run either GraphicLayoutUpdateIcons();	 or the other based on Advanced Layout	
				image(GraphicLayoutBuffer, cGLBufx, cWorkspaceY, GraphicLayoutBuffer.width, GraphicLayoutBuffer.height);
				return; //nothing else too do
			}
			else 
			{
				println("End Of Software Preview Playback");
				GraphicLayoutPreview = false;
				SetSelectedFrame(0); 		
				MenuTabs[0].refresh();	
			}
		}
		return; //added
	}
	//end preivew play back

	//Start Drawing
	background(cBackgroundColor);
	
	//draw frame
	stroke(cBorderColor);
	strokeWeight(2);
	line(125, 30, 125, 600); //vertical left side bar divider
	line(0, 30, 800, 30); //top divider bar
	line(0, 80, 125, 80); //status horiz divider
	noStroke();  
	
	mouseXS = round((float)mouseX / SF); //update the mouse positions with scale
	mouseYS = round((float)mouseY / SF);		
	
	image(fullNameImg, 3, 3, fullNameImg.width, fullNameImg.height);

	textAlign(LEFT);
	fill(cWorkspaceFont);
	textSize(12);

	if(CommunicationMode == 0) text("Status:\n"+trimString(portName,7), 5, 50);
	else if(CommunicationMode == 1)  text("Status:\nTCP\n"+TCPip+":"+TCPport, 5, 50); 
	DeviceConnect.display();
	
	if(GraphicImageResize == true && ImageDraggingState > 0)
	{
		int newWidth = 0;
		int newHeight = 0;

		switch(ImageDraggingState)
		{
		case 1:
			//find difference
			newWidth = (mouseXS - GraphicImageInitX);
			newHeight = (mouseYS - GraphicImageInitY);

			newWidth = GraphicImageWidth - newWidth;
			newHeight = GraphicImageHeight - newHeight;

			GraphicImageWidth = newWidth;
			GraphicImageHeight = newHeight;

			GraphicImageInitX = mouseXS; 
			GraphicImageInitY = mouseYS;

			GraphicImageX = mouseXS-cGLBufx;
			GraphicImageY = mouseYS-cWorkspaceY;
			break;

		case 2:	

			break;
			
		case 3:	
			//find difference
			newWidth = (GraphicImageInitX - mouseXS);
			newHeight = (GraphicImageInitY - mouseYS);

			newWidth = GraphicImageWidth - newWidth;
			newHeight = GraphicImageHeight - newHeight;

			GraphicImageWidth = newWidth;
			GraphicImageHeight = newHeight;

			GraphicImageInitX = mouseXS; 
			GraphicImageInitY = mouseYS;

			//GraphicImageX = (mouseXS-(GraphicImageWidth))-cGLBufx;
			//GraphicImageY = (mouseYS-(GraphicImageHeight))-cWorkspaceY;
			//	GraphicImageX = (mouseXS-GraphicImageWidth)-cGLBufx;
			//GraphicImageY = (mouseYS-GraphicImageHeight)-cWorkspaceY;
			break;	
			
		case 5: //center move
			newWidth = (GraphicImageInitX - mouseXS);
			newHeight = (GraphicImageInitY - mouseYS);

			GraphicImageInitX = mouseXS; 
			GraphicImageInitY = mouseYS;

			GraphicImageX = GraphicImageX - newWidth;
			GraphicImageY = GraphicImageY - newHeight;

			GraphicImageWidth = GraphicImageWidth - newWidth;
			GraphicImageHeight = GraphicImageHeight - newHeight;

			break;
		} //end switch

		//common
		GraphicLayoutBuffer.beginDraw();
		GraphicLayoutBuffer.background(cBackgroundColor);
		handlerDrawImageHandles();
		GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,(ImageHandleTR.xpos - ImageHandleTL.xpos)+10,(ImageHandleBL.ypos - ImageHandleTR.ypos)+10);
		handlerDrawImageHandles();
		GraphicLayoutBuffer.endDraw();
	}	
	//end Image Resize
	
	if (SelectedMenuTab == 0 || SelectedMenuTab == 1)
	{
		//displays frame info on left side
		//image(sequencesImg, 675, 0, sequencesImg.width, sequencesImg.height);
		//There are currently 4 states, Tools, Sequ, Page Tools, Per Frame Stuff
		//COMMON
		fill(cBorderColor);
		rect(0,80,125,60);
		
		ToolTabs[0].display();
		ToolTabs[1].display();
		ToolTabs[2].display();
		ToolTabs[3].display();
		//SequenceMenuButton.display(); //NOT DISPLAYED HERE DOES IT AT END

		switch(SideBarMenuState)
		{
		case 0:
			stroke(cBorderColor);
			strokeWeight(2);
			line(0, 350, 125, 350); //vertical left side bar divider
			noStroke(); 
			
			//SEQUENCE
			textSize(11);
			text("Single - RGB - RGBW", SeqCheckBoxes[0].xpos-10, SeqCheckBoxes[0].ypos-5);  				
			textAlign(CENTER);
			textSize(14);
			text("Speed: ", 62, SequenceSpeedObject.ypos-5);  
			text(UserSequences[SelectedSequence].UserID+"\nID #"+SelectedSequence, 62, 160);
			text("Num. of Channels:", 62, 370); 	
			text("Extended Pixels:\n"+(UserSequences[SelectedSequence].DataSize*(UserSequences[SelectedSequence].PacketCloneMode+1))/CurrentDataTypeMult, 62, 460); 	
			if(CurrentPixelUsage < DefinedPixelUsage)	text("Displayed:"+CurrentPixelUsage, 62, 490); 	
			else	text("Displayed:"+DefinedPixelUsage, 62, 490); 	
			
			text("Transition In:", 62, SeqTransistionDD.ypos-5); 	
			text("Play Mode:", 62, PlayModeDD.ypos-5); 	
			
			textAlign(LEFT);  		
			text("Intensity: ", 5, TXTFSeqIntensity.ypos+20);  	
			
			
			for (int i =0; i != SeqCheckBoxes.length; i++) SeqCheckBoxes[i].display();
			TXTFSeqIntensity.display();	
			SequenceChannelObject.display();
			SequenceSpeedObject.display();
			SequenceModeDD.display();
			PacketCloneDD.display();

			SeqTransistionDD.display();
			PlayModeDD.display();
			
			break;
		case 1:
			//TOOLS
			StartValReset.display();
			GradientGenerate.display();	
			GradientStepsObject.display();
			
			GradientMultiplierObject.display();
			GradientDrawRadialButton.display();
			GradientDrawLinearButton.display();				
			
			MainToolsAllSame.display();
			GraphicFuncPaintButton.display();
			MainToolsColorGroup.display();	
			MainToolsShowStartValues.display();
			
			for (int i =0; i != PaintRects.length; i++) 
			{
				if(PaintRectID == i)
				{
					fill(cColButtonsHL);
					rect(PaintRects[i].xpos-2,PaintRects[i].ypos-2,PaintRects[i].bWidth+4,PaintRects[i].bHeight+4);
					
				}
				PaintRects[i].display();
			} //end for()


			fill(255);
			textSize(14);
			textAlign(LEFT);
			text("Gradient Steps:", 10, GradientStepsObject.ypos-5);		
			textAlign(CENTER);	
			text("Multiplier:", 62, 465);
			text("Start ValueTools:",62, 305);
			text("Graphic Tools:",62, 380);
			
			text("Paint Multiple:",62,255);			
			textSize(18);		
			text("Main Tools:",62,165);		
			
			stroke(cBorderColor);
			strokeWeight(2);
			line(0, 505, 125, 505);
			noStroke();  		
			
			break;
		case 2://Frame Tools
			CopyFrameButton.display();
			PasteFrameButton.display();
			
			for (int i =0; i != FrameCheckBoxes.length; i++) FrameCheckBoxes[i].display();
			
			TextFields[0].display(); //slide value
			TextFields[6].display(); //frame speed		
			textSize(12);
			textAlign(CENTER);
			fill(cWorkspaceFont);
			text("Single-RGB-RGBW", 62, FrameCheckBoxes[0].ypos-10);
			textSize(14);		
			text("Slide Value:", 62, TextFields[0].ypos-5);
			text("Frame Mode:", 62, FrameSeqToolInsantDD.ypos-5); 
			text("Cell Speed:",62,TextFields[6].ypos-5);
			
			if(UserSequences[SelectedSequence].SeqMode != mTech) text("Special Frame\nOptions:" , 62, 260);	
			else text("Frame Options:\n\nTech Mode:\nChannel: "+(SelectedTechID+1)+"\nFrame: "+(((SelectedTechFrame+1)/2)+1), 62, 250);	
			

			textSize(18);			
			text("Slide Options", 62, TextFields[0].ypos-30); 		
			text("Frame Tools:\nFrame "+(SelectedFrame+1),62,165);

			FrameSeqToolInsantDD.display(); //only one displays, other is disabled through status
			FrameSeqToolTechDD.display();//only one displays, other is disabled through status
			
			break;		
		case 3: //Icon tools
			MouseIconPlace.display();
			MouseIconRemove.display();
			MouseIconReset.display();
			EnableGroupMode.display(); 
			IconToolGroupIDDec.display();
			IconToolGroupIDInc.display();
			
			if(SelectedMenuTab == 0) GraphicPreviewPlayPause.Status = 0; //enable
			else GraphicPreviewPlayPause.Status = 1; //grey out
			GraphicPreviewPlayPause.display();
			
			fill(255);
			textAlign(CENTER);

			textSize(18);		
			text((FunctionGroupIDNum+1),62, IconToolGroupIDDec.ypos+20);
			text("LED Icon\nTool Options:",62,165);
			
			textSize(14);	
			text("Icon Placement:\n(Manual Only)",62, MouseIconPlace.ypos-25);
			text("Enable Group\nAssignment:",62, EnableGroupMode.ypos-25);
			text("Assigned\nGroup ID:",62, IconToolGroupIDDec.ypos-30);	
			text("Sequence Soft\nPreview:",62, 210);		
			
			textSize(12);	
			text("(Not Fully\nImplemented Yet)",62, 275);	
			
			stroke(cBorderColor);
			strokeWeight(2);
			line(0, 450, 125, 450);
			line(0, 295, 125, 295);
			noStroke();  
			
			break;
		} //end switch
	} // end if (SelectedMenuTab == 0 || SelectedMenuTab == 1)

	for (int i =0; i != MenuTabs.length; i++) MenuTabs[i].display();  

	//==============================================================================================================     

	if (GlobalDragging == true)
	{
		HandleSliders(true); //true makes it run move(), false doesn't allow it
	} //end global dragging if

	//====================================START MAIN TAB SWITCH==========================================================================    

	switch(SelectedMenuTab)
	{
	case 0: //graphic layout
		DisplayFrameButtons();

		if(SelectedSequence == 0)
		{
			textAlign(CENTER);
			fill(cWorkspaceFontColor);
			textSize(18);	
			text("Please connect a device or\nload a device file to create a Sequence.", 465, 270);
			textAlign(LEFT);
			break;
		}
		
		if (UserSequences[SelectedSequence].SeqMode == mLinked)
		{
			DrawLinkedBuffer(); //draws from buffer
			break;
		}
		else if(UserSequences[SelectedSequence].SlideFlags[SelectedFrame] > 0)
		{	
			textAlign(CENTER);
			fill(cWorkspaceFontColor);
			textSize(18);
			text("Frame is Set as Slide. Edit Variables on Left Side Menu.", 465, 270);
			textAlign(LEFT);
			break;
		}		
		else
		{
			image(GraphicLayoutBuffer, cGLBufx, cWorkspaceY, GraphicLayoutBuffer.width, GraphicLayoutBuffer.height);
		} //end else
		
		
		if(GradientDrawInit == true) 	//draws GradientDraw line	
		{	
			stroke(255);
			strokeWeight(2);	
			
			switch(GradientDrawState)
			{
			case 1: //radial
				//draw radial	
				line(GradientDrawStartX,GradientDrawStartY,mouseXS, mouseYS); //draw the line

				float maxDistX = dist(GradientDrawStartX, 0, mouseXS, 0);
				float maxDistY = dist(0, GradientDrawStartY, 0, mouseYS);

				stroke(cBorderColor);
				if(mouseXS > GradientDrawStartX)
				{
					if(mouseYS > GradientDrawStartY)
					{
						//stroke(0);
						line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX - maxDistX), (GradientDrawStartY - maxDistY));	
					}
					else
					{
						//stroke(0, 255, 0);
						line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX - maxDistX), (GradientDrawStartY + maxDistY));	
					}
				}
				else
				{
					if(mouseYS > GradientDrawStartY)
					{
						//stroke(0, 0, 255);
						line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX + maxDistX), (GradientDrawStartY - maxDistY));		
					}
					else
					{
						//stroke(255, 0, 0);
						line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX + maxDistX), (GradientDrawStartY + maxDistY));
					}
				}
				break;
			case 2: //linear gradient
				line(GradientDrawStartX,GradientDrawStartY,mouseXS, mouseYS); //draw mouse line
				stroke(0);
				
				//int X1, X2, Y1, Y2, X3, Y3, X4, Y4;
				X1 = GradientDrawStartX + (mouseYS - GradientDrawStartY);
				Y1 = GradientDrawStartY + (GradientDrawStartX - mouseXS);
				X2 = GradientDrawStartX + (GradientDrawStartY - mouseYS);
				Y2 = GradientDrawStartY + (mouseXS - GradientDrawStartX);
				line(X1,Y1, X2, Y2); //draw top of T line				

				X3 = mouseXS + (mouseYS - GradientDrawStartY); //update for later use
				Y3 = mouseYS + (GradientDrawStartX - mouseXS); 
				X4 = mouseXS + (GradientDrawStartY - mouseYS);
				Y4 = mouseYS + (mouseXS - GradientDrawStartX);
				break;		
			} //end switch
			
			noStroke();
		} //end if gradientDraw mode

		if(MouseIconPlace.Selected == true && mouseYS > cWorkspaceY && mouseXS > cWorkspaceX)
		{
			fill(255);
			stroke(0);
			rect(mouseXS,mouseYS,LEDSize,LEDSize);
			fill(0);
			text("#",mouseXS+(LEDSize/4),mouseYS+LEDSize-(LEDSize/4));
		}
		
		//detects mouse over of LED Icons and displays it's ID number					
		for (int i = 0; i != CurrentPixelUsage; i++)
		{
			try {
				if (PixelIcon[i].over() && PixelIcon[i].GroupID == ViewGroupIDNum)
				{								
					textSize(14);
					fill(0);
					text((PixelIcon[i].ChanID+1),mouseXS+1,mouseYS+1);	
					fill(255);
					text((i+1),mouseXS,mouseYS);		
				}
			}
			catch(Exception e){}
		}	
		break;
		//==============================================================================================================    	
	case 1: //Time Line

		if(SelectedSequence == 0)
		{
			textAlign(CENTER);
			fill(cWorkspaceFontColor);
			textSize(18);			
			text("Please connect a device or\nload a device file to create a Sequence.", 465, 270);
			textAlign(LEFT);
			break;
		}

		if (UserSequences[SelectedSequence].SeqMode == mLinked)
		{
			DrawLinkedBuffer();			
		}
		else if(UserSequences[SelectedSequence].SeqMode == mPOV)
		{
			POVModeButton.display();
			POVVideoModeCheckBox.display();
			
			//display POVConfigType buttons and overrlays
			for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].display();			
			image(povButtonsImgs[3], POVOptionButtons[3].xpos,POVOptionButtons[3].ypos);	
			image(povButtonsImgs[2], POVOptionButtons[2].xpos,POVOptionButtons[2].ypos);	
			image(povButtonsImgs[1], POVOptionButtons[1].xpos,POVOptionButtons[1].ypos);	
			image(povButtonsImgs[0], POVOptionButtons[0].xpos,POVOptionButtons[0].ypos);		

			textSize(16);
			text(cPOVDescriptionsSecond[UserSequences[SelectedSequence].POVConfigType]+"\n"+cPOVDescriptions[UserSequences[SelectedSequence].POVConfigType],cPOVBufX+10,555,520,100);		
			
			fill(255);
			textSize(14);
			text("Point of Vision(POV) Mode:", cPOVBufX+10,55);
			text("Enable POV Video Mode\n(Load Video File To Enable)", POVVideoModeCheckBox.xpos+25, POVVideoModeCheckBox.ypos+15);				
			textSize(12);
			text("View Width: "+POVGraphicBuffer.width+" View Height: "+POVGraphicBuffer.height+"\nImage Width:"+POVImg.width+" Image Height: "+POVImg.height, 460, 50);
			text("P.O.V. Usage Mode:\nAllows a gap/empty space to be placed between frames.\nMakes it look like a grid instead of streaks.", POVModeDD.xpos, POVModeDD.ypos-35);	
			
			if(POVVideoModeCheckBox.Selected == true)
			{
				text("Frame Number: "+(MovieFrameCount+1)+" / "+((float)UserSequences[SelectedSequence].POVFramesAmount / (float)(UserSequences[SelectedSequence].SeqFrameAmount+1)), 140, 145);
				
				POVRestart.display();
				POVPlay.display();
				POVPause.display();	
				
				if(PlayVideoFlag == true)
				{						
					DrawPOVBuffer(); //utilize video frame for display through buffer
					POVVidFrame+=(UserSequences[SelectedSequence].SeqFrameAmount+1);	
					MovieFrameCount++;
					
					if(POVVidFrame == UserSequences[SelectedSequence].POVFramesAmount)
					{
						println("Draw() resetting POVVidFrame & MovieFrameCount");
						POVVidFrame = 0;
						MovieFrameCount = 0;
					}				
				}
				else noLoop();
				
				
				if(TranscribingFinished == true)
				{
					TranscribingFinished = false;	
					moviePOV.dispose();			
					DrawPOVBuffer();
				}
			} //end POVVideoModeCheckBox if
			
			try
			{
				image(POVBuffer, cPOVBufX, cPOVBufY, cPOVBufWidth, cPOVBufHeight);
			}
			catch(Exception e)
			{
				println("Null POVBuffer");
			}

			if(HoldMovieTranscribe == false)
			{
				fill(255);
				textSize(24);	
				text("VIDEO TRANSCRIBING - WAIT",cPOVBufX+150+2, cPOVBufY+150+2);	
				fill(255,0,0);			
				text("VIDEO TRANSCRIBING - WAIT",cPOVBufX+150, cPOVBufY+150);	
			}
			
			POVModeDD.display();
		}	
		else if(UserSequences[SelectedSequence].SeqMode == mFilePlay)
		{		
			fill(255);
			textSize(16);
			text("File Play Mode: ", 135,55);	
			text("Frames: "+UserSequences[SelectedSequence].SeqFrameAmount, 415,55);			
			//image(FilePlayBuffer, cTLChBufX, cTLChBufY, FilePlayBuffer.width, FilePlayBuffer.height);

			TempImgTimeLine = TimeLineBuffer.get(0, TLScrollValue, cTLGraphBufW, cTLChBufViewH); //change the second number with scroll bar value
			image(TempImgTimeLine, cTLChBufX, cTLChBufY, TempImgTimeLine.width, TempImgTimeLine.height);

			FilePlayLoadButton.display();
			TimeLineScrollBar.display();
			DisplayFrameButtons();
		}
		else if(UserSequences[SelectedSequence].SeqMode == mTech)
		{		
			fill(255);
			textSize(14);
			text("Technical Mode: ", 260,55);	
			textSize(12);			
			text("Pixel#   Info", 135,60);	
			
			image(TechnicalBuffer, cTLChBufX, cTLChBufY, TechnicalBuffer.width, TechnicalBuffer.height);	

			//TEMP
			textSize(24);
			fill(255,0,0);
			text("NOT YET ADDED\nCOMING SOON", 300,200);	
			//END TEMP
			
			TechnicalScrollHoriz.display();
			TechnicalScrollVert.display();	
			DisplayFrameButtons();
		}		
		else
		{
			//Normal Timeline
			//textFont(fDigital, 48);	
			try {
				for (int i =0; i != TimeLineFrameButtons.length; i++) TimeLineFrameButtons[i].display();				
			}
			catch(Exception e) {  }
			
			noStroke();
			textFont(fNormal, 48);
			textSize(14);
			fill(255);	

			//display startval info		
			//if(UserSequences[SelectedSequence].StartValError == true) text("Bad Start Value(s) has been detected, please adjust the purple indicator(s), press Reset, or press Generate for Gradients", 220, 40, 440, 100);				
			//else text("Start Values allow a Color Channel to start at a selected position in the Sequence. Drag indicators to adjust.", 220, 40, 440, 100);				
			try {
				TempImgTimeLine = TimeLineBuffer.get(0, TLScrollValue, cTLGraphBufW, cTLChBufViewH); //change the second number with scroll bar value
				image(TempImgTimeLine, cTLChBufX, cTLChBufY, TempImgTimeLine.width, TempImgTimeLine.height);
			}
			catch(Exception e)  { }
			
			TimeLineScrollBar.display();
			
			//Draws the verticle lines indicating the frame division, this overlays the buffer
			for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
			{
				noStroke();
				fill(255);
				rect(35+cTLChBufX+(TimeLineCellSize*q), cTLChBufY-5, 1, cTLChBufViewH); //line that indicates Frames
			}//end for()
			
			DisplayFrameButtons();		
		}	
		break;
		//==============================================================================================================    
	case 2: //Connection
		try {
			TempImgIndex = IndexScrollBuffer.get(0, (IndexScrollBar.Value*cSeqTileVertSpace), 180, 580); //change the second number with scroll bar value
			image(TempImgIndex, 596, cWorkspaceY, TempImgIndex.width, TempImgIndex.height);
		}
		catch(Exception e) { } 
		
		for (int i =0; i != ConnectionButtons.length; i++) ConnectionButtons[i].display();
		IndexScrollBar.display();
		HardwarePrevIcon.displaySq();
		IntensityOverrideCheckBox.display();	
		TextFields[14].display();
		
		//Set Idle Icon base on variable
		IdleSequenceIcon.displaySq(); //display blank square
		//if an Idle Sequence is enabled and set, display the tile over idle sequence
		if(device.UserIdleSequence > 0) UserSequences[device.UserIdleSequence].displayIcon(IdleSequenceIcon.xpos,IdleSequenceIcon.ypos);

		
		fill(cWorkspaceFont);   
		textSize(18);
		text("User Settings and Upload:", 135, 110);
		text("Upload To Device:", 135, 440);	
		
		textSize(14);
		text("Hardware Preview:", HardwarePrevIcon.xpos-10, HardwarePrevIcon.ypos-10);		
		text("Global Intensity(%):", TextFields[14].xpos-30, TextFields[14].ypos-5);		
		text("Idle Sequence:", IdleSequenceIcon.xpos+5, IdleSequenceIcon.ypos-10);				
		text("Use Per\nSequence\nIntensity:", IntensityOverrideCheckBox.xpos-80, IntensityOverrideCheckBox.ypos-10);				
		
		textSize(12);
		text("Select which sequences you wish to upload to the controller and the order they will be selected when pressing the device's button(s)\nUsage: Click a sequence tile or the Add a Sequence tile.", 135, 120, 450, 500);
		text("Complete Your Color Sequences and Create the Index to the left. When ready, click 'Upload Sequences and Index' button. To upload Configurations(options on Hardware Tab), press the 'Upload Configurations' button.", 135, 450, 450, 500);
		
		textAlign(CENTER);		
		text("Uses Global or Per Sequence Intensity\n(Enable Below)", HardwarePrevIcon.xpos, HardwarePrevIcon.ypos+90, 120, 100);
		text("(Click to Select)\n(Right Click to Clear)\nUploaded with Index\n& Sequences", IdleSequenceIcon.xpos+55, IdleSequenceIcon.ypos+100);
		textAlign(LEFT);


		stroke(cBorderColor);
		strokeWeight(2);
		line(cWorkspaceX, 410, 596, 410);		
		line(cWorkspaceX, 80, 596, 80);	
		noStroke();  
		break; //end connection tab
		//==============================================================================================================    		
	case 3: //software
		for (int i =0; i != SoftwareButtons.length; i++) SoftwareButtons[i].display();
		for (int i =0; i != SoftwareCheckBox.length; i++) SoftwareCheckBox[i].display();

		//not sure where else to handle this
		if(ConfigShape != 5) SoftwareButtons[3].Status = 1;
		else  SoftwareButtons[3].Status = 0;
		
		
		TextFields[3].display(); //User ID Field
		TextFields[11].display(); //user Channel Amount
		PixelAmountObject.display();
		IconLayoutAdvancedMode.display();
		
		image(auroraLogoImg, 145, 45, 120, 140);
		image(fullNameRGB, 230, 235, 350, 90);
		
		fill(cWorkspaceFont);
		textSize(16);
		textAlign(CENTER);
		text("Click the function button then click on an Icon to the right.", 600, 195, 200, 240);
		text("Default Channel Amount:\n"+UserChannelAmt+" out of "+device.Channels, 230, 340);  	
		textAlign(LEFT);	
		textSize(14);	
		text("Only used for Live Control and for the default channel amount when creating a new sequence. It does not affect any sequences already created.", 330, 330,265,400);  	

		text("Written in Proccesing\nwww.Processing.org", 290, 60);
		text("Software Version: "+cSoftwareV+"\nSoftware Revision: "+cRevisionIDstr[cSoftwareR], 290, 150);
		text("Graphic Layout\nImage Options:", 140, 425);  		
		text("Window Size:", 5, 100);  
		text("Graphic Layout Options:", 290, 420);  		
		
		textSize(12);		
		textAlign(RIGHT);	
		text("Small:\n\nMedium:\n\nLarge:", 755, 435);  //size
		text("None:       Small:", 780, 525);  //spacing
		text("Medium:       Large:", 785, 565);  //spacing		
		textAlign(LEFT);	
		textSize(14);		
		text("Pixel Map File: "+SelectedFilePathCondensed, 295, 595);  				
		text("Pixel Icon Size:", 680, 420);
		text("Pixel Icon Spacing:", 660, 510);
		text("Square Icons:",SoftwareCheckBox[7].xpos-35,SoftwareCheckBox[7].ypos-5);		
		text("Advanced Layout Mode", IconLayoutAdvancedMode.xpos+25, IconLayoutAdvancedMode.ypos+15);  
		text("(Native)",SoftwareButtons[11].xpos+20,SoftwareButtons[11].ypos+40);

		textSize(12);	
		text("Updates and Information: www.NLEDshop.com/nledaurora\nCopyright© 2017 Northern Lights Electronic Design, LLC", 140, 200);
		textSize(16);
		text("Group Function ID:",LayoutGroupDec.xpos-20,LayoutGroupDec.ypos-10);
		text("Pixel Icon Amount:",PixelAmountObject.xpos-20,PixelAmountObject.ypos-10);		
		textSize(20);			
		text(FunctionGroupIDNum+1,LayoutGroupDec.xpos+45,LayoutGroupDec.ypos+20);
		

		
		ImageRemoveButton.display();
		ImagePlaceButton.display();
		ImageResizeButton.display();		
		ImageResetButton.display();
		LayoutGroupInc.display();	
		LayoutGroupDec.display();	
		ShapeOptionsDD.display();	

		stroke(cBorderColor);
		strokeWeight(2);  
		line(280, 400, 280, 600);		
		line(125, 400, 800, 400);
		line(600, 30, 600, 400);	
		line(125, 225, 600, 225);	
		line(600, 145, 800, 145);	//above clear sequence button
		line(125, 320, 600, 320);	//above use channelamt area		
		noStroke();
		break;		
		//==============================================================================================================
	case 4: //hardware
		
		try {
			for (int i =0; i != COMButtons.length; i++) COMButtons[i].display();
		}
		catch(Exception e) { }
		
		float tempUsage = ((float)IndexedSequenceLength/(float)device.DataSpace) * 100;
		
		DeviceWebpage.display();
		RequestConfigurations.display();
		EnterBootloaderButton.display();
		OpenTCPButton.display();
		HardwareTabUploadConfigurations.display();

		if(device.BasicVersion > 0) //calculates the percentage for BasicVersion devices, since its done differently
		{	
			int tempHold = 0;
			for (int i =1; i != UserSequences.length; i++) tempHold = tempHold + UserSequences[i].SeqFrameAmount;
			tempUsage = tempHold / ((float)device.DataSpace / (float)device.Channels);	
			tempUsage = tempUsage * 100;
		}	

		textSize(16);
		fill(cWorkspaceFont);
		textAlign(LEFT);
		text(device.Name, 140, 55);

		textSize(14); 
		textLeading(20);
		
		try {
			if(device.FirmwareVersion > 100)
			{
				text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: Unverified-"+(device.FirmwareVersion-100)+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 135, 80);
			}
			else
			{	
				text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: "+device.FirmwareVersion+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 135, 80);  
			}
		}
		catch(Exception e) { }
		
		text("Bootloader Version: "+device.BootloaderVersion+"\nUser Configured ID#: "+device.UserConfiguredIDNum, 320, 80);  	
		
		text("Usage: "+nfs(tempUsage, 1, 2)+"%", 320, 140);   

		textAlign(CENTER); 	
		text("TCP/IP: ", 65, 100);
		text("Select\nCOM Port: ", 65, 160);
		
		textSize(20);	
		textAlign(LEFT); 		
		text("Device Configurations", 140, 180);
		
		for (int i =0; i != InputModule.length; i++) InputModule[i].display();
		
		if(DropDownPointer.Selected)	DropDownPointer.display();
		
		stroke(cBorderColor);
		strokeWeight(2);
		line(125, 150, 800, 150); //under hardware and firmware info

		//memory usage bar
		fill(0, 255, 0); //green
		rect(440, 125, 140, 15); //total box size
		fill(255, 0, 0);	//red
		rect(440, 125, round(tempUsage*1.4f), 15); //usage

		break;
		//==============================================================================================================
	}//end switch
	
	//show sequences menu button
	if (SelectedMenuTab == 0 || SelectedMenuTab == 1) image(sequencesImg, 675, 0, sequencesImg.width, sequencesImg.height);	
	
	if(OverlayMenuID > 0)
	{	
		fill(cBackgroundColor, 128);
		rect(0,0,800,600);	
		OverlayMenus[OverlayMenuID].display();
	}

	if (ColorPickerOpen == true)    ColorSelector.display();

	if (DraggingIndicator == true) DisplayDragIndicator();

	if (LiveControlUpdate == true)
	{
		try {
			//Send the built tempbytes array
			thread("SendLiveControlData");
		}
		catch(Exception e)
		{
			println("Port Not Open");
		}
		LiveControlUpdate = false;
	}//end if()

	/// MOVED FROM CONNECTION ==============================================	
	
	//Start Upload Progress Bar
	if(UploadInProgress==true)
	{
		fill(cBackgroundColor, 128);
		rect(0,0,800,600); //grey out
		stroke(cColButtonsHL);
		strokeWeight(4);
		fill(cBackgroundColor);
		rect(250,260,300,115);
		stroke(255);	
		fill(0);	
		strokeWeight(2);
		rect(270,305,260,25);
		
		textFont(fDigital, 48);
		textSize(48);
		fill(255);
		text("Upload In Progress:", 265, 290);
		
		textFont(fNormal, 48);
		noStroke();
		
		UploadProgressCancel.display();
		
		//rounds up since only full packets are expected
		UploadProgressVar = (float)SendCounterB / (float)(ceil((float)SequenceLength/(float)device.CurrentBlockSize) * device.CurrentBlockSize);

		if(SendCounterB > 10) //fixes problem with software freeze, maybe was only on basic, but either way
		{	
			
			for (int i =0; i != PApplet.parseInt(UploadProgressVar*21); i++)
			{
				colorMode(HSB, 25);
				fill(i, 25, 25);
				rect(275+(i*12),310,8,16, 6);	
			}	
			colorMode(RGB, 255);
		}
	} 	//end Upload Progress Bar		
	
	
	//================== START NOTIFICATIONS ==============================	
	
	if(ShowNotification > 0)
	{	
		pushStyle();
		//grey out entire screen
		fill(cBackgroundColor, 128);
		rect(0,0,800,600);	
		
		//set type
		textAlign(CENTER);	
		textFont(fDigital, 48);
		textSize(48);
		
		//draw area
		stroke(cColButtonsHL);
		strokeWeight(4);
		fill(cBackgroundColor);
		//calculate draw area position
		int tempStrW = PApplet.parseInt(textWidth(cNotificationText[ShowNotification]))+20;
		rect(400-(tempStrW/2),250,tempStrW,80);
		
		//draw type
		fill(255);
		text(cNotificationText[ShowNotification], 400, 300);	
		
		//restore default textsize and style
		popStyle();
	} //end if
	
	//==========================================================================================			
	
	if(ConfirmBoxIDNum > 0)
	{
		fill(cBackgroundColor, 128);
		rect(0,0,width,height);
		
		fill(cBorderColor);
		stroke(cColButtonsHL);
		strokeWeight(3);
		rect((800/2)-120,(600/2)-60, 240, 120, 20);
		fill(0);
		textSize(14);
		textAlign(CENTER);
		if(ConfirmBoxIDNum == 2) text(cConfirmBoxText[ConfirmBoxIDNum]+UserSequences[SequenceIDNum].UserID+"?", (800/2)-110, (600/2)-50, 220, 100); //delete sequence custom message
		else	text(cConfirmBoxText[ConfirmBoxIDNum], (800/2)-110, (600/2)-50, 220, 100);
		textAlign(LEFT);
		
		ConfirmButtonYes.display();
		ConfirmButtonNo.display();
	}		

	//================================== START SCREEN SIZE =======================================================================		
	
	//monitors if the user altered the screen size by dragging the window larger, and handles if resized
	if (PrevWidth != width || PrevHeight != height)
	{
		println("Window Resized to: "+width+" : "+height+" from "+PrevWidth+" : "+PrevHeight);    

		if(width < 480) { width = 480; PrevWidth = width;}// Makes minimum size 360x480
		if(displayHeight < (width/4) *3)
		{
			width = 1280; //makes maximum size 1280x960
			if(displayHeight < (width/4) *3)
			{
				width = 800; 
			}
		}
		
		surface.setSize(width, (width/4) *3);	//resizes sketch height	
		
		insets = frame.getInsets();	
		surface.setSize(width+(insets.left+insets.right),height+(insets.top+insets.bottom));	
		
		PrevHeight = height;  //used to watch if the grid window's size is changed
		PrevWidth = width;	

		SaveSoftwareConfigFile();	//save window size

		SF = (float)width / 800; //set new scale factor, 800px is the base size
		redraw();
	}//end if()
}//end draw()

//===================================================================================================	

public void LoadFilePlayModeFile(String passedFileName)
{
	println("LoadFilePlayModeFile()");	
	//Loads text file with lines as frames, comma delimiated entries
	
	String[] lines = loadStrings(passedFileName); 
	String[] WorkString = new String[cSoftwareMaxChans];	
	println(lines.length+"    "+lines[0]);
	WorkString = split(lines[0], ',');	//updates WorkString.length to move to DataSize
	
	if(lines.length > device.MaxFramesGlobal) println("FilePlay file too large");
	else {	
		//This latches the new File Play channel amount to the sequence
		//Update Sequence Frame Amount
		SetSelectedFrame(0); //since changing frameamount need to reset
		UserSequences[SelectedSequence].SeqFrameAmount = (lines.length-1); //minus 1 for base 0
		
		if(device.LockChannelAmt == false)	
		{
			if(WorkString.length > device.Channels) UserSequences[SelectedSequence].DataSize = device.Channels; //else set to max channels
			else UserSequences[SelectedSequence].DataSize = WorkString.length; //update datasize
		}
		else
		{
			//channel amount is locked
			//if(WorkString.length > device.Channels) 
			UserSequences[SelectedSequence].DataSize = device.Channels;
			//else UserSequences[SelectedSequence].DataSize = WorkString.length; //shorter than device.Channels, load anyway
		}
		
		ResizeSequenceFrameAmt(SelectedSequence); //resize to match above changes
		
		println("Loading file play, length: "+lines.length+" using Datasize: "+UserSequences[SelectedSequence].DataSize);	
		
		for(int q = 0; q < lines.length; q++)	
		{		
			WorkString = split(lines[q], ',');
			
			for(int i = 0; i < UserSequences[SelectedSequence].DataSize; i++)	//already calcd Datasize, prevents over runs
			{	
				WorkString[i] = trim(WorkString[i]);//removes any whitespace
				
				if(WorkString[i].equals("") == false)
				{
					UserSequences[SelectedSequence].DataFrames[q][i] = PApplet.parseInt(WorkString[i]);
				}
			} //end i for()
		} //end q for()
		
		UpdateSequence(SelectedSequence);
		MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
		MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 	
	} //end else
} //end func

//===================================================================================================	

public void LoadGammaTable(String passedFileName)
{
	println("LoadGammaTable()");
	//Loads a text file with comma delimited values, any format, line number, and whitespace
	//		as long as data starts on first line and every line is populated other than trailing lines
	
	String[] lines = loadStrings(passedFileName); 
	String[] WorkString = new String[256];	
	//println(lines.length+"    "+lines[0]);
	
	int lineCount = 0;
	int counter  = 0;
	
	while(lineCount < lines.length)	
	{
		WorkString = split(lines[lineCount], ',');
		
		for(int i = 0; i < WorkString.length; i++)	
		{	
			WorkString[i] = trim(WorkString[i]); //removes any whitespace
			
			if(WorkString[i].equals("") == false)
			{
				//println("Using: "+WorkString[i]+"       With: "+i);
				UserGammaTableArray[counter] = PApplet.parseInt(WorkString[i]);
				counter++;
			}
			//else println("was null");
			
		}
		//println("ran lineCount: "+lineCount);
		lineCount++;
	}
} //end LoadGammaTable()

//===================================================================================================	

public void QuickSaveFunciton()
{
	//scan save directory for save file names
	SaveUserSequencesFile("saves"+File.separator+"quicksave.txt");
}

//===================================================================================================	

public void LoadConfigFile()
{
	//config stores GUI options and default COM port
	String[] lines = loadStrings("software.ini"); 
	String[] WorkString = new String[7]; //may need to up this

	WorkString = split(lines[0], '\t');
	int tempWidth = PApplet.parseInt(WorkString[1]);
	WorkString = split(lines[1], '\t');
	int tempHeight = PApplet.parseInt(WorkString[1]);
	surface.setSize(tempWidth, tempHeight);

	WorkString = split(lines[2], '\t');
	if(portName != WorkString[1])	OpenCOMPort(WorkString[1]);
	
	WorkString = split(lines[3], '\t');	
	ProgramBaudRate = PApplet.parseInt(WorkString[1]);		
	
	WorkString = split(lines[4], '\t');	
	TCPip = WorkString[1]; //string
	
	WorkString = split(lines[5], '\t');	
	TCPport = PApplet.parseInt(WorkString[1]);
	
	WorkString = split(lines[6], '\t');	
	sEnableMouseOver = PApplet.parseInt(WorkString[1]);
	
}//end func

//===================================================================================================	

public void SaveSoftwareConfigFile()
{
	//config stores GUI options and default COM port
	println("SaveSoftwareConfigFile() - Saving software.ini");
	String[] WorkString = new String[7]; //may need to up this

	WorkString[0] = "ScreenW\t" + width;
	WorkString[1] = "ScreenH\t" + height;
	WorkString[2] = "COMPort\t" + portName;
	WorkString[3] = "Baud\t" + ProgramBaudRate;		
	WorkString[4] = "IP\t" + TCPip;	
	WorkString[5] = "Port\t" + TCPport;
	if(sEnableMouseOver == 1)	WorkString[6] = "mouseOver\t1";	//1 == true
	else	WorkString[6] = "mouseOver\t0"; //0 == false		
	
	saveStrings("software.ini", WorkString);
}//end func

//===================================================================================================	


public void fileSelected(File selection) 
{
	if (selection == null) {
		println("Window was closed or the user hit cancel.");
	} 
	else {
		println("User selected " + selection.getAbsolutePath());
		SelectedFilePath = selection.getAbsolutePath();	
		
		switch(FileBrowserAction)  
		{
		case 0: //null

			break;
		case 1: //load sequence file
			if(!CheckSequenceFileHardwareID(SelectedFilePath))
			{
				try {
					LoadUserSequencesFile(SelectedFilePath);
				}
				catch(Exception e)	{
					ConfirmBoxIDNum = 6;	//notify user and handle
				}					
			}	
			break;
		case 2: //save sequence file
			SaveUserSequencesFile(SelectedFilePath);
			break;
		case 3: //load Device File
			devStatus = "Emulated";		
			String[] lines = loadStrings(SelectedFilePath); 
			device.HardwareID = PApplet.parseInt(split(lines[0], '\t')[1]);  

			device.HardwareVersion = 0;
			device.FirmwareVersion = 0;
			device.FirmwareRevision = 0;		
			LoadDeviceFile();
			break;	  
		case 4: //load image file for POV
			
			POVFileLoadFunc();

			break;  
		case 5: //load image file for shape
			graphicImgFilePath = SelectedFilePath;
			graphicImg = loadImage(graphicImgFilePath);
			
			GraphicImageEnabled =  true;
			GraphicImageResize = true;
			
			MenuTabs[SelectedMenuTab].Selected = false;  
			SelectedMenuTab = 0;
			MenuTabs[0].Selected = true;			
			MenuTabs[0].refresh(); //update and re-init all pixel icons
			break; 	
		case 6: //load PixelMap file
			//else  
			MenuTabs[0].refresh(); //update and re-init all pixel icons
			
			SelectedFilePathCondensed = SelectedFilePath;
			PixelMapFilePath = SelectedFilePath; //store for later
			
			//if (SelectedFilePath.length() > 44)  SelectedFilePathCondensed = SelectedFilePath.substring(0, 14) + "......"+SelectedFilePath.substring(SelectedFilePath.length()-36);
			if (SelectedFilePath.length() > 34)  SelectedFilePathCondensed = SelectedFilePath.substring(0, 8) + "......"+SelectedFilePath.substring(SelectedFilePath.length()-26);
			
			ImportCustomPixelMap();
			break; 			
		case 7: //load gamma correction file
			LoadGammaTable(SelectedFilePath);
			break; 	
		case 8: //load File Play
			LoadFilePlayModeFile(SelectedFilePath);
			break; 
		}//end switch
	}//end else	
	redraw();
}//end func

//===============================================================================================================================

public boolean CheckSequenceFileHardwareID(String PassedLocation)
{
	println("CheckSequenceFileHardwareID() with "+PassedLocation); 
	String[] lines = loadStrings(PassedLocation); 
	int sLines = 0;  
	String[] WorkString = new String[20]; //was 300
	WorkString = split(lines[sLines], '\t');

	
	if(device.HardwareID != PApplet.parseInt(WorkString[4]) && device.HardwareID != 0)
	{
		println("Save file loaded different from currently connected hardware");
		ConfirmBoxIDNum = 10; //for constant and function switch()		
		return true;
	}
	return false;
} //end func


//===============================================================================================================================

public void LoadUserSequencesFile(String PassedLocation)
{
	println("LoadUserSequencesFile() - Version Independent"); 
	String[] lines = loadStrings(PassedLocation); 
	int sLines = 0;  
	String[] WorkString = new String[300]; //was 300
	println("Loading from "+PassedLocation+" : Length: "+lines.length);
	int SelSeq = 0;
	WorkString = split(lines[sLines], '\t');
	//start filling the Save File Header Information
	
	//First[1] Space SoftwareVer
	//Second[2] is SoftwareRev
	//Third[3] is Date, which is not used
	//Go to other function to Load Version 1 Files
	if(PApplet.parseInt(WorkString[1]) == 1 || WorkString[1].equals("0.99") ) { LoadUserSequencesFileVersion1(PassedLocation); return; }
	
	//=================== ELSE its version 2 ====================================================

	println("Sequence File is Version 2 - Loading From: "+PassedLocation); 

	//First Line - which save file header info 
	//SoftV - SoftRev - Month(mon/day/year) - HardwareID - UserChannelAmt - device.Channels - Sequences Length[7]
	//		ConfigShape ID - LEDSizeID - AdvancedLayout flag - ImgEnabled - ImgFilePath - ImgX - ImgY - ImgWidth - ImgHeight - 
	///	 GlobalIntensity - GlobalIntensity Enable  - IdleSequenceID - LEDSpacingID - SequencesTotalLength(not loaded)
	
	/*	
if(device.HardwareID != int(WorkString[4]) && device.HardwareID != 0)
{
	println("Save file loaded different from currently connected hardware");
	CloseCommunicationPort();
	device.HardwareID = int(WorkString[4]);	
	LoadDeviceFile();
	ConfirmBoxIDNum = 10; //for constant and function switch()							
}
*/
	
	if(devConnected == false) 
	{
		//If device not connected, load without device so set device.HardwareID otherwise if connected let it be, device file loaded
		device.HardwareID = PApplet.parseInt(WorkString[4]);			
		LoadDeviceFile(); //load device file if not already connected 
	}
	
	//fill this second so it overrides the default channel value 
	UserChannelAmt = PApplet.parseInt(WorkString[5]); 
	if(UserChannelAmt > device.Channels) UserChannelAmt = device.Channels;
	TextFields[11].Label = ""+UserChannelAmt;	//couldnt get it to work in LoadDeviceFile.....
	
	//6 Space is device.channels, filled later
	
	SequenceLength =  PApplet.parseInt(WorkString[7]); //amount of sequences in file
	
	ConfigShape = PApplet.parseInt(WorkString[8]);
	ShapeOptionsDD.SelStr = ConfigShape-1; //set drop down to loaded configshape
	
	LEDSizeID = PApplet.parseInt(WorkString[9]);
	SetLEDSizeCheckBoxes();

	IconLayoutAdvancedMode.Selected = PApplet.parseBoolean(WorkString[10]);	
	
	//Do this here I suppose
	applyGUIProfileAdvancedLayout();

	
	GraphicImageEnabled  = PApplet.parseBoolean(WorkString[11]);
	if(GraphicImageEnabled == true)
	{
		println("Using Graphic: "+WorkString[12]);		
		graphicImgFilePath = WorkString[12];
		graphicImg = loadImage(graphicImgFilePath); 		
		
		if(graphicImg == null)
		{
			//image not found
			println("Error Loading Graphic mage, defaulting");
			GraphicImageEnabled = false;
			//graphicImgFilePath = "imagelayouts"+File.separator+"default.png";	
			//graphicImg = loadImage(graphicImgFilePath); 	
			ShowNotification(24);
		} //End null if
		else
		{

			GraphicImageX = PApplet.parseInt(WorkString[13]); 	
			GraphicImageY = PApplet.parseInt(WorkString[14]);

			GraphicImageWidth = PApplet.parseInt(WorkString[15]); 	
			GraphicImageHeight = PApplet.parseInt(WorkString[16]);	
			
			//TEMP USAGE - DEGBUG, not sure what it is for
			GraphicLayoutBuffer.beginDraw();//this has to be here but not below.....
			handlerDrawImageHandles();
			GraphicLayoutBuffer.endDraw();	
			//END TEMP USAGE	
		}
	} //end GraphicImageEnabled if
	
	TextFields[14].Label = WorkString[17];	//Global Intensity	
	IntensityOverrideCheckBox.Selected = PApplet.parseBoolean(WorkString[18]);	

	device.UserIdleSequence = PApplet.parseInt(WorkString[19]);	
	
	try {
		LEDSpacingID = PApplet.parseInt(WorkString[20]);
		
		if(LEDSpacingID > 100 && LEDSpacingID < 200)  
		{	
			SoftwareCheckBox[7].Selected = true; //set Grid Icons if indicated	
			LEDSpacingID = LEDSpacingID - 100; //+100 Inidicates grid icon enable
		}
		
		if(LEDSpacingID > 2) 
		{	
			LEDSpacingID = 2; //incase it loads SequencesTotalLength, which changed order on v.2d
			SoftwareCheckBox[7].Selected = false; 
		}
	}
	catch(Exception e)
	{
		LEDSpacingID = 2; //set to DEFAULT
		SetLEDSpacingCheckBoxes();		
	}
	SetLEDSpacingCheckBoxes();	//run for either
	
	//WorkString[21] is SequencesTotalLength, not loaded
	
	//======================= SAVE FILE HEADER LOADED =======================

	//Create Sequence Objects
	UserSequences = new UserSequenceObj[SequenceLength+1];
	for (int i = 0; i != UserSequences.length; i++)
	{
		UserSequences[i] = new UserSequenceObj("User Seq "+i, i, device.Channels); 
	}

	//Now Load Sequence Header, Payload, Data
	for (SelSeq = 1; SelSeq != SequenceLength+1;SelSeq++) //starts on 1
	{
		//start sequence header
		sLines++;
		WorkString = split(lines[sLines], '\t');
		println("Loading " +SelSeq+"     Starting line#: "+(sLines+1));
		
		//UserID - Length - DataSize - SeqFrameAmount - Speed - SeqMode - SeqDataType - PlayMode - SeqTransitionFlags - SeqTransSpeed - SequenceIntensity - holdLastValue	
		
		//load Sequence Header Info
		UserSequences[SelSeq].UserID = WorkString[1].replaceAll("[^\\x00-\\x7f]", ""); //removes any non-readable characters, just in case
		UserSequences[SelSeq].Length = PApplet.parseInt(WorkString[2]);
		
		//If loading a save file with larger channel size sequences, crop them down
		if(PApplet.parseInt(WorkString[3]) > device.Channels) UserSequences[SelSeq].DataSize = device.Channels;
		else UserSequences[SelSeq].DataSize = PApplet.parseInt(WorkString[3]);	
		
		UserSequences[SelSeq].SeqFrameAmount = PApplet.parseInt(WorkString[4]);
		UserSequences[SelSeq].Speed = PApplet.parseInt(WorkString[5]);
		UserSequences[SelSeq].SeqMode = PApplet.parseInt(WorkString[6]);	
		UserSequences[SelSeq].DataType = PApplet.parseInt(WorkString[7]);
		UserSequences[SelSeq].SeqPlayMode = PApplet.parseInt(WorkString[8]);
		UserSequences[SelSeq].SeqTransitionFlags = PApplet.parseInt(WorkString[9]);
		UserSequences[SelSeq].SeqTransSpeed = PApplet.parseInt(WorkString[10]);
		UserSequences[SelSeq].SequenceIntensity = PApplet.parseInt(WorkString[11]);
		
		//try for now since older files may be lacking last 2 header values
		if(UserSequences[SelSeq].SeqMode == mPOV)
		{
			try {
				UserSequences[SelSeq].POVConfigType = PApplet.parseInt(WorkString[12]) & 0xFF; //mask off and keep LSB
				if((UserSequences[SelSeq].POVConfigType & 0x80) > 0) 
				{	
					UserSequences[SelSeq].POVVideoMode = true; //set flag
					UserSequences[SelSeq].POVConfigType = UserSequences[SelSeq].POVConfigType & 0x7F; //mask off MSB
				}
				
				UserSequences[SelSeq].POVUsageMode = (PApplet.parseInt(WorkString[12]) >> 8); //use bits 8-15
				UserSequences[SelSeq].POVFramesAmount = PApplet.parseInt(WorkString[13]);
			}
			catch(Exception e)
			{
				//UserSequences[SelSeq].POVConfigType = 0; 
				println("CATCH: POV Header values missing");
			}
		}
		else
		{
			try {
				UserSequences[SelSeq].gradientSteps = PApplet.parseInt(WorkString[12]); 
			}
			catch(Exception e)
			{
				UserSequences[SelSeq].gradientSteps = 0; //updatesequence() should update it to correct value?
			}	
		}

		//forgot to include this, so adding it to the end
		try {
			UserSequences[SelSeq].PacketCloneMode = PApplet.parseInt(WorkString[14]);	
		}
		catch(Exception e) {
			UserSequences[SelSeq].PacketCloneMode = 0;
		}		
		
		//setup for mTech Special, was in dataframevar, but need it here
		int seqFrameAmt = UserSequences[SelSeq].SeqFrameAmount+1; //rule for mTech
		if(UserSequences[SelSeq].SeqMode == mTech) seqFrameAmt = ((UserSequences[SelSeq].SeqFrameAmount+1)*2);		
		
		//it really won't work unless arrays are individually recast
		UserSequences[SelSeq].StartValues = new int[device.Channels];		
		UserSequences[SelSeq].DataFrameVar = new int[device.ArrayCastSize]; //needs to be bigger for Linked
		
		UserSequences[SelSeq].SlideValues = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; //need to update as more frames are added
		UserSequences[SelSeq].SlideFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; //need to update as more frames are added


		UserSequences[SelSeq].TechTime = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];
		UserSequences[SelSeq].TechFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];			
		
		//If Video POV, setup seqFrameAmt for DataFrame[][] loading
		if(UserSequences[SelSeq].SeqMode == mPOV && UserSequences[SelSeq].POVVideoMode == true) seqFrameAmt = UserSequences[SelSeq].POVFramesAmount;
		
		UserSequences[SelSeq].DataFrames = new int[seqFrameAmt][device.Channels]; //do last
		
		//================  Payload Arrays are all defined  ==========================================
		
		if(UserSequences[SelSeq].SeqMode == mLinked)
		{
			sLines++;
			WorkString = split(lines[sLines], '\t');
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{		
				UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
			}   
			//===============================				
			sLines++;
			WorkString = split(lines[sLines], '\t');
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{
				UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
			}   
			//===============================				
			sLines++;
			WorkString = split(lines[sLines], '\t');
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{
				UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
			}  	
		}
		else	//any mode but mLinked
		{
			//load data sized arrays
			if(UserSequences[SelSeq].SeqMode == mFade || UserSequences[SelSeq].SeqMode == mGradient || UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mTech) 
			{		
				if(UserSequences[SelSeq].SeqMode != mInstant)	
				{	
					sLines++;
					WorkString = split(lines[sLines], '\t');

					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].StartValues[i] = PApplet.parseInt(WorkString[i+1]);
					}    
				}
				//=======================================================
				//all run this
				sLines++;
				WorkString = split(lines[sLines], '\t');    
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
				{
					UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
				}    
			} //end if
			//======================================================= 
			if (UserSequences[SelSeq].SeqMode == mInstant) //only instant uses slides
			{
				sLines++;
				WorkString = split(lines[sLines], '\t');    
				for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
				{
					UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
				}
				//Now SlideFlags
				sLines++;
				WorkString = split(lines[sLines], '\t');    
				for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
				{
					UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
				}
			}
			//=======================================================        
			if(UserSequences[SelSeq].SeqMode == mTech) 
			{			
				//Now TechValues(slideFlags) then speed
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					sLines++;
					WorkString = split(lines[sLines], '\t');     
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].TechFlags[q][i] = PApplet.parseInt(WorkString[i+1]);
					}
				}//end for()
				//Now Speeds
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					sLines++;
					WorkString = split(lines[sLines], '\t');     
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].TechTime[q][i] = PApplet.parseInt(WorkString[i+1]);
					}
				}//end for()
			} //end mTech if()
			
			//======================================================= 	
			
			if (UserSequences[SelSeq].SeqMode == mGradient)
			{
				int tempDataMult = 0;
				
				switch(UserSequences[SelSeq].DataType)
				{	
				case 0:
					tempDataMult = 1;
					break;
				case 1:
					tempDataMult = 3;
					break;
				case 2:
					tempDataMult = 4;
					break;
				}	//end switch
				
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{				
					sLines++;
					WorkString = split(lines[sLines], '\t');     
					
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[(i%tempDataMult)+1]);
					}
				}//end for()
			}
			else //covers mTech and the rest
			{					
				for (int q=0; q != seqFrameAmt;q++)
				{					
					sLines++;
					WorkString = split(lines[sLines], '\t');     
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
					}
				}//end for()

				//=======================================================
				
				//if instant, fill from dataframes, using dataframevar
				if(UserSequences[SelSeq].SeqMode == mInstant)	
				{
					// it is an instant
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].StartValues[i] = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i];			
					}    			
				}			
			}//end else
		}//end mLinked Else
		println("Sequence# "+SelSeq+" has completed loading");	
	}//end for()

	//=========== ALL SEQUENCES LOADED========================
	//================ LOAD INDEX ========================
	
	IndexedSequenceLength = 0; //used for total indexed sequences length

	IndexMapPointer = 0;
	sLines++;
	WorkString = split(lines[sLines], '\t');  
	
	for (int q=0; q != cSoftwareMaxSequences;q++)
	{
		IndexMapArray[q] = PApplet.parseInt(WorkString[q+1]);
		
		if(IndexMapArray[q] != cIndexEmptyID) 	IndexMapPointer++; //updates IndexMapPointer variable on file load	
	} //end for()

	IndexMapPointer--; //makes up for stuff!
	IndexScrollBar.Value = 0;	
	
	//========== END LOAD INDEX ========================
	
	if(ConfigShape == 5 || ConfigShape == 6) //PixelMap or manual
	{	
		//load user channelamt of LEDicon coords into arrays
		sLines++;	
		WorkString = split(lines[sLines], '\t'); 
		
		LEDIconCoordX = new int[UserChannelAmt]; //resize arrays
		LEDIconCoordY = new int[UserChannelAmt];
		
		for (int q=0; q != (UserChannelAmt);q++)	LEDIconCoordX[q] = PApplet.parseInt(WorkString[q+1]);
		sLines++;	
		WorkString = split(lines[sLines], '\t'); 
		for (int q=0; q != (UserChannelAmt);q++)	LEDIconCoordY[q] = PApplet.parseInt(WorkString[q+1]);
	}

	//========== END LOAD LEDIcon Coords ==== START LOAD GROUP IDs ========================	

	//this next try makes it compatible with previous saves with no GroupIDs
	if(SequenceLength > 0)
	{	
		SelectedSequence = 1; //0 is never used or seen!
		UserSequences[SelectedSequence].Highlighted = true;
		LoadSequence();
	}	
	
	DrawUserSeqIconBuffer(9999); //update entire buffer
	DrawIndexScrollArea();	//draw this last for some reason but necassary!

	//shouldn't run this anymore, either load coords from file, or rebuild i guess
	
	//clear these in case advanced mode is set, it would keep adding every file load
	DefinedPixelUsage = 0;
	CurrentPixelUsage = 0;
	
	GraphicLayoutUpdateIcons();
	GraphicLayoutBuild(0); //needs to run here
	
	//this needs to be done after the GraphicLayoutBuild() builds the icons
	try 
	{
		sLines++;
		WorkString = split(lines[sLines], '\t'); 	

		for (int q=0; q != (UserChannelAmt);q++)	
		{
			try 
			{	
				PixelIcon[q].GroupID = (byte)PApplet.parseInt(WorkString[q+1]); 
			}
			catch(Exception e) 
			{ 
				PixelIcon[q].GroupID = 0;
			}
		}
	}
	catch(Exception e) { println("No Group IDs to load"); }	
	
	println("Loaded Sequences File");	
} //end LoadUserSequencesFile()

//======================================================================================================

public void LoadUserSequencesFileVersion1(String PassedLocation)
{
	println("LoadUserSequencesFileVersion1() - Loading From: "+PassedLocation); 
	String[] lines = loadStrings(PassedLocation); 
	int sLines = 0;  
	String[] WorkString = new String[300]; //was 300
	println("Loading from "+PassedLocation+" : Length: "+lines.length);
	int SelSeq = 0;

	//Month(mon/day/year) - HardwareID - UserChannelAmt - device.Channels - LEDs Per Chan - ConfigShape ID - Sequences Length 

	WorkString = split(lines[sLines], '\t');
	//start filling the Save File Header Information
	
	//First[1] Space SoftwareVer
	//Second[2] is SoftwareRev
	//Third[3] is Date, which is not used

	if(device.HardwareID != PApplet.parseInt(WorkString[4]) && device.HardwareID != 0)
	{
		println("Save file loaded different from currently connected hardware");
		CloseCommunicationPort();
		device.HardwareID = PApplet.parseInt(WorkString[4]);	
		LoadDeviceFile();
		ConfirmBoxIDNum = 10; //for constant and function switch()							
	}
	
	device.HardwareID = PApplet.parseInt(WorkString[4]);	
	
	if(devConnected == false) LoadDeviceFile(); //load device file if not already connected 
	//fill this second so it overrides the default channel value 
	UserChannelAmt = PApplet.parseInt(WorkString[5]); 
	if(UserChannelAmt > device.Channels) UserChannelAmt = device.Channels;
	TextFields[11].Label = ""+UserChannelAmt;	//couldnt get it to work in LoadDeviceFile.....
	
	//6 Space is device.channels, filled later
	//LEDsPerChan = int(WorkString[7]); //REMOVED

	ConfigShape = PApplet.parseInt(WorkString[8]);
	ShapeOptionsDD.SelStr = ConfigShape-1; //set drop down to loaded configshape
	
	LEDSizeID = PApplet.parseInt(WorkString[9]);
	SetLEDSizeCheckBoxes();
	LEDSpacingID = 2; //set to DEFAULT
	SetLEDSpacingCheckBoxes();	
	SoftwareCheckBox[7].Selected = false; //set Grid Icons to off
	
	SequenceLength =  PApplet.parseInt(WorkString[10]); //amount of sequences in file

	println("V1 load made it here");	
	
	
	try {
		println("Using Graphic: "+WorkString[11]);
		graphicImgFilePath = WorkString[11];
		graphicImg = loadImage(graphicImgFilePath); 
		GraphicImageEnabled = true;
		
		//TEMP USAGE
		GraphicLayoutBuffer.beginDraw();//this has to be here but not below.....
		handlerDrawImageHandles();
		GraphicLayoutBuffer.endDraw();	
		//END TEMP USAGE	
		
	}
	catch(Exception e)	{
		println("Error Loading Image Shape, defaulting");
		graphicImgFilePath = "imagelayouts"+File.separator+"default.png";	
		graphicImg = loadImage(graphicImgFilePath); 			
	}
	
	//Space 11 is data length of all sequences	
	
	try {
		//NEW!!!!! v1h
		IconLayoutAdvancedMode.Selected = PApplet.parseBoolean(WorkString[13]);
		applyGUIProfileAdvancedLayout();
		
		GraphicImageEnabled  = PApplet.parseBoolean(WorkString[14]);
		GraphicImageX = PApplet.parseInt(WorkString[15]); 	
		GraphicImageY = PApplet.parseInt(WorkString[16]);

		GraphicImageWidth = PApplet.parseInt(WorkString[17]); 	
		GraphicImageHeight = PApplet.parseInt(WorkString[18]);
		
		//TEMP USAGE
		//	GraphicLayoutBuffer.beginDraw();
		handlerDrawImageHandles();
		//	GraphicLayoutBuffer.endDraw();	
		//END TEMP USAGE		
		
	}
	catch(Exception e) 
	{
		println("Could not load header info for v.1h updates");
	}
	
	//UPDATE INFO
	//	not casting arrays fully at init, causes problems if they need to be resized, as in UserChannelAmt
	//	so init them at full device.Channels

	UserSequences = new UserSequenceObj[SequenceLength+1];
	for (int i = 0; i != UserSequences.length; i++)
	{
		UserSequences[i] = new UserSequenceObj("User Seq "+i, i, device.Channels); 
	}

	for (SelSeq = 1; SelSeq != SequenceLength+1;SelSeq++) //starts on 1
	{
		//println("Loading v1: " +SelSeq);
		
		//start sequence header
		sLines++;
		WorkString = split(lines[sLines], '\t');

		//load Sequence Header Info
		UserSequences[SelSeq].UserID = WorkString[1].replaceAll("[^\\x00-\\x7f]", ""); //removes any non-readable characters, just in case
		
		println("Loading v1: " +SelSeq+"     "+UserSequences[SelSeq].UserID);		
		
		UserSequences[SelSeq].Length = PApplet.parseInt(WorkString[2]);
		
		//If loading a save file with larger channel size sequences, crop them down
		if(PApplet.parseInt(WorkString[3]) > device.Channels) UserSequences[SelSeq].DataSize = device.Channels;
		else UserSequences[SelSeq].DataSize = PApplet.parseInt(WorkString[3]);			
		
		UserSequences[SelSeq].SeqFrameAmount = PApplet.parseInt(WorkString[5]); //was 4, but just data frame amount
		//UserSequences[SelSeq].DataFrameAmount = int(WorkString[5]);
		UserSequences[SelSeq].Speed = PApplet.parseInt(WorkString[6]);
		UserSequences[SelSeq].SeqMode = PApplet.parseInt(WorkString[7]);
		UserSequences[SelSeq].DataType = PApplet.parseInt(WorkString[8]);
		UserSequences[SelSeq].PacketCloneMode = 0;	
		
		
		//Makes v1 and v2 compatible
		//UserSequences[SelSeq].SeqFrameAmount = UserSequences[SelSeq].DataFrameAmount;
		if(UserSequences[SelSeq].SeqMode == 3) UserSequences[SelSeq].SeqMode = mGradient;
		else if(UserSequences[SelSeq].SeqMode == 2) UserSequences[SelSeq].SeqMode = mInstant;
		else if(UserSequences[SelSeq].SeqMode == 5) { UserSequences[SelSeq].SeqMode = mLinked;	 UserSequences[SelSeq].SeqFrameAmount--; }	//make up for base 0 change
		else if(UserSequences[SelSeq].SeqMode == 6) UserSequences[SelSeq].SeqMode = mPOV;	
		else if(UserSequences[SelSeq].SeqMode == 4) 
		{
			println("Sequence "+SelSeq+" is a combo, not loading");
			SelSeq--;
			break;
		}	
		
		//end v1 fixes

		
		if(UserSequences[SelSeq].SeqMode == mPOV)
		{
			try {
				UserSequences[SelSeq].POVConfigType = PApplet.parseInt(WorkString[9]) & 0xFF; //mask off and keep LSB
				UserSequences[SelSeq].POVUsageMode = (PApplet.parseInt(WorkString[9]) >> 8); //use bits 8-15
			}
			catch(Exception e)
			{
				UserSequences[SelSeq].POVConfigType = 0; 
			}
		}
		else
		{
			try {
				UserSequences[SelSeq].gradientSteps = PApplet.parseInt(WorkString[9]); 
			}
			catch(Exception e)
			{
				UserSequences[SelSeq].gradientSteps = 0; //updatesequence() should update it to correct value?
			}	
		}
		
		//NEW v.1h
		try {
			UserSequences[SelSeq].SequenceIntensity = PApplet.parseInt(WorkString[10]);
		}
		catch(Exception e)
		{
			UserSequences[SelSeq].SequenceIntensity = 100;
		}	
		
		//it really won't work unless arrays are individually recast
		UserSequences[SelSeq].DataFrameVar = new int[device.ArrayCastSize]; //needs to be bigger for Linked
		UserSequences[SelSeq].StartValues = new int[device.Channels];
		UserSequences[SelSeq].SlideValues = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; //need to update as more frames are added
		UserSequences[SelSeq].SlideFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; //need to update as more frames are added
		UserSequences[SelSeq].DataFrames = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];	//WAS UserSequences[SelSeq].DataSize];, then device.channels, now full size

		if(UserSequences[SelSeq].SeqMode == mLinked)
		{
			sLines++;
			WorkString = split(lines[sLines], '\t');
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{
				UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
			}   
			//===============================
			sLines++;
			WorkString = split(lines[sLines], '\t');
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{
				UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
			}   
			//===============================
			sLines++;
			WorkString = split(lines[sLines], '\t');		
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
			{
				UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
			}  

			
		}
		else	//any mode but mLinked
		{
			//load data sized arrays
			sLines++;
			WorkString = split(lines[sLines], '\t');

			for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
			{
				UserSequences[SelSeq].StartValues[i] = PApplet.parseInt(WorkString[i+1]);
			}    
			//=======================================================
			sLines++;
			WorkString = split(lines[sLines], '\t');    
			for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
			{
				//UserSequences[SelSeq].SpecialFrameVar[i] = int(WorkString[i+1]);
			}    
			//=======================================================
			sLines++;
			WorkString = split(lines[sLines], '\t');    
			for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
			{
				UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
			}    
			//=======================================================    
			sLines++;
			WorkString = split(lines[sLines], '\t');    
			for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
			{
				//REMOVED FOR V-2
				//UserSequences[SelSeq].FrameSpecial[i] = int(WorkString[i+1]);
			}    
			//=======================================================    
			if (UserSequences[SelSeq].SeqMode == mInstant) //only instant uses slides
			{
				sLines++;
				WorkString = split(lines[sLines], '\t');    
				for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
				{
					UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
				}
			}
			//======================================================= 	
			
			if (UserSequences[SelSeq].SeqMode == mGradient) 
			{
				int tempDataMult = 0;
				
				switch(UserSequences[SelSeq].DataType)
				{	
				case 0:
					tempDataMult = 1;
					break;
				case 1:
					tempDataMult = 3;
					break;
				case 2:
					tempDataMult = 4;
					break;
				}	//end switch
				
				
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					sLines++;
					WorkString = split(lines[sLines], '\t');     
					
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						//println("Thing: "+i+" : "+(i%tempDataMult)+" : "+int(WorkString[(i%tempDataMult)+1]));
						UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[(i%tempDataMult)+1]);
					}
				}//end for()
			}
			else if (UserSequences[SelSeq].SeqMode == mInstant) 
			{
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					if(UserSequences[SelSeq].SlideValues[q] == 0) //then it is a fade or instant
					{
						sLines++;
						WorkString = split(lines[sLines], '\t');     

						for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
						{
							//println("q: "+q+"      i:"+i);
							UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
						}
					}    
				}//end for()
			}
			else
			{
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					sLines++;
					WorkString = split(lines[sLines], '\t');     

					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
					}
				}//end for()
			}//end else
		}//end mLinked Else
	}//end for()
	println("V1 finished loading seqences");
	
	//========== LOAD INDEX ========================
	
	IndexMapPointer = 0;
	sLines++;
	WorkString = split(lines[sLines], '\t');  
	int tempconvert = 0;
	
	for (int q=0; q != 32;q++)
	{
		tempconvert = PApplet.parseInt(WorkString[q+1]);
		
		if(tempconvert == 255) tempconvert = cIndexEmptyID;
		
		IndexMapArray[q] = tempconvert;
		
		if(tempconvert != cIndexEmptyID) 
		{				
			IndexMapPointer++; //updates IndexMapPointer variable on file load		
		}	
	}
	
	IndexMapPointer--; //makes up for stuff!
	IndexScrollBar.Value = 0;	
	
	//========== END LOAD INDEX ========================
	
	if(ConfigShape == 5 || ConfigShape == 6) //PixelMap or manual
	{	
		//load user channelamt of LEDicon coords into arrays
		sLines++;	
		WorkString = split(lines[sLines], '\t'); 
		
		LEDIconCoordX = new int[UserChannelAmt]; //resize arrays
		LEDIconCoordY = new int[UserChannelAmt];
		
		for (int q=0; q != (UserChannelAmt);q++)	LEDIconCoordX[q] = PApplet.parseInt(WorkString[q+1]);
		sLines++;	
		WorkString = split(lines[sLines], '\t'); 
		for (int q=0; q != (UserChannelAmt);q++)	LEDIconCoordY[q] = PApplet.parseInt(WorkString[q+1]);
	}

	//========== END LOAD LEDIcon Coords ==== START LOAD GROUP IDs ========================	

	//this next try makes it compatible with previous saves with no GroupIDs
	if(SequenceLength > 0)
	{	
		SelectedSequence = 1; //0 is never used or seen!
		UserSequences[SelectedSequence].Highlighted = true;
		LoadSequence();
	}	
	
	DrawUserSeqIconBuffer(9999); //update entire buffer
	DrawIndexScrollArea();	//draw this last for some reason but necassary!

	//shouldn't run this anymore, either load coords from file, or rebuild i guess
	
	//clear these in case advanced mode is set, it would keep adding every file load
	DefinedPixelUsage = 0;
	CurrentPixelUsage = 0;
	
	GraphicLayoutBuild(0); //run this last
	
	//this needs to be done after the GraphicLayoutBuild() builds the icons
	try 
	{
		sLines++;
		WorkString = split(lines[sLines], '\t'); 	

		for (int q=0; q != (UserChannelAmt);q++)	
		{
			try 
			{	
				PixelIcon[q].GroupID = (byte)PApplet.parseInt(WorkString[q+1]); 
			}
			catch(Exception e) 
			{ 
				PixelIcon[q].GroupID = 0;
			}
		}
	}
	catch(Exception e) { println("No Group IDs to load"); }	
	
	println("Loaded Sequences File");
}//end Load Version 1 func()

//=====================================================================================================

public void SaveUserSequencesFile(String PassedLocation)
{
	println("SaveUserSequencesFile()  Saving To: "+PassedLocation);

	ArrayList strs = new ArrayList(); // Array list of PImage: must add a comment to indicate what is it
	String TempS="";

	int SelSeq = 0;
	SequenceLength = 0; //global variable for connection

	//First Line - which save file header info 
	//SoftV - SoftRev - Month(mon/day/year) - HardwareID - UserChannelAmt - device.Channels - Sequences Length 
	//	ConfigShape ID - LEDSizeID - AdvancedLayout flag - ImgEnabled - ImgFilePath - ImgX - ImgY - ImgWidth - ImgHeight
	
	int tempLEDSpacingID = LEDSpacingID;
	if(SoftwareCheckBox[7].Selected == true) tempLEDSpacingID = LEDSpacingID + 100; //indicates Grid Icon is enabled
	
	if(GraphicImageEnabled == false) graphicImgFilePath = "imagelayouts"+File.separator+"default.png"; //set to default if not enabled
	
	strs.add("\t"+cSoftwareV+"\t"+cSoftwareR+"\t"+month()+"/"+day()+"/"+year()+"\t"+device.HardwareID+"\t"+UserChannelAmt+"\t"+device.Channels+"\t"+(UserSequences.length-1)
	+"\t"+ConfigShape+"\t"+LEDSizeID+"\t"+IconLayoutAdvancedMode.Selected+"\t"+GraphicImageEnabled+"\t"+graphicImgFilePath
	+"\t"+GraphicImageX+"\t"+GraphicImageY+"\t"+GraphicImageWidth+"\t"+GraphicImageHeight+"\t"+TextFields[14].Label
	+"\t"+IntensityOverrideCheckBox.Selected+"\t"+device.UserIdleSequence+"\t"+tempLEDSpacingID); //Sequence length added last
	//start actual data
	println("Save File header written");		
	
	for (SelSeq = 1; SelSeq != UserSequences.length; SelSeq++) //start filling on sequence 1 object, object 0 ignored
	{
		int holdLastValue1 = 0; //used to store sequence specific values
		int holdLastValue2 = 0; 
		
		if(UserSequences[SelSeq].SeqMode == mPOV) 
		{	
			if(UserSequences[SelSeq].POVVideoMode == true) 
			{	
				holdLastValue1 = (UserSequences[SelSeq].POVUsageMode << 8) | (0x80 | UserSequences[SelSeq].POVConfigType); //build POV value, set video mode	
				holdLastValue2 = UserSequences[SelSeq].POVFramesAmount; //save video frame number, different than SeqFrameAmount
			}
			else holdLastValue1 = (UserSequences[SelSeq].POVUsageMode << 8) | UserSequences[SelSeq].POVConfigType; //build POV value	
		}
		else holdLastValue1 = UserSequences[SelSeq].gradientSteps;			
		
		//UserID - Length - DataSize - SeqFrameAmount - Speed - SeqMode - SeqDataType - PlayMode - SeqTransitionFlags - SeqTransSpeed - SequenceIntensity - holdLastValue
		strs.add("\t"+UserSequences[SelSeq].UserID+"\t"+UserSequences[SelSeq].Length+"\t"+UserSequences[SelSeq].DataSize+"\t"+UserSequences[SelSeq].SeqFrameAmount+"\t"+
		UserSequences[SelSeq].Speed+"\t"+UserSequences[SelSeq].SeqMode+"\t"+UserSequences[SelSeq].DataType+"\t"+UserSequences[SelSeq].SeqPlayMode+"\t"+
		UserSequences[SelSeq].SeqTransitionFlags+"\t"+UserSequences[SelSeq].SeqTransSpeed+"\t"+UserSequences[SelSeq].SequenceIntensity+"\t"+holdLastValue1+"\t"+
		holdLastValue2+"\t"+UserSequences[SelSeq].PacketCloneMode);
		
		MeasureSequenceLength(SelSeq); //make sure length is updated
		
		SequenceLength = SequenceLength + UserSequences[SelSeq].Length;		//run so it can be added to file at the end
		
		if(UserSequences[SelSeq].SeqMode == mLinked)
		{
			TempS = "";
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) //no +1
			{
				TempS = TempS+"\t"+UserSequences[SelSeq].SlideFlags[i];
			}
			strs.add(TempS); 		

			TempS = "";
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) //no +1
			{
				TempS = TempS+"\t"+UserSequences[SelSeq].SlideValues[i];
			}
			strs.add(TempS);	

			TempS = "";
			for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) //no +1
			{
				TempS = TempS+"\t"+UserSequences[SelSeq].DataFrameVar[i];
			}
			strs.add(TempS);		
		}
		else //anything but a Linked
		{
			//===============================================================================================
			if(UserSequences[SelSeq].SeqMode == mFade || UserSequences[SelSeq].SeqMode == mGradient || UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mTech) 
			{
				if(UserSequences[SelSeq].SeqMode != mInstant)	
				{	
					TempS = "";
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].StartValues[i];
					}
					strs.add(TempS);   
				}
				//===============================================================
				TempS = "";
				for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
				{
					TempS = TempS+"\t"+UserSequences[SelSeq].DataFrameVar[i];
				}
				strs.add(TempS);   
			}
			//===============================================================
			if(UserSequences[SelSeq].SeqMode == mInstant) 
			{
				//Save SlideValues
				TempS = "";
				for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
				{
					TempS = TempS+"\t"+UserSequences[SelSeq].SlideValues[i];
				}
				strs.add(TempS);
				//Now Save SlideFlags
				TempS = "";
				for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
				{
					TempS = TempS+"\t"+UserSequences[SelSeq].SlideFlags[i];
				}
				strs.add(TempS);				
			}
			//===============================================================		
			if (UserSequences[SelSeq].SeqMode == mTech) //only Combo has speed values for each frame
			{
				//TECHFlags
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					TempS = "";  
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].TechFlags[q][i];
					}
					strs.add(TempS);
				}//end for()	
				//SPEEDs
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					TempS = "";  
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].TechTime[q][i];
					}
					strs.add(TempS);
				}//end for()
			}	
			//=====================  START DATA  =============================

			if (UserSequences[SelSeq].SeqMode == mGradient)
			{
				//Gradients always use 4 data values per frame	
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					TempS = "";  
					for (int i=0; i != 4;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
					}
					strs.add(TempS);
				}//end for()			
			}
			else if (UserSequences[SelSeq].SeqMode == mTech)
			{
				//Has 2 dataframes per
				for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++)
				{
					TempS = "";  
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
					}
					strs.add(TempS);
				}//end for()
			}
			else if (UserSequences[SelSeq].SeqMode == mPOV && UserSequences[SelSeq].POVVideoMode == true)
			{
				for (int q=0; q != UserSequences[SelSeq].POVFramesAmount;q++)
				{
					TempS = "";  
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
					}
					strs.add(TempS);
				}//end for()
			}
			else
			{
				for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
				{
					TempS = "";  
					for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
					{
						TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
					}
					strs.add(TempS);
				}//end for()
			} //end else	
		} //end mLinked else			
	}//end Sequence for()
	
	//==================== SAVE INDEX Addresses =======================
	TempS = "";  
	for (int q=0; q != cSoftwareMaxSequences;q++) TempS = TempS+"\t"+IndexMapArray[q];
	strs.add(TempS);
	
	//==================== LED Icon Coords if Used =======================
	
	if(ConfigShape == 5 || ConfigShape == 6 || IconLayoutAdvancedMode.Selected == true) //PixelMap or manual and/or Advanced layout mode
	{
		println("saving PixelIcon Coords, length: "+PixelIcon.length);	
		
		TempS = ""; 	
		for (int i=0;i != (PixelIcon.length);i++)	//saves max icons there could be
		{
			try {	
				TempS = TempS+"\t"+PixelIcon[i].xpos;
			}
			catch(Exception e)	{
				TempS = TempS+"\t"+0;	
			}
		} //end for()
		strs.add(TempS);	
		
		TempS = ""; 	
		for (int i=0;i != UserChannelAmt;i++)	//saves max icons there could be
		{
			try {	
				TempS = TempS+"\t"+PixelIcon[i].ypos;
			}
			catch(Exception e)	{
				TempS = TempS+"\t"+0;	
			}
		} //end for()	
		strs.add(TempS);	
	}
	
	//======= START GROUP IDs SAVE ==============

	TempS = ""; 	
	for (int i=0;i != UserChannelAmt;i++)	//saves max icons there could be
	{
		try {	
			//if(PixelIcon[i].GroupID > 7 || PixelIcon[i].GroupID < 0) PixelIcon[i].GroupID = 0;//just in case, check for out of bounds
			TempS = TempS+"\t"+PixelIcon[i].GroupID;
		}
		catch(Exception e)	{
			TempS = TempS+"\t"+0;	
		}
	} //end for()
	strs.add(TempS);			
	
	//===================  END DATA =========================

	//move array list into String array for saving.
	String[] lines = new String[strs.size()]; 
	for (int q=0; q != strs.size();q++)  
	{
		lines[q]=(String) strs.get(q);
		if(q == 0) lines[q] += "\t"+SequenceLength; //saves data length at end of header
	} 

	String[]  ExtensionStripped = split(PassedLocation, '.');
	saveStrings(ExtensionStripped[0]+".txt", lines);
	println("Completed SaveUserSequencesFile()");
} //end func()


//============================================================================================


public void SetupMousePressAndHold()
{
	//int myStart = millis();
	mousePressHoldThread = true;
	delay(500);	//Required or would only work a few times, then stops working
	
	while(mousePressed == true)
	{
	delay(100);	//Required or would only work a few times, then stops working
	AdjustFrameButtonView(pressHeldID);

	if(SelectedFrame < UserSequences[SelectedSequence].SeqFrameAmount) SetSelectedFrame(SelectedFrame+1); 			
	MenuTabs[0].refresh(); //will run either GraphicLayoutUpdateIcons();	 or the other based on Advanced Layout	
	redraw();
	}
	
	mousePressHoldThread = false;
	println("Thread dead");
}


//============================================================================================


public void AdjustFrameButtonView(int passedID)
{
	println("AdjustFrameButtonView()");
	pressHeldID = passedID;
	
	if(passedID == 0)
	{
		FrameScrollBarView--;
		if(FrameScrollBarView < 0) FrameScrollBarView = 0;
	}
	else
	{
		if((UserSequences[SelectedSequence].SeqFrameAmount-10) > FrameScrollBarView) FrameScrollBarView++;	
	}
	SetSelectedFrame(SelectedFrame);	
	if(mousePressHoldThread == false) thread("SetupMousePressAndHold");
}


//============================================================================================


public void PortMonitorThread()
{
	while(SelectedMenuTab == 4 && DeviceConnect.Selected == false)
	{
		try {
			if(COMButtons.length != Serial.list().length) 
			{
				InitCOMButtons();	
			}
		}
		catch(Exception e) {  }		
			
		delay(500); //run second or runs twice
	} //end while
} //end

//============================================================================================

public void TransmissionTimerThread()
{
	int myStart = millis();

	while((millis() - myStart) < CMDTimeOutVal)
	{
	delay(1);	//Required or would only work a few times, then stops working
	if(SentCmdRequest == false && RecievedOpenAck == false) { return; } //force out by mouse click after min time
	}
	
	CloseCommunicationPort();
	
	ShowNotification(6); //display notification
	
	WaitForAckFlag = false;
	UploadInProgress = false;
	RecievedOpenAck = false;	
	SentCmdRequest = false;	
	
	println("Command Timed Out "+(millis() - myStart));
	redraw();
} //end NotificationTimerThread()

public void EnableTransmissionTimeOut()
{
	println("EnableTransmissionTimeOut()");
	redraw();
	thread("TransmissionTimerThread");
} //end func

//============================================================================================

public void NotificationTimerThread()
{
	int myStart = millis();

	while((millis() - myStart) < 3000)
	{
	delay(1);	//Required or would only work a few times, then stops working
	if((millis() - myStart) > 1000) ShowNotificationMinFlag = true; //timer has reached minimum time
	if(ShowNotification == 0) { break; } //force out by mouse click after min time
	}
	ShowNotification = 0; //otherwise timed out
	println("Timer end "+(millis() - myStart));
	redraw();
} //end NotificationTimerThread()

public void ShowNotification(int passedID)
{
	println("ShowNotification() with "+passedID+" -  "+cNotificationText[passedID]);
	ShowNotification = passedID;
	redraw();
	ShowNotificationMinFlag = false;
	thread("NotificationTimerThread");
} //end func

//============================================================================================

public void RunParseIndex()
{
	println("RunParseIndex()");
	
	IndexedSequenceLength = 0; //now that they have all been figured individually add up only the ones in the index and ones that are linked and not in index	
	
	//reset/clear  handlers
	for (int q = 1; q != UserSequences.length; q++) 
	{
		UserSequences[q].LinkerUtilized = false;
		UserSequences[q].assignedIDNum = cIndexEmptyID;
		UserSequences[q].assignedLinkedIDNum = cIndexEmptyID;
		UserSequences[q].IDassigned = false;
		UserSequences[q].mappedROMAdr = 0; //clear since it is alos used to check for previously indexed
	} //end for()
	
	int offsetVar = 0;	
	int i = 0; //declare it here so the result can be used outside
	
	
	IndexSerialAssignedIDNum = cIndexEmptyID;		
	IndexDMXAssignedIDNum = cIndexEmptyID;	//reset these

	
	for (i = 0; i < device.MaxIndexedSequences; i++) //was not equals to
	{	 
		if(IndexMapArray[i] == cIndexDMXID)
		{
		println("cIndexDMXID on index, assigned "+i+", adding to length: "+cHeaderByteLen);
		IndexDMXAssignedIDNum = i;
		tempDMXAdr = IndexedSequenceLength;			
		IndexedSequenceLength += cHeaderByteLen; //post increase
		//offsetVar++;
		}
		else if(IndexMapArray[i] == cIndexSerialID)
		{
		println("cIndexSerialID on index, assigned "+i+", adding to length: "+cHeaderByteLen);	
		IndexSerialAssignedIDNum = i;	
		tempSerialAdr = IndexedSequenceLength;		
		IndexedSequenceLength += cHeaderByteLen; //post increase
		//offsetVar++;
		}		
		else if(IndexMapArray[i] != cIndexEmptyID && UserSequences[IndexMapArray[i]].IDassigned == false)
		{
			//if not cIndexEmptyID then it is a sequence, handle it
			UserSequences[IndexMapArray[i]].LinkerUtilized = true;
			UserSequences[IndexMapArray[i]].assignedIDNum = i - offsetVar;
			UserSequences[IndexMapArray[i]].IDassigned = true;
			
			UserSequences[IndexMapArray[i]].mappedROMAdr = IndexedSequenceLength;
			IndexedSequenceLength += UserSequences[IndexMapArray[i]].Length;		
		} //end i for()
		else if(IndexMapArray[i] != cIndexEmptyID && UserSequences[IndexMapArray[i]].IDassigned == true)
		{	
			//If the indexmap value is not empty, and already assigned, meaning it is on the index at least twice
			println("Sequence "+IndexMapArray[i]+" is on the index again "+offsetVar+"   use adr: "+UserSequences[IndexMapArray[i]].mappedROMAdr);
			offsetVar++;
		}
		else
		{
			//once it has gone through the index and handled all the sequences that are there, go through them and check for mLinked
			// then go through all the linked and see if they have been handled
			for (int q = 1; q != UserSequences.length; q++)
			{
			//println("Running "+i+"   seq: "+q);
				//checks if sequence is a linked and it must have already been utilized since it would have to be in the index map	
				if(UserSequences[q].SeqMode == mLinked && UserSequences[q].LinkerUtilized == true)
				{	
				println("Found a linked "+q);
					//Now go through the linked seq's stored ID numbers
					for (int yy = 0; yy != UserSequences[q].SeqFrameAmount+1; yy++)
					{
						if(UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized == false && UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned == false)
						{	
							println("One sequence to be linked, SoftID: "+UserSequences[q].SlideFlags[yy]+" will be "+(i - offsetVar)+" instead of "+(i));
							UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized = true;
							UserSequences[UserSequences[q].SlideFlags[yy]].assignedIDNum = i;// - offsetVar;
							UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned = true;

							i++; //
							//offsetVar--; //adjust so it can keep running without running the i for() loop
													
							UserSequences[UserSequences[q].SlideFlags[yy]].mappedROMAdr = IndexedSequenceLength;
							
							IndexedSequenceLength += UserSequences[UserSequences[q].SlideFlags[yy]].Length;
						}	
					}//end for	
				} //end if		
			}	//end for()		
		println("If it gets here, all linked sequences have been parsed and sequences assigned "+i);	
		break;		
		}	//end else
	} //end i for()
	
	//IDLE
	if(device.UserIdleSequence > 0 && device.UserIdleSequence <= UserSequences.length)
	{
		if(UserSequences[device.UserIdleSequence].LinkerUtilized == false) 
		{	
		println("IDLE NOT ON INDEX USING "+(i - offsetVar));
		UserSequences[device.UserIdleSequence].LinkerUtilized = true;
		UserSequences[device.UserIdleSequence].assignedIDNum = i - offsetVar;
		UserSequences[device.UserIdleSequence].IDassigned = true;
		IndexedSequenceLength += UserSequences[device.UserIdleSequence].Length;
		}
		else println("IDLE ON INDEX");
	}	//end if

	for (int q = 1; q != UserSequences.length; q++) println("Seq#"+q+" : assignedID: "+UserSequences[q].assignedIDNum+" : Indexed: "+UserSequences[q].LinkerUtilized); //debug
	println("Total Sequences Length in Bytes: "+IndexedSequenceLength);
}

//====================================================================================================================================

public void FillManualGradient(int rollingIDnumber, int maxDist)
{
	//called by radial and linear Graphic layout functions
	float LocationVar = (256 * (UserSequences[SelectedSequence].SeqFrameAmount+1)); //whats the 256 for? max frames? or pixels?
	float StepFactorH = LocationVar / ((float)rollingIDnumber / ((float)MultiplierToolValue/10));
	
	int FrameVarCurrent = 0; 
	int FrameVarNext = 1; 
	float StepFactor = 0; 
	int HoldCurrent=0;
	int HoldNext=0;	
	println("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH+"  : rollingIDnumber"+(float)rollingIDnumber+"  : maxDist: "+(int)maxDist); //DEBUG
	LocationVar = 0;

	//scans the radius, looking for any Icons in range, then applies the start vals
	for(int raidusVal = 1;raidusVal!= maxDist;raidusVal++) //scans radius vales up to maximum, which is line length
	{
		for (int i = 0; i != CurrentPixelUsage; i++) //scans through Icon IDs
		{
			if(GradientDrawID[i] == raidusVal)	
			{
				//the icon has the ID that is being looked for
				//println("IconID#: "+i+" matches radiusVal "+raidusVal); 

				for(int q=0;q != CurrentDataTypeMult;q++)
				{
					
					if (q == 0)
					{
						//only run this stuff once per ColorChannel
						//println("LocationVar: "+LocationVar+"  "+StepFactorH);				
						LocationVar += StepFactorH; //increment step, equiv

						if (LocationVar > 255)
						{
							LocationVar -= 256;    //difference remains  
							if (FrameVarNext == (UserSequences[SelectedSequence].SeqFrameAmount))
							{
								FrameVarNext = 0; 
								FrameVarCurrent = (UserSequences[SelectedSequence].SeqFrameAmount);
							}
							else
							{
								FrameVarNext++;
								FrameVarCurrent++;	
								
								if(FrameVarCurrent > UserSequences[SelectedSequence].SeqFrameAmount) FrameVarCurrent = 0;
							}
						} //end locationvar if
					}
					
					int tempThis = (i*CurrentDataTypeMult)+q;
					
					StepFactor = (float)LocationVar / 256; //== Factor Number to multiply by

					HoldCurrent = UserSequences[SelectedSequence].DataFrames[FrameVarCurrent][tempThis];
					HoldNext = UserSequences[SelectedSequence].DataFrames[FrameVarNext][tempThis];
					//println("Hold :"+HoldCurrent+" : "+HoldNext);

					//check same
					if (HoldCurrent == HoldNext) //checkif same
					{ 
						//UserSequences[SelectedSequence].StartValues[tempThis] = HoldCurrent;
						UserSequences[SelectedSequence].StartValues[tempThis] = PApplet.parseInt(255*StepFactor); //Preload CycleHold usage
					}  
					else if (HoldCurrent < HoldNext)  //check which is bigger
					{
						//next larger
						UserSequences[SelectedSequence].StartValues[tempThis] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
					}
					else
					{
						//current Larger
						UserSequences[SelectedSequence].StartValues[tempThis] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
					}
					UserSequences[SelectedSequence].DataFrameVar[tempThis] = FrameVarCurrent;
					//println("StepFactor: "+StepFactor+" : Color: "+UserSequences[SelectedSequence].DataFrames[FrameVarNext][tempThis]+" : Final:"+UserSequences[SelectedSequence].StartValues[i]+" : FrameVar: "+FrameVarCurrent+" : NextFrameVar: "+FrameVarNext);
				} //end q for
			} //end if() 
		} //end i for()
	} //end radiusVal for()
	//MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	GraphicLayoutUpdateIcons();	//change v2c from	refresh[0]
	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 		
} // FillManualGradient()


public void GenerateLinearGradient()
{
	println("GenerateLinearGradient() "+PixelIcon.length);

	GradientDrawID = new int[CurrentPixelUsage]; //resize arrays

	try 
	{
	for (int i = 0; i != CurrentPixelUsage; i++) //was using DefinedPixelUsage
	{	
	if(PixelIcon[i].GroupID == ViewGroupIDNum) GradientDrawID[i] = 0; //if set to 0, it will try and set the start values
	else GradientDrawID[i] = 0xFFFF; //make it out of bounds
	}
	}
	catch(Exception e) { }
	
	
	float maxDist = dist(GradientDrawStartX, GradientDrawStartY, GradientDrawEndX, GradientDrawEndY);
	int lineDist = PApplet.parseInt(maxDist);	
	int rollingIDnumber = 1;	
	
	//int Ax, Bx, Cx, Ay, By, Cy;			
	//Ax = X1;
	//Bx = X2;
	//Ay = Y1;
	//By = Y2;
	//Cx = LEDIcon[0].xpos+85; //don't forget the offset!
	//Cy = LEDIcon[0].ypos+35;
	//println(Bx - Ax) * (Cy - Ay) - (By - Ay) * (Cx - Ax)		//A and B being lined start and end, and point c being the test point

	float lerp1, lerp2, lerp3, lerp4;
	//line(lerp(X1, X3, i*0.01),lerp(Y1, Y3, i*0.01),lerp(X2, X4, i*0.01), lerp(Y2, Y4, i*0.01));

	float lerpFactor = 1/maxDist;
	//println("Using lerpFactor: "+lerpFactor);

	try
	{
	for(int i = 0; i!=lineDist;i++) 
	{
		lerp1 = lerp(X1, X3, i*lerpFactor);
		lerp2 = lerp(Y1, Y3, i*lerpFactor);
		lerp3 = lerp(X2, X4, i*lerpFactor);
		lerp4 = lerp(Y2, Y4, i*lerpFactor);

		line(lerp1, lerp2, lerp3, lerp4);

		for (int q = 0; q != CurrentPixelUsage; q++) //was DefinedPixelUsage
		{
		try 
		{	
			if(((X2 - X1) * ((PixelIcon[q].ypos+35) - Y1) - (Y2 - Y1) * ((PixelIcon[q].xpos+85) - X1)) < 0) //this would indcate the correct side of the line, but anywhere
			{
				if(((lerp3 - lerp1) * ((PixelIcon[q].ypos+35) - lerp2) - (lerp4 - lerp2) * ((PixelIcon[q].xpos+85) - lerp1)) > 0) //check if on the wrong side of the new line
				{
					if(GradientDrawID[q] == 0)
					{
						//println("ID: "+(q+1)+" has is on the correct side of the line, assigned: "+rollingIDnumber);
						GradientDrawID[q] = rollingIDnumber;
					} //end if 0 
				} //end lerp if
			} //end right side of the line if()
		}
		catch(Exception e) { break; } //println("LED Icons to match channel amount not found, stoping at: "+q);
		} //end q for()
		rollingIDnumber++;
	} //end i for()
	}
	catch(Exception e) { }	

	FillManualGradient(rollingIDnumber, PApplet.parseInt(maxDist)); //fills the startvals based on assigned IDs, both modes

//	MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
//	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 	
}//end GenerateLinearGradient()


public void GenerateRadialGradient()
{
	println("GenerateRadialGradient() "+PixelIcon.length);
	//length of line is the offset number, comparable to the overal coordinate dimensions
	//starting position of the line....
	//icons should be on center since ellipseMode(CENTER) is default alnd not altered
	//consider the nearest ones the lowest offset values

	//scan outwards in a circle from start point, numbering them as it goes

	GradientDrawID = new int[CurrentPixelUsage]; //resize arrays
		
	try //makes it work if there are more channels defined than expected pixel icons
	{			
	for (int i = 0; i != CurrentPixelUsage; i++) //was DefinedPixelUsage
	{	
	if(PixelIcon[i].GroupID == ViewGroupIDNum) GradientDrawID[i] = 0; //if set to 0, it will try and set the start values
	else GradientDrawID[i] = 0xFFFF; //make it out of bounds
	}
	}
	catch(Exception e) { }
	
	float maxDist = dist(GradientDrawStartX, GradientDrawStartY, GradientDrawEndX, GradientDrawEndY);

	GradientDrawStartX -= 125; //adjust mouse position to graphicbuffer positions
	GradientDrawStartY -= 35;

	//0 is unused, rest are IDs
	//workspace is 570 x 475
	//assigned ID is the pixel distance from center so the radius.....

	int rollingIDnumber = 1;
	int lineDist = PApplet.parseInt(maxDist);

	float disX = 0; //init
	float disY = 0;	//init
	
	try //makes it work if there are more channels defined than expected pixel icons
	{
	for(int i = 1; i != lineDist; i++) //i=radius
	{
		for (int q = 0; q != CurrentPixelUsage; q++)  //was DefinedPixelUsage
		{
		try {
			disX = GradientDrawStartX - PixelIcon[q].xpos;
		}
		catch(Exception e) { break; } //println("LED Icons to match channel amount not found, stoping at: "+q);
			
			disY = GradientDrawStartY - PixelIcon[q].ypos;
			if (sqrt(sq(disX) + sq(disY)) < i ) 
			{
				if(GradientDrawID[q] == 0)
				{
					GradientDrawID[q] = rollingIDnumber;
					//println("PixelIcon#: "+(q+1)+"   Is within diameter "+i+ " Assigned ID#: "+GradientDrawID[q]); 
				}
			} 
		}//end q for()
		rollingIDnumber++;
	} //end i for()
	}
	catch(Exception e) { }
	
	FillManualGradient(rollingIDnumber, PApplet.parseInt(maxDist)); //fills the startvals based on assigned IDs, both modes

//	MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
//	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
} //end GenerateRadialGradient()

//==============================================================================================================     

public void ResetStartValuesCommon(int passedSeq)
{
	println("ResetStartValuesCommon()");
	
try {	
	for (int i =0; i != UserSequences[passedSeq].DataSize; i++)
	{			
		UserSequences[passedSeq].DataFrameVar[i] = 0;	
		UserSequences[passedSeq].StartValues[i] = UserSequences[passedSeq].DataFrames[0][i];
	}
}
catch(Exception e) { println("Error resetting start values"); }
	
	
} //end ResetStartValuesCommon()

//==============================================================================================================     

public void AppendLogFile(String newData)
{
	println(newData);

	try 
	{
		FileWriter fw = new FileWriter(sketchPath(File.separator+"logs"+File.separator+""+SessionLogFileName), true); // true means: "append"
		bw = new BufferedWriter(fw);
		bw.write(newData + "\n");
	} 
	catch (IOException e) 
	{
		// Report problem or handle it
		println("Log file appending erorr");
	}
	finally
	{
		if (bw != null)
		{
			try { 
				bw.close();
			} 
			catch (IOException e) {	}
		}
	}
} //end AppendLogFile()

//==============================================================================================================     

public boolean WithinStartLimits(int value, int start, int end)
{
	//println("WithinStartLimits("+value+", "+start+", "+end+")");
	if(start == end) return true; //they are the same, so may be preloaded, which would error
	
	if(start >= end) // 255 > 128
	{
		//println("Start Larger");	
		if(value < end || value > start) return false;
		else return true;	
		
	}
	else if(end > start) // 128 > 255
	{
		//println("End Larger");	
		if(value < start || value > end) return false;
		else return true;	

	}	
	return false; //means it errored
} //end func

//==============================================================================================================     

public void PaintColorChannel(int passedVal)
{
	println("Painting from Value");
	
	switch(PixelDataType)
	{
	case 0: //single
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal] = PaintColor[3];
		break;
	case 1: //RGB
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult] = PaintColor[0];
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult+1] = PaintColor[1];
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult+2] = PaintColor[2];
		break;
	case 2: //RGBW
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult] = PaintColor[0];
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult+1] = PaintColor[1];
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult+2] = PaintColor[2];
		UserSequences[SelectedSequence].DataFrames[SelectedFrame][passedVal * CurrentDataTypeMult+3] = PaintColor[3];
		break;
	}//end switch								
	
	MenuTabs[1].refresh();	//refresh timeline after painting
	MenuTabs[0].refresh();	//refresh timeline after painting
}	

//==============================================================================================================     


public void UpdateSideBarButtonStates()
{
	println("UpdateSideBarButtonStates()");
	
		TextFields[0].Status = 1; //Slide Value, //0=show, 1=grey out, 2=hide	
		TextFields[0].Label = ""+UserSequences[SelectedSequence].SlideValues[SelectedFrame];
		
		SetSlideDataTypeBoxStates(0); //check or clear boxes
			
		//GUI Sidebar elements
		SequenceSpeedObject.setValue(""+UserSequences[SelectedSequence].Speed);//update sequence speed text field
		SequenceChannelObject.setValue(""+UserSequences[SelectedSequence].DataSize);//update sequence DataSize text field
		GradientStepsObject.setValue(""+UserSequences[SelectedSequence].gradientSteps);
			
		TXTFSeqIntensity.Label = ""+UserSequences[SelectedSequence].SequenceIntensity;
		
		PlayModeDD.SelStr = UserSequences[SelectedSequence].SeqPlayMode;
		PacketCloneDD.SelStr = UserSequences[SelectedSequence].PacketCloneMode;
		SeqTransistionDD.SelStr = UserSequences[SelectedSequence].SeqTransitionFlags;		
		SequenceModeDD.SelStr = UserSequences[SelectedSequence].SeqMode-1; //load sequence mode into drop down, 0 is not a option
	
		SeqCheckBoxes[0].Selected = false; //single
		SeqCheckBoxes[1].Selected = false; //rgb
		SeqCheckBoxes[2].Selected = false; //rgbw
		SeqCheckBoxes[UserSequences[SelectedSequence].DataType].Selected = true; 
		
		if(device.LockChannelAmt == true) PacketCloneDD.Status = 1;
		else PacketCloneDD.Status = 0;
		//end sidebar

		//TOOL BUTTONS
		StartValReset.Status = 0; //0=show, 1=grey out, 2=hide	
		GradientGenerate.Status = 0; //0=show, 1=grey out, 2=hide	
		GradientStepsObject.Status = 0; //0=show, 1=grey out, 2=hide	
		
		GradientMultiplierObject.Status = 0; //0=show, 1=grey out, 2=hide	
		GradientDrawRadialButton.Status = 0; //0=show, 1=grey out, 2=hide	
		GradientDrawLinearButton.Status = 0; //0=show, 1=grey out, 2=hide			
		
		MainToolsAllSame.Status = 0; //0=show, 1=grey out, 2=hide	
		GraphicFuncPaintButton.Status = 0; //0=show, 1=grey out, 2=hide	
		MainToolsColorGroup.Status = 0; //0=show, 1=grey out, 2=hide	
		MainToolsShowStartValues.Status = 0; //0=show, 1=grey out, 2=hide	
	
		//Default will set later if need be
		FrameSeqToolInsantDD.Status = 1;	 //0=show, 1=grey out, 2=hide	
		FrameSeqToolTechDD.Status = 1; //0=show, 1=grey out, 2=hide
		TextFields[6].Status = 1; //grey out Frame Speed field	

		switch(UserSequences[SelectedSequence].SeqMode)
		{
		case mPOV:				
			//TOOL BUTTONS
			StartValReset.Status = 1; //0=show, 1=grey out, 2=hide	
			GradientGenerate.Status = 1; //0=show, 1=grey out, 2=hide	
			GradientStepsObject.Status = 1; //0=show, 1=grey out, 2=hide	
			
			GradientMultiplierObject.Status = 1; //0=show, 1=grey out, 2=hide	
			GradientDrawRadialButton.Status = 1; //0=show, 1=grey out, 2=hide	
			GradientDrawLinearButton.Status = 1; //0=show, 1=grey out, 2=hide			
			
			MainToolsAllSame.Status = 1; //0=show, 1=grey out, 2=hide	
			GraphicFuncPaintButton.Status = 1; //0=show, 1=grey out, 2=hide	
			MainToolsColorGroup.Status = 1; //0=show, 1=grey out, 2=hide	
			MainToolsShowStartValues.Status = 1; //0=show, 1=grey out, 2=hide		

			//disable colormodes other than RGB for POVs
			SeqCheckBoxes[0].Status = 1; //single
			SeqCheckBoxes[2].Status = 1; //rgbw
		
		case mFade: //Fade
		case mGradient:
			//Per Frame Options
			FrameSeqToolInsantDD.SelStr = 0;	
			FrameSeqToolInsantDD.Status = 1; //grey out			
			FrameSeqToolTechDD.SelStr = 0;	
			FrameSeqToolTechDD.Status = 2; //disable
			TextFields[0].Status = 1; //Slide Value, //0=show, 1=grey out, 2=hide	
			break;
		case mInstant: //Instant
			FrameSeqToolInsantDD.SelStr = 0;
			FrameSeqToolInsantDD.Status = 0;	 //0=show, 1=grey out, 2=hide				
			FrameSeqToolTechDD.Status = 2; //hide

			if(UserSequences[SelectedSequence].SlideFlags[SelectedFrame] > 0)
			{
			println("ITS A SLIDE FRAME "+binary(UserSequences[SelectedSequence].SlideFlags[SelectedFrame],8));
			
			if((UserSequences[SelectedSequence].SlideFlags[SelectedFrame] & 0x40) > 0) FrameSeqToolInsantDD.SelStr = 1;
			else FrameSeqToolInsantDD.SelStr = 2;
			
			TextFields[0].Status = 0; //Slide Value
			SetSlideDataTypeBoxStates((UserSequences[SelectedSequence].SlideFlags[SelectedFrame] & 0x07)+1); //check or clear boxes,0=clear, so +1
			}		
			break;
		case mTech:
			println("NO FINISHED METHOD FOR mTECH YET");
			
			//Per Frame Options
			FrameSeqToolInsantDD.Status = 2; //hide			
			FrameSeqToolTechDD.SelStr = 0;	
			FrameSeqToolTechDD.Status = 0; //disable
			TextFields[6].Status = 0; //start greyed out							
			
			break;
		}//end switch		
} //end UpdateSideBarButtonStates()


//===============================================================================================	

public void holdgraphicfunc(PGraphics GBuffer, int passedID, int SelSeq)
{
	//println("holdgraphicfunc() with "+passedID+" : "+SelSeq+" : "+GBuffer);
	int qTemp = 0;
	
	int ColorTemp = color(0);
	int c = color(0);  //temp color		
	int myColor = color(0);
	int currentOffset = 0;
	int tempPxLength= 0;
	int tempChan = getTechChannelNum(passedID); //build channel number
	int tempColorDataType = 0;	//mask off and use Color bits

	int[][] HoldDataFrames = new int[((UserSequences[SelSeq].SeqFrameAmount+1)*2)][UserSequences[SelSeq].DataSize];
	//int[][] HoldDataFrames = new int[cSoftwareMaxFrames][cSoftwareMaxChans];
	
	GBuffer.beginDraw();
	GBuffer.background(cBackgroundColor); //make background dark grey
	GBuffer.noStroke();
	
	for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++) arrayCopy(UserSequences[SelSeq].DataFrames[q], HoldDataFrames[q], UserSequences[SelSeq].DataSize);
	
	for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
	{
		//update variables
		tempColorDataType = getTechChanColorMode(passedID);//mask off and use Color bits			
		tempPxLength = (UserSequences[SelSeq].TechTime[q][passedID] / 10)+10;

		//println("ColorMode: "+tempColorDataType+"   "+tempPxLength);
		
		if((UserSequences[SelSeq].TechFlags[q][passedID] & 0x08) == 0)
		{
			//Instant
			//println("Instant on "+q+"  with chan: "+passedID+"   "+tempPxLength+"   "+currentOffset);
			GBuffer.noStroke();

			switch(tempColorDataType)
			{
			case 0: //Single
				if(device.Bit16Mode == true)	GBuffer.fill((HoldDataFrames[qTemp][tempChan]>>8));
				else	GBuffer.fill(HoldDataFrames[qTemp][tempChan]);
				break;
			case 1: //RGB
			case 2: //RGBW								
				if(device.Bit16Mode == true)	GBuffer.fill((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
				else	GBuffer.fill(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);  
				break;	
			}		

			GBuffer.rect(currentOffset,0,tempPxLength,cTLChBufH); //draw rect to buffer
			
			if(tempColorDataType == 2)  //if RGBW draw extra box for greyscale
			{
				GBuffer.fill(HoldDataFrames[qTemp][tempChan+3]);	
				GBuffer.rect(currentOffset,10,tempPxLength,(cTLChBufH/2));
			}
			
		}
		else
		{
			//fade
			//println("fade on "+q+"  with chan: "+passedID+"  Frame: "+q);
			//println("qTemp: "+qTemp+" : "+red(ColorTemp)+" : "+green(ColorTemp)+" : "+blue(ColorTemp));
			float inter;
			c = color(0);  //temp color		
			myColor = color(0);
			
			switch(tempColorDataType)
			{
			case 0: //Single
				if(device.Bit16Mode == true)	myColor = color((HoldDataFrames[qTemp][tempChan]>>8));
				else	myColor = color(HoldDataFrames[qTemp][tempChan]);
				
				if(device.Bit16Mode == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8));
				else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan]);
				
				break;
			case 1: //RGB
			case 2: //RGBW	
				if(device.Bit16Mode == true)	myColor = color((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
				else	myColor = color(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);	

				if(device.Bit16Mode == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8), (HoldDataFrames[qTemp+1][tempChan+1]>>8), (HoldDataFrames[qTemp+1][tempChan+2]>>8));
				else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan], HoldDataFrames[qTemp+1][tempChan+1], HoldDataFrames[qTemp+1][tempChan+2]);  
				
				break;	
			} //end switch 					

			println("qTemp: "+qTemp);
			
			for (int i = 0; i <= tempPxLength; i++) 
			{
				inter = map(i, 0, tempPxLength, 0, 1);
				
				if(tempColorDataType == 0) c = lerpColor(myColor, ColorTemp, inter);
				else c = lerpColor(color(myColor), ColorTemp, inter);		
				
				GBuffer.stroke(c); //draws gradient line by line
				GBuffer.line(currentOffset+i, 0, currentOffset+i, cTLGraphBufH);
			}			
			
			
			if(tempColorDataType == 2)  //if RGBW draw extra box for greyscale
			{
				GBuffer.noStroke();
				GBuffer.fill(255);
				
				for (int i = 0; i <= tempPxLength; i++) 
				{
					inter = map(i, 0, tempPxLength, 0, 1);
					
					if(i == 0)
					{
						if(device.Bit16Mode == true) 
						{
							ColorTemp = color((HoldDataFrames[qTemp+1][tempChan+3]>>8));
						}			 
						else 
						{
							ColorTemp = color(HoldDataFrames[qTemp+1][tempChan+3]);
						}		
					}	 //end if i == 0
					
					if(device.Bit16Mode == true)  c = lerpColor(color((HoldDataFrames[qTemp][tempChan+3]>>8)), ColorTemp, inter);
					else	c = lerpColor(color(HoldDataFrames[qTemp][tempChan+3]), ColorTemp, inter);
					
					GBuffer.stroke(c);
					GBuffer.line(currentOffset+i, 10, currentOffset+i, cTLGraphBufH); //5 = half the buffer height		
				}	//end for()
			} //end if()
		} //end else / fade
		qTemp+=2;
		currentOffset += tempPxLength;
	} //end for
	GBuffer.endDraw();
}//end func

//===================================================================================================

public void DrawTechnicalBuffer()
{
	println("DrawTechnicalBuffer()");

	String tempColorStr = "RGB";
	String tempChanStr = "1";
	//	int tempPxLength = 0;
	int currentOffset = 0;
	int channelCounter = 0;
	
	TotalColorChannels = updateTechTotalColorChannel(SelectedSequence);
	
	TechnicalBuffer = createGraphics(cTechnicalBufW, cTechnicalBufH);	
	TechnicalBuffer.beginDraw();
	TechnicalBuffer.background(cBackgroundColor);
	//end start value stuff

	TechnicalBuffer.textFont(fDigital, 48);

	TechChanLabelButtons = new Button[TotalColorChannels];
	TechColorModeButton = new Button[TotalColorChannels];
	
	channelCounter = 1;
	for (int i = 0; i != TotalColorChannels; i++)
	{
		TechnicalBuffer.stroke(cStrokeColor);//line seperating color channels
		TechnicalBuffer.strokeWeight(2);
		TechnicalBuffer.line(0, (i*cTLChBufH), (TimeLineBuffer.width-30), (i*cTLChBufH));	

		TechChanLabelButtons[i] = new Button(""+(i+1), 0, 5+(i*cTLChBufH), 30, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false, false);
		TechChanLabelButtons[i].displayTech();
		
		//TechAddFrameButtons[i] = new Button("Add"+(i+1), 0, 5+(i*cTLChBufH), 30, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false);
		//TechAddFrameButtons[i].displayTech();	

		//read tech flags for color mode
		switch((UserSequences[SelectedSequence].TechFlags[0][i] & 0x03)) //all frames have same colormode
		{
		case 0:
			tempColorStr = "Single";
			tempChanStr = ""+channelCounter;
			channelCounter++;
			break;		
		case 1:
			tempColorStr = "RGB";
			tempChanStr = channelCounter+","+(channelCounter+1)+","+(channelCounter+2);	//"1,2,3";
			channelCounter += 3;		
			break;
		case 2:
			tempColorStr = "RGBW";
			tempChanStr = channelCounter+","+(channelCounter+1)+","+(channelCounter+2)+","+(channelCounter+3);	//"1,2,3,4";
			channelCounter += 4;			
			break;
		}
		
		TechColorModeButton[i]  = new Button(tempColorStr, 85, 5+(i*cTLChBufH), 35, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, false);
		TechColorModeButton[i].displayTech();
		//end pixel color mode buttons
		
		TechnicalBuffer.text("Channels:\n"+tempChanStr,35,12+(i*cTLChBufH));
	} //end for()

	//vertical line seperator, left side
	TechnicalBuffer.stroke(cStrokeColor);
	TechnicalBuffer.strokeWeight(1);
	TechnicalBuffer.line(125,0,125,cTechnicalBufH);
	TechnicalBuffer.noStroke();		
	
	//now handle data
	//draws every frame of the color channel then goes to next row
	for (int i = 0; i != TotalColorChannels; i++)
	{
		PreviewBuffer[i] = createGraphics(cTLGraphBufW, cTLGraphBufH);
		holdgraphicfunc(PreviewBuffer[i], i, SelectedSequence);
		TechnicalBuffer.image(PreviewBuffer[i], 125, 5+(i*cTLChBufH), cTLGraphBufW, cTLGraphBufH);
		
		currentOffset = 0;
		for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
		{
			currentOffset += (UserSequences[SelectedSequence].TechTime[q][i] / 10)+10; //place line at end of section, not starts	
			
			TechnicalBuffer.stroke(cStrokeColor);

			TechnicalBuffer.strokeWeight(1);
			TechnicalBuffer.line(125+currentOffset,(i*cTLChBufH),125+currentOffset,(i*cTLChBufH)+cTLChBufH);
		}
		TechnicalBuffer.noStroke();	
		
	} //end for()
	
	TechnicalBuffer.endDraw();
} // end func

//================================================================================================	

public void DrawFilePlayBuffer()
{
	println("DrawFilePlayBuffer() - NOT USED");
/*
	FilePlayBuffer = createGraphics(cTLGraphBufW, (TotalColorChannels*cTLChBufH));		
	FilePlayBuffer.beginDraw();
	
	FilePlayBuffer.fill(0,0,255);
	FilePlayBuffer.rect(100,100,100,100);
	
	FilePlayBuffer.endDraw();	
*/	
} // end func

//================================================================================================	

public void DrawPOVBuffer()
{
	//Draws POV timeline area to a graphic buffer. Can be called anytime.
	
	//this is per POVConfigType though???
	//CurrentPOVW = UserSequences[SelectedSequence].SeqFrameAmount;			
	//CurrentPOVH = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;
	//POVGraphicBuffer = createGraphics(CurrentPOVW+1,CurrentPOVH);
	//println("DrawPOVBuffer() "+UserSequences[SelectedSequence].SeqFrameAmount);
	switch(UserSequences[SelectedSequence].POVConfigType)
	{
	default:
	case 0:
		CurrentPOVW = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;		
		CurrentPOVH = UserSequences[SelectedSequence].SeqFrameAmount;	
		POVGraphicBuffer = createGraphics(CurrentPOVW,CurrentPOVH+1);	
		break;
	case 1:
		CurrentPOVW = UserSequences[SelectedSequence].SeqFrameAmount;			
		CurrentPOVH = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;
		POVGraphicBuffer = createGraphics(CurrentPOVW+1,CurrentPOVH);	
		break;
	case 2:
		CurrentPOVW = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;		
		CurrentPOVH = UserSequences[SelectedSequence].SeqFrameAmount;	
		POVGraphicBuffer = createGraphics(CurrentPOVW,CurrentPOVH+1);		
		break;
	case 3:
		CurrentPOVW = UserSequences[SelectedSequence].SeqFrameAmount;	
		CurrentPOVH = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;	
		POVGraphicBuffer = createGraphics(CurrentPOVW+1,CurrentPOVH);			
		break;
	} //end switch
	
	if(POVVideoModeCheckBox.Selected == false || POVVidFrame == 0) 
	println("DrawPOVBuffer() using w: "+CurrentPOVW+" h: "+CurrentPOVH+" Type: "+UserSequences[SelectedSequence].POVConfigType+"    VidFrame: "+POVVidFrame);
	
	POVBuffer = createGraphics(cPOVBufWidth, cPOVBufHeight);
	POVBuffer.beginDraw();
	POVBuffer.background(30, 30, 30);
	POVBuffer.noStroke();

	float tempSz;		
	int x = 0;
	int tempCenterX = 0;
	int tempCenterY = 0;	

	//println(floor((float)(cPOVBufHeight-40) / CurrentPOVH)+" : "+ floor((cPOVBufWidth-40) / CurrentPOVW));
	
	//decide which is smaller and use that..
	if(floor((float)(cPOVBufHeight-40) / CurrentPOVH) < floor((float)(cPOVBufWidth-40) / CurrentPOVW)) 
	{
		tempSz = CurrentPOVH;
		tempSz = floor((float)(cPOVBufHeight-40) / tempSz); //smallest divided by largest
	}
	else {
		tempSz = CurrentPOVW;
		tempSz = floor((float)(cPOVBufWidth-40) / tempSz); //smallest divided by largest
	}
	
	//borders with info
	POVGraphicBuffer.beginDraw();
	POVGraphicBuffer.background(255,0,0);
	POVGraphicBuffer.noStroke();
	
	TotalColorChannels = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult; //DEBUG UPDATE???
	
	//40px insets
	try
	{
		switch(UserSequences[SelectedSequence].POVConfigType)
		{
		case 0: //"First Pixel Is Bottom Left. Rows Are Displayed Top To Bottom."		
			tempCenterX = 20+PApplet.parseInt(((cPOVBufWidth-40) - (tempSz * TotalColorChannels))/2);
			tempCenterY = 20+PApplet.parseInt(((cPOVBufHeight-40) - (tempSz * CurrentPOVH)) / 2);

			for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
			{
				x = 0;
				//for (int i=0; i != TotalColorChannels;i++)
				for(int i = TotalColorChannels-1; i >= 0; i--)
				{
					POVBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+((q)*tempSz), tempSz, tempSz);
					
					POVGraphicBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVGraphicBuffer.rect(i, q, 1, 1);					
					x+=3;
				} //end for()
			}//end for()		
			break;
			
		case 1: //"First Pixel Is Bottom Left. Columns Are Displayed Left To Right."
			tempCenterX = PApplet.parseInt(((cPOVBufWidth-40) - (tempSz * (UserSequences[SelectedSequence].SeqFrameAmount+1))) / 2);
			tempCenterY = 20+PApplet.parseInt((cPOVBufHeight-40) - (tempSz * TotalColorChannels)) / 2;
			
			for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i=0; i != TotalColorChannels;i++)
				{
					POVBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
					
					POVGraphicBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVGraphicBuffer.rect(q, i, 1, 1);				
					
					x+=3;
				} //end for()
			}//end for()	
			break;
			
		case 2: //"First Pixel Is Top Left. Rows Are Displayed Top To Bottom
			tempCenterX = 20+PApplet.parseInt((cPOVBufWidth-40) - (tempSz * TotalColorChannels)) / 2;
			tempCenterY = PApplet.parseInt((cPOVBufHeight) - (tempSz * (UserSequences[SelectedSequence].SeqFrameAmount+1))) / 2;

			for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
			{
				x = 0;
				//for (int i=TotalColorChannels-1; i >= 0;i--)
				for (int i=0; i != TotalColorChannels;i++)
				{
					POVBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+(q*tempSz), tempSz, tempSz);
					
					POVGraphicBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVGraphicBuffer.rect(i, q, 1, 1);		
					
					x+=3;
				} //end for()
			}//end for()	
			break;
		case 3: //"First Pixel Is Top Left. Columns Are Displayed Left To Right."
			tempCenterX = PApplet.parseInt((cPOVBufWidth-40) - (tempSz * (UserSequences[SelectedSequence].SeqFrameAmount+1))) / 2;
			tempCenterY = 20+PApplet.parseInt(((cPOVBufHeight-40) - (tempSz * TotalColorChannels)) / 2);

			for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i=TotalColorChannels-1; i >= 0;i--)
				{
					POVBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
					
					POVGraphicBuffer.fill(UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1], UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2]);
					POVGraphicBuffer.rect(q, i, 1, 1);				
					
					x+=3;
				} //end for()
			}//end for()			
			break;		
		} //end switch
	}//end try
	catch(Exception e)
	{			
		println("error, reload image file");
	}
	
	POVGraphicBuffer.endDraw();
	POVBuffer.endDraw();
} //end func

//================================================================================================	

public void UpdateColorChannelBuffer(int passedID)
{	
	println("UpdateColorChannelBuffer() with "+passedID);
	
	try {
		PreviewBuffer[passedID] = createGraphics(600, cTLGraphBufH);
		GenerateSeqPreview(PreviewBuffer[passedID], passedID, SelectedSequence); //should be passing passedID
		
		TimeLineBuffer.beginDraw();
		TimeLineBuffer.image(PreviewBuffer[passedID], 35, 5+(passedID*cTLChBufH), 600, cTLGraphBufH);
		
		TLStartIndicators[passedID].bufferDisplay();	 //displays to graphic buffer
		
		TimeLineBuffer.endDraw();
	}
	catch(Exception e) {println("Unable to Run UpdateColorChannelBuffer()"); }
} //end UpdateColorChannelBuffer()

//================================================================================================	

public void DrawTimeLineBuffer()
{
	//Draws the timeline to a graphic buffer. Can be called anytime.
	
	//Used to call DrawLinkedBuffer, but that is a draw() only routine, and is refreshed regardless
	

	
	if(UserSequences[SelectedSequence].SeqMode == mPOV)
	{	
		DrawPOVBuffer();
		return;
	}	
	
	//if(UserSequences[SelectedSequence].SeqMode == mFilePlay)
	//{
	//		DrawFilePlayBuffer();
	//		return;
	//	}		
	
	if(UserSequences[SelectedSequence].SeqMode == mTech)
	{
		DrawTechnicalBuffer();
		return;
	}
	
	println("DrawTimeLineBuffer() - TotalColorChannels: "+TotalColorChannels+" Sequence#: "+SelectedSequence);
	
	int tempButtonCounter = 0;

	int tempFrameVar = 0;
	float tempVar = 0; 
	boolean TempFlag = false;

	//start Start Values Calc Vars
	int RStart = 0;
	int GStart = 0;
	int BStart = 0;
	int WStart = 0;

	int CurrentStartR = 0;
	int CurrentStartG = 0;
	int CurrentStartB = 0;
	int CurrentStartW = 0;

	int CurrentEndR = 0;
	int CurrentEndG = 0;
	int CurrentEndB = 0;
	int CurrentEndW = 0;

	float DifferenceR = 0;
	float DifferenceG = 0;
	float DifferenceB = 0;
	float DifferenceW = 0;	

	int tempR = 0;
	int tempG = 0;
	int tempB = 0;
	int tempW = 0;
	
	int tempX = 0;
	int tempY = 0;
	
	int sameOffset = 0;
	
	boolean TempStartIndicatorError = false;
	UserSequences[SelectedSequence].StartValError = false; //for user notifcation of bad start values	
	
	if(TimeLineBuffer == null) return;
	
	int tempA = 600 / (UserSequences[SelectedSequence].SeqFrameAmount+1); //distance between frames in pixels, for figuring TLbutton position
	TimeLineCellSize = tempA;
	int qTemp = 0;

	//create frame buttons	
	TimeLineFrameButtons = new Button[(UserSequences[SelectedSequence].SeqFrameAmount+1)];
	
	for (int q=0; q != UserSequences[SelectedSequence].SeqFrameAmount+1;q++)
	{
		if (q == SelectedFrame) TempFlag = true; //figures whether to start a TLbutton highlighted
		else TempFlag = false;

		TimeLineFrameButtons[tempButtonCounter] = new Button(""+(1+q), cTLChBufX+22+(tempA*qTemp), cTLChBufY-25, 25, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, TempFlag, false);
		tempButtonCounter++;
		qTemp++;

	}//end for()	
	//end frame button creation		
	
	TimeLineBuffer.beginDraw();
	//TimeLineBuffer.height = cStartY+(TotalColorChannels*cTLChBufH)+5; //resize crop bottom off???x
	TimeLineBuffer.background(cBackgroundColor);
	//end start value stuff

	TimeLineBuffer.strokeWeight(2);
	TimeLineBuffer.textFont(fDigital, 48);

	//println("++++++++++++++++++++++++"+TimeLineBuffer.height+" : "+TotalColorChannels+" : "+TimeLineBuffer.width);
	
	TLStartIndicators =  new TLTriangle[TotalColorChannels];
	TimeLineLabelButtons = new Button[TotalColorChannels];
	
	for (int i = 0; i != TotalColorChannels; i++)
	{
		TimeLineBuffer.stroke(cStrokeColor);//line seperating color channels
		TimeLineBuffer.line(0, (i*cTLChBufH), (TimeLineBuffer.width-30), (i*cTLChBufH));	
		

		TimeLineLabelButtons[i] = new Button(""+(i+1), 0, 5+(i*cTLChBufH), 30, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false, false);
		TimeLineLabelButtons[i].displayTL();
		
		
		TimeLineBuffer.noStroke();
		
		if(UserSequences[SelectedSequence].SeqMode == mGradient && i != 0)
		{	
			//If its a Gradient, repeat  the same image
			TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(i*cTLChBufH), 600, cTLGraphBufH);
		}
		else
		{
			PreviewBuffer[i] = createGraphics(600, cTLGraphBufH);
			GenerateSeqPreview(PreviewBuffer[i], i, SelectedSequence); //should be passing i	
			TimeLineBuffer.image(PreviewBuffer[i], 35, 5+(i*cTLChBufH), 600, cTLGraphBufH);
		}
		
		//not sure how to handle display the start value, might have to calculate it by running
		//find currentStart and Current End, calculate scale factor, multiply by StartValue and use it to scale TempA
		//how to factor in color and shit.... right now it only checks red[0], but it will need to find the highest of the starts and use that?
		//      should already be scaled

		//Figures Start Values Indicator Position
		if (UserSequences[SelectedSequence].SeqMode != mInstant && UserSequences[SelectedSequence].SeqMode != mFilePlay)
		{
			switch(PixelDataType)
			{
			case 2: //RGBW
				WStart = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)+3]; 
			case 1: //RGB
				RStart = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)];
				GStart = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)+1];
				BStart = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				WStart = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)]; 
				break;	
			}	

			tempFrameVar = UserSequences[SelectedSequence].DataFrameVar[(i*CurrentDataTypeMult)]; //set to default framevar

			//println("DrawTimeLine: "+PixelDataType+" : "+SelectedSequence+" : "+tempFrameVar+" : "+i);

			switch(PixelDataType)
			{
			case 2: //RGBW
				CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+3];
			case 1: //RGB
				CurrentStartR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				CurrentStartG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+1];
				CurrentStartB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				break;	
			}	  	  

			//increment framevar
			if (tempFrameVar < UserSequences[SelectedSequence].SeqFrameAmount) tempFrameVar++;
			else tempFrameVar = 0; //increment or wrap FrameVar

			switch(PixelDataType)
			{
			case 2: //RGBW
				CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+3];
			case 1: //RGB
				CurrentEndR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				CurrentEndG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+1]; 
				CurrentEndB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				break;	
			}	 	  	
			
			//reads the start and end values, if they are the same, it overwrites the startvalue which is an indicator preload value
			switch(PixelDataType)
			{
			case 0: //Single
				if(CurrentStartW == CurrentEndW)
				{
					sameOffset = WStart;
					WStart = CurrentStartW; //they are same, overwrite start since it was data
				}	
				
				break;
			case 2: //RGBW
				if(CurrentStartW == CurrentEndW)
				{
					sameOffset = WStart;
					WStart = CurrentStartW; //they are same, overwrite start since it was data
				}			
				
			case 1: //RGB
				if(CurrentStartR == CurrentEndR)
				{
					//sameOffset = RStart;
					RStart = CurrentStartR; //they are same, overwrite start since it was data
				}

				if(CurrentStartG == CurrentEndG)
				{
					//sameOffset = GStart;
					GStart = CurrentStartG; //they are same, overwrite start since it was data
				}

				if(CurrentStartB == CurrentEndB)
				{
					//sameOffset = BStart;
					BStart = CurrentStartB; //they are same, overwrite start since it was data
				}
				
				if(PixelDataType == 1)
				{
					if(CurrentStartR == CurrentEndR && CurrentStartG == CurrentEndG && CurrentStartB == CurrentEndB)
					{
						sameOffset = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)];	//use any one, should all be the same
					}
				}
				else if(PixelDataType == 2)
				{
					if(CurrentStartR == CurrentEndR && CurrentStartG == CurrentEndG && CurrentStartB == CurrentEndB && CurrentStartW == CurrentEndW)
					{
						sameOffset = UserSequences[SelectedSequence].StartValues[(i*CurrentDataTypeMult)];	//use any one, should all be the same
					}	
				}
				break;	
			} //end switch				
			
			tempFrameVar = UserSequences[SelectedSequence].DataFrameVar[(i*CurrentDataTypeMult)]; //set to default framevar
			
			//println("=========================================================================");
			//detect bad start values or out of range colors
			switch(PixelDataType)
			{
			case 0: //Single
				if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[SelectedSequence].StartValError = true;
				break;	
			case 2: //RGBW
				if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[SelectedSequence].StartValError = true;
			case 1: //RGB
				if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) UserSequences[SelectedSequence].StartValError = true;
				if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) UserSequences[SelectedSequence].StartValError = true;
				if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) UserSequences[SelectedSequence].StartValError = true;			
				break;
			}	
			
			DifferenceR = 0;
			DifferenceG = 0;
			DifferenceB = 0;
			DifferenceW = 0;

			//println("Difference"+i+": "+DifferenceR+" : "+DifferenceG+" : "+DifferenceB+" : "+DifferenceW);
			//println("StartVals"+i+": "+RStart+" : "+GStart+" : "+BStart+" : "+WStart);
			//println("CurrentStart"+i+": "+CurrentStartR+" : "+CurrentStartG+" : "+CurrentStartB+" : "+CurrentStartW); 			
			//println("CurrentEnd"+i+": "+CurrentEndR+" : "+CurrentEndG+" : "+CurrentEndB+" : "+CurrentEndW); 

			if(CurrentStartR >= CurrentEndR) DifferenceR = CurrentStartR - RStart;
			else DifferenceR = RStart - CurrentStartR;

			if(CurrentStartG >= CurrentEndG) DifferenceG = CurrentStartG - GStart;
			else DifferenceG = GStart - CurrentStartG;			
			
			if(CurrentStartB >= CurrentEndB) DifferenceB = CurrentStartB - BStart;
			else DifferenceB = BStart - CurrentStartB;
			
			if(CurrentStartW >= CurrentEndB) DifferenceW = CurrentStartW - WStart;
			else DifferenceW = WStart - CurrentStartW;
			
			
			if (DifferenceR < 0) DifferenceR = (DifferenceR * -1); //checks and handles negative numbers
			if (DifferenceG < 0) DifferenceG = (DifferenceG * -1);
			if (DifferenceB < 0) DifferenceB = (DifferenceB * -1);      
			if (DifferenceW < 0) DifferenceW = (DifferenceW * -1); 		
			
			//println("THIS1 "+i+": "+DifferenceR+" : "+DifferenceG+" : "+DifferenceB+" : "+DifferenceW);
			
			tempR = (CurrentEndR - CurrentStartR);
			tempG = (CurrentEndG - CurrentStartG);
			tempB = (CurrentEndB - CurrentStartB);				
			tempW = (CurrentEndW - CurrentStartW);				
			
			if (tempR < 0) tempR = (tempR * -1); //checks and handles negative numbers
			if (tempG < 0) tempG = (tempG * -1);
			if (tempB < 0) tempB = (tempB * -1);      
			if (tempW < 0) tempW = (tempW * -1); 
			
			//println("THIS2 "+i+": "+tempR+" : "+tempG+" : "+tempB+" : "+DifferenceW);

			DifferenceR = DifferenceR / (float)tempR;
			DifferenceG = DifferenceG / (float)tempG;	
			DifferenceB = DifferenceB / (float)tempB;
			DifferenceW = DifferenceW / (float)tempW;		
			
			if (DifferenceR > 0xFFFF) DifferenceR = 0; //checks for infinity
			if (DifferenceG > 0xFFFF) DifferenceG = 0;  
			if (DifferenceB > 0xFFFF) DifferenceB = 0;
			if (DifferenceW > 0xFFFF) DifferenceW = 0;				
			
			
			if (Float.isNaN(DifferenceR)) DifferenceR = 0;
			if (Float.isNaN(DifferenceG)) DifferenceG = 0;
			if (Float.isNaN(DifferenceB)) DifferenceB = 0;			
			if (Float.isNaN(DifferenceW)) DifferenceW = 0;
			
			//println("DifferenceCalculated"+i+": "+DifferenceR+" : "+DifferenceG+" : "+DifferenceB+" : "+DifferenceW);

			switch(PixelDataType)
			{
			case 0: //Single
				tempVar = DifferenceW;
				break;
			case 1: //RGB
				tempVar =  max(max(DifferenceR, DifferenceG), DifferenceB);
				break;	
			case 2: //RGBW
				tempVar =  max(max(DifferenceR, DifferenceG), max(DifferenceB, DifferenceW));
				break;
			}		

			
			//not sure if this is a rule or a good way to do it, but makes RGBWs work and preload as well
			//println(i+"   "+tempVar+"   "+tempA+"    "+tempFrameVar+"    "+sameOffset);				
			if(tempVar == 0) tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA)+PApplet.parseInt(((float)sameOffset/255)*(float)tempA);
			else tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);

			
			tempY =  5+(i*cTLChBufH);
			sameOffset = 0;
			
			if(tempX > (597+35) || tempX < 35) //prevent bad indicator placement, user can drag to set correctly
			{
				//println("Start Value indicator out of range, bad data "+tempX);
				UserSequences[SelectedSequence].StartValError = true;
				tempX = 35;
				TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), cColButtonsOut, false, false);		
			}	
			else if(UserSequences[SelectedSequence].StartValError == true)
			{
				TempStartIndicatorError = true;	
				UserSequences[SelectedSequence].StartValError = false;

				tempX = 35;
				TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), cColButtonsOut, false, false);			
			}
			else TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, cColButtonsHL, cColButtonsHL, cColButtonsOut, false, false);		
			TLStartIndicators[i].bufferDisplay(); //displays to graphic buffer
		}
		else
		{
			//Then its mInstant or fileplay
			tempFrameVar = UserSequences[SelectedSequence].DataFrameVar[(i*CurrentDataTypeMult)];
			tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);

			//it is an instant, all start values start at beginning
			//println("Error, Size: "+UserSequences[SelectedSequence].StartValues.length+" : "+UserSequences[SelectedSequence].DataFrames.length);
			try {	
				for (int q = 0; q != UserSequences[SelectedSequence].DataSize; q++) 
				UserSequences[SelectedSequence].StartValues[q] = UserSequences[SelectedSequence].DataFrames[0][UserSequences[SelectedSequence].DataFrameVar[q]];		
			}
			catch(Exception e)
			{
				println("Unable to create startvals from DataFrame - Graphicsbuffer.pde");	
			}
			if(UserSequences[SelectedSequence].SeqMode != mFilePlay)
			{
				TLStartIndicators[i] = new TLTriangle(""+i, tempX, 5+(i*cTLChBufH), 0, 10, cColButtonsHL, cColButtonsHL, cColButtonsOut, false, false);
				TLStartIndicators[i].bufferDisplay(); //displays to graphic buffer
			}
		}
	} //end for()
	TimeLineBuffer.endDraw();

	UserSequences[SelectedSequence].StartValError = TempStartIndicatorError;	
	
	if(UserSequences[SelectedSequence].StartValError == true) println("Bad Start Value(s) Detected");
}//end func

//============================================================================================================

public void DrawIndexScrollArea()
{
	println("DrawIndexScrollArea() "+IndexMapPointer);

	//should already be done, but in case their are not updated
	for (int i = 1; i != UserSequences.length; i++)	 MeasureSequenceLength(i); 
	
	RunParseIndex(); //updates IndexedSequenceLength

	//println(IndexMapPointer+"     "+IndexScrollBar.Maximum+"    "+IndexScrollBar.Value);
	
	if (420 < (IndexMapPointer*cSeqTileVertSpace)) //not sure why 420, tried to change it
	{
		if((IndexMapPointer+1) == device.MaxIndexedSequences)
		{
			//No more room for add sequence tile
			IndexScrollBar.Maximum = (IndexMapPointer-5);
			IndexScrollBuffer = createGraphics(180, (IndexMapPointer+1)*cSeqTileVertSpace);					
		}		
		else
		{				
			IndexScrollBar.Maximum = (IndexMapPointer-4);	
			IndexScrollBuffer = createGraphics(180, (IndexMapPointer+2)*cSeqTileVertSpace);	
		}
		if(IndexScrollBar.Maximum < 0) IndexScrollBar.Maximum = 0; 
		
		IndexScrollBar.Value = IndexScrollBar.Maximum;
	}
	else IndexScrollBar.Maximum = 0; //disable scrolling
	
	IndexScrollBuffer.beginDraw();
	IndexScrollBuffer.background(cScrollBoxColor);

	for (int i = 0; i != IndexMapPointer+2; i++)
	{
		if((i+1) != (device.MaxIndexedSequences+1))// && (device.BasicVersion == 0 || device.BasicMaxSequences > i))
		{	
			//Draw Number
			IndexScrollBuffer.fill(255);
			IndexScrollBuffer.textSize(36);
			IndexScrollBuffer.textFont(fDigital, 48);
			IndexScrollBuffer.text((i+1)+"", 5, 50+(i*cSeqTileVertSpace));
			IndexScrollBuffer.textFont(fNormal, 48);
		}
		
		//if not cIndexEmptyID display icon, if it is cIndexEmptyID, set "Add" tile and break.
		if (IndexMapArray[i] == cIndexEmptyID) 
		{	
			//println("Exception Occured in DrawIndexScrollArea()");
			if(i != device.MaxIndexedSequences)
			{	
				println("No more UserSequences to Draw");
				IndexScrollBuffer.fill(cColButtonsBG); //was cBorderColor
				IndexScrollBuffer.stroke(0);
				IndexScrollBuffer.rect(60, (5+(i*cSeqTileVertSpace)), cSeqTileW, (cSeqTileH-10)); //the -10 makes it have some border though it is still clickable

				float tempFloat = (float)((float)IndexedSequenceLength/(float)device.DataSpace);
				if(IndexedSequenceLength > device.DataSpace)
				{
					println("Memory Overfilled");
					IndexScrollBuffer.fill(255);
					IndexScrollBuffer.textSize(12);
					IndexScrollBuffer.textAlign(CENTER);
					IndexScrollBuffer.text("The Memory is over filled, remove Sequences.", 65, (15+(i*cSeqTileVertSpace)), (cSeqTileW-5), cSeqTileH);
					IndexScrollBuffer.textAlign(LEFT);			
				}
				else
				{
					IndexScrollBuffer.strokeWeight(2);		
					IndexScrollBuffer.fill(0,255,0);	//Green Rect	
					IndexScrollBuffer.rect(68, (52+(i*cSeqTileVertSpace)), 94, 18);
					
					IndexScrollBuffer.fill(cColButtonsHL);	//red(filled) rect				
					IndexScrollBuffer.rect(68, (52+(i*cSeqTileVertSpace)), tempFloat*94, 18);				
					IndexScrollBuffer.noStroke();
					
					IndexScrollBuffer.fill(255);
					IndexScrollBuffer.textSize(12);
					IndexScrollBuffer.textAlign(CENTER);
					IndexScrollBuffer.text("Click To Add A Sequence", 65, (15+(i*cSeqTileVertSpace)), (cSeqTileW-5), cSeqTileH);
					IndexScrollBuffer.fill(0);			
					IndexScrollBuffer.text("Usage: "+IndexedSequenceLength, 60, (57+(i*cSeqTileVertSpace)), (cSeqTileW-5), cSeqTileH);
					
					IndexScrollBuffer.textAlign(LEFT);
				}
			}
			break; //once an empty has been found, it is the end of the linker
		}
		else if(IndexMapArray[i] == cIndexSerialID)
		{
			SerialSequenceIcon.bufferDisplaySqIndex(60, (5+(i*cSeqTileVertSpace)));
		}
		else if(IndexMapArray[i] == cIndexDMXID)
		{
			DMXSequenceIcon.bufferDisplaySqIndex(60, (5+(i*cSeqTileVertSpace)));
		}		
		else
		{
			UserSequences[IndexMapArray[i]].bufferDisplayIconB(60, (5+(i*cSeqTileVertSpace))); 			
		}
	}
	IndexScrollBuffer.endDraw();
} //end func

//===========================================================================================================================

public void InitLinkedBuffer()
{
	println("InitLinkedBuffer()");

	LinkedScrollBar.Maximum = (UserSequences[SelectedSequence].SeqFrameAmount+1)-5;
	if(LinkedScrollBar.Maximum < 1) LinkedScrollBar.Maximum = 0;
	if(LinkedScrollBar.Value > LinkedScrollBar.Maximum ) LinkedScrollBar.Value = LinkedScrollBar.Maximum;

	//UPDATE TO V2 or double check
	if(device.BasicVersion > 0)
	{
		if(UserSequences[SelectedSequence].SeqFrameAmount >= device.Channels) UserSequences[SelectedSequence].SeqFrameAmount = device.Channels-1;
	}

	int startY = cWorkspaceY+30;	
	int LCBtemp = 0;

	//LObjButtonPlus  = new Button[UserSequences[SelectedSequence].SeqFrameAmount+1];
	//LObjButtonMinus  = new Button[UserSequences[SelectedSequence].SeqFrameAmount+1];
	//LObjTextField  = new TextField[UserSequences[SelectedSequence].SeqFrameAmount+1];	
	//for (int i = 0; i != LinkedTextFieldObject.length; i++) LinkedTextFieldObject[i] = new TextFieldObjectL(i,340,(i+1)*cLinkedRoWHeight,25, 1, 256);
	
	LinkedCheckBox = new CheckBox[20]; //4 check boxes for each	
	LinkedTimerCheckBox = new CheckBox[5];
	
	for (int i = 0; i != (LinkedCheckBox.length/4); i++) //doesn't make boxes for each one, makes only visible boxes and updates the states
	{
		LinkedCheckBox[LCBtemp] =  new CheckBox(cTLChBufX+465, 30+(i*cLinkedRoWHeight)+startY, 20, 20, color(255), color(0), color(0), false);
		LinkedCheckBox[LCBtemp+1] =  new CheckBox(cTLChBufX+465, 60+(i*cLinkedRoWHeight)+startY, 20, 20, color(255), color(0), color(0), false); 
		LinkedCheckBox[LCBtemp+2] =  new CheckBox(cTLChBufX+465+140, 30+(i*cLinkedRoWHeight)+startY, 20, 20, color(255), color(0), color(0), false);
		LinkedCheckBox[LCBtemp+3] =  new CheckBox(cTLChBufX+465+140, 60+(i*cLinkedRoWHeight)+startY, 20, 20, color(255), color(0), color(0), false);		
		LCBtemp+=4;
		
		LinkedTimerCheckBox[i] =  new CheckBox(cTLChBufX+300, 65+(i*cLinkedRoWHeight)+startY, 20, 20, color(255), color(0), color(0), false);
	}
} //end InitLinkedBuffer()


public void DrawLinkedBuffer()
{
	//Draws all of the linked to the main screen buffer, called from draw() only
	
	println("DrawLinkedBuffer()");
	int startY = cWorkspaceY+30-(LinkedScrollBar.Value*cLinkedRoWHeight);
	int startX = cWorkspaceX+10;

	if(TextFieldActive == false)
	{
		for (int i = 0; i != 5; i++)	//only 5 visible labels, state is updated when scrolled
		{
			LObjTextField[i].Label = ""+UserSequences[SelectedSequence].SlideValues[i+LinkedScrollBar.Value]; //SlideValues double duty

			if(i == UserSequences[SelectedSequence].SeqFrameAmount) break; //5 rows or max frames....
		}
	}
	
	try 
	{ //fixes out of bounds that it was somehow getting through
		
		for (int i = 0; i != 5; i++)
		{		
			//start by clearing the checkboxs
			LinkedCheckBox[(i*4)].Selected = false;  
			LinkedCheckBox[(i*4)+1].Selected = false;  
			LinkedCheckBox[(i*4)+2].Selected = false;  
			LinkedCheckBox[(i*4)+3].Selected = false;  
			
			LinkedTimerCheckBox[i].Selected = false;
			
			if((UserSequences[SelectedSequence].DataFrameVar[i+LinkedScrollBar.Value] & 0x80) == 128) LinkedTimerCheckBox[i].Selected = true;
			
			//Now fill from SeqObject values
			switch(UserSequences[SelectedSequence].DataFrameVar[i+LinkedScrollBar.Value] & 0x7F)
			{
			case 0:	//instant
				LinkedCheckBox[(i*4)].Selected = true; 
				break;
			case 1: //fast fade
				LinkedCheckBox[(i*4)+1].Selected = true; 
				break;	
			case 2: //slow fade
				LinkedCheckBox[(i*4)+3].Selected = true; 
				break;
			case 7: //per sequence
				LinkedCheckBox[(i*4)+2].Selected = true; 
				break;							
			}
			if(i == UserSequences[SelectedSequence].SeqFrameAmount) break; //5 rows or max frames....	
		} //end for()

		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1); i++) if(i < LinkedTextFieldObject.length)	LinkedTextFieldObject[i].display();
		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1)*4; i++) if(i < LinkedCheckBox.length)	 LinkedCheckBox[i].display();	//only shows up to 5, thats the catch is for?
		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1); i++) if(i < LinkedTimerCheckBox.length)	 LinkedTimerCheckBox[i].display();		
		
		
		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1); i++)
		{
			if((i-LinkedScrollBar.Value) > -1 && (i-LinkedScrollBar.Value) < 5)
			{
				stroke(255);//cStrokeColor);
				strokeWeight(2);
				line(startX, ((i+1)*cLinkedRoWHeight)+startY, 765, ((i+1)*cLinkedRoWHeight)+startY);
				stroke(cStrokeColor);
				fill(cWorkspaceFontColor);
				textSize(36); //has to be here as display() changes it
				textFont(fDigital, 48);
				text((i+1)+"", startX, startY+60+(i*cLinkedRoWHeight));
				noStroke();
				textFont(fNormal, 48);

				textSize(14);
				fill(cWorkspaceFontColor);
				
				if(LinkedTimerCheckBox[(i-LinkedScrollBar.Value)].Selected == false)
				text("Loops/Iterations: ", startX+200, startY+20+(i*cLinkedRoWHeight));
				else
				text("Time(Seconds): ", startX+200, startY+20+(i*cLinkedRoWHeight));				
				text("Enable Timer: ", startX+200, startY+80+(i*cLinkedRoWHeight));							
				text("Transition Type:", startX+480, startY+20+(i*cLinkedRoWHeight));
				text("Instant:", startX+410, startY+45+(i*cLinkedRoWHeight));
				text("Per Sequence:", startX+500, startY+45+(i*cLinkedRoWHeight));				
				text("Fast Fade:", startX+390, startY+75+(i*cLinkedRoWHeight));
				text("Slow Fade:", startX+530, startY+75+(i*cLinkedRoWHeight));				
				
				
				if (UserSequences[SelectedSequence].SlideFlags[i] != 0)
				{
					//1 is added to have a way to show the blank Icon
					UserSequences[UserSequences[SelectedSequence].SlideFlags[i]].displayIconSmall(startX+60, (10+(i*cLinkedRoWHeight)+startY));	
				}
				else
				{
					fill(cBorderColor);
					rect(startX+60, startY+(10+(i*cLinkedRoWHeight)), 110, 75);
					fill(0);
					textSize(12);
					textAlign(CENTER);
					text("Click This Icon\nTo Select a\nSequence", startX+65, startY+(25+(i*cLinkedRoWHeight)), 105, 70);
					textAlign(LEFT);
				}
			}
		} //end for()
	} //end try
	catch(Exception e) { println("Exception Caught"); }

	stroke(255);
	strokeWeight(2);
	line(cTLChBufX, cTLChBufY, 765, cTLChBufY);

	fill(cWorkspaceFontColor);
	textSize(14);
	text("Use the Add/Remove buttons to set the amount of Linked Sequences available.", cWorkspaceX+5, cWorkspaceY+15);
	LinkedScrollBar.display();
	DisplayFrameButtons();	
}//end DrawLinkedBuffer()

//=============================================================================================

public void DrawUserSeqIconBuffer(int methodArgument)
{
	println("DrawUserSeqIconBuffer() "+methodArgument);

	if(methodArgument == 9999) //means update all sequences
	{	
		println("DrawUserSeqIconBuffer() - Update All Icons");
		//===========================================================================================  		
		if(UserSequences.length >= 1)
		{	
			for (int i = 1; i != UserSequences.length; i++)
			{
				UserSequences[i].previewImage = createGraphics(PApplet.parseInt(UserSequences[i].bWidth*0.9f), PApplet.parseInt(cTLGraphBufH*0.9f));
				GenerateSeqPreview(UserSequences[i].previewImage , 0, i); // set passedID to 0
			}
		}
	}	
	else
	{
		println("DrawUserSeqIconBuffer() - Single Icon Update "+methodArgument);		
		//======================================================================================================================  

		UserSequences[methodArgument].previewImage = createGraphics(PApplet.parseInt(UserSequences[methodArgument].bWidth*0.9f), PApplet.parseInt(cTLGraphBufH*0.9f));
		GenerateSeqPreview(UserSequences[methodArgument].previewImage, 0, methodArgument); //made passID 0 since it should use the first data frame and colorchannel 0s
	} //end else
}//end func

//========================================================================================================================

public void GenerateSeqPreview(PGraphics GBuffer, int PassedID, int SelSeq)
{
	//generates a gradient or steps or both

	//println("GenerateSeqPreview() with "+PassedID+" : "+SelSeq+" : "+GBuffer);
	int tempChan = PassedID * CurrentDataTypeMult; //build channel number
	int tempA = GBuffer.width / (UserSequences[SelSeq].SeqFrameAmount+1);
	
	if (PassedID == TotalColorChannels) tempChan = PassedID;

	GBuffer.beginDraw();
	GBuffer.background(cBackgroundColor); //make background dark grey
	GBuffer.noStroke();

	if(UserSequences[SelSeq].SeqMode == mLinked)
	{
		//make it transparent
		GBuffer.background(0, 0, 0, 0); //make background transparent;
		GBuffer.endDraw();
		return;
	}
	else if(UserSequences[SelSeq].SeqMode == mPOV)
	{
		//it is up to cTLGraphBufH pixels high		
		println("Generate as POV "+SelSeq+" : TotalColorChannels: "+TotalColorChannels);
		
		POVGraphicBuffer = createGraphics(UserSequences[SelSeq].SeqFrameAmount+1, TotalColorChannels);
		POVGraphicBuffer.beginDraw();
		//	POVGraphicBuffer.background(0,0,0,0); //transparent BG
		POVGraphicBuffer.background(65);
		POVGraphicBuffer.noStroke();
		
		int x = 0;
		
		switch(UserSequences[SelSeq].POVConfigType)
		{
		case 0: //"First Pixel Is Bottom Left. Rows Are Displayed Top To Bottom."
			for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i=0; i != TotalColorChannels;i++)
				{
					POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
					POVGraphicBuffer.rect(i, q, 1, 1);					
					x+=3;
				} //end for()
			}//end for()		
			break;
			
		case 1: //"First Pixel Is Bottom Left. Columns Are Displayed Left To Right."
			for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i=0; i != TotalColorChannels;i++)
				{		
					POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
					POVGraphicBuffer.rect(q, i, 1, 1);				
					x+=3;
				} //end for()
			}//end for()		
			break;
		case 2: //"First Pixel Is Top Left. Rows Are Displayed Top To Bottom."
			for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i=TotalColorChannels; i != 0;i--)
				{		
					POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
					POVGraphicBuffer.rect(q, i, 1, 1);				
					x+=3;
				} //end for()
			}//end for()		
			break;
		case 3: //"First Pixel Is Top Left. Columns Are Displayed Left To Right."
			for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
			{
				x = 0;
				for (int i = TotalColorChannels; i != 0;i--)
				{		
					POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
					POVGraphicBuffer.rect(q, i, 1, 1);				
					x+=3;
				} //end for()
			}//end for()		
			break;							
		}//end switch
		
		POVGraphicBuffer.endDraw();
		GBuffer.image(POVGraphicBuffer,0,0,600,TotalColorChannels);	//TotalColorChannels was 10, simple fix but not what I want

		GBuffer.endDraw();
		return;
	}

	//Not a linked or POV
	int qTemp = 0;
	int ColorTemp = color(0);
	int c = color(0);  //temp color		
	int myColor = color(0);
	
	//int[][] HoldDataFrames = new int[UserSequences[SelSeq].SeqFrameAmount+1][UserSequences[SelSeq].DataSize];
	
	//preload work buffer[][] with DataFrames[][] unless combo, than its already handled
	//if(UserSequences[SelSeq].SeqMode != mTech)	
	//	for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++) arrayCopy(UserSequences[SelSeq].DataFrames[q], HoldDataFrames[q], UserSequences[SelSeq].DataSize);
	//int[][] *HoldDataFrames = &UserSequences[SelSeq].DataFrames;

	for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
	{
		//first check for slides since that effects the qTemp var

		//Start Modes
		if (UserSequences[SelSeq].SeqMode == mFade || UserSequences[SelSeq].SeqMode == mGradient)
		{
			//Fade	
			//if(PassedID == 0) println("Fade "+q+" : "+qTemp+" : tempChan: "+tempChan);

			//this code				
			if (qTemp == UserSequences[SelSeq].SeqFrameAmount)
			{		  
				switch(UserSequences[SelSeq].DataType)
				{
				case 0: //Single
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan]>>8));
					else	ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan]);   
					break;
				case 1: //RGB
				case 2: //RGBW								
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan]>>8), (UserSequences[SelSeq].DataFrames[0][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[0][tempChan+2]>>8)); 
					else	ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan], UserSequences[SelSeq].DataFrames[0][tempChan+1], UserSequences[SelSeq].DataFrames[0][tempChan+2]);   
					break;	
				}
			}
			else 
			{
				switch(UserSequences[SelSeq].DataType)
				{
				case 0: //Single
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]>>8));
					else	ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]);
					break;
				case 1: //RGB
				case 2: //RGBW								
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+2]>>8));
					else	ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan], UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+2]);  
					break;	
				}		  		  
			}						
			//end this code				
			
			//println("qTemp: "+qTemp+" : "+red(ColorTemp)+" : "+green(ColorTemp)+" : "+blue(ColorTemp));
			float inter;
			c = color(0);  //temp color		
			myColor = color(0);
			
			
			switch(UserSequences[SelSeq].DataType)
			{
			case 0: //Single
				if(device.Bit16Mode == true)	myColor = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8));
				else	myColor = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan]);
				break;
			case 1: //RGB
			case 2: //RGBW	
				if(device.Bit16Mode == true)	myColor = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
				else	myColor = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);		
				break;	
			} //end switch 					

			
			for (int i = 0; i <= tempA; i++) 
			{
				inter = map(i, 0, tempA, 0, 1);
				
				if(UserSequences[SelSeq].DataType == 0) c = lerpColor(myColor, ColorTemp, inter);
				else c = lerpColor(color(myColor), ColorTemp, inter);		
				
				GBuffer.stroke(c); //draws gradient line by line
				GBuffer.line(i+(qTemp*tempA), 0, i+(qTemp*tempA), cTLGraphBufH);
			}			
			
			
			if(UserSequences[SelSeq].DataType == 2)  //if RGBW draw extra box for greyscale
			{
				GBuffer.noStroke();
				GBuffer.fill(255);
				
				for (int i = 0; i <= tempA; i++) 
				{
					inter = map(i, 0, tempA, 0, 1);
					
					if(i == 0)
					{
						if(device.Bit16Mode == true) 
						{
							if ((qTemp+1) > UserSequences[SelSeq].SeqFrameAmount) ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan+3]>>8));
							else ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+3]>>8));
						}			 
						else 
						{
							if ((qTemp+1) > UserSequences[SelSeq].SeqFrameAmount) ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan+3]);
							else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+3]);
						}		
					}	 //end if i == 0
					
					if(device.Bit16Mode == true)  c = lerpColor(color((UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]>>8)), ColorTemp, inter);
					else	c = lerpColor(color(UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]), ColorTemp, inter);
					
					GBuffer.stroke(c);
					GBuffer.line(i+(qTemp*tempA), 10, i+(qTemp*tempA), cTLGraphBufH); //5= half the buffer height		
				}	//end for()
			} //end if()
		}
		else if (UserSequences[SelSeq].SeqMode == mInstant || UserSequences[SelSeq].SeqMode == mFilePlay)
		{	
			if(UserSequences[SelSeq].SlideFlags[q] > 0 && UserSequences[SelSeq].SeqMode != mFilePlay)
			{
				// It is a slide frame
				if ((UserSequences[SelSeq].SlideFlags[q] & 0x40) > 0) //checks dir bit
				{
					//Slide Up - Single, RGB, RGBW					
					float tempC = (float)tempA /  (float)UserSequences[SelSeq].SlideValues[q];

					GBuffer.noStroke();
					for (int i = 0; i != UserSequences[SelSeq].SlideValues[q]; i++) 
					{
						if (i%2 == 0)
						{
							GBuffer.fill(100);
							GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
						}
						else
						{
							GBuffer.fill(20);
							GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
						}
					}
					
					GBuffer.fill(255, 0, 0);
					for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 1, 15+(tempA * qTemp)+(zz*15), 9, 20+(tempA * qTemp)+(zz*15), 1);
					
					GBuffer.noStroke();
				} //end else if() SlideUp
				else
				{		
					//slide Down - Single, RGB, RGBW
					float tempC = (float)tempA /  (float)UserSequences[SelSeq].SlideValues[q];

					GBuffer.noStroke();
					for (int i = 0; i !=  UserSequences[SelSeq].SlideValues[q]; i++) 
					{
						if (i%2 == 0)
						{
							GBuffer.fill(100);
							GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
						}
						else
						{
							GBuffer.fill(20);
							GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
						}
					} //end i for()

					GBuffer.fill(255, 0, 0);
					for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 9, 15+(tempA * qTemp)+(zz*15), 1, 20+(tempA * qTemp)+(zz*15), 9);
					
				}    //end slide down if
			} //end slide check
			else
			{
				//regular mInstant frame or mFileplay mode
				GBuffer.noStroke();

				switch(UserSequences[SelSeq].DataType)
				{
				case 0: //Single
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8));	//make grey
					else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan]);	//make grey
					break;
				case 1: //RGB
					if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
					else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);
					break;	
				case 2: //RGBW
					if(device.Bit16Mode == true) ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
					else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);
					break;
				} //end switch		
				GBuffer.fill(ColorTemp);
				GBuffer.rect((tempA * qTemp), 0, tempA, cTLGraphBufH);

				if(UserSequences[SelSeq].DataType == 2) //RGBW - draws greyscale box half of the Preview Graident
				{
					if(device.Bit16Mode == true) GBuffer.fill(color((UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]>>8)));
					else GBuffer.fill(color(UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]));
					GBuffer.rect((tempA * qTemp), 10, tempA, cTLGraphBufH);
				}
			} //end else - no slide
		}  
		qTemp++;
	} //end q for()	
	GBuffer.endDraw();
} //end func

//===================================================================================================	


public void SetSelectedFrame(int passedID)
{
	if(GraphicLayoutPreview == false) println("SetSelectedFrame() with "+passedID);
	
	try {
		TimeLineFrameButtons[SelectedFrame].Selected = false;
	}
	catch(Exception e) { }

	//Can not know what FrameScrollBarView was, so cannot use it to calculate previous frameID#
	// if builtID was made global than it could use that
	//int builtID = passedID-FrameScrollBarView;
	for(int i = 0; i != FrameButtons.length;i++)  FrameButtons[i].Selected = false; //easy way out
	for(int i = 0; i != GradientRects.length;i++) GradientRects[i].Selected = false; //easy way out

	SelectedFrame = passedID;
	
	try {
		TimeLineFrameButtons[SelectedFrame].Selected = true;
		//println("SelectedFrame: "+SelectedFrame);	
	}
	catch(Exception e) { }

	try {
		FrameButtons[passedID-FrameScrollBarView].Selected = true;
		GradientRects[passedID-FrameScrollBarView].Selected = true;
	}
	catch(Exception e) { }	
	
	//added for Sequence Software Preview
	if(GraphicLayoutPreview == false) UpdateSideBarButtonStates();
}

//==============================================================================================================     

public void ResetLEDIcons()
{
	println("ResetLEDIcons()");
	CurrentPixelUsage = 0;	
	DefinedPixelUsage = 0;
	PixelIcon = new LEDgraphic[cSoftwareMaxChans];
	LEDIconCoordX = new int[1];
	LEDIconCoordY = new int[1];
	
	MenuTabs[0].refresh(); 
}

//==============================================================================================================     

public void GraphicLayoutUpdateIcons()
{
	//displays/updates the LED pixel icons per group to a graphic buffer. Can be called anytime.
	
	if(GraphicLayoutPreview == false) println("GraphicLayoutUpdateIcons()    ViewGroupIDNum: "+ViewGroupIDNum);

	if(GraphicLayoutBuffer == null && IconLayoutAdvancedMode.Selected == false)  GraphicLayoutBuild(0);
	CurrentPixelUsage = TotalColorChannels * (UserSequences[SelectedSequence].PacketCloneMode+1); //update this with packet cloning?? or sequenceChannelAmount? in future

	//if basic layout mode and colorchan is larger than defined, rebuild icons
	/*
	if(TotalColorChannels > DefinedPixelUsage) 
	{
		if(IconLayoutAdvancedMode.Selected == false) GraphicLayoutBuild(0); //if basic mode, rebuild to match new layout
	}
	else 
	{
		if(IconLayoutAdvancedMode.Selected == false) GraphicLayoutBuild(0); //if basic mode, rebuild to match new layout
	}
	*/
	if(GraphicLayoutPreview == false) println("TotalColorChannels: "+TotalColorChannels+"    CurrentPixelUsage: "+CurrentPixelUsage+"   DefinedPixelUsage: "+DefinedPixelUsage);  

	GraphicLayoutBuffer.beginDraw(); //redraw background
	GraphicLayoutBuffer.background(cBackgroundColor);	
	
	//start image stuff=============================================	
	if(GraphicImageEnabled == true)
	{
		GraphicLayoutBuffer.beginDraw(); //should be already done, but this fixes it not displaying
		
		try {
			if(GraphicImageX == 0 && GraphicImageY == 0)
			{
				
				graphicImg = loadImage(graphicImgFilePath);

				GraphicImageWidth = graphicImg.width;
				GraphicImageHeight = graphicImg.height;

				if(GraphicImageWidth > cGLBufWidth) GraphicImageWidth = cGLBufWidth;
				if(GraphicImageHeight > cGLBufViewH) GraphicImageHeight = cGLBufViewH;

				graphicImg.resize(GraphicImageWidth,GraphicImageHeight);
				GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,GraphicImageWidth,GraphicImageHeight);
			}
			else GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,(ImageHandleTR.xpos - ImageHandleTL.xpos)+10,(ImageHandleBL.ypos - ImageHandleTR.ypos)+10);
		}
		catch(Exception e) { }
		
		
		if(GraphicImageResize == true)
		{
			handlerDrawImageHandles();
		} //end GraphicImageResize if()
	} //GraphicImageEnabled if()	
	//end image stuff=============================================	

	/*
	//draws lines from icon to icon
	try {	
	for (int i = 0; i != CurrentPixelUsage; i++)	
	{	
	if(ConfigShape == 3 && i > 0)
	{
	GraphicLayoutBuffer.beginDraw(); //REMOVE ONCE FIX LEDGRAPHIC .display()
	GraphicLayoutBuffer.stroke(255);
	GraphicLayoutBuffer.strokeWeight(2);
	GraphicLayoutBuffer.line(PixelIcon[i-1].xpos, PixelIcon[i-1].ypos, PixelIcon[i].xpos, PixelIcon[i].ypos);
	GraphicLayoutBuffer.noStroke();
	}
	}
	}
	catch(Exception e) { println("Error Drawing Lines Icon"); }
	*/

	if(ConfigShape == 6)
	{
		MouseIconPlace.Status = 0;
		MouseIconRemove.Status = 0;
		MouseIconReset.Status = 0;
	}
	else
	{
		MouseIconPlace.Status = 1;
		MouseIconRemove.Status = 1;
		MouseIconReset.Status = 1;
	}

	int i = 0;
	try 
	{		
		for (i = 0; i != CurrentPixelUsage; i++)	
		{
			if(PixelIcon[i].GroupID == ViewGroupIDNum)  PixelIcon[i].bufferDisplay(); //displays to graphic buffer
		} //end for()
	}
	catch(Exception e) {
	println("Error Displaying Icon at "+i); 
	} //end catch
	
	GraphicLayoutBuffer.endDraw();	
}//end func

//==============================================================================================================     

public void AddToLayout()
{
	println("AddToLayout()");
	if(ConfigShape ==  5 && PixelMapFilePath.equals("")) return;
	else if (ConfigShape ==  5 ) ImportCustomPixelMap(); //reloads the file from PixelMapFilePath
	GraphicLayoutBuild(DefinedPixelUsage);
} //end AddToLayout()

//==============================================================================================================     

public void GraphicLayoutBuild(int passedStarting)
{
	//Rebuilds the Pixel Icon arrays only called with pixel amount changes, LED icon reset, or for intitial loading
	//	does not transfer group IDs, so be careful in advanced layout mode
	ConfigShape = (ShapeOptionsDD.SelStr+1); //pull shape DD value

	println("GraphicLayoutBuild() with "+ConfigShape+"    TotalColorChannels: "+TotalColorChannels+"   passedStarting: "+passedStarting);
	//displays the shape that was setup in config, fills in the grey scale values for the colors.
	//used for config and workspace

	CalcLEDSize();
	int centX = 335;
	int centY = 255;
	int LocalPixelAmt = TotalColorChannels; //Use TotalColorChannels for basic layout mode
	int LocalBuildID = passedStarting; //need both for now
	
	if(ConfigShape == 0 || ConfigShape > 6) ConfigShape = 1; //check for out of bounds IDs and fix	

	println("LocalPixelAmt: "+LocalPixelAmt);
	if(IconLayoutAdvancedMode.Selected == false) 
	{
		if(ConfigShape != 6) //if not manual mode
		{
			DefinedPixelUsage = 0; //if basic mode, always start definedPixelUsage as 0
			CurrentPixelUsage = 0; //right?
			if(UserSequences[SelectedSequence].PacketCloneMode > 0) LocalPixelAmt = LocalPixelAmt + (TotalColorChannels * (UserSequences[SelectedSequence].PacketCloneMode));
		}
	}
	else
	{
		LocalPixelAmt = PixelAmountObject.value();
		println("Adding With "+LocalPixelAmt+"    TotalColorChannels: "+TotalColorChannels+"    CurrentPixelUsage: "+CurrentPixelUsage+"   DefinedPixelUsage: "+DefinedPixelUsage);  
		println("Group ID#: "+FunctionGroupIDNum);
	}
	
	//LEDCounter holds how many pixels were placed
	//LocalBuildID is the object array pointer

	println("Changed LocalPixelAmt: "+LocalPixelAmt);

	if(LocalPixelAmt > PixelIcon.length) 
	{	
	LocalPixelAmt = PixelIcon.length;
	ShowNotification(29);
	}

	int LEDCounter = 0;	
	
	switch(ConfigShape)
	{
	case 1:	//BuildRound();
		float degreeChange = (float)360 / LocalPixelAmt;
		float Angle=0;
		int Radius = 230; //affects spacing
		
		switch(LEDSpacingID)
		{
			case 0:
			Radius = 60; //affects spacing
			break;
			case 1:
			Radius = 115; //affects spacing
			break;		
			case 2:
			Radius = 190; //affects spacing
			break;
			case 3:
			Radius = 230; //affects spacing
			break;			
		}			
		
		for (int i=0;i != LocalPixelAmt; i++)
		{ 
			//show only  0, 3, 6, ect but in the correct places
			double Xa = centX+(Radius*Math.sin(Angle*Math.PI/180));
			double Ya = centY+(Radius*-Math.cos(Angle*Math.PI/180));
			Angle = Angle + degreeChange; //new Angle for calculations
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)Xa, (int)Ya, LEDSize); //put the ones I want to use correctly
			LocalBuildID++;
		}	
		LEDCounter = LocalPixelAmt;
		break;

	case 2:	//BuildSquare();  
		int ShapeSize = 425; //affects spacing
		
		switch(LEDSpacingID)
		{
			case 0:
			ShapeSize = 100; //affects spacing
			break;
			case 1:
			ShapeSize = 210; //affects spacing
			break;		
			case 2:
			ShapeSize = 325; //affects spacing
			break;
			case 3:
			ShapeSize = 425; //affects spacing
			break;			
		}		
		
		float Spacing = (float)ShapeSize / ((float)(LocalPixelAmt)/4);	
		//sizes ready	
		
		//BOTTOM
		for (int i=0;i != (LocalPixelAmt)/4;i++)
		{    
			//temp = LEDCounter%(LocalPixelAmt);
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), centY+(ShapeSize/2), LEDSize);
			LocalBuildID++;			
			LEDCounter++;
		}
		//RIGHT
		for (int i=0;i!=(LocalPixelAmt)/4;i++)
		{
			//temp = LEDCounter%LocalPixelAmt;
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (centX+(ShapeSize/2)), (int)((centY+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), LEDSize);	
			LocalBuildID++;
			LEDCounter++;
		}
		//TOP
		for (int i=0;i != (LocalPixelAmt)/4;i++)
		{
			//temp = LEDCounter%LocalPixelAmt;
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY-(ShapeSize/2)), LEDSize);
			LocalBuildID++;			
			LEDCounter++;
		}
		//LEFT
		for (int i=0;i != (LocalPixelAmt)/4;i++)
		{   
			//temp = LEDCounter%LocalPixelAmt;
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, centX-(ShapeSize/2), (int)((centY-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), LEDSize);
			LocalBuildID++;
			LEDCounter++;
		}
		break;
		
	case 3: //BuildSpiral();   
		int radius = 500;
		int coils = 16; //displays up to 310
		int rotation = 0;
		
		//not great profiles but work well enough
		switch(LEDSpacingID)
		{
			case 0:
			radius = 250; //affects spacing
			coils = 19;
			break;
			case 1:
			radius = 350; //affects spacing
			coils = 17; 
			break;		
			case 2:
			radius = 500; //affects spacing
			break;
		}		
			
		final float thetaMax = coils * 2 * PI;
		// How far to step away from center for each side.
		final float awayStep = radius / thetaMax;
		// distance between points to plot
		final int chord = LEDSize+(LEDSize/2);//25;
		int iterationcounter=0;

		//  for (float theta = chord / awayStep; theta <= thetaMax; ) 
		for (float theta = chord / awayStep; theta <= thetaMax; ) 
		{
			if(iterationcounter == LocalPixelAmt) break; ///not yet updated!!!!

			// How far away from center
			float away = awayStep * theta;
			// How far around the center.
			float around = theta + rotation;
			// Convert 'around' and 'away' to X and Y.
			int x = (int)round(centX + cos( around ) * away);
			int y = (int)round(centY + sin( around ) * away);
			// Now that you know it, do it.

			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)x, (int)y, LEDSize); //put the ones I want to use correctly    
			LocalBuildID++;			
			LEDCounter++;		
			
			// to a first approximation, the points are on a circle
			// so the angle between them is chord/radius
			theta += chord / away;

			iterationcounter++;
		} //end for
		break;   

	case 4: // BuildLine();  
		ShapeSize = 640;
		
		switch(LEDSpacingID)
		{
			case 0:
			ShapeSize = 160; //affects spacing
			break;
			case 1:
			ShapeSize = 320; //affects spacing
			break;		
			case 2:
			ShapeSize = 460; //affects spacing
			break;
			case 3:
			ShapeSize = 640; //affects spacing
			break;			
		}			
		
		Spacing = ShapeSize / ((float)(LocalPixelAmt));
		
		for (int i=0;i != (LocalPixelAmt);i++)
		{
			//PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY), LEDSize);	//left to right
			PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), (centY), LEDSize);		//right to left
			LocalBuildID++;
			LEDCounter++;
		}   
		break; 
	case 5:	// PixelMap
	case 6:   //Manual Mode		
		//need this for() to use coords from the arrays,t
		for (int q = 0; q != LEDIconCoordX.length; q++)	//CHECK KIND OF JUST WROTE IT!!!!!!
		{
			try {	
				if(LEDIconCoordX[q] != 0 || LEDIconCoordY[q] != 0)
				{	
					PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, LEDIconCoordX[q], LEDIconCoordY[q], LEDSize);	
					LocalBuildID++;
					LEDCounter++;
				}
			}
			catch(Exception e)
			{	
				println("Errror Building Graphic/PixelMap");
			}
		} //end for()
		
		RemoveLEDIconNum = -1000;
		break;			
	}//end switch
	
	if(IconLayoutAdvancedMode.Selected == false) { FunctionGroupIDNum = 0; ViewGroupIDNum = 0; }
	
	//if normal mode, all groupIDs are 0, if advanced mode Assign based on FunctionGroupIDNum
	//assign group ID only to just placed icons
	for (int i = passedStarting; i != (CurrentPixelUsage + LEDCounter); i++)	
	{
		try {
			PixelIcon[i].GroupID = FunctionGroupIDNum;	
		}
		catch(Exception e) { println("errored at "+i); break;}
	}
	
	println("LocalBuildID = "+LocalBuildID);	
	println("LEDCounter = "+LEDCounter);	
	
	CurrentPixelUsage = CurrentPixelUsage + LEDCounter; //update CurrentPixelUSage, which is a display based on sequence type and amounts
	DefinedPixelUsage = DefinedPixelUsage + LEDCounter; //update defined, which is technically max
}//end function

//==============================================================================================================     

public void DisplayDragIndicator()
{
	//Only can be called from draw()
	//println("DisplayDragIndicator()");
	
	//NOT 16-bit complient, it seems to work in software.....  not sure why it wouldn't be I looked it over...
	int CurrentStartR = 0;
	int CurrentStartG = 0;
	int CurrentStartB = 0;
	int CurrentStartW = 0;

	int CurrentEndR = 0;
	int CurrentEndG = 0;
	int CurrentEndB = 0;
	int CurrentEndW = 0; 

	mouseXS = round((float)mouseX / SF);
	mouseYS = round((float)mouseY / SF);  
	
	TLStartIndicators[DraggedIndicatorID].ColBG = color(cColButtonsHL); //changes it from purple(notification) back to red once moved
	
	TimeLineBuffer.beginDraw();
	TimeLineBuffer.fill(cBackgroundColor); //draws a rect over the previous position
	//Equal-Lattoral	TimeLineBuffer.rect(TLStartIndicators[DraggedIndicatorID].xpos-(TLStartIndicators[DraggedIndicatorID].bSize/2)-1, TLStartIndicators[DraggedIndicatorID].ypos-1, (float)(TLStartIndicators[DraggedIndicatorID].bSize*1.2), (float)(TLStartIndicators[DraggedIndicatorID].bSize*1.2));
	TimeLineBuffer.rect(TLStartIndicators[DraggedIndicatorID].xpos-(TLStartIndicators[DraggedIndicatorID].bSize)-1, TLStartIndicators[DraggedIndicatorID].ypos-1, (float)(TLStartIndicators[DraggedIndicatorID].bSize*2.25f), (float)(TLStartIndicators[DraggedIndicatorID].bSize*1.3f));

	if(UserSequences[SelectedSequence].SeqMode == mGradient) TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(DraggedIndicatorID*cTLChBufH), 600, cTLGraphBufH);
	else TimeLineBuffer.image(PreviewBuffer[DraggedIndicatorID], 35, 5+(DraggedIndicatorID*cTLChBufH), 600, cTLGraphBufH);
	
	TLStartIndicators[DraggedIndicatorID].xpos = mouseXS - cTLChBufX; //set xpos, then check and correct
	if (TLStartIndicators[DraggedIndicatorID].xpos < 35)  TLStartIndicators[DraggedIndicatorID].xpos = 35;
	else if (TLStartIndicators[DraggedIndicatorID].xpos > 600+35) TLStartIndicators[DraggedIndicatorID].xpos = 600+35;

	TimeLineBuffer.textFont(fDigital, 48);//load font for buttons
	TimeLineLabelButtons[DraggedIndicatorID].displayTL();
	
	//Displays the White Frame Line indicator and label buttons
	int tempA = 600 / (UserSequences[SelectedSequence].SeqFrameAmount+1); //distance between frames in pixels, for figuring TLbutton position
	if(UserSequences[SelectedSequence].SeqMode == mTech) tempA = 600 / (UserSequences[SelectedSequence].SeqFrameAmount+1);
	
	if(UserSequences[SelectedSequence].SeqMode != mInstant)	TLStartIndicators[DraggedIndicatorID].bufferDisplay(); //Dispalys to graphic buffer

	TimeLineBuffer.endDraw();	

	//figure out FrameVar
	int tempFrameVar = floor((TLStartIndicators[DraggedIndicatorID].xpos - 35) / tempA);
	if(tempFrameVar > UserSequences[SelectedSequence].SeqFrameAmount) tempFrameVar = UserSequences[SelectedSequence].SeqFrameAmount;
	
	
	float tempLocation = ((float)(TLStartIndicators[DraggedIndicatorID].xpos - 35) / (float)tempA) - tempFrameVar;
	//println("xpos: "+(TLStartIndicators[DraggedIndicatorID].xpos-35)+" : "+tempFrameVar+" : "+tempLocation+" : DraggedIndicatorID: "+DraggedIndicatorID+" : Multiplier: "+CurrentDataTypeMult);  

	if(UserSequences[SelectedSequence].SeqMode == mInstant)
	{
		//snap the indicator to frames
		TimeLineBuffer.beginDraw();	
		TLStartIndicators[DraggedIndicatorID].xpos = 35+tempFrameVar * tempA;
		TLStartIndicators[DraggedIndicatorID].bufferDisplay();
		TimeLineBuffer.endDraw();	
		
		//set FrameVar and Start Vals
		switch(PixelDataType)
		{
		case 0: //single
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)] = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempFrameVar;
			break;
			
		case 2: //RGBW	
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+3] = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+3];		
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+3] = tempFrameVar;		
			
		case 1: //RGB
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)] = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+1] = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+1];	 
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+2] = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+2];		

			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempFrameVar;
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+1] = tempFrameVar;
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+2] = tempFrameVar;
			break;
		}//end switch			
	}
	else
	{
		//nowset dataframevar			
		int tempDataFrameVar = 0; //done using it otherwise, so double duty
		//println("Using tempFrameVar: "+tempFrameVar);

		for(int q = 0; q != tempFrameVar+1;q++)
		{
			if (UserSequences[SelectedSequence].SlideFlags[q] > 0)
			{
				//Slide
			}
			else
			{
				//Fade or Instant
				switch(PixelDataType)
				{
				case 0: //single
					UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempDataFrameVar;
					break;
					
				case 2: //RGBW			
					UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+3] = tempDataFrameVar;		
					
				case 1: //RGB
					UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempDataFrameVar;
					UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+1] = tempDataFrameVar;
					UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+2] = tempDataFrameVar;
					break;
				}//end switch			
				
				tempDataFrameVar++;
			} //end else
		} //end for()			
		//end dataframevar calculation	
		
		switch(PixelDataType)
		{
		case 0: //single
			CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			break;
		case 1: //RGB
			CurrentStartR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			CurrentStartG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+1];
			CurrentStartB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+2];
			break;
		case 2: //RGBW
			CurrentStartR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			CurrentStartG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+1];
			CurrentStartB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+2];
			CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+3];		 
			break;
		}//end switch

		if (tempFrameVar < UserSequences[SelectedSequence].SeqFrameAmount) tempFrameVar++;
		else tempFrameVar = 0; //increment or wrap FrameVar

		switch(PixelDataType)
		{
		case 0: //single
			CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			break;
		case 1: //RGB
			CurrentEndR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			CurrentEndG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+1]; 
			CurrentEndB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+2];
			break;
		case 2: //RGBW
			CurrentEndR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)];
			CurrentEndG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+1]; 
			CurrentEndB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+2];
			CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][(DraggedIndicatorID*CurrentDataTypeMult)+3];			 
			break;
		}//end switch	
		
		float RedLerp = lerp(CurrentStartR,CurrentEndR, tempLocation);
		float GreenLerp = lerp(CurrentStartG,CurrentEndG, tempLocation);
		float BlueLerp = lerp(CurrentStartB,CurrentEndB, tempLocation);
		float WhiteLerp = lerp(CurrentStartW,CurrentEndW, tempLocation);
		
		//set into StartVals	array, how???
		tempFrameVar = floor((TLStartIndicators[DraggedIndicatorID].xpos - 35) / tempA); //need to redefine it since it has been modified to find currentend

		switch(PixelDataType)
		{
		case 0: //single
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)] = (int)WhiteLerp; //using red, but it a greyscale value so no matter
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempFrameVar;
			break;
			
		case 2: //RGBW	
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+3] = (int)WhiteLerp;			
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+3] = tempFrameVar;		
			
		case 1: //RGB
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)] = (int)RedLerp;
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+1] = (int)GreenLerp;		 
			UserSequences[SelectedSequence].StartValues[(DraggedIndicatorID*CurrentDataTypeMult)+2] = (int)BlueLerp;	

			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)] = tempFrameVar;
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+1] = tempFrameVar;
			UserSequences[SelectedSequence].DataFrameVar[(DraggedIndicatorID*CurrentDataTypeMult)+2] = tempFrameVar;
			break;
		}//end switch

		//display values
		if(mouseXS < 125) mouseXS = 125;
		else if(mouseXS > 690) mouseXS = 690;	
		
		textSize(12);
		fill(cBorderColor);
		stroke(cColButtonsHL);
		rect(mouseXS-10, TLStartIndicators[DraggedIndicatorID].ypos+85-TLScrollValue, 90, 65);
		fill(0);
		noStroke();
		
		text("Red: "+PApplet.parseInt(RedLerp)+"\nGreen "+PApplet.parseInt(GreenLerp)+"\nBlue: "+PApplet.parseInt(BlueLerp)+"\nWhite: "+PApplet.parseInt(WhiteLerp), mouseXS, TLStartIndicators[DraggedIndicatorID].ypos+100-TLScrollValue);
	}//end else
} //end func

//==============================================================================================================     


public void CloseLiveControlMenu()
{
	println("CloseLiveControlMenu()");
	cmdByte = cmdBulkLiveControl; //Live Control
	cmdData[0] = 0; //Disable Live Control
	cmdData[1] = 0; 
	cmdData[2] = 0;  
	cmdData[3] = 0;  
	RequestCommand();
} //end CloseLiveControlMenu()


public void OpenLiveControlMenu()
{
	//Open Live Connection
	println("OpenLiveControlMenu()");
	cmdByte = cmdBulkLiveControl; //Live Control Connection
	cmdData[0] = 1; //Enable Live Control'
	if(LiveControlCheckBox[3].Selected == true)  cmdData[1] = 1; //16-bit
	else  cmdData[1] = 0; //8-bit
	cmdData[2] = (UserChannelAmt >> 8) & 0xFF;  
	cmdData[3] = UserChannelAmt & 0xFF;   
	RequestCommand();  
	//End Live mode request
	
	LiveControlCheckBox[0].xpos = OverlayMenus[1].xpos+60;
	LiveControlCheckBox[1].xpos = OverlayMenus[1].xpos+100;
	LiveControlCheckBox[2].xpos = OverlayMenus[1].xpos+140;
	LiveControlCheckBox[3].xpos = OverlayMenus[1].xpos+240;
	
	LiveControlCheckBox[0].ypos = OverlayMenus[1].ypos+20;
	LiveControlCheckBox[1].ypos = OverlayMenus[1].ypos+20;
	LiveControlCheckBox[2].ypos = OverlayMenus[1].ypos+20;
	LiveControlCheckBox[3].ypos = OverlayMenus[1].ypos+20;
	
	LiveControlClose.xpos = OverlayMenus[1].xpos+680;
	LiveControlClose.ypos = OverlayMenus[1].ypos+15;
	LiveControlToggle.xpos = OverlayMenus[1].xpos+560;
	LiveControlToggle.ypos = OverlayMenus[1].ypos+15;
	
	LiveControlApply.xpos = OverlayMenus[1].xpos+325;
	LiveControlApply.ypos = OverlayMenus[1].ypos+10;
	
	
	
	TextFields[4].xpos = OverlayMenus[2].xpos+105;
	TextFields[4].ypos = OverlayMenus[2].ypos+10;
	TextFields[5].xpos = OverlayMenus[2].xpos+240;
	TextFields[5].ypos = OverlayMenus[2].ypos+10; 	
	
	//not the best method, but works, if it has 16-bit serial it has 16-bit live control...
	if(IsOnConfigFlags("f8or16Bit") == true) 	LiveControlCheckBox[3].Status = 0;
	else LiveControlCheckBox[3].Status = 1; //no 16-bit control for color picker on non-16bit devices

	try {
		ControlSliders = new SliderBar[UserChannelAmt];	
		ControlRects = new ColorRect[UserChannelAmt];	//make one for each channel, in case of single
	}
	catch(Exception e)
	{
		return; //if no device channels defined, return;
	}  

	int tempMaxVal = 255;
	
	if(LiveControlCheckBox[3].Selected == true)
	{
		//it is in 16-bit mode
		tempMaxVal = 0xFFFF;
	}
	
	//setup Color Squares
	LiveConTotalColChan = UserChannelAmt / LiveConDataMult;
	
	float rectSF = 1;
	int column = 0;
	int row = 0;
	
	int ControlRectSize = 50;
	int ControlRectSpace = 10;			
	
	int ControlRectAdjSize = PApplet.parseInt(ControlRectSize * rectSF);
	int ControlRectAdjSpace = PApplet.parseInt(ControlRectSpace * rectSF);

	//calculate scale factor
	for (int i = 0; i != LiveConTotalColChan; i++) 
	{
		ControlRectAdjSize = PApplet.parseInt(ControlRectSize * rectSF);
		ControlRectAdjSpace = PApplet.parseInt(ControlRectSpace * rectSF);	
		
		column++;

		if(((column+1) * (ControlRectAdjSize+ControlRectAdjSpace)) >= (OverlayMenus[1].Width-(ControlRectAdjSpace*2))) 
		{
			column = 0;
			row++;
		}
		if(((row+1)*(ControlRectAdjSize+ControlRectAdjSpace)) >= ((OverlayMenus[1].Height+ControlRectAdjSpace)-55))
		{
			i = 0;
			column = 0;
			row = 0;
			rectSF = rectSF - 0.05f;
		}
	}	//end for()		
	//end calculate scale factor

	column = 0;
	row = 0;
	ControlRectSize = PApplet.parseInt(ControlRectSize * rectSF);
	ControlRectSpace = PApplet.parseInt(ControlRectSpace * rectSF);			

	for (int i = 0; i != LiveConTotalColChan; i++) 
	{	
		ControlRects[i] = new ColorRect(OverlayMenus[1].xpos+(ControlRectSpace*2), OverlayMenus[1].ypos+50, ControlRectSize, ControlRectSize, 0, 0, 0, 0, ""+(i+1));			
		ControlRects[i].xpos = ControlRects[i].xpos + round(column*(ControlRectSize+ControlRectSpace));
		ControlRects[i].ypos = ControlRects[i].ypos + round(row*(ControlRectSize+ControlRectSpace));				
		ControlRects[i].Label = ""+(i+1);
		
		column++;
		
		if(((column+1) * (ControlRectSize+ControlRectSpace)) > (OverlayMenus[1].Width-(ControlRectSpace*2))) 
		{
			column = 0;
			row++;
		}
	}//end for()
	
	//start Slider Setup
	if(UserChannelAmt > 104 && UserChannelAmt <= 130)
	{
		rectSF = 0.7f;
	}
	else if(UserChannelAmt > 130 && UserChannelAmt <= 156)
	{
		rectSF = 0.6f;
	}			
	else if(UserChannelAmt > 156 && UserChannelAmt <= 182)
	{
		rectSF = 0.48f;
	}		
	else if(UserChannelAmt > 182 && UserChannelAmt <= 208)
	{
		rectSF = 0.38f;
	}	
	else if(UserChannelAmt > 208) rectSF = 0.5f;

	println("using: "+rectSF+" with "+UserChannelAmt+" sliders");
	
	column = 0;
	row = 0;

	for (int i = 0; i != ControlSliders.length; i++) 
	{			
		ControlSliders[i] = new SliderBar(8, OverlayMenus[1].xpos+35,  OverlayMenus[1].ypos+50, round(100*rectSF), 14, 0, 0, tempMaxVal, color(255), color(0), cBorderColor, color(0), true, false, false);		
		//1 can do 104, always 26 sliders tall
		// .7 can do 130
		// .4 can do 182
		// .3 can do 208
		//need to only factor in the calcualted with, and always leave 40 pixels between each slider, cause font and hieght will always be the same

		if(column == 0) ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*rectSF)));
		else if(rectSF == 0.5f && i > 233) { ControlSliders[i].xpos = 100; ControlSliders[i].ypos = 610; }
		else  ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*rectSF))) + (35*column);

		ControlSliders[i].ypos = ControlSliders[i].ypos + (row*19);		
		row++;

		if((row*19) > (490))
		{
			row = 0;
			column++;
		}
	} //end for()
	//END SLIDERS

	println("Sliders Built, Total: "+ControlSliders.length);	
}  //end func()

//==============================================================================================================     

public void DisplayFrameButtons()
{
	stroke(0);
	strokeWeight(2);
	fill(cBorderColor);
	rect(130,545,560,50, 15);
	line(600,545,600,595);
	noStroke();

	GroupIDDecf.display();
	GroupIDIncf.display();

	textAlign(CENTER);
	textSize(18);
	text(ViewGroupIDNum+1,750,585);
	textSize(14);
	text("Group View:",750,555);
	textAlign(LEFT);

	//each square is 35px
	if ((UserSequences[SelectedSequence].SeqFrameAmount+1) != GradientRects.length && UserSequences[SelectedSequence].SeqMode == mGradient) BuildGradientMenu();	

	int ii;
	for (ii = 0; ii != FrameButtons.length; ii++) //same as GradientRects.length 
	{
		if(ii == (UserSequences[SelectedSequence].SeqFrameAmount+1)) break; ///max buttons for sequence
		
		if (UserSequences[SelectedSequence].SeqMode == mGradient)
		{
			GradientRects[ii].display();
			GradientRects[ii].Label = ""+(1+ii+FrameScrollBarView);
		}
		else
		{
			FrameButtons[ii].display();
			FrameButtons[ii].Label = ""+(1+ii+FrameScrollBarView);
		}
	} //end for()	
	
	//println("Done DisplayFrameButtons() "+FrameScrollBarView);
	
	//FrameButton Bar
	AddFrame.display();
	RemoveFrame.display();
	IncFrameBar.display();
	DecFrameBar.display();
}//end DisplayFrameButtons()

//==============================================================================================================     

public void BuildGradientMenu()
{
	//println("BuildGradientMenu()");
	for (int i =0; i != GradientRects.length; i++) 
	{ 
		if(i == (UserSequences[SelectedSequence].SeqFrameAmount+1)) break;
		
		GradientRects[i].Red = UserSequences[SelectedSequence].DataFrames[i+FrameScrollBarView][0];
		GradientRects[i].Green = UserSequences[SelectedSequence].DataFrames[i+FrameScrollBarView][1];
		GradientRects[i].Blue = UserSequences[SelectedSequence].DataFrames[i+FrameScrollBarView][2];
		GradientRects[i].White = UserSequences[SelectedSequence].DataFrames[i+FrameScrollBarView][3];
		GradientRects[i].Label = ""+(1+i+FrameScrollBarView);
	}
} //end func

//==============================================================================================================  

public void handlerDrawImageHandles()
{
	//println("=============="+graphicImg.width+" : "+graphicImg.height+"==========================");
	//println("gWidth: "+graphicImg.width+" - gHeight: "+graphicImg.height);
	//println("GraphicImageWidth: "+GraphicImageWidth+" - GraphicImageHeight: "+GraphicImageHeight);

	ImageHandleTL.xpos = GraphicImageX;
	ImageHandleTL.ypos = GraphicImageY;

	ImageHandleTR.xpos = GraphicImageWidth-10;
	ImageHandleTR.ypos = GraphicImageY;

	ImageHandleBR.xpos = GraphicImageWidth-10;
	ImageHandleBR.ypos = GraphicImageHeight-10;

	ImageHandleBL.xpos = GraphicImageX;
	ImageHandleBL.ypos = GraphicImageHeight-10; 

	ImageHandleCenter.xpos = GraphicImageX+(((ImageHandleTR.xpos - ImageHandleTL.xpos)+10)/2)-10;
	ImageHandleCenter.ypos = GraphicImageY+(((ImageHandleBL.ypos - ImageHandleTR.ypos)+10)/2)-10;
	//GraphicLayoutBuffer.rectMode(CENTER);
	ImageHandleCenter.displayGLBuf();
	//GraphicLayoutBuffer.rectMode(CORNER);
	GraphicLayoutBuffer.stroke(255);
	GraphicLayoutBuffer.strokeWeight(2);

	GraphicLayoutBuffer.line(ImageHandleTL.xpos,ImageHandleTL.ypos,ImageHandleTR.xpos,ImageHandleTR.ypos);
	GraphicLayoutBuffer.line(ImageHandleTR.xpos+10,ImageHandleTR.ypos,ImageHandleBR.xpos+10,ImageHandleBR.ypos+10);
	GraphicLayoutBuffer.line(ImageHandleBL.xpos,ImageHandleBL.ypos+10,ImageHandleTL.xpos,ImageHandleTL.ypos+10); 
	GraphicLayoutBuffer.line(ImageHandleBR.xpos+10,ImageHandleBR.ypos+10,ImageHandleBL.xpos,ImageHandleBL.ypos+10);

	ImageHandleTL.displayGLBuf(); 
	// ImageHandleTR.displayGLBuf();
	ImageHandleBR.displayGLBuf();
	// ImageHandleBL.displayGLBuf();
}

//==============================================================================================================  

public void SetLEDSizeCheckBoxes()
{
	SoftwareCheckBox[0].Selected = false;
	SoftwareCheckBox[1].Selected = false;
	SoftwareCheckBox[2].Selected = false;
	SoftwareCheckBox[LEDSizeID].Selected = true;	
}

public void SetLEDSpacingCheckBoxes()
{
	SoftwareCheckBox[3].Selected = false;
	SoftwareCheckBox[4].Selected = false;
	SoftwareCheckBox[5].Selected = false;
	SoftwareCheckBox[6].Selected = false;	
	SoftwareCheckBox[LEDSpacingID+3].Selected = true;	//+3 is for the starting ID
}

public void CalcLEDSize()
{
	switch(LEDSizeID)
	{
	case 0:
	LEDSize = 10;		
	break;
	case 1:
	LEDSize = 16;	
	break;
	case 2:
	LEDSize = 20;		
	break;
	}
}

//==============================================================================================================  

public void ImportCustomPixelMap()
{
	//loads a coordinate patch file, find min and mix point in both directions and scales the overall size to fit within the preview areas
	// creates the Pixel objects to display during draw and fills the Coordinate Arrays for Pixel Patching
	println("ImportCustomPixelMap()");

	String[] lines = loadStrings(PixelMapFilePath); //divides the lines
	String[] WorkString = new String[3]; //used to divide the lines into tab

	WorkString = split(lines[0], '\t');

	int MaxPixels = PApplet.parseInt(WorkString[0]);
	int MinX = 1000;
	int MinY = 1000;
	int MaxX = 0;
	int MaxY = 0;
	int countvar = 0; 

	try 
	{
		for (int i=1;i != lines.length;i++)
		{
			WorkString = split(lines[i], '\t');
			if (PApplet.parseInt(WorkString[0]) > MaxX) MaxX = PApplet.parseInt(WorkString[0]);
			if (PApplet.parseInt(WorkString[0]) < MinX) MinX = PApplet.parseInt(WorkString[0]);

			if (PApplet.parseInt(WorkString[1]) > MaxY) MaxY = PApplet.parseInt(WorkString[1]);
			if (PApplet.parseInt(WorkString[1]) < MinY) MinY = PApplet.parseInt(WorkString[1]);
			countvar++;
		}
	}
	catch(Exception e)
	{
		println("Coordinates missing or other error with PixelMap file, found "+countvar+" coordinates");
		ShowNotification(17);
		MaxPixels = countvar; //updates MaxPixels with amount found
	}

	//println("X: "+MinX+" : "+MaxX);
	//println("Y: "+MinY+" : "+MaxY);
	//println("MaxPixels: "+MaxPixels);

	final int cLocalWidth = cGLBufWidth-20;
	final int cLocalHeight = cGLBufViewH-20;
	
	int Xdifference = MaxX - MinX;
	int Ydifference = MaxY - MinY;

	println("Coord Differences: "+Xdifference+" : "+Ydifference);

	int tempSz = 0;

	if(Xdifference >= Ydifference) tempSz =  cLocalWidth / (Xdifference+1);
	else tempSz = cLocalHeight / (Ydifference+1);

	if(tempSz > LEDSize) tempSz = PApplet.parseInt((float)tempSz * 0.75f);

	//new v.2d
//	if(SoftwareCheckBox[7].Selected == true) tempSz = LEDSize;

	
	
	int[] PatchCoordX = new int[MaxPixels]; //resize the patch arrays based on PatchedChannels
	int[] PatchCoordY = new int[MaxPixels];

	//file created was incremented method channel numbers
	for (int i=0;i != MaxPixels;i++)
	{
		WorkString = split(lines[i+1], '\t');
		PatchCoordX[i] = PApplet.parseInt(WorkString[0]) - MinX;
		PatchCoordY[i] = PApplet.parseInt(WorkString[1]) - MinY;
	} //end for()

	int offsetX = (cLocalWidth - (tempSz * Xdifference)) / 2;
	int offsetY = (cLocalHeight - (tempSz * Ydifference)) / 2; 

	//set GUI element
	LEDIconCoordX = new int[MaxPixels]; //resize arrays
	LEDIconCoordY = new int[MaxPixels]; //resize arrays

	for (int i=0;i != MaxPixels;i++)
	{
		LEDIconCoordX[i] = offsetX+(PatchCoordX[i]*tempSz);
		LEDIconCoordY[i] = offsetY+(PatchCoordY[i]*tempSz);
	}
	
	if(IconLayoutAdvancedMode.Selected == false) 	GraphicLayoutBuild(0);
	else PixelAmountObject.setValue(""+MaxPixels); //set the fill value to the amount of pixels in the map/patch file
	//MenuTabs[0].refresh();
}//end func	


//==============================================================================================================  


public void applyGUIProfileAdvancedLayout()
{
	println("applyGUIProfileAdvancedLayout()");
	DefinedPixelUsage = 0; //if basic mode, always start definedPixelUsage as 0
	CurrentPixelUsage = 0;
	
	if(IconLayoutAdvancedMode.Selected == true)
	{
		PixelIcon = new LEDgraphic[cSoftwareMaxChans]; //rebuild to clear
		
		SoftwareButtons[17].Status = 0; //enable
		SoftwareButtons[16].Status = 0; //enable
		SoftwareButtons[15].Status = 0; //enable
		PixelAmountObject.setStatus(0);
		LayoutGroupInc.Status = 0;
		LayoutGroupDec.Status = 0;				
	}
	else
	{
		//rebuild as if the ConfigShapeDD had been changed.
		SoftwareButtons[17].Status = 1; //grey out for now
		SoftwareButtons[16].Status = 1; //grey out for now
		SoftwareButtons[15].Status = 1; //grey out for now
		PixelAmountObject.setStatus(1);
		LayoutGroupInc.Status = 1;
		LayoutGroupDec.Status = 1;				
		
		GraphicLayoutBuild(0); //reset icons and rebuild
	}	
} //end func


//==============================================================================================================  



   

//====================================================================================================================================

class ColorRect
{
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	//color ColBG;
	int Red;
	int Green;
	int Blue;
	int White;

	boolean MouseOverFlag;
	boolean Selected;
	
	String Label;
	
	ColorRect(int ixpos, int iypos, int ibWidth, int ibHeight, int iRed, int iGreen, int iBlue, int iWhite, String iLabel)
	{
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		Red = iRed;
		Green = iGreen;
		Blue = iBlue;
		White = iWhite;
		Label = iLabel;
		Selected = false;
		MouseOverFlag = false;
	}

	public void display()
	{
		strokeWeight(1);
		stroke(cWorkspaceFont);
		
		if(device.Bit16Mode == true)	fill((Red>>8), (Green>>8), (Blue>>8));	
		else fill(Red, Green, Blue);

		int holdPixelType = PixelDataType;	//handles color picking for livemode
		if(SelectedMenuTab == 2 && OverlayMenuID == 1) 
		{
			holdPixelType = LiveConDataType;
		}	
		
		switch(holdPixelType)//PixelDataType)
		{
		case 0: //Single
			if(device.Bit16Mode == true)	fill((White>>8));
			else fill(White);	
			rect(xpos, ypos, bWidth, bHeight);//main rect
			break;
		case 1: //RGB
			rect(xpos, ypos, bWidth, bHeight);//main rect
			break;	
		case 2: //RGBW
			rect(xpos, ypos, bWidth, bHeight); //main rect
			
			if(device.Bit16Mode == true)	fill((White>>8));
			else fill(White); //draws white rect on bottom third
			rect(xpos, ypos+(((float)bHeight/3)*2), bWidth, ((float)bHeight/3));	
			break;
		}	
		
		if(!Label.equals(""))
		{
			textAlign(CENTER);
			textSize((bHeight/1.75f));
			//text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
			fill(255);
			//invert color for text
			if(device.Bit16Mode == true)	fill(0xFFFF-(Red>>8), 0xFFFF-(Green>>8), 0xFFFF-(Blue>>8));	
			else fill((255 - Red),(255- Green),(255 - Blue));
			text(Label, xpos+(bWidth/2), ypos+(bHeight/1.35f));	
		}

		if(MouseOverFlag == true || Selected == true)
		{
			stroke(cColButtonsHL);
			strokeWeight(2);
			fill(0,0,0,0); //transparent
			rect(xpos-2, ypos-2, bWidth+4, bHeight+4);
		}
		
		noStroke();
	} //end display()

	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight) 
		{      
			return true;
		} 
		else {
			return false;
		}
	}
	
	
	public boolean mouseOver() 
	{
		//	if(Status== 0) return false;    //0=show, 1=grey out, 2=hide
		
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight)
		{      
			MouseOverFlag = true;	
			return true;
		} 
		else {
			MouseOverFlag = false;	
			return false;
		}
	}
	
} 

//=====================================================================================================

class ColorPickerObj
{
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int selPointX;
	int selPointY;

	int slRed;
	int slGreen;
	int slBlue;
	int slWhite;

	int mode; //0 = Single, 1 = All, 2 = Group, 3 = Live Mode, 4 = Tech Select
	int passedFrame;
	int passedChan;
	
	ColorPickerObj(int ixpos, int iypos, int ibWidth, int ibHeight, int iselPointX, int iselPointY, int islRed, int islGreen, int islBlue, int islWhite)
	{
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		selPointX = iselPointX;
		selPointY = iselPointY;
		slRed = islRed;
		slGreen = islGreen;
		slBlue = islBlue;
		slWhite = islWhite;
		mode = 0;
		passedFrame = 0;
		passedChan = 0;
	}

	public void display()
	{
		image(gradientImg, xpos, ypos, bWidth, bHeight);

		int holdPixelType = PixelDataType;	//handles color picking for livemode
		if(SelectedMenuTab == 2 && OverlayMenuID == 1) 
		{
			holdPixelType = LiveConDataType;
		}
		
		switch(holdPixelType)
		{
		case 0: //Single	
			ColorSelectorSliders[0].Value = 0;
			ColorSelectorSliders[1].Value = 0;
			ColorSelectorSliders[2].Value = 0;		
			ColorSelectorSliders[3].Value = slWhite; //use red, but value should be greyscale
			break;
		case 1: //RGB
			ColorSelectorSliders[0].Value = slRed;
			ColorSelectorSliders[1].Value = slGreen;
			ColorSelectorSliders[2].Value = slBlue;	
			ColorSelectorSliders[3].Value = 0;
			break;	
		case 2: //RGBW
			ColorSelectorSliders[0].Value = slRed;
			ColorSelectorSliders[1].Value = slGreen;
			ColorSelectorSliders[2].Value = slBlue;	
			ColorSelectorSliders[3].Value = slWhite;
			break;
		}
		
		fill(255);
		textSize(12);
		textLeading(14);	
		textAlign(RIGHT);
		text("Red:\nGreen:\nBlue:\nWhite:", xpos+45, ypos+215);
		text(slRed+"\n"+slGreen+"\n"+slBlue+"\n"+slWhite, xpos+85, ypos+215);
		
		textAlign(LEFT);
		if(mode  == 1)     text("Coloring All",xpos+10, ypos+280);
		else if(mode == 2)     text("Color Group: "+(ViewGroupIDNum+1),xpos+10, ypos+280);
		else if(GraphicFuncPaintButton.Selected == true)  text("Paint Color",xpos+10, ypos+280);
		else text("LED#: "+(OpenedColorLEDIconID+1),xpos+10, ypos+280);	
		text("Recent\nPalette:",xpos+20, ypos+185);		
		
		textSize(10);	
		textAlign(CENTER);
		text("Selected", xpos+245, ypos+215);
		textAlign(LEFT);

		strokeWeight(1);
		stroke(0);
		
		for (int i=0; i != paletteColors.length;i++)
		{
			fill(paletteColors[i][0],paletteColors[i][1],paletteColors[i][2]);
			rect(xpos+70+(i*30), ypos+175,25,25);		
		}
		
		switch(holdPixelType)
		{
		case 0: //Single
			if(device.Bit16Mode == true)	fill((slWhite>>8));
			else	fill(slWhite);
			rect(xpos+230, ypos+220, 30, 30);	
			break;
		case 1: //RGB
		case 2: //RGBW
			if(device.Bit16Mode == true)	fill((slRed>>8),(slGreen>>8),(slBlue>>8));
			else	fill(slRed,slGreen,slBlue);
			rect(xpos+230, ypos+220, 30, 30);
			
			if(holdPixelType == 1) break;
			
			if(device.Bit16Mode == true)	fill((slWhite>>8));
			else fill(slWhite); //draws white rect on half
			rect(xpos+230, ypos+240, 30, 10);	
			
			for (int i=0; i != paletteColors.length;i++)
			{
				fill(paletteColors[i][3]);
				rect(xpos+70+(i*30), ypos+190,25,10);		
			}			
			
			break;
		}	//end switch
		
		noStroke();
		
		switch(holdPixelType)
		{
		case 0: //Single
			ColorSelectorSliders[3].display(); 
			break;
		case 1: //RGB
			ColorSelectorSliders[0].display();
			ColorSelectorSliders[1].display();
			ColorSelectorSliders[2].display();	
			break;	
		case 2: //RGBW
			ColorSelectorSliders[0].display();
			ColorSelectorSliders[1].display();
			ColorSelectorSliders[2].display();
			ColorSelectorSliders[3].display(); 	
			break;
		}
		
		ColorSelectorApply.display();
		ColorSelectorCancel.display();

		TextFields[10].display();	
		
		fill(0, 0, 0, 0); //make fill transparent
		stroke(255);
		rect(round(selPointX/SF)-2, round(selPointY/SF)-2, 4, 4);
		stroke(0);
		rect(round(selPointX/SF)-3, round(selPointY/SF)-3, 4, 4);
	} //end display

	
	public void InitPosition(int passedType, int passedC, int passedF)
	{
		println("Init Color Selector, Type: "+passedType+"   "+passedC+"   "+passedF);
		
		mouseXS = round((float)mouseX / SF);
		mouseYS = round((float)mouseY / SF);  
		this.xpos = mouseXS;
		this.ypos = mouseYS;
		
		mode = passedType;

		//if(UserSequences[SelectedSequence].SeqMode == mGradient && mode != 3) mode = 1; //force color all, unless it is live control rect
		
		passedChan = passedC;		
		passedFrame = passedF;
		
		ColorPickerOpen = true;
		
		if ((this.xpos+bWidth) > round(width/SF)) this.xpos = round(width/SF) - bWidth;
		if ((this.ypos+bHeight) > round(height/SF)) this.ypos = round(height/SF) - bHeight;    

		ColorSelectorSliders[0].xpos = this.xpos +90;
		ColorSelectorSliders[0].ypos = this.ypos+205;

		ColorSelectorSliders[1].xpos = this.xpos +90;
		ColorSelectorSliders[1].ypos = this.ypos+220;

		ColorSelectorSliders[2].xpos = this.xpos + 90;
		ColorSelectorSliders[2].ypos = this.ypos+235;  

		ColorSelectorSliders[3].xpos = this.xpos +90;
		ColorSelectorSliders[3].ypos = this.ypos+250;  
		
		TextFields[10].xpos = this.xpos +100;
		TextFields[10].ypos = this.ypos+265; 
		
		ColorSelectorApply.xpos = this.xpos+170;
		ColorSelectorApply.ypos = this.ypos+265; 

		ColorSelectorCancel.xpos = this.xpos+220;
		ColorSelectorCancel.ypos = this.ypos+265; 

		selPointX = xpos + (xpos/2);
		selPointY = ypos + (ypos/2);
		
		//dublicated and rearranged from mousePressed() ????
		if(GraphicFuncPaintButton.Selected == true || PaintColorPick == true)
		{
			println("Ran color fill for painting");	
			ColorSelectorSliders[0].Value = PaintRects[PaintRectID].Red;
			ColorSelectorSliders[1].Value = PaintRects[PaintRectID].Green;
			ColorSelectorSliders[2].Value = PaintRects[PaintRectID].Blue;
			ColorSelectorSliders[3].Value = PaintRects[PaintRectID].White;	

			
			slRed = ColorSelectorSliders[0].Value;
			slGreen = ColorSelectorSliders[1].Value;
			slBlue = ColorSelectorSliders[2].Value;
			slWhite = ColorSelectorSliders[3].Value;		
		}
		else if(mode == 1)
		{
			println("All the same no color setup - Color Sliders Not Initialized");
			ColorSelectorSliders[0].Value = 0;
			ColorSelectorSliders[1].Value = 0;
			ColorSelectorSliders[2].Value = 0;
			ColorSelectorSliders[3].Value = 0;
			
			slRed = ColorSelectorSliders[0].Value;
			slGreen = ColorSelectorSliders[1].Value;
			slBlue = ColorSelectorSliders[2].Value;
			slWhite = ColorSelectorSliders[3].Value;			
		}
		else if(mode == 3)
		{		
			switch(LiveConDataType)
			{
			case 0: //single
				ColorSelectorSliders[3].Value = ControlSliders[passedChan*LiveConDataMult].Value;
				slRed = 0;
				slGreen = 0;
				slBlue = 0;
				slWhite = ControlSliders[passedChan*LiveConDataMult].Value;		   
				break;
			case 1: //RGB
				ColorSelectorSliders[0].Value = ControlSliders[(passedChan*LiveConDataMult)].Value;
				ColorSelectorSliders[1].Value = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
				ColorSelectorSliders[2].Value = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
				slRed = ControlSliders[(passedChan*LiveConDataMult)].Value;
				slGreen = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
				slBlue = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
				slWhite	= 0;		
				break;
			case 2: //RGBW
				println("This: "+passedChan);
				ColorSelectorSliders[0].Value = ControlSliders[(passedChan*LiveConDataMult)].Value;
				ColorSelectorSliders[1].Value = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
				ColorSelectorSliders[2].Value = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
				ColorSelectorSliders[3].Value = ControlSliders[passedChan*LiveConDataMult+3].Value;
				slRed = ControlSliders[(passedChan*LiveConDataMult)].Value;
				slGreen = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
				slBlue = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
				slWhite = ControlSliders[passedChan*LiveConDataMult+3].Value;			
				break;
			}//end switch
		}	
		else if(UserSequences[SelectedSequence].SeqMode == mGradient)
		{		
			//its a gradient
			ColorSelectorSliders[0].Value = GradientRects[SelectedFrame].Red;
			ColorSelectorSliders[1].Value = GradientRects[SelectedFrame].Green;
			ColorSelectorSliders[2].Value = GradientRects[SelectedFrame].Blue;
			ColorSelectorSliders[3].Value = GradientRects[SelectedFrame].White;		

			slRed = ColorSelectorSliders[0].Value;
			slGreen = ColorSelectorSliders[1].Value;
			slBlue = ColorSelectorSliders[2].Value;
			slWhite = ColorSelectorSliders[3].Value;	
		}			
		else
		{			
			switch(PixelDataType)
			{
			case 0: //single
				ColorSelectorSliders[3].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan];
				
				slRed = 0;//ColorSelectorSliders[3].Value;
				slGreen = 0;//ColorSelectorSliders[3].Value;
				slBlue = 0;//ColorSelectorSliders[3].Value;
				slWhite = ColorSelectorSliders[3].Value;				
				break;
			case 1: //RGB
				ColorSelectorSliders[0].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult];
				ColorSelectorSliders[1].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult+1];
				ColorSelectorSliders[2].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult+2];
				
				slRed = ColorSelectorSliders[0].Value;
				slGreen = ColorSelectorSliders[1].Value;
				slBlue = ColorSelectorSliders[2].Value;
				slWhite = 0;		
				break;
			case 2: //RGBW
				ColorSelectorSliders[0].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult];
				ColorSelectorSliders[1].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult+1];
				ColorSelectorSliders[2].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult+2];
				ColorSelectorSliders[3].Value = UserSequences[SelectedSequence].DataFrames[passedFrame][passedChan * CurrentDataTypeMult+3];
				
				slRed = ColorSelectorSliders[0].Value;
				slGreen = ColorSelectorSliders[1].Value;
				slBlue = ColorSelectorSliders[2].Value;
				slWhite = ColorSelectorSliders[3].Value;			
				break;
			}//end switch
		}	  
		//end ===========================	
		
		if(PixelDataType == 0) SliderPointer = ColorSelectorSliders[3]; //if in single mode, make White Slider the pointer
		else SliderPointer = ColorSelectorSliders[0]; //set Slider for TextField Editing
		TextFields[10].Label = ""+SliderPointer.Value;
	} //end init

	
	public void PickColor()
	{   
		//doesn't use scale since technically the Pixel array is the same size
		this.selPointX = mouseX;
		this.selPointY = mouseY; 
		myColor = get(mouseX, mouseY);      
		myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
		myGreen = myColor >> 8 & 0xFF;
		myBlue = myColor & 0xFF;    
		
		int holdPixelType = PixelDataType;	
		if(mode == 3) 
		{
			//its live mode
			holdPixelType = LiveConDataType;
		}	

		if(device.Bit16Mode == true)
		{
			if(myRed != 0)	myRed = (myRed+1) * 256;
			if(myGreen != 0)	myGreen = (myGreen+1) * 256;
			if(myBlue != 0)	myBlue = (myBlue+1) * 256;
			if(myWhite != 0)	myWhite = (myWhite+1) * 256;
			println("Color Picked Multiplied");
			
			
			if(myRed > 0xFFFF)	myRed = 0xFFFF;
			if(myGreen > 0xFFFF)	myGreen = 0xFFFF;
			if(myBlue > 0xFFFF)	myBlue = 0xFFFF;
			if(myWhite > 0xFFFF)	myWhite = 0xFFFF;
		}

		switch(holdPixelType)
		{
		case 0: //Single
			//this.slSelectColor = color(int((myRed+myGreen+myBlue)/3));
			this.slRed = 0;
			this.slGreen = 0;
			this.slBlue = 0;
			this.slWhite = PApplet.parseInt((myRed+myGreen+myBlue)/3);
			break;
		case 1: //RGB
			//this.slSelectColor = color(myRed, myGreen, myBlue);
			this.slRed = (int)myRed;
			this.slGreen = (int)myGreen;
			this.slBlue = (int)myBlue;
			this.slWhite = 0;		
			break;	
		case 2: //RGBW
			//this.slSelectColor = color(myRed, myGreen, myBlue);
			this.slRed = (int)myRed;
			this.slGreen = (int)myGreen;
			this.slBlue = (int)myBlue;
			//DEBUG FIGURE OUT, but you can't pick white, have to use the slider
			//	this.slWhite = myWhite;			
			break;
		}	//end switch()
	} //end PickColor()


	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight) 
		{      
			return true;
		} 
		else {
			return false;
		}
	} 

	public boolean overPicker() 
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight-90) 
		{      
			return true;
		} 
		else {
			return false;
		}
	}
}//end class

//=====================================================================================================

class CheckBox
{
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int ColBG;
	int ColHL;
	int ColOut;  
	boolean Selected;
	int Status = 0; //0=show, 1=grey out, 2=hide
	
	boolean MouseOverFlag;
	
	CheckBox(int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iSelected)
	{
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		ColBG = iColBG;
		ColHL = iColHL;
		ColOut = iColOut;
		Selected = iSelected;
		
		CheckBoxList.add(this);
		MouseOverFlag = false;				
	}

	public void display()
	{
		strokeWeight(1);
		stroke(ColOut);
		fill(ColBG);
		
		if (Selected==true) 
		{	
			fill(ColBG);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColBG,128);
			}
		}		
		else  
		{	
			fill(ColBG);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColBG,64);
			}
		}		
		rect(xpos, ypos, bWidth, bHeight);  
		
		
		if (Selected==true)
		{
			line(xpos, ypos, xpos+bWidth, ypos+bHeight);
			line(xpos+bWidth, ypos, xpos, ypos+bHeight);
		}

		handleStatus();
	}//end display()


	public void handleStatus()
	{
		noStroke();
		
		if(Status == 1) 
		{
			strokeWeight(2);
			stroke(cBackgroundColor, 200); //grey out button
			fill(cBackgroundColor, 200); //grey out button
			rect(xpos, ypos, bWidth, bHeight);  
			noStroke();
		}
	}

	public boolean over() 
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0)
		{     
			Selected =! Selected;	
			return true;
		} 
		else {
			return false;
		}
	}
	
	public boolean overB() 
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0)
		{     
			//Selected =! Selected;	
			return true;
		} 
		else {
			return false;
		}
	}
	
	
	public boolean mouseOver() 
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0)
		{     
			MouseOverFlag = true;	
			return true;
		} 
		else {
			MouseOverFlag = false;
			return false;
		}
	}	
}//end class

//======================================================================================

class TabButton
{
	//use one over() for detecting the button click and if it is open, then use a different over() with the full tab page size
	String Label;
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int ColBG;
	int ColHL;
	int ColOut;  
	boolean Selected;  
	boolean ReqRefresh;

	TabButton(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iSelected, boolean iReqRefresh)
	{
		Label = iLabel; 
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		ColBG = iColBG;
		ColHL = iColHL;
		ColOut = iColOut;
		Selected = iSelected;
		ReqRefresh = iReqRefresh;
	}

	public void refresh()
	{
		this.ReqRefresh = false;
		
		switch(SelectedMenuTab)
		{
		case 0:
			if (this == MenuTabs[0]) 
			{	
				
				// if in basic mode and change to a sequence with different amount of pixels, want it to look the same and be easy
				if(IconLayoutAdvancedMode.Selected == false)
				{
					if(ConfigShape < 5) 
					{	
						GraphicLayoutBuild(0); //wish didn't have to do this... where else could it go?
						//MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
					}
				}
				
				GraphicLayoutUpdateIcons();
				
			}
			else this.ReqRefresh = true;	
			break;
		case 1:
			if (this == MenuTabs[1]) DrawTimeLineBuffer();
			else this.ReqRefresh = true;	
			break;		
		case 2:
			//	if (this == MenuTabs[2]) DrawIndexScrollArea();
			//	else this.ReqRefresh = true;	
			break;
		default:
			this.ReqRefresh = true;	
			break;		
		}
	} //end refresh()

	public void display()
	{
		noStroke();
		if (Selected==true)
		{
			fill(ColHL);
			rect(xpos, ypos, bWidth, bHeight, bHeight/2);   
			rect(xpos, ypos+(bHeight/1.75f), bWidth, (float)bHeight/2.1f);
		}
		else       
		{
			fill(ColBG, 128);
			rect(xpos, ypos, bWidth, bHeight, bHeight/8);
		}

		//adjust stroke to on higlight and invert text color
		textAlign(LEFT);
		fill(ColOut);
		textSize((bHeight/1.75f));
		text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
	}

	public boolean over() 
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight) 
		{    
			Selected =! Selected;	
			return true;
		} 
		else {
			return false;
		}
	}
} //end TabButton

//======================================================================================

class DropDown
{
	//use one over() for detecting the button click and if it is open, then use a different over() with the full tab page size
	String[] Labels;
	int numStrs;
	int SelStr;
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int ColBG;
	int ColHL;
	int ColOut;  
	boolean Selected;
	int Status;
	
	boolean DirMode; //false = down, true = up
	
	boolean MouseOverFlag;
	
	DropDown(String[] iLabels, int inumStrs, int iSelStr, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iDirMode)//, boolean iOpened)
	{
		Labels = iLabels; 
		numStrs = inumStrs;
		SelStr = iSelStr;
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		ColBG = iColBG;
		ColHL = iColHL;
		ColOut = iColOut;
		Selected = false;
		DirMode = iDirMode;
		Status = 0; //normal
		
		DropDownList.add(this);	
	}

	
	public void handleStatus()
	{
		noStroke();
		
		if(Status == 1) 
		{
			strokeWeight(2);
			stroke(cBackgroundColor, 200); //grey out button
			fill(cBackgroundColor, 200); //grey out button
			rect(xpos, ypos, bWidth, bHeight);  
			noStroke();
		}
	}	
	
	
	public void displayNormal()
	{
		strokeWeight(1);
		stroke(ColOut);

		//		if (Selected==true) fill(ColHL);
		//		else fill(ColBG);

		if (Selected==true) 
		{	
			fill(ColHL);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColHL,128);
			}
		}		
		else  
		{	
			fill(ColBG);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColBG,64);
			}
		}

		rect(xpos, ypos, bWidth, bHeight);  
		//adjust stroke to on higlight and invert text color
		textAlign(LEFT);
		fill(ColOut);
		textSize((bHeight/1.75f));
		text(Labels[SelStr], xpos+(bWidth/20), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);

		fill(255);
		int tempSize = (bWidth/4);
		if(tempSize >  (bHeight/4)) tempSize = (bHeight);
		
		//   triangle(xpos+(bWidth-(bWidth/4)), ypos+(bHeight/4), xpos+(bWidth-(bWidth/4))+(bHeight/2), ypos+(bHeight/4), xpos+(bWidth-(bWidth/4))+(bHeight/4), ypos+(bHeight/4)+(bHeight/2));
		triangle(xpos+(bWidth-tempSize), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/2), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/4), ypos+(bHeight/4)+(bHeight/2));
		noStroke();
	}
	
	
	public void selectDD()
	{
		Selected =! Selected;	//toggle selected state

		if(Selected == true)
		{	
			DropDownPointer = this;
			GlobalDDOpen = true;
			DropDownMouseOverID = SelStr;
		}
		else
		{
			GlobalDDOpen = false; //clear in case	
		}
	}

	
	public void display()
	{
		if(Status == 2) return; //do not display if status = 2 = hide
		
		//println(DropDownMouseOverID);	
		
		if(Selected == false)
		{
			displayNormal();
		}
		else
		{
			if(DirMode == false)	
			{	
				//down mode
				fill(ColBG);
				displayNormal();
				strokeWeight(1);
				stroke(ColOut);  

				for (int i = 0; i != numStrs; i++)
				{
					fill(ColBG);
					rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
					if(i == SelStr) fill(ColHL);
					else fill(ColBG);
					//drop down drawn
					
					if(DropDownMouseOverID > 0 && DropDownMouseOverID == (i+1) && MouseOverFlag == true)
					{
						if(i == SelStr) fill(ColHL,128);
						else fill(0,0,0,64);//fill(ColBG,64);
					}

					rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
					
					fill(ColOut);
					textSize((bHeight/1.75f));
					text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f)+(bHeight*(i+1)), bWidth, bHeight);
				}   //end for 
				noStroke();			
			}
			else
			{						
				//Menu upwards
				displayNormal(); //display the button part
				strokeWeight(1);
				stroke(ColOut);  
				
				for (int i = 0; i != numStrs; i++)
				{
					fill(ColBG);
					rect(5+xpos, ypos+(bHeight*(i-numStrs)), bWidth-5, bHeight); //draw background first
					if(((numStrs-1)-i) == SelStr) fill(ColHL);
					else fill(ColBG);
					//drop down drawn
					
					if(DropDownMouseOverID > 0 && DropDownMouseOverID == (i+1) && MouseOverFlag == true)
					{
						if(((numStrs-1)-i) == SelStr) fill(ColHL,128);
						else fill(0,0,0,64);//fill(ColBG,64);
					}
					rect(5+xpos, ypos+(bHeight*(i-numStrs)), bWidth-5, bHeight);
				} //end for
				
				for (int i = 0; i != numStrs; i++)
				{
					fill(ColOut);
					textSize((bHeight/1.75f));
					text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f)-(bHeight*(i+1)), bWidth, bHeight);
				}   //end for 
				noStroke();
				
			}	
		}
		
		handleStatus();
	} //end display()
	
	/*
	void displayOpen()
	{
		fill(ColBG);
		display();
		strokeWeight(1);
		stroke(ColOut);  

		for (int i = 0; i != numStrs; i++)
		{
			fill(ColBG);
			rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
			fill(ColOut);
			textSize((bHeight/1.75));
			text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5)+(bHeight*(i+1)), bWidth, bHeight);
		}	 //end for 
		noStroke();
	}
*/

	public boolean overOpen()
	{
		if(DirMode == false)	
		{		
			//Down Mode
			if(Selected == false)
			{
				return false;
			}
			else
			{
				for (int i = 0; i != numStrs; i++)
				{
					if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos+(bHeight*(i+1)) && mouseYS <= ypos+bHeight+(bHeight*(i+1)) && Status == 0)
					{    
						Selected = false;
						SelStr = i;	
						GlobalDDOpen = false;				
						return true;
					}
				}
				Selected = false;
				return false;
			}	
		}
		else
		{	
			if(Selected == false)
			{
				return false;
			}
			else
			{
				for (int i = 0; i != numStrs; i++)
				{
					if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos-(bHeight*(i+1)) && mouseYS <= ypos+bHeight-(bHeight*(i-1)) && Status == 0)
					{    
						Selected = false;
						SelStr = i;	
						GlobalDDOpen = false;				
						return true;
					}
				}
				Selected = false;
				return false;
			}
		}
	} //end overNew()
	
	
	public boolean over() ///over the icon to open
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight  && Status == 0) 
		{    
			if(GlobalDDOpen == true) return false; //if drop down already open, don't let it open another
			
			selectDD();
			return true;
		} 
		else {
			return false;
		}
	}
	
	public boolean mouseOver() ///over the icon to open
	{
		if ( mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight  && Status == 0) 	
		{      
			MouseOverFlag = true;	
			return true;
		} 
		else {
			MouseOverFlag = false;
			return false;
		}
	}
	
	
	public boolean mouseOverOpen()
	{
		if(DirMode == false)	
		{		
			//Down Mode
			if(Selected == false)
			{
				return false;
			}		
			else
			{
				for (int i = 0; i != numStrs; i++)
				{
					if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos+(bHeight*(i+1)) && mouseYS <= ypos+bHeight+(bHeight*(i+1)) && Status == 0)
					{    
						MouseOverFlag = true;
						DropDownMouseOverID = i+1;				
						return true;
					}
				}
				DropDownMouseOverID = 0;
				MouseOverFlag = false;
				return false;
			}	
		}
		else
		{	
			if(Selected == false)
			{
				return false;
			}
			else
			{
				for (int i = 0; i != numStrs; i++)
				{
					if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos-(bHeight*(i+1)) && mouseYS <= ypos+bHeight-(bHeight*(i-1)) && Status == 0)
					{    
						MouseOverFlag = true;
						DropDownMouseOverID = (numStrs-i);				
						return true;
					}
				}
				DropDownMouseOverID = 0;
				MouseOverFlag = false;
				return false;
			}
		}
	} //end overNew()	
	
	
	
} //end dropdown class

//======================================================================================

class TLTriangle
{
	String Label;
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int zpos ; // rect yposition  
	int bSize;
	int ColBG;
	int ColHL;
	int ColOut;  
	boolean Toggle;
	boolean Selected;

	TLTriangle(String iLabel, int ixpos, int iypos, int izpos, int ibSize, int iColBG, int iColHL, int iColOut, boolean iToggle, boolean iSelected)
	{
		Label = iLabel; 
		xpos = ixpos;
		ypos = iypos; 
		zpos = izpos;     
		bSize = ibSize;
		ColBG = iColBG;
		ColHL = iColHL;
		ColOut = iColOut;
		Toggle = iToggle;
		Selected = iSelected;
	}

	public void bufferDisplay()
	{
		TimeLineBuffer.strokeWeight(1);
		TimeLineBuffer.stroke(ColOut);

		if (Selected==true)  TimeLineBuffer.fill(ColHL);
		else  TimeLineBuffer.fill(ColBG);

		// TimeLineBuffer.fill(255, 0, 0);

		TimeLineBuffer.stroke(255);
		TimeLineBuffer.strokeWeight(1);
		//  println("TempX: "+tempX+" : TempY: "+tempY+" : TempA : "+tempA+" : TempB: "+tempB+" : tempFrameVar: "+tempFrameVar);
		TimeLineBuffer.triangle(xpos-(bSize), ypos, xpos+(bSize), ypos, xpos, ypos+bSize);

		TimeLineBuffer.line(xpos,ypos+(bSize),xpos, ypos+(bSize)+8);
		
		TimeLineBuffer.noStroke();
		if (Toggle==false) Selected = false;
	}

	public boolean over() 
	{
		if (mouseXS >= (xpos+cTLChBufX)-(bSize) && mouseXS <= (xpos+cTLChBufX+(bSize)) && mouseYS >= cTLChBufY+(ypos-TLScrollValue) && mouseYS <= (cTLChBufY+(bSize+8))+(ypos-TLScrollValue)) 
		{   
			Selected =! Selected;		
			return true;
		} 
		else {
			return false;
		}
	}
} 

//======================================================================================

class Button
{
	String Label;
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int ColBG;
	int ColHL;
	int ColOut;  
	boolean Toggle;
	boolean Selected;
	int Status; //0=show, 1=grey out, 2=hide
	
	boolean MouseOverFlag;
	
	Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iToggle, boolean iSelected, boolean iAllowMouseOver)
	{
		Label = iLabel; 
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		ColBG = iColBG;
		ColHL = iColHL;
		ColOut = iColOut;
		Toggle = iToggle;
		Selected = iSelected;
		Status = 0; //init at 0
		
		//Setup mouse over list
		if(iAllowMouseOver == true) ButtonList.add(this);
		MouseOverFlag = false;
	}

	public void handleStatus()
	{
		noStroke();
		
		if(Status == 1) 
		{
			strokeWeight(2);
			stroke(cBackgroundColor, 200); //grey out button
			fill(cBackgroundColor, 200); //grey out button
			rect(xpos, ypos, bWidth, bHeight);  
			noStroke();
		}
	}
	
	public void display()
	{
		strokeWeight(1);
		stroke(ColOut);

		if (Selected==true) 
		{	
			fill(ColHL);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColHL,128);
			}
		}		
		else  
		{	
			fill(ColBG);
			
			if(Status == 0 && MouseOverFlag == true) 
			{
				fill(ColBG,64);
				//fill(0,0,0,128);
			}
		}
		
		textAlign(LEFT);
		rect(xpos, ypos, bWidth, bHeight, bHeight/4);  
		//adjust stroke to on higlight and invert text color
		fill(ColOut);
		textSize((bHeight/1.75f));
		text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);

		handleStatus();
		
		if (Toggle==false) Selected = false;
	}

	public void displaySq()
	{
		strokeWeight(1);
		stroke(ColOut);

		if (Selected==true) fill(ColHL);
		else  fill(ColBG);

		rect(xpos, ypos, bWidth, bHeight);  
		//adjust stroke to on higlight and invert text color
		fill(ColOut);
		textSize(12);
		textAlign(CENTER);
		text(Label, xpos+(bWidth/2), ypos+20);
		textAlign(LEFT);   
		handleStatus();
		if (Toggle==false) Selected = false;
	} 

	
	public void bufferDisplaySqIndex(int xposB, int yposB)
	{
		//special display() for index buffer
		IndexScrollBuffer.strokeWeight(1);
		IndexScrollBuffer.stroke(ColOut);
		IndexScrollBuffer.fill(ColBG);
		IndexScrollBuffer.rect(xposB, yposB, bWidth, bHeight);  
		//adjust stroke to on higlight and invert text color
		IndexScrollBuffer.fill(ColOut);
		
		IndexScrollBuffer.textSize(12);
		IndexScrollBuffer.textAlign(CENTER);
		IndexScrollBuffer.text(Label, xposB+(bWidth/2), yposB+20);
		IndexScrollBuffer.textAlign(LEFT);   

	} 	
	
	
	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0) 
		{      
			Selected =! Selected;	
			return true;
		} 
		else {
			return false;
		}
	} //end over()
	
	public boolean overB() //does not toggle selected
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0) 
		{      
			return true;
		} 
		else {
			return false;
		}
	} //end over()
	
	
	public boolean mouseOver() //does not toggle selected
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0) 
		{      
			MouseOverFlag = true;	
			return true;
		} 
		else {
			MouseOverFlag = false;
			return false;
		}
	} //end over()	
	
	//=============================== Graphics Layout Buffer =====================================
	
	public void displayGLBuf() //used for image corner handles
	{
		GraphicLayoutBuffer.strokeWeight(2);
		GraphicLayoutBuffer.stroke(0);
		GraphicLayoutBuffer.rect(xpos, ypos, bWidth, bHeight);  
	}	
	
	public boolean overGLBuf() //used for image corner handles
	{
		if (mouseXS >= (xpos+cGLBufx) && mouseXS <= (xpos+cGLBufx+bWidth) && mouseYS >= (ypos+cWorkspaceY) && mouseYS <= (cWorkspaceY+ypos+bHeight)) 
		{    
			Selected =! Selected;	
			return true;
		} 
		else {
			return false;
		}
	}		
	
	//=============================== TimeLineBuffer =====================================
	
	
	public void displayTL() 
	{
		TimeLineBuffer.strokeWeight(1);
		TimeLineBuffer.stroke(ColOut);

		if (Selected==true)  TimeLineBuffer.fill(ColHL);
		else  TimeLineBuffer.fill(ColBG);

		TimeLineBuffer.rect(xpos, ypos, bWidth, bHeight, bHeight/4);  

		//adjust stroke to on higlight and invert text color
		TimeLineBuffer.fill(ColOut);
		TimeLineBuffer.textSize(bHeight*1.2f); //was /1.7
		
		if(Label.length() > 2) TimeLineBuffer.textSize(bHeight/1.25f);
		
		//TimeLineBuffer.text(Label, xpos+((bWidth - TimeLineBuffer.textWidth(Label))/2), ypos+((bHeight-(TimeLineBuffer.textAscent()+TimeLineBuffer.textDescent()))/1.5), bWidth, bHeight);
		TimeLineBuffer.textAlign(CENTER);
		//TimeLineBuffer.text(Label,xpos+(bWidth/2),ypos+(bHeight/2),bWidth,bHeight);
		TimeLineBuffer.text(Label,xpos,ypos+((float)bHeight/3.5f),bWidth,bHeight);
		TimeLineBuffer.textAlign(LEFT);
		TimeLineBuffer.noStroke();

		if (Toggle==false) Selected = false;
	}

	public boolean overTL() 
	{
		if ( mouseXS >= (xpos+cTLChBufX) && mouseXS <= (xpos+cTLChBufX+bWidth) && mouseYS >= cTLChBufY+(ypos-TLScrollValue) && mouseYS <= (cTLChBufY+bHeight)+(ypos-TLScrollValue)) 
		{      
			Selected =! Selected;		
			return true;
		} 
		else {
			return false;
		}
	}
	
	//=============================== Technical =====================================
	
	public void displayTech() 
	{
		TechnicalBuffer.strokeWeight(1);
		TechnicalBuffer.stroke(ColOut);

		if (Selected==true)  TechnicalBuffer.fill(ColHL);
		else  TechnicalBuffer.fill(ColBG);

		TechnicalBuffer.rect(xpos, ypos, bWidth, bHeight, bHeight/4);  

		//adjust stroke to on higlight and invert text color
		TechnicalBuffer.fill(ColOut);
		TechnicalBuffer.textSize(bHeight*1.2f); //was /1.7
		
		if(Label.length() > 2) TechnicalBuffer.textSize(bHeight/1.25f);
		
		TechnicalBuffer.textAlign(CENTER);
		TechnicalBuffer.text(Label,xpos,ypos+((float)bHeight/3.5f),bWidth,bHeight);
		TechnicalBuffer.textAlign(LEFT);
		TechnicalBuffer.noStroke();

		if (Toggle==false) Selected = false;
	}	
} //end class

//======================================================================================

class SliderBar
{
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int slWidth; // single bar slWidthth
	int slHeight; // rect height
	int Value; 
	int Minimum; 
	int Maximum;
	int BgColor;
	int slHandleColor;
	int slSelectColor; 
	int slStrokeColor;
	boolean CircleHandle;  //ture circle, false rectangle
	boolean HorizVertToggle;
	boolean ScrollBarToggle;
	int  SetNumber;

	//gotta move the int variables into float variables
	float temp1=slWidth;
	float temp2=Maximum;
	float temp3=Value;
	float temp4=Minimum;
	float MathVar=0;

	SliderBar(int iSetNumber, int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, int iBgColor, int islHandleColor, int islSelectColor, int islStrokeColor, boolean iCircleHandle, boolean iHorizVertToggle, boolean iScrollBarToggle) 
	{   
		xpos = ixp;
		ypos = iyp;  
		slWidth = iw;
		slHeight = ih;
		Value=iValue;
		Maximum=iMax;
		Minimum=iMin;
		BgColor=iBgColor;
		slHandleColor=islHandleColor;
		slSelectColor=islSelectColor;
		slStrokeColor=islStrokeColor;
		CircleHandle=iCircleHandle;  		//false is rectangle, true is circle
		HorizVertToggle=iHorizVertToggle; //false is horiz, true is vert
		ScrollBarToggle=iScrollBarToggle; //false is normal, true is scrollbar style
		
		SetNumber = iSetNumber;
	}

	public void setValue(int passedVal)
	{
		if (passedVal > Maximum) { //check so it doesn't drag off the end
			passedVal = Maximum;
		}
		if (passedVal < Minimum) { //check so it doesn't drag off the end
			passedVal = Minimum;
		}
		Value = passedVal;		
	}//end setValue() 

	
	
	public int getValue()
	{
		if (Value > Maximum) { //check so it doesn't drag off the end
			Value = Maximum;
		}
		if (Value < Minimum) { //check so it doesn't drag off the end
			Value = Minimum;
			println("HAPPENED====================================");
		}	
		
		return Value;
	}
	
	
	
	public void move(int uX, int uY) 
	{
		//uX = round((float)uX / SF);
		//uY = round((float)uY / SF);	  
		if(ScrollBarToggle == true)
		{
			//scrollbar mode
			if(HorizVertToggle == false) //horizontal
			{
				//this function handles position of the slider's handle for Verticle
				temp1 = slWidth - (slHeight * 2);   
				temp3 = Value;
				
				MathVar = ((((uX-xpos)-slHeight) / temp1)-1) *-1; //creates a scale factor based on mouse position 
				MathVar = Maximum - (MathVar*(Maximum-Minimum));   

				if (MathVar > Maximum) { //check so it doesn't drag off the end
					MathVar=Maximum;
				}
				if (MathVar < Minimum) { //check so it doesn't drag off the end
					MathVar=Minimum;
				}  	
				
				Value=PApplet.parseInt(MathVar); //set the value based on mouse movement
			}//end if
			else
			{
				//this function handles position of the slider's handle for Verticle
				temp1 = slHeight - (slWidth * 2);   
				temp3 = Value;

				MathVar = ((((uY-ypos)-slWidth) / temp1)-1) *-1; //creates a scale factor based on mouse position  
				MathVar = Maximum - (MathVar*(Maximum-Minimum));   

				if (MathVar > Maximum) { //check so it doesn't drag off the end
					MathVar=Maximum;
				}
				if (MathVar < Minimum) { //check so it doesn't drag off the end
					MathVar=Minimum;
				}  
				Value=PApplet.parseInt(MathVar); //set the value based on mouse movement
			}	
		}	
		else
		{
			//regular usage
			if(HorizVertToggle == false) //horizontal
			{
				//this function handles position of the slider's handle
				temp1 = slWidth;   
				temp3 = Value;
				temp4 = Minimum;

				MathVar = (((uX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
				//relative to slider position
				MathVar = Maximum - (MathVar*(Maximum-Minimum));   

				if (MathVar > Maximum) { //check so it doesn't drag off the end
					MathVar=Maximum;
				}

				if (MathVar < Minimum) { //check so it doesn't drag off the end
					MathVar=Minimum;
				}  

				Value = PApplet.parseInt(MathVar); //set the value based on mouse movement
			}//end if
			else
			{
				println("NO SLIDER MOVE() HANDLER");	
			}
		}		
	} //end move()
	
	public void display() 
	{   
		if(ScrollBarToggle == true)
		{
			if(HorizVertToggle == false) //horizontal
			{ 
				stroke(slStrokeColor);
				strokeWeight(1);

				//circle handles are displayed differently so there are if/else statements to set it correctly
				fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
				rect(xpos, ypos, slWidth, slHeight);   //main rect

				fill(200); 
				rect(xpos+(slHeight/10)+slHeight, ypos+(slHeight/10), slWidth-(slHeight/5)-(slHeight*2), (slHeight-(slHeight/5)));   //middle		
				rect(xpos+(slHeight/10), ypos+(slHeight/10), slHeight-(slHeight/5), slHeight-(slHeight/5)); //left rect	
				rect(xpos+(slHeight/10)+(slWidth-slHeight), ypos+(slHeight/10), slHeight-(slHeight/5), slHeight-(slHeight/5));  //right rect 
				
				stroke(slStrokeColor);
				fill(slHandleColor);
				strokeWeight(1);
				//top
				triangle(xpos+slHeight-(slHeight/5),ypos+(slHeight/5),xpos+slHeight-(slHeight/5),ypos+(slHeight-(slHeight/5)),xpos+(slHeight/5),ypos+(slHeight/2));	
				//right
				triangle(xpos+slWidth-slHeight+(slHeight/5),ypos+(slHeight/5),xpos+slWidth-slHeight+(slHeight/5),ypos+(slHeight-(slHeight/5)),xpos+slWidth-slHeight+slHeight-(slHeight/5), ypos+(slHeight/2));
				//Handle
				
				temp1 = (slWidth - (slHeight*3));
				temp2 = Maximum;  //move variables into float
				temp3 = Value;    //or do they don't compute correctly
				temp4 = Minimum;			
				float MathVar;
				
				MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2+slHeight;
				
				fill(slHandleColor); //places the slider handle
				ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-2, slHeight-2); //Circle instead of rectangle
			}
			else
			{
				stroke(slStrokeColor);
				strokeWeight(1);

				//circle handles are displayed differently so there are if/else statements to set it correctly
				fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
				rect(xpos, ypos, slWidth, slHeight);  

				fill(200); 
				rect(xpos+(slWidth/10), ypos+(slWidth/10)+slWidth, slWidth-(slWidth/5), (slHeight-(slWidth/5))-(slWidth*2));   
				rect(xpos+(slWidth/10), ypos+(slWidth/10), slWidth-(slWidth/5), slWidth-(slWidth/5));   
				rect(xpos+(slWidth/10), ypos+(slWidth/10)+slHeight-slWidth, slWidth-(slWidth/5), slWidth-(slWidth/5));   

				stroke(slStrokeColor);
				fill(slHandleColor);
				strokeWeight(1);
				//top
				triangle(xpos+(slWidth/5), ypos+(slWidth/4)+(slWidth/2), xpos+(slWidth/2), ypos+(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+(slWidth/2));
				//bottom
				triangle(xpos+(slWidth/5), ypos+(slWidth/4)+slHeight-slWidth, xpos+(slWidth/2), ypos+slHeight-(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+slHeight-slWidth);

				temp1 = (slHeight - (slWidth*3));
				temp2 = Maximum;  //move variables into float
				temp3 = Value;    //or do they don't compute correctly
				temp4 = Minimum;

				//println(temp1+" : "+temp2+" : "+temp3+" : "+temp4);
				
				//Handle
				float MathVar;
				MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slWidth/2+slWidth;
				fill(slHandleColor); //places the slider handle
				ellipse(xpos+(slWidth/2), ypos+MathVar, slWidth-2, slWidth-2); //Circle instead of rectangle

				// rect(xpos, ypos+MathVar, slWidth, slWidth); //and comment this line for circle
				noStroke();
			}
			
		}
		else
		{
			stroke(slStrokeColor);
			strokeWeight(1);

			//circle handles are displayed differently so there are if/else statements to set it correctly
			fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
			rect(xpos, ypos, slWidth, slHeight);   

			if (CircleHandle==true) temp1 = slWidth - slHeight;
			else temp1=slWidth-(slWidth/20);

			temp2=Maximum;  //move variables into float
			temp3=Value;    //or do they don't compute correctly
			temp4 = Minimum;

			float MathVar;

			if (CircleHandle==true)
			MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
			else  
			MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 

			fill(color(slSelectColor)); //draws the Selcolor over the selected area
			rect(xpos, ypos, MathVar, slHeight);

			fill(slHandleColor); //places the slider handle
			if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); //Circle instead of rectangle
			else   rect((xpos+MathVar), ypos, slWidth/20, slHeight); //and comment this line for circle
			
		}			
	}//end display()

	public void selectSlider()
	{
		SliderPointer = this;
		GlobalDragging = true;
	}//end selectSlider

	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+slWidth && mouseYS >= ypos && mouseYS <= ypos+slHeight) 
		{          
			return true;
		} 
		else {
			return false;
		}
	}
}

//=====================================================================================

class TextField
{
	String Label;
	int xpos; // rect xposition  
	int ypos ; // rect yposition
	int bWidth;
	int bHeight;
	int ColBG;
	int ColHL;

	int InputMethod; //0 = characters only, 1 = numbers only , 2 = numbers only with trailing %, 3 = floats
	int minValue; //either min number, or minim characters
	int maxValue; //either max number, or maximum characters
	boolean Toggle;
	boolean Selected;
	String txtfCallback;

	int Status; //0=show, 1=grey out, 2=hide
	
	boolean MouseOverFlag;
	
	TextField(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iInputMethod, int iminValue, int imaxValue, boolean iToggle, boolean iSelected, String itxtfCallback)
	{
		Label = iLabel; 
		xpos = ixpos;
		ypos = iypos;  
		bWidth = ibWidth;
		bHeight = ibHeight;
		ColBG = iColBG;
		ColHL = iColHL;
		Toggle = iToggle;
		Selected = iSelected;
		InputMethod = iInputMethod;
		minValue = iminValue; 
		maxValue = imaxValue; 
		txtfCallback = itxtfCallback;
		Status = 0; //init at show

		//if(sEnableMouseOver == 1) 
		TextFieldList.add(this);
		MouseOverFlag = false;		
	}

	public void handleStatus()
	{
		noStroke();
		
		if(Status == 1) 
		{
			strokeWeight(2);
			stroke(cBackgroundColor, 200); //grey out button
			fill(cBackgroundColor, 200); //grey out button
			rect(xpos, ypos, bWidth, bHeight);  
			noStroke();
		}
	}	
	
	public void display()
	{
		translate(0, 0);
		strokeWeight(2);
		fill(ColBG);

		if (Selected==true)
		{
			stroke(ColHL); 
		}
		else       
		{
			stroke(cColButtonsBG);
			if(Status == 0 && MouseOverFlag == true) 
			{
				stroke(ColHL,128);
				fill(ColBG,192);
			}		
		}
		rect(xpos, ypos, bWidth, bHeight);
		
		//adjust stroke to on higligh and invert text color
		noStroke();
		fill(0);
		textSize((bHeight/1.75f));
		
		textAlign(LEFT);
		if(InputMethod != 2) text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
		else  text(Label+"%", xpos+((bWidth - textWidth(Label+1))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
		
		handleStatus();
		
		if (Toggle==false) Selected = false;
	}


	public void SelectField()
	{
		try {
			textFieldPtr.Selected = false; //was commented out
		}
		catch(Exception e) { }
		
		textFieldPtr = this;
		GlobalLabel = Label;
		Label = "";
		Selected = true; 
		
		TextFieldActive = true;
	}

	
	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0) 
		{     
			Selected =! Selected;		
			return true;
		} 
		else {
			return false;
		}
	}
	
	public boolean mouseOver() //does not toggle selected
	{
		if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight && Status == 0) 
		{     
			MouseOverFlag = true;		
			return true;
		} 
		else {
			MouseOverFlag = false;
			return false;
		}		
	} //end over()		
	
} 

//============================================================================================

class LEDgraphic
{
	short ChanID;
	short xpos; // rect xposition  
	short ypos ; // rect yposition
	byte bSize;
	byte GroupID;

	LEDgraphic(int iChanID, int ixpos, int iypos, byte ibSize)//, color icColor)
	{
		ChanID = (short)iChanID; 
		xpos = (short)ixpos;
		ypos = (short)iypos;  
		bSize = ibSize;
	}

	public void bufferDisplay()
	{   
		//need to do a switch for single(which will use the white slider, and RGB/RGBW
		GraphicLayoutBuffer.beginDraw();
		
	//	if(SoftwareCheckBox[7].Selected == true)
		GraphicLayoutBuffer.rectMode(CENTER);
		
		int IDOffset = 0;
		if(ChanID >= TotalColorChannels)  //for displaying packet cloning
		{	
			//clone the data
			IDOffset = floor(ChanID / TotalColorChannels);
			if(IDOffset > 0) IDOffset = IDOffset * TotalColorChannels;
			else IDOffset = 0;
		}
		


		
		//outside starting color ring
		GraphicLayoutBuffer.noStroke();

		
		//START CODE PORT to strip pre-load
		int tempFrameVar = UserSequences[SelectedSequence].DataFrameVar[((ChanID-IDOffset)*CurrentDataTypeMult)]; //set to default framevar
		int CurrentStartR = 0;
		int CurrentStartG = 0;
		int CurrentStartB = 0;
		int CurrentStartW = 0;

		int CurrentEndR = 0;
		int CurrentEndG = 0;
		int CurrentEndB = 0;
		int CurrentEndW = 0;
		
		
		switch(PixelDataType)
		{
		case 2: //RGBW
			CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+3];
		case 1: //RGB
			CurrentStartR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)];
			CurrentStartG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+1];
			CurrentStartB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+2];
			break;
		case 0: //Single
			CurrentStartW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)];
			break;	
		}	  	  

				
		if(UserSequences[SelectedSequence].SeqMode == mInstant) 		//added v.2e
		{
		//start values may not be updated
		
		switch(PixelDataType)
		{
		case 2: //RGBW
UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+3] = CurrentStartW;
		case 1: //RGB
UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)] = CurrentStartR;
UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+1] = CurrentStartG;
UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+2] = CurrentStartB;
			break;
		case 0: //Single
UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)] = CurrentStartW;
			break;	
		}	  	  		

		} //end instant if	
				
		
		
		//increment framevar
		if (tempFrameVar < UserSequences[SelectedSequence].SeqFrameAmount) tempFrameVar++;
		else tempFrameVar = 0; //increment or wrap FrameVar

		switch(PixelDataType)
		{
		case 2: //RGBW
			CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+3];
		case 1: //RGB
			CurrentEndR = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)];
			CurrentEndG = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+1]; 
			CurrentEndB = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)+2];
			break;
		case 0: //Single
			CurrentEndW = UserSequences[SelectedSequence].DataFrames[tempFrameVar][((ChanID-IDOffset)*CurrentDataTypeMult)];
			break;	
		}	 	  	
		//now it knows what the starting and end colors are
		
		
		//reads the start and end values, if they are the same, it overwrites the startvalue which is an indicator preload value
		switch(PixelDataType)
		{
		case 0: //Single
			if(CurrentStartW == CurrentEndW)
			{
				myWhite = CurrentStartW; //they are same, overwrite start since it was data
			}	
			else myWhite =  UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+3];
			myRed = myWhite;
			myGreen = myWhite;
			myBlue = myWhite;
			
			if(MainToolsShowStartValues.Selected == true || GraphicLayoutPreview == true)
			{
				GraphicLayoutBuffer.fill(color(UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset)* CurrentDataTypeMult]));
				
				if(SoftwareCheckBox[7].Selected == true) GraphicLayoutBuffer.rect(xpos, ypos, bSize*1.4f, bSize*1.4f);
				else GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.4f, bSize*1.4f);	
			}
			
			break;
		case 2: //RGBW
			if(CurrentStartW == CurrentEndW)
			{
				myWhite = CurrentStartW; //they are same, overwrite start since it was data
			}			
			else myWhite =  UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+3];
			
		case 1: //RGB
			if(CurrentStartR == CurrentEndR)
			{
				myRed = CurrentStartR; //overwrite preload
			}				
			else myRed =  UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)];	
			

			if(CurrentStartG == CurrentEndG)
			{
				myGreen = CurrentStartG;//overwrite preload
			}
			else myGreen =  UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+1];
			

			if(CurrentStartB == CurrentEndB)
			{
				myBlue = CurrentStartB;//overwrite preload
			}
			else myBlue =  UserSequences[SelectedSequence].StartValues[((ChanID-IDOffset)* CurrentDataTypeMult)+2];
				
			if(MainToolsShowStartValues.Selected == true || GraphicLayoutPreview == true)
			{
				if(device.Bit16Mode == true) GraphicLayoutBuffer.fill(color(UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset)* CurrentDataTypeMult]>>8, UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset) * CurrentDataTypeMult+1]>>8,UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset) * CurrentDataTypeMult+2]>>8));					
				else GraphicLayoutBuffer.fill(color(UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset)* CurrentDataTypeMult], UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset) * CurrentDataTypeMult+1],UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset) * CurrentDataTypeMult+2]));	
				
				if(SoftwareCheckBox[7].Selected == true) GraphicLayoutBuffer.rect(xpos, ypos, bSize*1.4f, bSize*1.4f);
				else GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.4f, bSize*1.4f);
				//draw full RGB ellipse first
				
				if(PixelDataType == 2) //then draw the semi-circle if needed
				{
					if(device.Bit16Mode == true) GraphicLayoutBuffer.fill(color(UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset)* CurrentDataTypeMult+3]>>8));	
					else GraphicLayoutBuffer.fill(color(UserSequences[SelectedSequence].DataFrames[SelectedFrame][(ChanID-IDOffset)* CurrentDataTypeMult+3]));	
					
					//GraphicLayoutBuffer.fill(color(myWhite));
					if(SoftwareCheckBox[7].Selected == true)  GraphicLayoutBuffer.rect(xpos, ypos+(bSize/2), bSize*1.4f, (bSize*1.4f)/2);
					else GraphicLayoutBuffer.arc(xpos, ypos, bSize*1.4f, bSize*1.4f, 0, PI, OPEN);
				}
			}	//end if
			
			break;	
		} //end switch							
		//END	
		
		
		GraphicLayoutBuffer.stroke(0);
		GraphicLayoutBuffer.strokeWeight(1);		
		/*
		if(PixelDataType == 2)
		{
			GraphicLayoutBuffer.stroke(myWhite);
			GraphicLayoutBuffer.strokeWeight(2);
		}
		else
		{
			//stroke for around center ellipse
			GraphicLayoutBuffer.stroke(0);
			GraphicLayoutBuffer.strokeWeight(1);	
		}
		*/
		
		if(GraphicLayoutPreview == false)
		{	
		//main icon graphic
		GraphicLayoutBuffer.fill(color(myRed, myGreen, myBlue));
		
		//Handle circle or square
		if(SoftwareCheckBox[7].Selected == true) GraphicLayoutBuffer.rect(xpos, ypos, bSize, bSize); 
		else GraphicLayoutBuffer.ellipse(xpos, ypos, bSize, bSize); 

		
		GraphicLayoutBuffer.fill((255 - myRed), (255 - myGreen), (255 - myBlue));
		if ((myRed < 200 && myRed > 55) || (myGreen < 200 && myGreen > 55) || (myBlue < 200 && myBlue > 55))
		{
			GraphicLayoutBuffer.fill(255);
		}  
		GraphicLayoutBuffer.textSize((bSize/1.75f));
		GraphicLayoutBuffer.textAlign(CENTER, CENTER); //centers the text on the ellipse
		GraphicLayoutBuffer.text((ChanID+1), xpos, ypos-(bSize/10));
		
		}
		
		GraphicLayoutBuffer.textAlign(LEFT, BASELINE);
		GraphicLayoutBuffer.noStroke();
		
		GraphicLayoutBuffer.rectMode(CORNERS);  //incase it was changed for grid icon mode
		GraphicLayoutBuffer.endDraw();
	}

	
	public boolean over() 
	{
		if (mouseXS >= (xpos+cWorkspaceX)-(bSize/2) && mouseXS <= (xpos+cWorkspaceX)+(bSize/2) && mouseYS >= ypos+35-(bSize/2) && mouseYS <= (ypos+35)+(bSize/2)) 
		{      
			return true;
		} 
		else {
			return false;
		}
	}
}

public void CloseCommunicationPort()
{
	if(CommunicationMode == 0) CloseCOMPort();	
	else if(CommunicationMode == 1) CloseTCP();		
} //end CloseCommunicationPort()

//===================================================================================================

public void OpenTCP()
{
	//if(TCPClient != null && TCPClient.active() == true) { println("TCP Open or Opening"); return; }
	println("OpenTCP()");
	
	//close and dispose of connection if open
	try {
		TCPClient.clear();
		TCPClient.dispose();
		TCPClient.stop();
	}
	catch(Exception e) { }

	CloseCOMPort();	//sets portname, devstatus, DeviceSelected etc
	
	try {

		devStatus = "Trying TCP";
		
		TCPClient = new Client(this, TCPip, TCPport); //holds here like a while()

		if(TCPClient.active() == true) 
		{
			println("Connected to TCP Server at "+TCPClient.ip()+" on port 23");
			CommunicationMode = 1; //TCP Mode
			portName = "TCP/IP";
			OpenConnection();
		}
		else
		{
			TCPClient.stop();
			
			if(DeviceConnect.Selected == false) //incase user clicks TCP, it attempts connect then they connect through serial
			{
				devStatus = "TCP Failed";
				portName = "None";
			}
		}
	}
	catch(Exception e)
	{
		println("Could Not Connect To TCP/IP Server");
	}
} //end OpenTCP()


public void CloseTCP()
{
	println("CloseTCP()");
	
	DeviceConnect.Selected = false;		
	devStatus = "Unconnected";	
	CommunicationMode = 0;//revert to serial mode
	
	try {
		TCPClient.clear();
		TCPClient.dispose();
		TCPClient.stop();
	}
	catch(Exception e) { }
} //CloseTCP()

//===================================================================================================

public void CloseCOMPort()
{
	println("CloseCOMPort() - Closing Port");  	
	DeviceConnect.Selected = false;		
	devStatus = "Unconnected";	
	
	for (int i=0; i < COMButtons.length;i++)	COMButtons[i].Selected = false;
	
	try	 
	{	
		//close COM port
		myPort.stop();
		myPort.dispose();
		devConnected = false;
	}
	catch(Exception e)
	{
		println("No Port To Close");
	}	
	
	if(SelectedMenuTab == 4) thread("PortMonitorThread"); //start monitoring
	println("COM Port Closed");
}

//===================================================================================================

public void OpenCOMPort(String NameID)
{
	println("OpenCOMPort() with "+NameID+" at baud: "+ProgramBaudRate);
	redraw();
	
	if(NameID.equals("TCP/IP"))
	{
		thread("OpenTCP");
		return;
	}
	
	try {
		myPort.stop();
		myPort.dispose();     
	}
	catch(Exception e) { }

	int x = 0; //so can be used in catch
	
	try 
	{
		for (x =0; x != Serial.list().length; x++) 
		{
			if(NameID.equals(Serial.list()[x]))
			{	
				portName = Serial.list()[x];			
				myPort = new Serial(this, portName, ProgramBaudRate);
				
				try {
					for (int q =0; q != COMButtons.length; q++) COMButtons[q].Selected = false;	
					//COMButtons[x].Selected = true;
				}
				catch(Exception e)	{	}	
				
				println("Connected to "+portName);
				OpenConnection();
				break;
			}
			else
			{
				//println(Serial.list()[x]+" is not a Match for COM port in software.ini");		
			}	
		}	
	}
	catch(Exception e)
	{
		println("Could Not Open COM Port "+Serial.list()[x]);
		portName = "None";
		DeviceConnect.Selected = false;		
		devStatus = "Unconnected";	
		ShowNotification(22);
		
		//COMButtons[x].Selected = false;	
	}
} //end func()

//===================================================================================================

public void FuncRecommendColorShift()
{	
//String[] PixelChipsetStrings = {"WS2801", "WS2811", "WS2812", "WS2812B", "LPD1886", "LPD6803", "LPD8806", "TM1803", "TM1814", "APA102", "APA104", "SK6812"};

	try
	{
		for(int i=0;i<=PixelChipsetDD.numStrs+1;i++)
		{
			if(PixelChipsetDD.Labels[PixelChipsetDD.SelStr].indexOf(cPixelChipsetStrings[i])>=0)
			{
			InputModule[3].Label = "Select The Pixel Chipset:\n\n\nRecommended Color: "+cPixelChipsetColorID[i];
			return; //return if something is found
			}
		} //end for()
	}
	catch(Exception e)
	{
	//nothing
	}
	//otherwise uses default
	InputModule[3].Label = "Select The Pixel Chipset:\n\n\nRecommended Color: Unknown / Test";	
} //end FuncRecommendColorShift

//===================================================================================================


class SpecHWModules
{
  int IDnumber;
  String Label;
  int xpos;
  int ypos;
  int bWidth;
  int bHeight;
  
  int Priority;
  
  String ModuleFlagStr;
  String ModuleByteStr;
  
  boolean Enabled;

  SpecHWModules(int iIDnumber, String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, String iModuleFlagStr, String iModuleByteStr, int iPriority)
  {
	IDnumber = iIDnumber;
	Label = iLabel;
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
	ModuleFlagStr = iModuleFlagStr;
	ModuleByteStr = iModuleByteStr;
	Priority = iPriority;
  }

  public void display()
  {
	if(Enabled == false) return;
	
	stroke(0);
	strokeWeight(2);
	fill(cBorderColor, 200);
	rect(xpos, ypos, bWidth, bHeight);
	noStroke();
	
	switch(IDnumber)
	{
	case 0:	//device.RS485Capable
		HardwareButtons[0].display();		
		break;		
	case 1:		//LED indicator 2
		LEDIndicatorModeBDD.display();
		if(LEDIndicatorModeBDD.Selected == true)	DropDownPointer = LEDIndicatorModeBDD;		
		break;		  
	case 2:	//device.GlobalColorShift		
		HardwareColSwapDD.display();	
		if(HardwareColSwapDD.Selected == true)	DropDownPointer = HardwareColSwapDD;	
		break;		  
	case 3:	//Pixel Type
		PixelChipsetDD.display();	
		if(PixelChipsetDD.Selected == true)	DropDownPointer = PixelChipsetDD;
		break;				
	case 4:	//device.HardwareID
		HardwareButtons[2].display();	
		break;			
	case 5: //DMX Adress
		TextFields[2].display(); //DMX Address
		break;			
	case 6:
		Label = "DMX Reception\nMode - ID Number: "+DMXModesDD.SelStr;
		DMXModesDD.display(); //has to be last so it overlays everything else
		if(DMXModesDD.Selected == true)	DropDownPointer = DMXModesDD;			
		break;	
	case 7:
		MasterModeDD.display();
		if(MasterModeDD.Selected == true)	DropDownPointer = MasterModeDD;
		break;
	case 8:
		HardwareCheckBox[0].display();
		fill(0);
		textAlign(LEFT);
		text("16-Bit Serial", HardwareCheckBox[0].xpos+25 , HardwareCheckBox[0].ypos+15); 
		
		Label = "Serial Baud Rate:\nID Number: "+BaudRateDD.SelStr;
		
		BaudRateDD.display();	
		if(BaudRateDD.Selected == true)	DropDownPointer = BaudRateDD;
		break;
	case 9:
		LEDIndicatorModeADD.display();
		if(LEDIndicatorModeADD.Selected == true)	DropDownPointer = LEDIndicatorModeADD;
		break;	
	case 10:
		DisplayModeDD.display();
		if(DisplayModeDD.Selected == true)	DropDownPointer = DisplayModeDD;
		break;	
	case 11:
		AutoDetectDD.display();	
		if(AutoDetectDD.Selected == true)	DropDownPointer = AutoDetectDD;
		break;			
	case 12: //fGammaCorrectionEnabled
		HardwareButtons[3].display();
		break;			
	case 13: //Automatic Shut Off/Resume Time Out Value
		AccMeterAutoDetectDD.display();	
		if(AccMeterAutoDetectDD.Selected == true)	DropDownPointer = AccMeterAutoDetectDD;		
		
		AccMeterAutoDetectModeDD.display();	
		if(AccMeterAutoDetectModeDD.Selected == true)	DropDownPointer = AccMeterAutoDetectModeDD;
		break;				
	case 14: //Enable Accelerometer Speed Adjustment
		HardwareButtons[4].display();
		break;
	case 15: //Enable Double Tap Button Press
		AccMeterTapDD.display();	
		if(AccMeterTapDD.Selected == true)	DropDownPointer = AccMeterTapDD;
		break;
	case 16: //Power Down Time Out
		PowerDownTimeOutDD.display();	
		if(PowerDownTimeOutDD.Selected == true)	DropDownPointer = PowerDownTimeOutDD;
		break;		
	case 17: //Packet Clone
	//	TextFields[15].display();
		break;	
	case 18: //Fade Transition
	//	TextFields[16].display();
		break;
	case 19: //Dual Communication Mode
		HardwareCheckBox[1].display();	
		fill(0);
		textAlign(LEFT);
		text("Enable", HardwareCheckBox[1].xpos-45 , HardwareCheckBox[1].ypos+15); 
		break;	
	case 20: //PWM Freq A
		PWMFreqADD.display();
		break;
	case 21: //Stand-Alone A
		StandAloneADD.display();
		TextFields[13].display();
		fill(0);
		textAlign(LEFT);
		textSize(12);
		text("Enter Sequence ID#:", TextFields[13].xpos-90, TextFields[13].ypos-5);
		break;
	case 22: //PWM Profile
		PWMProfileADD.display();
		break;	
	case 23: //I.R. Remote addon card
		IRRemoteModeDD.display();
		break;			
	}

	textAlign(CENTER);
	textSize(12);  
	fill(0);
	text(Label, xpos+5, ypos+10, bWidth-10, bHeight-10);  
  } //end display
  
  public void InitPositions()
  {
	  
	switch(IDnumber)
	{
	case 0:	//device.RS485Capable
		HardwareButtons[0].xpos = xpos+30;
		HardwareButtons[0].ypos = ypos+55;
		break;		
	case 1:	//second LED indicator
		LEDIndicatorModeBDD.xpos = xpos+10;
		LEDIndicatorModeBDD.ypos = (ypos+(bHeight))-40;
		break;		  
	case 2:	//device.GlobalColorShift	
		HardwareColSwapDD.xpos = xpos+10;						
		HardwareColSwapDD.ypos = ypos+60;			
		break;		  
	case 3:	//Pixel Type
		PixelChipsetDD.xpos = xpos+10;		
		PixelChipsetDD.ypos = ypos+25;		
		break;				
	case 4:	//device.HardwareID
		HardwareButtons[2].xpos = xpos+60;
		HardwareButtons[2].ypos = ypos+55;	
		break;	
	case 5:	
		TextFields[2].xpos = xpos+20;
		TextFields[2].ypos = (ypos+(bHeight))-50;				
		break;				
	case 6: //DMX Reception Mode	
		DMXModesDD.xpos = xpos+5;
		DMXModesDD.ypos = (ypos+(bHeight))-35;			
		break;			
	case 7: //DMX Master Mode
		if(device.Bit16Mode == true)
		{
		MasterModeDD.Labels = cDDMasterModesMultiBit;
		MasterModeDD.numStrs = cDDMasterModesMultiBit.length;	
		}
		else
		{
		MasterModeDD.Labels = cDDMasterModes8Bit;
		MasterModeDD.numStrs = cDDMasterModes8Bit.length;		
		}
		MasterModeDD.xpos = xpos+10;
		MasterModeDD.ypos = (ypos+(bHeight))-35;	
		break;			
	case 8:
		BaudRateDD.xpos = xpos+10;
		BaudRateDD.ypos = (ypos+(bHeight))-52;	
		
		HardwareCheckBox[0].xpos = xpos+10;
		HardwareCheckBox[0].ypos = (ypos+(bHeight))-25;	
		
		//set checkbox grey out or not if enabled
		if(IsOnConfigFlags("f8or16Bit") == true) HardwareCheckBox[0].Status = 0; //0=show, 1=grey out, 2=hide
		else HardwareCheckBox[0].Status = 1; //0=show, 1=grey out, 2=hide		
		break;	
	case 9:
		LEDIndicatorModeADD.xpos = xpos+10;
		LEDIndicatorModeADD.ypos = (ypos+(bHeight))-40;
		break;	
	case 10:
		DisplayModeDD.xpos = xpos+10;
		DisplayModeDD.ypos = (ypos+(bHeight))-40;
		break;	
	case 11:
		AutoDetectDD.xpos = xpos+10;
		AutoDetectDD.ypos = (ypos+(bHeight))-40;			
		break;			
	case 12://fGammaCorrectionEnabled
		HardwareButtons[3].xpos = xpos+30;
		HardwareButtons[3].ypos = ypos+55;	
		break;	
	case 13: //Automatic Shut Off/Resume Time Out Value
		AccMeterAutoDetectDD.xpos = xpos+20;		
		AccMeterAutoDetectDD.ypos = ypos+65;		
		AccMeterAutoDetectModeDD.xpos = xpos+20;		
		AccMeterAutoDetectModeDD.ypos = ypos+40;
		break;				
	case 14: //Enable Accelerometer Speed Adjustment
		HardwareButtons[4].xpos = xpos+30;
		HardwareButtons[4].ypos = ypos+45;	
		break;
	case 15: //Enable Double Tap Button Press
		AccMeterTapDD.xpos = xpos+20;		
		AccMeterTapDD.ypos = ypos+55;	
		break;		
	case 16: //Power Down Time Out	
		PowerDownTimeOutDD.xpos = xpos+10;
		PowerDownTimeOutDD.ypos = (ypos+(bHeight))-40;	
		break;
	case 17: //empty
	
		break;	
	case 18: //empty

		break;	
	case 19: //Dual Communication Mode
		HardwareCheckBox[1].xpos=xpos+70;	
		HardwareCheckBox[1].ypos=ypos+65;	
		break;	
	case 20: //PWM Freq A
		PWMFreqADD.xpos=xpos+10;
		PWMFreqADD.ypos=(ypos+(bHeight))-40;	
		break;
	case 21: //Stand-Alone A
		StandAloneADD.xpos=xpos+5;	
		StandAloneADD.ypos=(ypos+(bHeight))-35;			
		TextFields[13].xpos=xpos+125;	
		TextFields[13].ypos=(ypos+(bHeight))-35;	
		break;
	case 22: //PWM Profile
		PWMProfileADD.xpos = xpos+10;
		PWMProfileADD.ypos = (ypos+(bHeight))-35;			
		break;			
	case 23: //I.R. Remote Add on
		IRRemoteModeDD.xpos = xpos+10;
		IRRemoteModeDD.ypos = (ypos+(bHeight))-35;			
		break;	
	}	    
  }//end InitPositions

  
  public int GetBitValues(int passedID)
  {
	    
	switch(IDnumber)
	{
	case 0:	//device.RS485Capable
		//"fRS485Enable,f8or16Bit"
		if(HardwareButtons[0].Selected && passedID == 0)  return 1;//fRS485Enable
		if(HardwareCheckBox[0].Selected && passedID == 1) return 1;//f8or16FBit
		break;		
	case 1: //LED Indicator Mode 2

		break;		  
	case 2:	//bGlobalColorShift
	
		break;		  
	case 3:	//Pixel Chipset
	
		break;				
	case 4: //Enable Serial Reception Instead of DMX

		break;	
	case 5:	//DMX Adress
			
		break;				
	case 6: //DMX Reception
	
		break;			
	case 7: //DMX Master Mode
	
		if(IsOnConfigFlags("fMaster16Bit") == true) 
		{
			//"fMasterEnable,fMasterFullPkts,fMaster16Bit"
			switch(MasterModeDD.SelStr)
			{
			case 0: //None
				//both ID flag and Autodetect stay 0
				
				return 0;
			case 1: //Master Full Pkts 8-Bit
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable
				//temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 1;//fMasterFullPkts(1 is Full, 0 is partial)
				if(passedID == 2) 			return 0;//fMaster16Bit	stays 0						
				//fMaster16Bit stays 0	
				break;
			case 2: //Master Full Pkts 16-Bit
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable
				//temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)	
				//temp2Flags = temp2Flags | 0x04; //fMaster16Bit
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 1;//fMasterFullPkts(1 is Full, 0 is partial)
				if(passedID == 2) 			return 1;//fMaster16Bit	stays 0						
				
				break;
			case 3:	//Master Partial Pkts 8-Bit
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable	
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 0;//fMasterFullPkts(1 is Full, 0 is partial) 
				if(passedID == 2) 			return 0;//fMaster16Bit	stays 0			
				break;	
			case 4:	//Master Partial Pkts 16-Bit
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable	
				//temp2Flags = temp2Flags | 0x04; //		
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 0;//fMasterFullPkts(1 is Full, 0 is partial)
				if(passedID == 2) 			return 1;//fMaster16Bit	
				break;		
			}//end switch
		}
		else
		{
			//"fMasterEnable,fMasterFullPkts"
			switch(MasterModeDD.SelStr)
			{
			case 0: //None
				//both ID flags	
				return 0;
			case 1: //Master Full Packets
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable
				//temp2Flags = temp2Flags | 0x02; //fMasterFullPkts(1 is Full, 0 is partial)
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 1; //fMasterFullPkts
				
				break;
			case 2: //Master Partial Packets
				//temp2Flags = temp2Flags | 0x01; //fMasterEnable				
				if(passedID == 0) 			return 1;//fMasterEnable
				if(passedID == 1) 			return 0;//fMasterFullPkts(1 is Full, 0 is partial) - leave it 0
				break;
			}//end switch
		}
			
		break;			
	case 8: //Serial Baud Rate
		if(HardwareCheckBox[0].Selected == true) return 1;	
		return 0;
		//break;	
	case 9: //LED Inidicator A
		//11 "Both", 01"Stand-Alone", 10"RX", 00"Disabled"
		//"fLEDModeMSBa,fLEDModeLSBa"
		switch(LEDIndicatorModeADD.SelStr) //LEDMode
		{
		case 0: //Both
			//tempFlags = tempFlags | 0x0C;
			if(passedID == 0) 			return 1;
			if(passedID == 1) 			return 1;
			break;
		case 1: //Stand-Alone
			//tempFlags = tempFlags | 0x04;
			if(passedID == 0) 			return 0;
			if(passedID == 1) 			return 1;			
			break;
		case 2: //RX only
			//tempFlags = tempFlags | 0x08;
			if(passedID == 0) 			return 1;
			if(passedID == 1) 			return 0;				
			break;
		case 3: //disabled
			//no change both 00
			return 0;
		}
		break;	
	case 10: //External LED Display Mode
		//"fDisModeMSBa,fDisModeLSBa"
		switch(DisplayModeDD.SelStr)
		{
		case 0: //Always On
			//00 is always on
			return 0;
		case 1: //Countdown
			if(passedID == 0) 			return 1;
			if(passedID == 1) 			return 0;
			break;
		case 2: //Dim
			if(passedID == 0) 			return 0;
			if(passedID == 1) 			return 1;
			break;
		case 3: //both
			if(passedID == 0) 			return 1;
			if(passedID == 1) 			return 1;
			break;
		}
		break;	
	case 11: //Standard Auto-Detect
		switch(AutoDetectDD.SelStr)
		{
		case 0: //None
			//both ID flag and Autodetect stay 0
			return 0;
		case 1: //Autodetect DMX
			//tempFlags = tempFlags | 0x10; //Set AutoDetectID Flag to 1
			//tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
			if(passedID == 0) 			return 1;
			if(passedID == 1) 			return 1;
			break;
		case 2: //Autodetect Serial
			//AutoDetectID Flag stays 0 for serial
			//tempFlags = tempFlags | 0x20; //Set AutoDetectEnable Flag to 1
			if(passedID == 0) 			return 0;
			if(passedID == 1) 			return 1;
			break;
		}//end switch
		break;			
	case 12: //Gamma Correction Enabled
		if(HardwareButtons[3].Selected == true) return 1;
		return 0;
	case 13: //Automatic Shut Off/Resume Time Out Value
		if(passedID == 0) if(AccMeterAutoDetectDD.SelStr > 0) return 1;
		if(passedID == 1) if(AccMeterAutoDetectModeDD.SelStr == 1) return 1;
		//if(AccMeterAutoDetectDD.SelStr > 0)	return 1; //fAccMeterAutoShutOff
		//if(AccMeterAutoDetectModeDD.SelStr > 0)	return 1; //fAccMeterAutoShutOffMode
		return 0; //break;				
	case 14: //Enable Accelerometer Speed Adjustment
		if(HardwareButtons[4].Selected)	return 1;//fAccMeterMovement
		return 0; //break;
	case 15: //Enable Double Tap Button Press
		if(AccMeterTapDD.SelStr > 0) return 1;//fAccMeterDoubleTap
		return 0; //break;		
	case 16: //Power Down Time Out	

		break;
	case 17:
	
		break;	
	case 18:
	
		break;	
	case 19: //Dual Communication Mode
		if(HardwareCheckBox[1].Selected == true) return 1; //fDualModeCom
		return 0; //break;	
	case 20: //PWM Freq A

		break;
	case 21: //Stand-Alone A

		break;
	case 22: //PWM Profile


		break;		
	case 23: //IR Remote Addon
		switch(IRRemoteModeDD.SelStr)
		{
		case 0: //None
			//both ID flags	0
			return 0;
		case 1: //Enabled, 19200, 1-0
			if(passedID == 0) 	return 1;
			if(passedID == 1) 	return 0;	
			break;
		case 2: //Enabled, 250k, 1-1	
			if(passedID == 0) 	return 1;
			if(passedID == 1) 	return 1;
			break;
		}//end switch
		break;				
	}	//end switch 
	
	  println("Did not find InputModule[] to GetBitValues() from");
	  return 0;
  } //end GetBitValues()
  
  
  public int GetByteValues(int passedID)
  {
	    
	switch(IDnumber)
	{
	case 0:	//device.RS485Capable

		break;		
	case 1:

		break;		  
	case 2:	//bGlobalColorShift
		return (HardwareColSwapDD.SelStr); //Global Color Swap	  
	case 3:	//Pixel Chipset
		return (PixelChipsetID[PixelChipsetDD.SelStr]); //Pixel Type		
	case 4: //Enable Serial Reception Instead of DMX

		break;	
	case 5:	//DMX Adress
		if(passedID == 0) 	return ((PApplet.parseInt(TextFields[2].Label) >> 8) & 0xFF); //DMXAdr MSB
		if(passedID == 1) 	return (PApplet.parseInt(TextFields[2].Label) & 0xFF); //DMXAdr LSB
		break;				
	case 6: //DMX Reception Mode
		return DMXModesDD.SelStr;	//DMX Mode ID		
	case 7: //DMX Master Mode

		break;			
	case 8: //Serial Baud Rate
		return BaudRateDD.SelStr; //BaudRateID
	case 9: //LED Inidicator A

		break;	
	case 10: //External LED Display Mode

		break;	
	case 11: //Standard Auto-Detect

		break;			
	case 12: //Gamma Correction Enabled

		break;	
	case 13: //Automatic Shut Off/Resume Time Out Value
		return (cAccMeterShutOffVals[AccMeterAutoDetectDD.SelStr]); 	//Timeoutval			
	case 14: //Enable Accelerometer Speed Adjustment
		
		break;
	case 15: //Enable Double Tap Button Press

		return (AccMeterTapDD.SelStr);	//Double Tap Mode	
	case 16: //Power Down Time Out	

		break;
	case 17:
	
		break;	
	case 18:
	
		break;	
	case 19: //Dual Communication Mode
	
		break; //break;	
	case 20: //PWM Freq A

		break;
	case 21: //Stand-Alone A

		break;
	case 22: //PWM Profile
		return (PWMProfileADD.SelStr);	//16-bit lamp PWM Profile	
	case 23: //IR Remote Add On

		break;			
	}	//end switch  
	  
	  println("Did not find InputModule[] to GetByteValues() from");
	  return 0;
  } //end GetByteValues()
  
  
  
  public boolean over() 
  {
	if(Enabled == false) return false;  
	  
    if (mouseXS >= xpos && mouseXS <= xpos+bWidth && mouseYS >= ypos && mouseYS <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
  
  public void PlaceTile()
  {
	if(InputModule[IDnumber].bWidth < moduleHoldSz)
	{
	//println("Module "+IDnumber+" with width of: "+InputModule[IDnumber].bWidth+" can fit at Y: "+moduleHoldY+", X: "+moduleHoldX+" with available: "+moduleHoldSz);	

	InputModule[IDnumber].xpos = moduleHoldX;		
	InputModule[IDnumber].ypos = moduleHoldY;

	moduleHoldX = 0;
	moduleHoldY = 0;
	moduleHoldSz = 0;
	}  
	else if((modulePosX + InputModule[IDnumber].bWidth) < 800)	
	{
	//println("IDnumber: "+IDnumber+" : "+modulePosX);

	InputModule[IDnumber].xpos = modulePosX;		
	modulePosX += (InputModule[IDnumber].bWidth+10);
	InputModule[IDnumber].ypos = modulePosY;	
	}
	else 
	{
	//saves previous row extra space and will try to fit something in
	if((800 - modulePosX) > moduleHoldSz)
	{
	//if new row size is larger than last, use it, otherwise utilize largest space	
	moduleHoldX = modulePosX;
	moduleHoldY = modulePosY;
	moduleHoldSz = 800 - modulePosX;		
	//println("remaining Module Size: "+moduleHoldSz);
	}
	
	modulePosY += 100;
	InputModule[IDnumber].xpos = 140;
	modulePosX = 140 + (InputModule[IDnumber].bWidth+10);
	InputModule[IDnumber].ypos = modulePosY;	
	}
	
	InputModule[IDnumber].Enabled = true;
	InputModule[IDnumber].InitPositions();	  
  } //end func
}  //end class
	
	
	
public void SetSlideDataTypeBoxStates(int PassedID)
{
	println("SetSlideDataTypeBoxStates() with "+PassedID);

	//will pass to turn them all off or i+1 to turn on a single one
	FrameCheckBoxes[0].Selected = false; //single
	FrameCheckBoxes[1].Selected = false; //RGB
	FrameCheckBoxes[2].Selected = false; //RGBW
	if (PassedID != 0)	
	{
		FrameCheckBoxes[PassedID-1].Selected = true;
		FrameCheckBoxes[0].Status = 0; //set all to enabled
		FrameCheckBoxes[1].Status = 0;
		FrameCheckBoxes[2].Status = 0;	
	}
	else
	{
		FrameCheckBoxes[0].Status = 1; //set all to grey out
		FrameCheckBoxes[1].Status = 1;
		FrameCheckBoxes[2].Status = 1;
	}
} //end SetSlideDataTypeBoxStates()


public void HandleSequenceModeDropDown()
{
	int PassedID = SequenceModeDD.SelStr+1;
	println("HandleSequenceModeDropDown() with "+PassedID); 

	if(device.BasicVersion > 0 && PassedID > 2)
	{
		if(device.LinkedSupport == false) { SequenceModeDD.SelStr = UserSequences[SelectedSequence].SeqMode-1; return; }
		else if(PassedID != 4) { SequenceModeDD.SelStr = UserSequences[SelectedSequence].SeqMode-1; return; }
	}
	
	switch(PassedID)
	{
	case mFade: //Fade
		UserSequences[SelectedSequence].SeqMode = mFade;
		
		UpdateSequence(SelectedSequence);
		break;   
	case mGradient: //Gradient
		UserSequences[SelectedSequence].SeqMode = mGradient;  
		
		//make all dataframes same as 0, also in updatesequence()
		for (int x = 0; x != UserSequences[SelectedSequence].SeqFrameAmount+1;x++) 
		{
			switch(PixelDataType)
			{
			case 0: //Single
				for (int i = 0; i != UserSequences[SelectedSequence].DataSize;i++)  UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
				break;		
			case 1: //RGB
				for (int i = 0; i < UserSequences[SelectedSequence].DataSize-2;i+=3)  
				{
					UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
					UserSequences[SelectedSequence].DataFrames[x][i+1] = UserSequences[SelectedSequence].DataFrames[x][1];
					UserSequences[SelectedSequence].DataFrames[x][i+2] = UserSequences[SelectedSequence].DataFrames[x][2];
				}
				break;
			case 2: //RGBW
				for (int i = 0; i < UserSequences[SelectedSequence].DataSize-3;i+=4)  
				{
					UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
					UserSequences[SelectedSequence].DataFrames[x][i+1] = UserSequences[SelectedSequence].DataFrames[x][1];
					UserSequences[SelectedSequence].DataFrames[x][i+2] = UserSequences[SelectedSequence].DataFrames[x][2];
					UserSequences[SelectedSequence].DataFrames[x][i+3] = UserSequences[SelectedSequence].DataFrames[x][3];
				}		
				break;
			}	  
		}

		UpdateSequence(SelectedSequence);
		BuildGradientMenu();
		break; 
	case mInstant: //Instant
		UserSequences[SelectedSequence].SeqMode = mInstant;  
		UserSequences[SelectedSequence].StartValues = new int[UserSequences[SelectedSequence].DataSize]; //reset start values
		UpdateSequence(SelectedSequence);
		break;		
	case mTech: //Combo 
		if(device.BasicVersion > 0) return; //rejects POV usage if any of the current basicversion types

		UserSequences[SelectedSequence].SeqMode = mTech; 
		
		UpdateSequence(SelectedSequence);
		break; 
	case mLinked: //Linked/Multi	
		if(device.LinkedSupport == false) return; //rejects if linked are not supported(4 chan DMX)

		if(UserSequences[SelectedSequence].SeqMode != mLinked)
		{
			//if clicked linked button and it is not aleady a linked, need to clear everything otherwise it will use current data to build a linked
			UserSequences[SelectedSequence].SeqFrameAmount = 1; //forces rest to 1 if no linked data is contained
			UserSequences[SelectedSequence].DataFrameVar = new int[(UserSequences[SelectedSequence].SeqFrameAmount+1)]; //Transistion Array
			UserSequences[SelectedSequence].SlideValues = new int[(UserSequences[SelectedSequence].SeqFrameAmount+1)]; //Iteration Array
			UserSequences[SelectedSequence].SlideFlags = new int[(UserSequences[SelectedSequence].SeqFrameAmount+1)];	// Sequence ID Array	
		}	
		
		UserSequences[SelectedSequence].SeqMode = mLinked;  
		InitLinkedBuffer(); 
		UpdateSequence(SelectedSequence);	
		break;
	case mPOV: //POV
		if(device.BasicVersion > 0) return; //rejects POV usage if any of the current basicversion types
		UserSequences[SelectedSequence].SeqMode = mPOV;  	  
		UpdateSequence(SelectedSequence);
		break;			
	case mFilePlay:
		if(device.BasicVersion > 0) return; //rejects POV usage if any of the current basicversion types
		
		UserSequences[SelectedSequence].SeqMode = mFilePlay;  
		UpdateSequence(SelectedSequence);
		break;	
	} //end switch
	UpdateSideBarButtonStates();
}//end func

//====================================================================================

public void HandleSliders(boolean bMoveEnable)
{
	if(prevSliderSetNum != SliderPointer.SetNumber)	{ prevSliderSetNum = SliderPointer.SetNumber;	println("Dragging Set# "+SliderPointer.SetNumber); }

	mouseXS = round((float)mouseX / SF);
	mouseYS = round((float)mouseY / SF);

	if (bMoveEnable == true)
	{
		//when doing a mousewheel or arrow key don't want it to move()
		SliderPointer.move(mouseXS, mouseYS);
	}

	switch(SliderPointer.SetNumber)
	{
	case 0: //timeline scrollbar
		TLScrollValue =  TimeLineScrollBar.Value;
		break;
	case 1: //color picker
		int holdPixelType = PixelDataType;	
		if(SelectedMenuTab == 2 && OverlayMenuID == 1) 
		{
			holdPixelType = LiveConDataType;
		}

		switch(holdPixelType)
		{
		case 0: //Single
			ColorSelector.slRed = 0;//ColorSelectorSliders[3].Value;
			ColorSelector.slGreen = 0;//ColorSelectorSliders[3].Value;
			ColorSelector.slBlue = 0;//ColorSelectorSliders[3].Value;
			ColorSelector.slWhite = ColorSelectorSliders[3].Value;
			break;
		case 1: //RGB
			ColorSelector.slRed = ColorSelectorSliders[0].Value;
			ColorSelector.slGreen = ColorSelectorSliders[1].Value;
			ColorSelector.slBlue = ColorSelectorSliders[2].Value;
			ColorSelector.slWhite = 0;	
			break;	
		case 2: //RGBW
			ColorSelector.slRed = ColorSelectorSliders[0].Value;
			ColorSelector.slGreen = ColorSelectorSliders[1].Value;
			ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
			ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
			break;
		}	
		TextFields[10].Label = ""+SliderPointer.Value; //fill in text field with value
		break;
	case 2: //TechnicalScrollVert
		
		break;
	case 3: //TechnicalScrollHoriz

		break;
	case 4: 
		
		break;      
	case 5: //Connection ScrollBar
		
		break;
	case 6: //Linked ScrollBar
		
		break;
	case 7:
		
		break;
	case 8: //Live Control Sliders
		TextFields[5].Label = ""+ControlSliders[PApplet.parseInt( TextFields[4].Label)-1].Value;
		LiveControlUpdate = true;
		break;
	case 9: //Stand Alone control
		if (SliderPointer == StandaloneSliders[0])  TextFields[8].Label = ""+SliderPointer.Value;  //speed slider
		if (SliderPointer == StandaloneSliders[1])  TextFields[9].Label = ""+SliderPointer.Value * StandaloneSliders[2].Value;  //speed slider
		if (SliderPointer == StandaloneSliders[2])  TextFields[9].Label = ""+StandaloneSliders[1].Value * StandaloneSliders[2].Value;  //speed slider
		break;
	case 10: 
		
		break;   
	case 11: 

		break;   
	case 12: //Gradient Draw Factor

		break;
	case 13: //Sequence Select Scroll Bar
		//SequenceSelectScrollBar.move(mouseXS, mouseYS);
		PlaceSequenceIconsMenu();
		break;		
	} //end switch
} //end HandleSliders()

//=================================================================================================================================

public void keyPressed()
{
	println("keyPressed() - "+key);	
	
	if (TextFieldActive == true)
	{
		redraw();
		if (key == ENTER || key == RETURN) //check for both for cross platform support
		{
			TextFieldActive = false;
			textFieldPtr.Label = textFieldPtr.Label.replaceAll("[^\\x00-\\x7f]", ""); //removes any non-readable characters
			textFieldPtr.Selected = false;
			method(textFieldPtr.txtfCallback);
			return;
		}  
		else if (key == BACKSPACE) //UserID text box can be any character
		{
			try {
				println("Trying");
				textFieldPtr.Label = textFieldPtr.Label.substring(0, textFieldPtr.Label.length()-1);
			}
			catch(Exception e) { }	
			redraw();
			return;
		}	
		
		//====================================================	

		//then type in the characters
		if(textFieldPtr.InputMethod == 0)
		{
			if(textFieldPtr.Label.length() > textFieldPtr.maxValue) return;
			//Makes sure its a valid character otherwise it will be stored(but not seen) in .label as well
			if((byte)key > 0 && (byte)key < 127) textFieldPtr.Label =  ""+textFieldPtr.Label + PApplet.parseChar(key);
			else println("KEY IGNORED"); //DEBUG
			redraw();
			return;
		}
		else
		{
			if (key=='1' || key== '2' || key=='3' || key=='4' || key=='5' || key=='6' || key=='7' || key=='8' || key=='9' || key=='0' || key=='-' || (key =='.' && textFieldPtr.InputMethod == 3))
			{
				textFieldPtr.Label =  ""+textFieldPtr.Label + PApplet.parseChar(key);
				redraw();
			}
			return;
		}
	} // end TextFieldActive if()
	
	if((key == ENTER || key == RETURN) && GraphicImageResize == true) { GraphicImageResize = false; MenuTabs[0].refresh(); redraw(); return; }
	if((key == ENTER || key == RETURN) && ColorPickerOpen == true) { ApplyColorSelection(); redraw(); return; }
	if((key == ENTER || key == RETURN) && (OverlayMenuID == 6 || OverlayMenuID == 7)) { OverlayMenuID = 0; redraw(); return; } //closes tech radial menus

	if (key == CODED) 
	{
		redraw();	
		switch(keyCode)
		{
		case UP:
			println("Up on "+SliderPointer);
			SliderPointer.Value--;
			SliderPointer.setValue(SliderPointer.Value);
			HandleSliders(false);
			break;

		case DOWN:
			println("Down on "+SliderPointer); 
			SliderPointer.Value++;    
			SliderPointer.setValue(SliderPointer.Value);
			HandleSliders(false);
			break;
		case RIGHT:
			println("Right on "+SliderPointer);
			SliderPointer.Value++;
			SliderPointer.setValue(SliderPointer.Value);
			HandleSliders(false);  
			break;

		case LEFT:
			println("Left on "+SliderPointer); 
			SliderPointer.Value--;    
			SliderPointer.setValue(SliderPointer.Value);
			HandleSliders(false);	  
			break;
		}
	}
	
	//Release INPUT KEYS
	if (key == 's')
	{
		SaveUserSequencesFile("saves"+File.separator+"quicksave-"+hour()+"-"+minute()+"-"+day()+"-"+month()+".txt");
		ShowNotification(3);
	}


	if (key == ESC) 
	{ 
		key = 0; //have to alter it or it will use default?
		println("ESCAPE DISABLED");
		if(LiveControlEnabled == true) CloseLiveControlMenu();
		OverlayMenuID = 0; //close any overlay menus
		ColorPickerOpen = false; //close color picker as if cancel was pressed
		redraw();
	}
	
	//=======================================================================
	
	//Development INPUT KEYS
	if (key == 'l')	LoadUserSequencesFile("saves"+File.separator+"tempSave.txt");
	
	if (key == 'r') redraw();
	
	if (key == 'v') UploadInProgress = false;
	if (key == 't')  TerminateUpload =! TerminateUpload;
	if (key == 'k')
	{
		InitCOMButtons();
		redraw();
	}
	
	
	if (key == 'u')
	{
GraphicLayoutPreview = !GraphicLayoutPreview;
	}
	
	if (key == 'k')
	{
		printArray(UserSequences[SelectedSequence].DataFrameVar);
	}

	if (key == 'm')
	{
		cmdByte = 123;
		cmdData[0] = 0;
		cmdData[1] = 0; 
		cmdData[2] = 0;  
		cmdData[3] = 0;  
		RequestCommand();
	}

	if (key == 'o')
	{
		SendSingleDataByte(0);
	}	

	if (key == 'i')
	{
		WaitForAckFlag = true;
	}	


	if (key == '[')
	{		
		thread("OpenTCP");
	}
	if (key == ']')
	{
		CloseTCP();		
	}

	if (key == 'y')// TerminateUpload =! TerminateUpload;
	{
		//FillTechDebug();
		printArray(UserSequences[SelectedSequence].StartValues);
		
		//printArray(UserSequences[SelectedSequence].DataFrames[0]);			
		//	println("FrameAmount: "+UserSequences[SelectedSequence].SeqFrameAmount);
		//	println("DataSize: "+UserSequences[SelectedSequence].DataSize);
		//	println(	UserSequences[SelectedSequence].DataFrames[0]);
		//	println(	UserSequences[SelectedSequence].DataFrames[1]);
		
	}

	// ============= END Development Keys =================================
	
	
	//  myPort.setDTR(false);
}//end keyPressed()

//=================================================================================================================================

public void mouseMoved()
{
	//only used for graphic layout mouse over
	mouseXS = round((float)mouseX / SF);
	mouseYS = round((float)mouseY / SF);
	
	//if on graphic layout tab and it is not a linked - display mouse over pixel icons
	if(SelectedMenuTab == 0 && UserSequences[SelectedSequence].SeqMode != mLinked) 
	{	
		if(mouseXS >= cWorkspaceX && mouseXS <= (cWorkspaceX+cGLBufWidth) && mouseYS >= 35 && mouseYS <= (35+575)) 
		{ 
			redraw();
		}
	}
	
	if(sEnableMouseOver == 1)
	{
		//Mouse Over Functions
		// Fairly ineffiecent, it will detect any object, even those not shown, so it will always redraw on mouse moved
		
		for (int i = 0; i != ButtonList.size(); i++) 
		{ 
			// An ArrayList doesn't know what it is storing so we have to cast the object coming out
			//if(i == 0) println(ButtonList.size());
			PointerButton = ButtonList.get(i);	
			if(PointerButton.mouseOver()) redraw();  //no other way to highlight, have to redraw
		} //end for


		for (int i = 0; i != DropDownList.size(); i++) 
		{ 
			DropDownListPointer = DropDownList.get(i); // An ArrayList doesn't know what it is storing so we have to cast the object coming out
			if(DropDownListPointer.mouseOver()) redraw(); //no other way to highlight, have to redraw
			if(DropDownListPointer.mouseOverOpen()) redraw(); //no other way to highlight, have to redraw
		} //end for 


		for (int i =0; i != GradientRects.length; i++) 
		{
			if(GradientRects[i].mouseOver()) redraw(); //no other way to highlight, have to redraw
		}

		for (int i =0; i != TextFieldList.size(); i++) 
		{
			TextFieldListPointer = TextFieldList.get(i);	
			if(TextFieldListPointer.mouseOver()) redraw();  //no other way to highlight, have to redraw
		}
		
		for (int i =0; i != CheckBoxList.size(); i++) 
		{
			CheckBoxListPointer = CheckBoxList.get(i);	
			if(CheckBoxListPointer.mouseOver()) redraw();  //no other way to highlight, have to redraw
		}
	} //end sEnableMouseOver if()
	
} //end mouseMoved()

public void mouseDragged()
{
	//The mouseDragged() function is called once every time the mouse moves while a mouse button is pressed. (If a button is not being pressed, mouseMoved() is called instead.) 
	//println("MouseDragging");
	if(DraggingIndicator == true) redraw();
	if(GlobalDragging == true) redraw();
	if(SelectedMenuTab == 0 && UserSequences[SelectedSequence].SeqMode != mLinked && GraphicImageResize == true) 	redraw();	
}

public void mouseReleased()
{
	if(GlobalDragging == true){	println("Done dragging #:"+SliderPointer.SetNumber); prevSliderSetNum = 1000;}

	if(GraphicImageResize == true && ImageDraggingState > 0) 
	{
		ImageDraggingState = 0;
		GraphicLayoutUpdateIcons(); //replaced the icons over the image after mouse release
	}
	
	GlobalDragging = false;
	DraggingIndicator = false;
	redraw(); // rdraw for button highlight changes
}


public void mouseWheel(MouseEvent event) 
{
	mouseXS = round((float)mouseX / SF);
	mouseYS = round((float)mouseY / SF);
	
	try {	
		
		float e = event.getCount();
		
		if(OverlayMenuID == 4) //Sequence Select Menu
		{
			if(OverlayMenus[OverlayMenuID].over()) 
			{ 	
				SequenceSelectScrollBar.setValue(PApplet.parseInt(SequenceSelectScrollBar.Value+e));
				HandleSliders(false);
			}
			return;
		}
		else
		{
			switch(SelectedMenuTab)
			{
			case 0:	
				//check timeline
				if(mouseXS >= cTLChBufX && mouseXS <= 800 && mouseYS >= cTLChBufY && mouseYS <= cTLChBufY+cTLChBufViewH) 
				{ 
					if(UserSequences[SelectedSequence].SeqMode == mLinked) 		LinkedScrollBar.setValue(PApplet.parseInt(LinkedScrollBar.Value+(e)));
				} 	
				break;
			case 1:
				//check timeline
				if(mouseXS >= cTLChBufX && mouseXS <= 800 && mouseYS >= cTLChBufY && mouseYS <= cTLChBufY+cTLChBufViewH) 
				{ 
					if(UserSequences[SelectedSequence].SeqMode == mLinked) 		LinkedScrollBar.setValue(PApplet.parseInt(LinkedScrollBar.Value+(e)));
					else TimeLineScrollBar.setValue(PApplet.parseInt(TimeLineScrollBar.Value+(cTLChBufH*(e*2))));
					TLScrollValue = TimeLineScrollBar.Value;
				} 
				break;
			case 2:	
				//check Index
				if (mouseXS >= 596 && mouseXS <= 800 && mouseYS >= cWorkspaceY &&  mouseYS <= 600) //596 is where the index space starts xpos
				{      
					IndexScrollBar.setValue(PApplet.parseInt(IndexScrollBar.Value+e));
				} 
				break;
			} //end switch
		}
	}
	catch(Exception ee) { println("Mousewheel ignored, would have errored"); }
	
	redraw();
} //end func

//Slides: considered a special frame in software but still a dataframe in firmware

//FIGURE OUT LINKER, how it is won't work cause say sequence 12, is in place 1(0) then it still should be 0....
//but if same sequence is in multiple spots it still should point to same sequence in firmware linker 
//it can stay sending data for seq1 if no one is found for the higher link numbers but need to not use
//up the memory space with seq1 frame data and map....

//make it count how many frames are used, to display memory usage
//Right now if no valid link is in the index, it sends sequence[1] in its place, that could suck up memory
//somehow linker works into that... cause it points to sequences
// but linker filles from lowest upwards, so if there is no valid link, all user data is already uploaded
//Although, why put the same sequence in the linker twice or more, no reason, let it suck memory

//But I still have to build the linker correctly, right now its assuming there are only 1-8 sequences, more and it would error since its over 8
//so indexMaoArray value should in no way be sent, work it out somehow, or just do 1-8 since even if a sequence is sent twice, it will still be linked
//to the the same mapvariable,

//=====================================================================================================

public void SendMonitor()
{
	SendCounter++; //used for 
	SendCounterB++; //counts all bytes

	
	if(device.HardwareID == 44  || (device.HardwareID == 43 && device.FirmwareRevision >= 5)) 
	{	
		if(SendCounter == device.CurrentBlockSize)
		{
		println("Waiting for ACK, SendCounter: "+SendCounter);
		SendCounter = 0;
		while(WaitForAckFlag == false) 
		{
		delay(1);
		}
		WaitForAckFlag = false; //set back to false
		println("ACK RECEIVED FOR PACKET# "+USBpacketCount);	
		USBpacketCount++;
		redraw();
		}
		else delay(2); //was there, so leave it for now	
	} //end hardwareID if	
		

	else if (SendCounter >= device.EraseBlockSize)
	{
		delay(10); //delay to allow the device to erase the next block
		SendCounter = 0;
		//USBpacketCount++;
	}

	
	delay(1); 
}//end func

//=====================================================================================================

public void SendLegacyData() // THREADED FUNCTION
{
delay(50); //allow time for erase

if(device.LinkedSupport == true) SendLegacyWithLinked();
else SendLegacy();

UploadInProgress = false; //now clear the flag
} //end func

public void SendLegacyWithLinked()
{
	println("SendLegacyWithLinked()");

	println("=========================================================================");

	int LegacyMaxSequences = 32;

	SequenceLength = device.BasicSeqLength;

	//reset handlers
	for (int q = 1; q != UserSequences.length; q++) 
	{
		UserSequences[q].LinkerUtilized = false;
		UserSequences[q].assignedIDNum = 255;
		UserSequences[q].assignedLinkedIDNum = 255;
		UserSequences[q].IDassigned = false;
	}
	
	int offsetVar = 0;	
	
	for (int i = 0; i != 32; i++) //32 is max amount of indexed sequences, 2 bytes per = 64
	{	 	
		if(IndexMapArray[i] < 255 && UserSequences[IndexMapArray[i]].IDassigned == false)
		{
			//if not 255 then it is a sequence, handle it
			UserSequences[IndexMapArray[i]].LinkerUtilized = true;
			UserSequences[IndexMapArray[i]].assignedIDNum = i - offsetVar;
			UserSequences[IndexMapArray[i]].IDassigned = true;
			
			//SequenceLength += UserSequences[IndexMapArray[i]].Length;
		} //end i for()
		else if(IndexMapArray[i] < 255 && UserSequences[IndexMapArray[i]].IDassigned == true)
		{	
			offsetVar++;	//detects if on index twice and offsets since its ID is assigned	
		}
		else if(IndexMapArray[i] > 255) //detect DMX or serial and offset
		{
			offsetVar++;		
		}
		else
		{
			//once it has gone through the index and handled all the sequences that are there, go through them and check for mLinked
			// then go through all the linked and see if they have been handled
	label:
			for (int q = 1; q != UserSequences.length; q++)
			{
				//checks if sequence is a linked and it must have already been utilized since it would have to be in the index map	
				if(UserSequences[q].SeqMode == mLinked && UserSequences[q].LinkerUtilized == true)
				{	
					for (int yy = 0; yy != UserSequences[q].SeqFrameAmount; yy++)
					{
						if(UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized == false && UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned == false)
						{	
							println("One yet to be linked, SoftID: "+UserSequences[q].SlideFlags[yy]+" will be "+(i - offsetVar)+" instead of "+(i));
							
							UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized = true;
							UserSequences[UserSequences[q].SlideFlags[yy]].assignedIDNum = i - offsetVar;
							UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned = true;
							break label;
						}	
					}//end for	
					
				}	
			}	//end for()
		}
	} //end i for()
	
	for (int q = 1; q != UserSequences.length; q++) println(q+" : assigned: "+UserSequences[q].assignedIDNum+" : Utilized: "+UserSequences[q].LinkerUtilized);
	
println("===================================="+SequenceLength+"=====================================");


	for (int q = 1; q != UserSequences.length; q++) println("SoftSeq#: "+q+" - Assigned: "+UserSequences[q].assignedIDNum+" - LinkerAssiD: "+UserSequences[q].assignedLinkedIDNum);


	int tempPointer = 0;
	int[] tempArray = new int[32];
	
	
	int tempIDnum = 0;
	
	for (int i = 0; i != 32; i++) tempArray[i] = 255;
	
	
	for (int i = 1; i != UserSequences.length; i++) //starts at 1 since first sequence is ignored
	{
		//println("Loop:  Seq: "+i+" : is: "+UserSequences[i].assignedIDNum+" : Looking for:"+tempIDnum);

		if(UserSequences[i].assignedIDNum == tempIDnum)
		{	
			tempArray[tempPointer] = i;
			tempPointer++;
			i = 0; //reset loop, will increase to 1
			tempIDnum++;
		}
	}	
//	println(tempArray);


	//send start, then delay while PIC erases, then begin transfer.
	delay(30); //was 10, didn't work, made it 20

	//used
	int CalcMapStart=0; 
	int qq = 0; //holds index value

	//NEW
	int DeviceMaxFrames = PApplet.parseInt((float)((float)device.DataSpace) / (float)device.Channels); //256/4 = 64
	SendCounter = 0;
	SendCounterB = 0;
	
	int[] SlideBuild = new int[DeviceMaxFrames];
	
	// ========================= Build Slide Values =============================
	int g=0;

	for(int i=0; i != SlideBuild.length;i++)  SlideBuild[i] = 127; //make all 127

	for(int q=0; q != LegacyMaxSequences;q++) //setting amount is q
	{	
		try 
		{	
			qq = tempArray[q];	
			if(qq == 255) qq = 0;

			if(UserSequences[qq].SeqMode != mLinked) //if linked don't send(or reserve) any data frames
			{	
		 
			for(int i=0; i != (UserSequences[qq].SeqFrameAmount+1);i++)   
			{
				//take all the slide values up to FrameLength and place in Build
				//0 is none, 1 is down, 2 is up

				//NEW - have to convert to 127 as middle	based on up or down
				/*	
				30 – 36	Slide Down, Single, w/o color shift
				40 – 46	Slide Down, RGB,  w/o color shift
				50 – 56	Slide Down, RGBW,  w/o color shift

				60 – 66	Slide Up, Single, w/o color shift
				70 – 76	Slide Up, RGB,  w/o color shift
				80 – 86	Slide Up, RGBW,  w/o color shift
				*/

				//println(q+" : "+qq+" - "+i+" - "+UserSequences[qq].FrameSpecial[i]);

	/*			
	REWRITE FOR VERSION 2 USAGE, SlideFlags and SlideValues instead of framespecial			
//if(SettingFrames[q][i].SlideUpDown == 1)
if (UserSequences[qq].FrameSpecial[i] > 29 && UserSequences[qq].FrameSpecial[i] < 60)//down
{
	SlideBuild[g] = 127 - UserSequences[qq].SlideValues[i]; 
	if(UserSequences[qq].SlideValues[i] < 0) UserSequences[qq].SlideValues[i] = 0;
}
//else if( SettingFrames[q][i].SlideUpDown == 2) //up
else if (UserSequences[qq].FrameSpecial[i] > 59 && UserSequences[qq].FrameSpecial[i] < 90)//up
{
	SlideBuild[g] = 127 + UserSequences[qq].SlideValues[i];  
	if(UserSequences[qq].SlideValues[i] > 255) UserSequences[qq].SlideValues[i] = 255;
}
else
SlideBuild[g] = 127;
*/
				g++; 
			} //end i for() 

		} //end mLinked if()	
		} //end try
		catch(Exception e)
		{
			g++; 
		}		
	} //end q for()
/*
	// ========================= Send Slide Values =============================
		
	for(int i=0; i != DeviceMaxFrames;i++)
	{
		myPort.write(SlideBuild[i]);
		SendMonitor();
	}

	// =================== speeds =============================
	for(int i=0; i != LegacyMaxSequences;i++) 
	{
	//println(i+" : "+qq);
	
		qq = tempArray[i];
		if(qq == 255) qq = 0;

		try 
		{	
			temp = 	UserSequences[qq].Speed;
			if(temp > 255) temp = 255; //max speed is 255, regardless of setting

			myPort.write(temp); //only saves speed for 
		}
		catch(Exception e)
		{
			myPort.write(0); //sequence not found, send 0 	
		}

		SendMonitor();
	}
	//println("Speeds Sent");

	// =================== FrameAmt =============================
	
	for(int i=0; i != LegacyMaxSequences;i++) 
	{
		qq = tempArray[i];
		if(qq == 255) qq = 0;

		try 
		{	
			if(UserSequences[qq].SeqMode == mLinked) myPort.write(UserSequences[qq].SeqFrameAmount); 
			else myPort.write(UserSequences[qq].SeqFrameAmount); //DOESN"T USE DATA SO ENSURE THIS IS CORRECT
		}
		catch(Exception e)
		{
			myPort.write(0);  //sequence not found, send 0 		
		}
		SendMonitor();
	}

	// ========================= Modes =============================
	//SeqMode; //0 Fade, 1 Instant, 2 Gradient, 3 Combo, 4 Linked
	for(int i=0; i != LegacyMaxSequences;i++)  //Sequences, no 0 sequence
	{
		qq = tempArray[i];
		if(qq == 255) qq = 0;

		try 
		{	
			if(UserSequences[qq].SeqMode == mFade || UserSequences[qq].SeqMode == mGradient) myPort.write(mFade);//cycle
			else myPort.write(UserSequences[qq].SeqMode);//instant or Linked
		}
		catch(Exception e)
		{
			myPort.write(0);	//sequence not found, send 0 	
		}
		SendMonitor();
	}

	// ========================= Mao Start =============================
	for(int i=0; i != LegacyMaxSequences;i++)  //Sequences, no 0 sequence
	{
		qq = tempArray[i];
		if(qq == 255) qq = 0;	

		if(i==0) 
		{
			myPort.write(0);//first frame is Mapstart=0
			CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;		
		}
		else if(UserSequences[qq].SeqMode == mLinked)  myPort.write(0);//first frame is Mapstart=0
		else
		{
			try 
			{	
				println("Cacling Map with ID: "+qq+", its "+(UserSequences[qq].SeqFrameAmount+1)+" frames.");

				myPort.write(CalcMapStart);
				CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;

				println("CalcMapStart: "+CalcMapStart);
			}
			catch(Exception e)
			{
				myPort.write(0);	//sequence not found, send 0 
				println("Sequence Not Found Sent 0");
			}
		}
		SendMonitor();
	}//end for
	*/
	//=============== PRELOAD FOR LINKED ================================

/*
		//Seq IDs
		for(int i=0;i != UserSequences[SelSeq].SeqFrameAmount; i++) // not +1
		{
			BuildUSBPacket(UserSequences[UserSequences[SelSeq].DataFrames[0][i]].assignedLinkedIDNum); 	
			println("Linked SeqID: "+(UserSequences[UserSequences[SelSeq].DataFrames[0][i]].assignedLinkedIDNum));
		}

		//iteration value
		for(int i=0;i != UserSequences[SelSeq].SeqFrameAmount; i++) // not +1
		{
			BuildUSBPacket((byte)UserSequences[SelSeq].SlideValues[i]); //iteration amount
			println("Iterations: "+UserSequences[SelSeq].SlideValues[i]);
		}
		
		//Transition ID/Speed
		for(int i=0;i != UserSequences[SelSeq].SeqFrameAmount; i++) // not +1
		{
			BuildUSBPacket((byte)UserSequences[SelSeq].Special FrameVar[i]);
			println("Transition: "+UserSequences[UserSequences[SelSeq].DataFrameVar[i]].Special FrameVar[i]);	
		}
*/
	
	//println(UserSequences[4].DataFrames[0]);
	
	//- startvals are sequence ID, and framevar is iterations
	for(int q=0; q != LegacyMaxSequences;q++) //Sequences, no 0 sequence
	{
		qq = tempArray[q];
		if(qq == 255) qq = 0;	

		try 
		{
			if(UserSequences[qq].SeqMode == mLinked)
			{
			println("qq = "+qq);
			
			for(int i=0; i != device.Channels;i++)  //channels=8
			{
			UserSequences[qq].StartValues[i] = UserSequences[UserSequences[qq].SlideFlags[i]].assignedIDNum;			
			UserSequences[qq].DataFrameVar[i] = UserSequences[qq].SlideValues[i];
			
			println("assigned: "+UserSequences[qq].StartValues[i] +" : Iterations: "+UserSequences[qq].DataFrameVar[i]);
			//println(UserSequences[UserSequences[qq].DataFrames[0][i]].assignedIDNum+" : "+UserSequences[qq].SlideValues[i]+"  <----- Main Arrays");
			}
			}
		}
		catch(Exception e)
		{
			//myPort.write(0);	//sequence not found, send 0 
		}
		//SendMonitor();
	}//end for	

	// ========================================== Start Values =========================================
	
	for(int q=0; q != LegacyMaxSequences;q++) //Sequences, no 0 sequence
	for(int i=0; i != device.Channels;i++)  //channels=8
	{
		qq = tempArray[q];
		if(qq == 255) qq =0;	

		try 
		{
		myPort.write(UserSequences[qq].StartValues[i]); 		
		}
		catch(Exception e)
		{
		myPort.write(0);	//sequence not found, send 0 
		}
		SendMonitor();
	}//end for
	//println("Start Values Sent");	

	// ========================= FrameVars =============================
	
	for(int q=0; q != LegacyMaxSequences;q++) //Sequences, no 0 sequence
	for(int i=0; i != device.Channels;i++)  //channels=8
	{
		qq = tempArray[q];
		if(qq == 255) qq = 0;

		try 
		{
			myPort.write(UserSequences[qq].DataFrameVar[i]);
		}
		catch(Exception e)
		{
			myPort.write(0);	//sequence not found, send 0 
		}
		SendMonitor();
	}
	//println("FrameVars Sent");	
	
	// ========================= Frame Data =============================

//println("SendCounterB: "+SendCounterB);
//sent correct amount so far
	
//println(UserSequences[3].StartValues); 		
	
	
	CalcMapStart=0;
	for(int q=0; q != LegacyMaxSequences;q++) //Sequences, no 0 sequence
	{
		qq = tempArray[q];
		if(qq != 255) //qq = 0;	
		{
			if(UserSequences[qq].SeqMode != mLinked) //if linked don't send(or reserve) any data frames
			{		
				try 
				{	
					for(int z=0; z != (UserSequences[qq].SeqFrameAmount+1);z++)
					for(int i=0; i != device.Channels;i++) 
					{
						//println("Data: "+qq+" : "+z+" : "+i+" : "+UserSequences[qq].DataFrames[z][i]);	
						myPort.write(UserSequences[qq].DataFrames[z][i]);
						//myPort.write(CalcMapStart);
						SendMonitor();
						CalcMapStart++;
					}
				}
				catch(Exception e)
				{
					println("DataValue exception "+q);
				}
			}//end seqMode if()
		}		
	} //end q	for()

	// ========================= Send Dummies for empty data frames =============================

	println("Data Values Left to Send: "+(device.DataSpace - CalcMapStart)+" and "+(device.CurrentBlockSize - (SendCounterB%device.CurrentBlockSize))+"left to match memory block"); 
	CalcMapStart = (device.DataSpace - CalcMapStart) + (device.CurrentBlockSize - (SendCounterB%device.CurrentBlockSize));

	for(int i=0; i != CalcMapStart;i++) 
	{
		myPort.write(0); //DEBUG SEND i
		SendMonitor();
	}

	println("LegacyDataWithLinked() Done");
} //end func

//==========================================================================================================================================================================================================================================================

public void SendLegacy()
{

	//check if offset frame, send vertslider values instead of greyscalestorage 
	//slide values are based on 0 - 48 sliders, make them work correclt... 0 - 96, center on 48  
	//if a setting is offset, force it to cycle mode

	//send start, then delay while PIC erases, then begin transfer.
	println("SendLegacy()");
	delay(20); //seems to be necassary

	//used//int CalcMapStart=0; 

	int qq = 0; //holds index value

	//NEW
	int DeviceMaxFrames = PApplet.parseInt((float)((float)device.DataSpace) / (float)device.Channels); //256/4 = 64
	//Done in common
	//SendCounter = 0;
	//SendCounterB = 0;
	int[] SlideBuild = new int[64];
	
	// ========================= Build Slide Values =============================
int g=0;

	for(int i=0; i != 64;i++)  SlideBuild[i] = 127; //make all 127

	for(int q=0; q != 8;q++) //setting amount is q
	{	
		try 
		{	
			qq = IndexMapArray[q];	
			if(qq == 255) qq = 1;


			for(int i=0; i != (UserSequences[qq].SeqFrameAmount+1);i++)   
			{
				//take all the slide values up to FrameLength and place in Build
				//0 is none, 1 is down, 2 is up

				//NEW - have to convert to 127 as middle	based on up or down
				/*	
				30 – 36	Slide Down, Single, w/o color shift
				40 – 46	Slide Down, RGB,  w/o color shift
				50 – 56	Slide Down, RGBW,  w/o color shift

				60 – 66	Slide Up, Single, w/o color shift
				70 – 76	Slide Up, RGB,  w/o color shift
				80 – 86	Slide Up, RGBW,  w/o color shift
				*/
/*
REWRITE FOR V2 - no framespecial use slideflags

println(q+" : "+qq+" - "+i+" - "+UserSequences[qq].FrameSpecial[i]);

//if(SettingFrames[q][i].SlideUpDown == 1)
if (UserSequences[qq].FrameSpecial[i] > 29 && UserSequences[qq].FrameSpecial[i] < 60)//down
{
	SlideBuild[g] = 127 - UserSequences[qq].SlideValues[i]; 
	if(UserSequences[qq].SlideValues[i] < 0) UserSequences[qq].SlideValues[i] = 0;
}
//else if( SettingFrames[q][i].SlideUpDown == 2) //up
else if (UserSequences[qq].FrameSpecial[i] > 59 && UserSequences[qq].FrameSpecial[i] < 90)//up
{
	SlideBuild[g] = 127 + UserSequences[qq].SlideValues[i];  
	if(UserSequences[qq].SlideValues[i] > 255) UserSequences[qq].SlideValues[i] = 255;
}
else
SlideBuild[g] = 127;
*/
				g++; 
			} //end i for() 

		} //end try
		catch(Exception e)
		{
			g++; 
		}		
	} //end q for()
	println("Slides Built "+DeviceMaxFrames);
/*
	// ========================= Send Slide Values =============================
	for(int i=0; i != DeviceMaxFrames;i++)
	{
		myPort.write(SlideBuild[i]);
		SendMonitor();
	}

	// =================== speeds =============================
	for(int i=0; i != 8;i++) 
	{
		qq = IndexMapArray[i];
		if(qq == 255) qq = 1;

		try 
		{	
			temp = 	UserSequences[qq].Speed;
			if(temp > device.MaxSpeed) temp = device.MaxSpeed; //max speed is 255, regardless of setting

			myPort.write(temp); //only saves speed for 
		}
		catch(Exception e)
		{
			myPort.write(0); //sequence not found, send 0 	
		}

		SendMonitor();
	}
	println("Speeds Sent");


	// =================== FrameAmt =============================
	for(int i=0; i != 8;i++) 
	{
		qq = IndexMapArray[i];
		if(qq == 255) qq = 1;

		try 
		{		
			myPort.write(UserSequences[qq].SeqFrameAmount); //DOESN"T USE DATA SO ENSURE THIS IS CORRECT
		}
		catch(Exception e)
		{
			myPort.write(0);  //sequence not found, send 0 		
		}
		SendMonitor();
	}


	// ========================= Modes =============================
	//SeqMode; //0 Fade, 1 Instant, 2 Gradient, 3 Combo, 4 Linked
	for(int i=0; i != 8;i++)  //Sequences, no 0 sequence
	{
		qq = IndexMapArray[i];
		if(qq == 255) qq = 1;

		try 
		{	
			//println("SeqMode for: "+qq+" : "+UserSequences[qq].SeqMode);
			if(UserSequences[qq].SeqMode == mFade || UserSequences[qq].SeqMode == mGradient) myPort.write(mFade);//cycle
			else myPort.write(mInstant);//flash
		}
		catch(Exception e)
		{
			myPort.write(0);	//sequence not found, send 0 	
		}

		SendMonitor();
	}


	// ========================= Mao Start =============================
	for(int i=0; i != 8;i++)  //Sequences, no 0 sequence
	{
		qq = IndexMapArray[i];
		if(qq == 255) qq = 1;	


		if(qq==1) 
		{
			myPort.write(0);//first frame is Mapstart=0
			CalcMapStart = CalcMapStart + UserSequences[1].SeqFrameAmount+1;		
		}	
		else
		{
			try 
			{	
				println("Cacling Map with "+qq+", its "+UserSequences[qq].SeqFrameAmount);

				myPort.write(CalcMapStart);
				CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;

				println("CalcMapStart: "+CalcMapStart);
			}
			catch(Exception e)
			{
				myPort.write(0);	//sequence not found, send 0 
				println("Sequence Not Found Sent 0");
			}
		}
		SendMonitor();
	}//end for


	// ========================= Start Values =============================
	for(int q=0; q != 8;q++) //Sequences, no 0 sequence
	for(int i=0; i != device.Channels;i++)  //channels=8
	{
		qq = IndexMapArray[q];
		if(qq == 255) qq = 1;	

		try 
		{
			myPort.write(UserSequences[qq].StartValues[i]); 
			//println("startvalues for "+qq+" is "+UserSequences[qq].StartValues[i]);
		}
		catch(Exception e)
		{
			myPort.write(0);	//sequence not found, send 0 
		}
		SendMonitor();
	}//end for
	println("Start Values Sent");	


	// ========================= FrameVars =============================
	for(int q=0; q != 8;q++) //Sequences, no 0 sequence
	for(int i=0; i != device.Channels;i++)  //channels=8
	{
		qq = IndexMapArray[q];
		if(qq == 255) qq = 1;

		try 
		{
			myPort.write(UserSequences[qq].DataFrameVar[i]);
		}
		catch(Exception e)
		{
			myPort.write(0);	//sequence not found, send 0 
		}
		SendMonitor();
	}
	println("FrameVars Sent");	

	// ========================= Frame Data =============================
	CalcMapStart=0;
	for(int q=0; q != 8;q++) //Sequences, no 0 sequence
	{
		qq = IndexMapArray[q];
		if(qq == 255) qq = 1;	

		try 
		{	
			for(int z=0; z != (UserSequences[qq].SeqFrameAmount+1);z++)
			for(int i=0; i != device.Channels;i++) 
			{
				//println("Data: "+qq+" : "+z+" : "+i+" : "+UserSequences[qq].DataFrames[z][i]);	
				myPort.write(UserSequences[qq].DataFrames[z][i]);
				SendMonitor();
				CalcMapStart++;
			}
		}
		catch(Exception e)
		{
			println("DataValue exception "+q);
		}
	} //end q for()

	
	// ========================= Send Dummies =============================
	
	
	CalcMapStart = device.DataSpace - CalcMapStart;
	println("Data Values Left to Send: "+CalcMapStart); 

	for(int i=0; i != CalcMapStart;i++) 
	{
		myPort.write(i); //DEBUG SEND i
		SendMonitor();
	}
*/
	println("LegacyData() Done");
}//end function

//================================================= START CODE ===============================================================

public void settings() 
{
	size(800, 600); //LOAD CONFIG FIRST????
}//end settings()

public void setup() 
{
	if (InitializedWindowSize == false) 
	{

		PrevHeight = height;  //used to monitor if the grid window's size is changed so objects can be redeclared
		PrevWidth = width;   
		insets = frame.getInsets();

		sequencesImg = loadImage("sequences.png");
		fullNameImg = loadImage("logo.png");
		fullNameRGB = loadImage("NLED-full-rainbow-1.png");
		
		gradientImg = loadImage("gradient-1.png");
		auroraLogoImg = loadImage("aurora-logo.png");
		
		PImage titlebaricon = loadImage("favicon.gif");
		surface.setIcon(titlebaricon);

		surface.setTitle("NLED Aurora Control Software - "+cSoftwareV+""+cRevisionIDstr[cSoftwareR]+" - Northern Lights Electronic Design, LLC");
		surface.setResizable(true);
		frameRate(30);
		noLoop();
		
		frame.setMinimumSize(new Dimension(480, 360));
		
		fNormal = loadFont("SansSerif.bold-48.vlw");
		fDigital = loadFont("IrisUPCBold-48.vlw");
		textFont(fNormal, 48);
		
		//=====================================================================================================================================
		TotalColorChannels = 1; //start as default		
		
		IndexScrollBuffer = createGraphics(180, 800);
		LinkedScrollBuffer = createGraphics(545, 470);  
		SeqIconBuffer = createGraphics(140, 580); //was 565 heigh	
	}

	// Create an empty ArrayList (will store objects)
	ButtonList = new ArrayList<Button>();	
	DropDownList = new ArrayList<DropDown>();	
	TextFieldList = new ArrayList<TextField>();	
	CheckBoxList = new ArrayList<CheckBox>();	

	//================================================================================================

	FrameButtons = new Button[11]; //DONT CAST IT LIKE THAT
	for (int i =0; i != FrameButtons.length; i++) 
	{
		FrameButtons[i] = new Button(""+(i+1), 175+(i*35), 555, 30, 30, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);  
	}
	FrameButtons[SelectedFrame].Selected = true;	
	
	MenuTabs = new TabButton[5];
	MenuTabs[0] = new TabButton("Graphic Layout", 130, 10, 90, 20, cBorderColor, color(255), color(0), false, true);
	MenuTabs[1] = new TabButton("Timeline", 230, 10, 90, 20, cBorderColor, color(255),  color(0), false, true);
	MenuTabs[2] = new TabButton("Connection", 330, 10, 90, 20, cStrokeColor, color(255), color(0), false, true);
	MenuTabs[3] = new TabButton("Software Config", 430, 10, 100, 20, cBorderColor, color(255), color(0), false, true);
	MenuTabs[4] = new TabButton("Hardware Config", 540, 10, 100, 20, cBorderColor, color(255), color(0), false, true);
	MenuTabs[SelectedMenuTab].Selected = true;

	ToolTabs = new TabButton[4];
	ToolTabs[0] = new TabButton("Sequ.", 0, 115, 60, 25, cMenuColor, cBackgroundColor, color(255), false, true); 
	ToolTabs[1] = new TabButton("Tools", 65, 115, 60, 25, cMenuColor, cBackgroundColor, color(255), false, true);
	ToolTabs[2] = new TabButton("Frame", 65, 85, 60, 25, cMenuColor, cBackgroundColor, color(255), false, true); 
	ToolTabs[3] = new TabButton("Icons", 0, 85, 60, 25, cMenuColor, cBackgroundColor, color(255), false, true);  
	ToolTabs[SideBarMenuState].Selected = true;

	SeqCheckBoxes = new CheckBox[3];
	SeqCheckBoxes[0] = new CheckBox(15, 235, 15, 15, color(255), color(0), color(0), false);
	SeqCheckBoxes[1] = new CheckBox(55, 235, 15, 15, color(255), color(0), color(0), false);
	SeqCheckBoxes[2] = new CheckBox(95, 235, 15, 15, color(255), color(0), color(0), false);
	SeqCheckBoxes[PixelDataType].Selected = true; //Select RGB

	FrameCheckBoxes = new CheckBox[3];
	FrameCheckBoxes[0] = new CheckBox(10, 570, 15, 15, color(255), color(0), color(0), false);
	FrameCheckBoxes[1] = new CheckBox(50, 570, 15, 15, color(255), color(0), color(0), false);
	FrameCheckBoxes[2] = new CheckBox(90, 570, 15, 15, color(255), color(0), color(0), false);
	SetSlideDataTypeBoxStates(0);

	//=====================================================================================================================================

	SoftwareCheckBox = new CheckBox[8];
	SoftwareCheckBox[0] = new CheckBox(760, 425, 20, 20, color(255), color(0), color(0), false); 
	SoftwareCheckBox[1] = new CheckBox(760, 450, 20, 20, color(255), color(0), color(0), false);
	SoftwareCheckBox[2] = new CheckBox(760, 475, 20, 20, color(255), color(0), color(0), false);
	//added

	SoftwareCheckBox[3] = new CheckBox(700, 530, 20, 20, color(255), color(0), color(0), false);	//none
	SoftwareCheckBox[4] = new CheckBox(760, 530, 20, 20, color(255), color(0), color(0), false); //small 
	
	SoftwareCheckBox[5] = new CheckBox(700, 570, 20, 20, color(255), color(0), color(0), false); //med
	SoftwareCheckBox[6] = new CheckBox(760, 570, 20, 20, color(255), color(0), color(0), false); //large
	
	
	SoftwareCheckBox[7] = new CheckBox(510, 425, 20, 20, color(255), color(0), color(0), false);	//square icons

	
	SetLEDSizeCheckBoxes();
	SetLEDSpacingCheckBoxes();
	
	//=====================================================================================================================================
	
	SoftwareButtons = new Button[18]; 
	SoftwareButtons[0] = new Button("Save Sequence File", 620, 40, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[1] = new Button("Load Sequence File", 620, 75, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[2] = new Button("Manual", 390, 95, 70, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[3] = new Button("Load File", 405, 425, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true); //load patch file button
	SoftwareButtons[4] = new Button("Edit User ID Text", 620, 325, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[5] = new Button("Delete Sequence", 620, 290, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[6] = new Button("Website", 300, 95, 70, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[7] = new Button("Duplicate Sequence", 620, 255, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[8] = new Button("Load Device File", 635, 110, 130, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[9] = new Button("Clear All Sequences", 620, 160, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[10] = new Button("Apply", 250, 365, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[11] = new Button("800 x 600", 10, 115, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[12] = new Button("1024 x 768", 10, 180, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[13] = new Button("1280 x 960", 10, 215, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[14] = new Button("Reset Pixel Icons", 550, 425, 130, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[15] = new Button("Add Layout To Group", 290, 485, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[16] = new Button("Merge Groups", 290, 520, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	SoftwareButtons[17] = new Button("Clear Group", 290, 550, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	//change these if Adanced mode checkbox is set
	SoftwareButtons[17].Status = 1; //grey out for now
	SoftwareButtons[16].Status = 1; //grey out for now
	SoftwareButtons[15].Status = 1; //grey out for now

	//=====================================================================================================================================

	HardwareButtons = new Button[6];
	HardwareButtons[0] = new Button("Enabled", 125, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	HardwareButtons[1] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	HardwareButtons[2] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	HardwareButtons[3] = new Button("Enabled", 255, 330, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); //Gamma Correction button
	HardwareButtons[4] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);  //accmetere speed enable

	HardwareCheckBox = new CheckBox[2];
	HardwareCheckBox[0] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);
	HardwareCheckBox[1] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);

	//=====================================================================================================================================

	ConnectionButtons = new Button[6];
	ConnectionButtons[0] = new Button("Upload Sequences & Index", 360, 560, 200, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConnectionButtons[1] = new Button("Upload Configurations", 360, 515, 200, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConnectionButtons[2] = new Button("Reset Index", 475, 90, 110, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConnectionButtons[3] = new Button("Live Control", 420, 40, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConnectionButtons[4] = new Button("Stand-Alone Control", 250, 40, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConnectionButtons[5] = new Button("Gamma Correction", 140, 375, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	
	POVOptionButtons  = new Button[4];
	POVOptionButtons[3] = new Button("",740,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	POVOptionButtons[2] = new Button("", 680,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	POVOptionButtons[1] = new Button("", 620,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	POVOptionButtons[0] = new Button("", 560,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	//POVOptionButtons[0].Selected = true;
	
	POVRestart = new Button("Restart",640,565,60,25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	POVPlay = new Button("Play",710,565,50,25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	POVPause = new Button("||",765,565,25,25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	povButtonsImgs = new PImage[4]; 
	povButtonsImgs[0] = loadImage("pov-button-graphic-1.png");
	povButtonsImgs[1] = loadImage("pov-button-graphic-2.png");
	povButtonsImgs[2] = loadImage("pov-button-graphic-3.png");
	povButtonsImgs[3] = loadImage("pov-button-graphic-4.png");

	POVModeDD = new DropDown(cDDPOVModeString, cDDPOVModeString.length, 0, cPOVBufX+10, 110, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);

	GraphicPreviewPlayPause  = new Button("Play / ||",20,235,85,25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	//=====================================================================================================================================

	//Color Picker Sliders
	ColorSelectorSliders = new SliderBar[4];
	ColorSelectorSliders[0] = new SliderBar(1, 160, 325, 120, 10, 0, 0, 255, color(255), color(0), color(255, 0, 0), color(0), true, false, false); //Red
	ColorSelectorSliders[1] = new SliderBar(1, 160, 345, 120, 10, 0, 0, 255, color(255), color(0), color(0, 255, 0), color(0), true, false, false); //Green
	ColorSelectorSliders[2] = new SliderBar(1, 160, 365, 120, 10, 0, 0, 255, color(255), color(0), color(0, 0, 255), color(0), true, false, false); //Blue
	ColorSelectorSliders[3] = new SliderBar(1, 160, 385, 120, 10, 0, 0, 255, color(255), color(0), color(128), color(0), true, false, false); //White

	ColorSelectorApply = new  Button("Apply", 5, 5, 40, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ColorSelectorCancel = new  Button("Cancel", 5, 5, 45, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	//=====================================================================================================================================

	//Tools Menu
	GraphicFuncPaintButton = new  Button("Paint Tool", 10, 210, 100, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false, true);
	MainToolsAllSame = new  Button("All", 5, 260, 50, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true); 
	MainToolsColorGroup = new  Button("Group", 65, 260, 50, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);
	MainToolsShowStartValues = new  Button("Hide Color Icons", 5, 310, 110, 20, cColButtonsBG, cColButtonsBG, cColButtonsOut, true, true, true);
	StartValReset = new Button("Reset Values", 10, 340, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);  
	
	GradientDrawRadialButton = new  Button("Radial Tool", 10, 390, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); 
	GradientDrawLinearButton  = new  Button("Linear Tool", 10, 420, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); 
	GradientGenerate = new Button("Generate", 20, 570, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	PaintRects = new ColorRect[4]; //redefined later
	PaintRects[0] = new ColorRect(5, 180, 25, 25, 0, 0, 0, 0, "A");	
	PaintRects[1] = new ColorRect(35, 180, 25, 25, 0, 0, 0, 0, "B");	
	PaintRects[2] = new ColorRect(65, 180, 25, 25, 0, 0, 0, 0, "C");	
	PaintRects[3] = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "D");	

	TechnicalColorStart  = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "");	
	TechnicalColorEnd  = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "");	
	
	
	//Frame Tools
	FrameSeqToolInsantDD = new DropDown(cDDFrameSeqInstant, cDDFrameSeqInstant.length, 0, 5, 420, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	  
	FrameSeqToolTechDD = new DropDown(cDDFrameSeqTech, cDDFrameSeqTech.length, 0, 5, 420, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	  
	//FrameToolsDD.Status = 1;


	CopyFrameButton = new Button("Copy", 5, 200, 50, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	PasteFrameButton = new Button("Paste", 65, 200, 50, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	//Group Tools
	EnableGroupMode = new  Button("Enable", 10, 340, 100, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false, true);

	MouseIconPlace = new Button("Place Icons", 5, 495, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); 
	MouseIconRemove = new Button("Remove Icons", 5, 530, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); 
	MouseIconReset = new Button("Reset Icons", 5, 565, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true); 

	IconToolGroupIDDec = new Button("<", 15, 415, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	IconToolGroupIDInc = new Button(">", 80, 415, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	ImageHandleTR = new  Button("", 10, 335, 10, 10, color(255), cColButtonsHL, cColButtonsOut, false, false, true); 
	ImageHandleTL = new  Button("", 10, 335, 10, 10, color(255), cColButtonsHL, cColButtonsOut, false, false, true); 
	ImageHandleBR = new  Button("", 10, 335, 10, 10, color(255), cColButtonsHL, cColButtonsOut, false, false, true); 
	ImageHandleBL = new  Button("", 10, 335, 10, 10, color(255), cColButtonsHL, cColButtonsOut, false, false, true); 
	ImageHandleCenter = new  Button("", 10, 335, 20, 20, color(255), cColButtonsHL, cColButtonsOut, false, false, true); 

	//=====================================================================================================================================

	//Don't forget to had the textfiled handler to cTextFieldMEthods array
	ObjButtonPlus  = new Button[5];
	ObjButtonMinus  = new Button[5];
	ObjTextField  = new TextField[5];
	SequenceSpeedObject = new TextFieldObject(0,5,275,25,1,65535);
	SequenceChannelObject = new TextFieldObject(1,5,380,25,1,65535);
	PixelAmountObject = new TextFieldObject(2,505,485,25,1,65535);
	GradientStepsObject = new TextFieldObject(3,5,535,25,-1024,1024);
	GradientMultiplierObject = new TextFieldObject(4,5,470,25,0,100);
	ObjTextField[4].InputMethod = 3;
	ObjTextField[4].Label = ""+MultiplierToolValue/10;
	
	//===========

	LObjButtonPlus  = new Button[5];
	LObjButtonMinus  = new Button[5];
	LObjTextField  = new TextField[5];
	LinkedTextFieldObject = new TextFieldObjectL[5]; //expand later

	for (int i = 0; i != LinkedTextFieldObject.length; i++) LinkedTextFieldObject[i] = new TextFieldObjectL(i,340,(i+1)*cLinkedRoWHeight,25, 1, 65535);

	//=====================================================================================================================================

	TextFields = new TextField[15];

	TextFields[0] = new TextField("Enter#", 35, 510, 50, 25, color(255), color(200, 40, 40), 1, 0, 255, true, false, "txtHandleSlideValue"); //Slide Value
	//don't have to do this TextFields[0].Status = 1; //start greyed out
	TextFields[1] = new TextField("Enter#", 225, 470, 50, 20, color(255), color(200, 40, 40),  1, 0, 100, true, false, "txtHandleGenericNumber"); //whats this for now? 
	TextFields[2] = new TextField("1", 120, 195, 80, 20, color(255), color(200, 40, 40),  1, 1, 512, true, false, "txtHandleGenericNumber"); //DMX Adr Config
	TextFields[3] = new TextField("Enter Text ID", 630, 360, 130, 25, color(255), color(200, 40, 40),  0, 0, 30, true, false, "txtHandleUserIDField");//User ID Field
	TextFields[4] = new TextField("1", 65, 50, 50, 25, color(255), color(200, 40, 40),  1, 1, cSoftwareMaxChans, true, false, "txtHandleLiveControlAddress"); //Live control Address
	TextFields[5] = new TextField("0", 210, 50, 70, 25, color(255), color(200, 40, 40),  1, 0, 255, true, false, "txtHandleLiveControlValue"); //USB Live Control Channel Value
	TextFields[6] = new TextField("1", 25, 365, 70, 25, color(255), color(200, 40, 40),  1, 1, 65535, true, false, "txtHandleFrameSpeed");//Frame Speed
	//don't have to do this TextFields[6].Status = 1; //start greyed out
	TextFields[7] = new TextField("Enter#", 265, 145, 60, 25, color(255), color(200, 40, 40),  1, 0, cSoftwareMaxSequences, true, false, "txtHandleGenericNumber");//Live Control, Sequence Number
	TextFields[8] = new TextField("1", 270, 200, 80, 25, color(255), color(200, 40, 40),  1, 0, 0xFFFF, true, false, "txtHandleGenericNumber"); //Live Control Speed Box
	TextFields[9] = new TextField("1", 305, 350, 50, 25, color(255), color(200, 40, 40),  1, 0, 0xFFFF, true, false, "txtHandleGenericNumber"); //Fade Control Value Number
	TextFields[10] = new TextField("", 0, 0, 50, 20, color(255), color(200, 40, 40),  1, 0, 255, true, false, "txtHandleColorPickerFields"); //Color Picker Field
	TextFields[11] = new TextField("Enter#", 175, 365, 60, 25, color(255), color(200, 40, 40),  1, 0, cSoftwareMaxChans, true, false, "txtHandleUserChannelAmt"); //User Channel Amount on Software Tab
	//TextFields[12] = new TextField("1", 55, 235, 60, 20, color(255), color(200, 40, 40),  1, 1, 0xFFFF, true, false, "txtHandleSeqSpeed");  //Speed Field
	TextFields[13] = new TextField("1", 20, 265, 25, 25, color(255), color(200, 40, 40),  1, 1, 32, true, false, "txtHandleGenericNumber");  //Stand-Alone Module ID field
	TextFields[14] = new TextField("100", 235, 520, 50, 25, color(255), color(200, 40, 40),  2, 0, 100, true, false, "txtHandleGenericNumber");  //Intensity Percentage

	TXTFSeqIntensity = new TextField("100", 70, 315, 50, 25, color(255), color(200, 40, 40), 2, 1, 100, true, false, "txtHandleSequenceIntensity");
	TXTFTechTime = new TextField("65535", 70, 315, 50, 25, color(255), color(200, 40, 40), 1, 1, 0xFFFF, true, false, "txtHandleTechTime");	
	
	textFieldPtr = TXTFSeqIntensity; //default it so it doesn't NullPointerException

	//=======================================================================================================

	OverlayMenus = new OverlayMenu[8];
	OverlayMenus[0] = new OverlayMenu(0,0,0,0,0); //null Menu
	OverlayMenus[1] = new OverlayMenu(1, 10, 40, 780, 550); //Live Control Color Squares
	OverlayMenus[2] = new OverlayMenu(2, 10, 40, 780, 550); //Live Control Sliders
	OverlayMenus[3] = new OverlayMenu(3, 10, 40, 780, 550); //Stand Alone Menu
	OverlayMenus[4] = new OverlayMenu(4, 70, 40, 660, 550); //Sequence Selection
	OverlayMenus[5] = new OverlayMenu(5, 10, 40, 780, 550); //Gamma Correction
	OverlayMenus[6] = new OverlayMenu(6, 100, 100, 125, 125); //Technical Color Channel
	OverlayMenus[7] = new OverlayMenu(7, 100, 100, 140, 140); //Technical Color Select
	

	//=======================================================================================================

	LiveControlCheckBox = new CheckBox[4];
	LiveControlCheckBox[0] = new CheckBox(60, 20, 20, 20, color(255), color(0), color(0), false); //single
	LiveControlCheckBox[1] = new CheckBox(100, 20, 20, 20, color(255), color(0), color(0), true); //rgb
	LiveControlCheckBox[2] = new CheckBox(140, 20, 20, 20, color(255), color(0), color(0), false);	//rgbw
	LiveControlCheckBox[3] = new CheckBox(280, 20, 20, 20, color(255), color(0), color(0), false);	//16-bit live mode

	//=======================================================================================================

	StandAloneClose = new  Button("Close", (OverlayMenus[3].xpos+OverlayMenus[3].Width)-100, 60, 80, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);
	LiveControlClose = new  Button("Close", 700, 60, 80, 25, cColButtonsHL, cPurpleColor, cColButtonsOut, false, false, true);
	LiveControlToggle = new  Button("Sliders/Color", 200, 60, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	LiveControlApply  = new  Button("Apply", 200, 60, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	SequenceSelectClose = new  Button("Close", 700, 40, 50, 25, cColButtonsHL, cPurpleColor, cColButtonsOut, false, false, true);  
	SequenceSelectAdd = new  Button("New Sequence", 700, 40, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);   
	
	
	RadialMenuTechColorMode = new  Button[3];
	RadialMenuTechColorMode[0] = new  Button("Single", 700, 60, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	RadialMenuTechColorMode[1] = new  Button("RGB", 700, 40, 50, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);
	RadialMenuTechColorMode[2] = new  Button("RGBW", 700, 40, 50, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true); 

	
	RadialTechSolidButton = new  Button("Solid", 700, 40, 50, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);   
	RadialTechFadeButton = new  Button("Fade Up/Down", 700, 40, 90, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, true);   


	StandaloneSliders = new   SliderBar[3];
	StandaloneSliders[0] = new SliderBar(9, 95, 230, 260, 16, 0, 1, 65535, color(255), color(0), cBorderColor, color(0), true, false, false);  //Alter Speed
	StandaloneSliders[1] = new SliderBar(9, 175, 350, 120, 16, 0, 0, 1023, color(255), color(0), cBorderColor, color(0), true, false, false); //Fade Control Value
	StandaloneSliders[2] = new SliderBar(9, 175, 380, 120, 16, 1, 1, 64, color(255), color(0), cBorderColor, color(0), true, false, false);  //Fade Control Mult

	StandaloneButtons = new Button[11];
	StandaloneButtons[0] = new  Button("Send", 370, 55, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[1] = new  Button("Send", 370, 130, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[2] = new  Button("Send", 370, 210, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[3] = new  Button("Step Forward", 140, 285, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[4] = new  Button("Step Backward", 280, 285, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[5] = new  Button("Send", 370, 350, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true); //Fade Control Send

	StandaloneButtons[6] = new  Button("Sequence Up", 480, 125, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[7] = new  Button("Sequence Down", 480, 165, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[8] = new  Button("Play/Pause", 480, 205, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[9] = new  Button("Speed+1", 480, 300, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	StandaloneButtons[10] = new  Button("Speed-1", 480, 270, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	StandaloneCheckBox = new CheckBox[2];
	StandaloneCheckBox[0] = new CheckBox(190, 135, 20, 20, color(255), color(0), color(0), false);
	StandaloneCheckBox[1] = new CheckBox(190, 150, 20, 20, color(255), color(0), color(0), false);

	IntensityOverrideCheckBox  = new CheckBox(235, 560, 20, 20, color(255), color(0), color(0), false);
	IconLayoutAdvancedMode  = new CheckBox(290, 460, 20, 20, color(255), color(0), color(0), false);
	POVVideoModeCheckBox  = new CheckBox(300, 110, 20, 20, color(255), color(0), color(0), false);

	//=====================================================================================================================================
	
	AccMeterAutoDetectDD = new DropDown(cDDAccMeterShutOff, cDDAccMeterShutOff.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	AccMeterAutoDetectModeDD = new DropDown(cDDAccMeterShutOffMode, cDDAccMeterShutOffMode.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	AccMeterTapDD  = new DropDown(cDDAccMeterTapMode, cDDAccMeterTapMode.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	

	LEDIndicatorModeADD = new DropDown(cDDLEDMstring, cDDLEDMstring.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	LEDIndicatorModeBDD = new DropDown(cDDLEDMstring, cDDLEDMstring.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	DMXModesDD = new DropDown(cNoneStr, 1, 0, 85, 280, 170, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	BaudRateDD = new DropDown(cDDBaudstring, cDDBaudstring.length, 0, 260, 215, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	DisplayModeDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);		
	DisplayModeBDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);		
	MasterModeDD = new DropDown(cDDMasterModes8Bit, cDDMasterModes8Bit.length, 0, 90, 340, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
	AutoDetectDD = new DropDown(cDDAutoDetectModesT1, cDDAutoDetectModesT1.length, 0, 405, 300, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
	HardwareColSwapDD = new DropDown(cGlobalColSwapStr, cGlobalColSwapStr.length, 0, 480, 470, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	PixelChipsetDD = new DropDown(cNoneStr, cNoneStr.length, 0, 350, 470, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false); 
	ShapeOptionsDD = new DropDown(cDDShapeOptions, cDDShapeOptions.length, 0, 290, 425, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	PowerDownTimeOutDD = new DropDown(cDDPowerTimeOut, cDDPowerTimeOut.length, 0, 405, 300, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
	PWMProfileADD = new DropDown(cDDPWMProfileA, cDDPWMProfileA.length, 0, 405, 300, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
	IRRemoteModeDD = new DropDown(cDDIRRemote, cDDIRRemote.length, 0, 405, 300, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	

	SequenceModeDD = new DropDown(cDDSequenceMode, cDDSequenceMode.length, 0, 5, 185, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	
	PWMFreqADD = new DropDown(cDDPWMFreqA, cDDPWMFreqA.length, 0, 5, 160, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	 
	StandAloneADD = new DropDown(cDDStandAloneA, cDDStandAloneA.length, 0, 5, 160, 110, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
	StandAloneDD = new DropDown(cColorSwapStr, cColorSwapStr.length, 0, 215, 60, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
	
	SeqTransistionDD = new DropDown(cDDSeqTransistion, cDDSeqTransistion.length, 0, 5, 520, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true);	//DROP UP
	PlayModeDD = new DropDown(cDDSeqPlayMode, cDDSeqPlayMode.length, 0, 5, 570, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true);	//DROP UP
	PacketCloneDD = new DropDown(cDDPacketClone, cDDPacketClone.length, 0, 5, 415, 115, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true); //DROP UP
	
	DropDownPointer = new DropDown(cNoneStr, 1, 0, 405, 360, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);

	// ============= END DROP DOWNS, START BUTTONS ========================================

	HardwarePrevIcon = new  Button("Click to\nSelect a Sequence\nPreview it on\nthe Device", 170, 220, 110, cSeqTileH, cScrollBoxColor, cColButtonsHL, color(255), false, false, true);
	IdleSequenceIcon = new  Button("Click to\nSelect Idle\nSequence", 440, 250, 110, cSeqTileH, cScrollBoxColor, cColButtonsHL, color(255), false, false, true);
	
	DMXSequenceIcon = new  Button("DMX Reception\n\nClick to Select", 300, 200, 110, cSeqTileH, cBorderColor, cColButtonsHL, color(0), false, false, true);
	SerialSequenceIcon = new  Button("Serial Reception\n\nClick to Select", 300, 280, 110, cSeqTileH, cBorderColor, cColButtonsHL, color(0), false, false, true);

	//=====================================================================================================================================

	DeviceConnect = new Button("Connect", 60, 40, 60, 20, cColButtonsHL, color(0,155,0), cColButtonsOut, true, false, true);
	POVModeButton = new Button("Load File", 330, 40, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	ConfirmButtonYes = new Button("Yes", 325, 325, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ConfirmButtonNo = new Button("No", 415, 325, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	DeviceWebpage = new Button("Open Device Webpage", 610, 40, 180, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	RequestConfigurations = new Button("Request Configurations", 630, 160, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	HardwareTabUploadConfigurations = new Button("Upload Configurations", 480, 160, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	EnterBootloaderButton = new Button("Enter Bootloader Mode", 610, 75, 180, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	OpenTCPButton = new Button("Open TCP", 30, 110, 70, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true); 

	GroupIDDecf = new Button("<", 710, 565, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	GroupIDIncf = new Button(">", 765, 565, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	AddFrame = new Button("+", 650, 555, 30, 30, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	RemoveFrame = new Button("-", 610, 555, 30, 30, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	IncFrameBar = new Button(">", 560, 555, 30, 30, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);
	DecFrameBar  = new Button("<", 140, 555, 30, 30, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);

	SequenceMenuButton  = new Button("Sequences", 670, 0, 130, 35, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	LayoutGroupInc = new Button(">", 580, 545, 20, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);
	LayoutGroupDec = new Button("<", 510, 545, 20, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);

	ImagePlaceButton = new Button("Place Image", 140, 460, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ImageRemoveButton = new Button("Remove Image", 140, 495, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ImageResizeButton = new Button("Resize Image", 140, 530, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	ImageResetButton = new Button("Reset Position", 140, 565, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	UploadProgressCancel = new Button("Cancel", 340, 340, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	//Gamma Correction Buttons
	GammaOverlayCloseButton = new Button("Close", 650, 70, 100, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false, true);
	GammaLoadFileButton = new Button("Load Gamma File", 405, 245, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	GammaUploadButton = new Button("Upload Gamma Table", 600, 245, 180, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	GammaUploadDefaultButton = new Button("Upload Default Gamma Table", 50, 245, 240, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);

	FilePlayLoadButton = new Button("Load Play File", 270, 38, 120, 23, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);
	
	//set initial status
	PixelAmountObject.setStatus(1);
	LayoutGroupInc.Status = 1;
	LayoutGroupDec.Status = 1;
	// ============= END BUTTONS , START SLIDERS ========================================

	TimeLineScrollBar = new SliderBar(0, 776, cTLChBufY, 24, cTLChBufViewH, 0, 0, (TotalColorChannels*cTLChBufH), color(255), cColButtonsHL, color(255), color(0), true, true, true);

	TechnicalScrollVert = new SliderBar(2, 776, cTLChBufY, 24, cTechnicalBufH, 0, 0, 10, color(255), cColButtonsHL, color(255), color(0), true, true, true);	
	TechnicalScrollHoriz = new SliderBar(3, cTLChBufX+35, 520, 605, 24, 0, 0, 10, color(255), cColButtonsHL, color(255), color(0), true, false, true);

	IndexScrollBar = new SliderBar(5, 776, 35, 24, 560, 0, 0, 2, color(255), cColButtonsHL, color(255), color(0), false, true, true);
	LinkedScrollBar = new SliderBar(6, 776, cTLChBufY, 24, cTLChBufViewH, 0, 0, 1, color(255), cColButtonsHL, color(255), color(0), false, true, true);
	SequenceSelectScrollBar = new SliderBar(13, 776, cTLChBufY, 24, OverlayMenus[4].Height-70, 0, 0, 10, color(255), cColButtonsHL, color(255), color(0), false, true, true);

	//initialized in case of arrow press before slider select
	SliderPointer = new SliderBar(0, 0, 0, 0, 0, 0, 0, 0, color(255), cColButtonsHL, color(255), color(0), false, false, true); //init in case

	device = new DeviceObj("No Device");

	GradientRects = new ColorRect[11];
	for (int i =0; i != GradientRects.length; i++) 
	{
		GradientRects[i] = new ColorRect(175+(i*35), 555, 30, 30, (int)myRed, (int)myGreen, (int)myBlue, (int)myWhite, ""+(i+1));
	}
	//No selected for gradient rects
	
	for (int i=0; i != paletteColors.length;i++) for (int z=0; z != paletteColors[i].length;z++) paletteColors[i][z] = 0;
	ColorSelector = new ColorPickerObj(100, 100, 270, 290, 0, 0, 0,0,0,0);

	InputModule = new SpecHWModules[24];
	InputModule[0] = new SpecHWModules(0,"Serial RS-485 Enable:\n(Disable for TTL Serial)",0, 0,140, 90,"fRS485Enable","BYTE",0);
	InputModule[1] = new SpecHWModules(1,"Second Activity\nLED Mode:",0, 0,130, 90,"fLEDModeMSBb,fLEDModeLSBb","BYTE",0);
	InputModule[2] = new SpecHWModules(2,"Select Correct Color Order For Chipset:",0, 0,120, 90,"CONFIG","bGlobalColorShift",210);
	InputModule[3] = new SpecHWModules(3,"Select The Pixel Chipset:\n\n\nRecommended Color: varies / R>G>B",0, 0,160, 90,"CONFIG","bPixelChipset",250);
	InputModule[4] = new SpecHWModules(4,"Enable Serial Reception Instead of DMX reception. Auto-Detect is disabled during serial reception.",0,0, 200, 90,"CONFIG","BYTE",0);
	InputModule[5] = new SpecHWModules(5,"DMX Address:\n(Enter Number)\n\n\n(1-512)",0,0, 120, 90,"CONFIG","bDMXAdrMSB,bDMXAdrLSB",0);
	InputModule[6] = new SpecHWModules(6,"DMX Reception\nMode - ID Number: "+DMXModesDD.SelStr,0,0, 180, 90,"CONFIG","bDMXModeID",190); 
	InputModule[7] = new SpecHWModules(7,"DMX Master Mode:\n(Not all listed options are valid)",0,0, 160, 90,"fMasterEnable,fMasterFullPkts,fMaster16Bit","BYTE",190); 
	InputModule[8] = new SpecHWModules(8,"Serial Baud Rate:\nID Number: "+BaudRateDD.SelStr,0,0, 120, 90,"f8or16Bit","bBaudRateID",200); 
	InputModule[9] = new SpecHWModules(9,"Activity\nLED Mode:",0,0, 120, 90,"fLEDModeMSBa,fLEDModeLSBa","BYTE",0); 
	InputModule[10] = new SpecHWModules(10,"External\nLED Display Mode:",0,0, 140, 90,"fDisModeMSBa,fDisModeLSBa","BYTE",190); 
	InputModule[11] = new SpecHWModules(11,"Auto-Detect Data Control Reception:",0,0, 140, 90,"fAutoDetectID,fAutoDetect","BYTE",180); 
	InputModule[12] = new SpecHWModules(12,"Enable Gamma\nCorrection:\n(See Connection tab)",0,0, 140, 90,"fGammaCorrectionEnabled","CONFIG",0); 
	InputModule[13] = new SpecHWModules(13,"Accelerometer Movement Detection:",0,0, 140, 90,"fAccMeterAutoShutOff,fAccMeterAutoShutOffMode","bAccmeterTimeoutVal",210); 
	InputModule[14] = new SpecHWModules(14,"Enable Accelerometer Speed Adjustment",0,0, 140, 90,"fAccMeterMovement","BYTE",0); 
	InputModule[15] = new SpecHWModules(15,"Enable Accelerometer Double Tap Button Press",0,0, 140, 90,"fAccMeterDoubleTap","bAccmeterDoubleTapVal",200); 
	InputModule[16] = new SpecHWModules(16,"Power Down\nTime Out",0,0, 140, 90,"fTimeOutEnabledMSB,fTimeOutEnabledLSB","BYTE",0); 
	InputModule[17] = new SpecHWModules(17,"Pixel Data Packet Cloning:\n(0 is Disabled)",0,0, 120, 90,"DELETE","DELETE",0); 
	InputModule[18] = new SpecHWModules(18,"Sequence Fade Transition:\n(0 is Disabled)",0,0, 120, 90,"DELETE","DELETE",0); 
	InputModule[19] = new SpecHWModules(19,"Dual Communication Mode (Serial\n/WiFi/Bluetooth)",0,0, 120, 90,"fDualModeCom","BYTE",0); 
	InputModule[20] = new SpecHWModules(20,"PWM Frequency:",0,0, 120, 90,"CONFIG","BYTE",180); 
	InputModule[21] = new SpecHWModules(21,"Stand-Alone Mode\n& Signal Loss Mode:",0,0, 160, 90,"CONFIG","BYTE",160);
	InputModule[22] = new SpecHWModules(22,"PWM Profile\nResolution & Frequency:",0,0, 160, 90,"CONFIG","bPWMMode",160);
	InputModule[23] = new SpecHWModules(23,"Enable I.R. Remote Control:\n(Addon Card)",0,0, 160, 90,"fIRCardEnable,fIRCardEnableSpeed","BYTE",160);
	

	device.WebpageURL = "www.NLEDshop.com"; //set default URL
	SessionLogFileName = "log-"+hour()+"-"+minute()+"-"+day()+"-"+month()+"-"+year()+".txt";

	POVBuffer = createGraphics(560, 360);
	POVBuffer.beginDraw();
	POVBuffer.background(0, 0, 0, 0);
	POVBuffer.endDraw();

	POVImg = createGraphics(1, 1);
	graphicImg = loadImage("imagelayouts"+File.separator+"default.png"); 	
	
	PixelIcon = new LEDgraphic[cSoftwareMaxChans];	
	GraphicLayoutBuffer = createGraphics(cGLBufWidth, cGLBufViewH);
	
	
	if(InitializedWindowSize == false) InitNoSequences();
	InitializedWindowSize = true; 
	
	println("====Starting Software Version "+cSoftwareV+" Revision "+cSoftwareR+"====");	
	
	thread("CheckForUpdate");	//thread it since it takes time
	
	InitNoSequences();
	
	InitCOMButtons();
	LoadConfigFile(); //load screen size and default port	
}//end setup()

//==================== END SETUP ============================================================================

public void CheckForUpdate()
{
	try {
		//VERSION CHECK FROM WEB
		String VersionCheckFile[] = loadStrings("http://www.nledshop.com/nledaurora/auroraversion2.txt");
		String[] WorkString  = new String[3];

		WorkString = split(VersionCheckFile[0], '\t');

		if(PApplet.parseInt(WorkString[1]) > cSoftwareV || PApplet.parseInt(WorkString[2]) > cSoftwareR)
		{
			println("Software out of date");
			ShowNotification(23);
		}
		else println("Software up to date");
	}
	catch(Exception e)
	{
		println("Unable to Check for Software Updates");
	}
} //end CheckForUpdate()

//============================================================================================


public void TryLastCOMPort()
{
	println("TryLastCOMPort()");
	InitCOMButtons();
	//goes through serial list and finds if the current port that is or was connected is currently available, then connect to it and set button state
	for (int x =0; x != Serial.list().length; x++) 
	{
		if(portName.equals(Serial.list()[x]))
		{		
			println("This ran, but shouldn't during setup()");	
			OpenCOMPort(portName);
		}
	}	//end for()	
} //end TryLastCOMPort()


public void InitCOMButtons()
{
	//Runs as Thread - Builds COM Buttons
	println("InitCOMButtons() "+Serial.list().length);

	try {
		if(COMButtons.length != Serial.list().length) 
		{
			redraw();
		}
	}
	catch(Exception e) {  }
	
	try 
	{
		COMButtons = new Button[Serial.list().length];  
		
		// start shorten string from Configuration Software
		String[] COMPortNames = new String[Serial.list().length];
		int varStart = 0;
		int varEnd = 0;
		
		for (int i=0; i != Serial.list().length;i++)
		{
			// added from Configuration Software
			if (Serial.list()[i].length() > 7) //7 chars long max....
			{ 
				varStart = Serial.list()[i].length() - 7; 
				varEnd =  Serial.list()[i].length();
			}
			else 
			{ 
				varStart = 0; 
				varEnd = Serial.list()[i].length();
			}
			COMPortNames[i] = Serial.list()[i].substring(varStart, varEnd);
			//end shorten string 

			COMButtons[i] = new Button(COMPortNames[i], 25, 190+(i*30), 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false, false);
			
			if(Serial.list()[i].indexOf("cu") > 0) COMButtons[i].Status = 1; //Forces only tty ports and not cu ports, for some reason
		} //end for()  
	}//end try
	catch(Exception e) {println("Exception in InitCOMButtons()"); }	
}	//end func

public void mousePressed()
{
	if(myMousePressed()) redraw();
	else { 
		println("Click returned false");
		if(GlobalDDOpen == true) { DropDownPointer.Selected = false;	GlobalDDOpen = false; }
	}
}


public boolean myMousePressed()
{
	mouseXS = round((float)mouseX / SF);
	mouseYS = round((float)mouseY / SF);
	
	//If a Notification is enabled, a click will close it after the minimum wait time
	if(ShowNotification > 0)
	{
		if(ShowNotificationMinFlag == true) { ShowNotification = 0; ShowNotificationMinFlag = false; }
		return true;
	}

	//====================================================================================================================================  

	//all accessible at anytime
	if(pressHandlerConfirmBox() == true) return true;
	
	if (mouseButton == RIGHT)
	{
		pressHandlerRightClick(); //always is true
		return false;
	} //end right button check

	//====================================================================================================================================  

	//if clicked with textfield selected it will deselect it
	if(textFieldPtr.Selected == true) 
	{
		textFieldPtr.Selected = false; 
		textFieldPtr.Label = GlobalLabel;
		redraw();
	}	
	
	if (ColorPickerOpen == true) 
	{
		if(pressHandlerColorPickerOpen() == true) return true; //if open you can only click on the colorpicker
	}	

	if(UploadProgressCancel.over() && UploadInProgress == true)
	{
		//Doesn't stop the thread, but lets it play out without the upload bar showing
		UploadInProgress = false;
		TerminateUpload = true;
		ShowNotification(21); //show message
		return true;
	}	

	if(OverlayMenuID > 0)
	{
		OverlayMenus[OverlayMenuID].mousePressed(); //no need to check over()
		return true;
	}

	if(DeviceConnect.over()) 
	{
		DeviceConnect.Selected = false; //set to false since over() toggles selected
		//if(DeviceConnect.Selected == true) OpenConnection(); 
		//else 
		//always reconnect and which will follow with OpenConnection()
		TryLastCOMPort();	//not connected attempt previously selected COM port
	}

	if(pressHandlerMenuTabs() == true) return true; 
	
	if (SelectedMenuTab == 0 || SelectedMenuTab == 1)
	{	
		if(UserSequences[SelectedSequence].SeqMode != mPOV)
		{
			if(pressHandlerFrameButtonOptions() == true) return true; //frame buttons - don't run if POV
		}
		
		for(int i = 0; i != ToolTabs.length;i++)
		{
			if(ToolTabs[i].Selected == false && ToolTabs[i].over())
			{
				//ToolTabs[i].Selected = true; 
				ToolTabs[SideBarMenuState].Selected = false; 
				SideBarMenuState = i; 
				
				EnableGroupMode.Selected = false;	
				return true;
			}
		}

		switch(SideBarMenuState)
		{
		case 0: //SEQUENCE Tools
			if (SequenceModeDD.over()) return true;
			else if(SequenceModeDD.overOpen()) 
			{
				HandleSequenceModeDropDown();
				return true;
			}	
			
			if (PacketCloneDD.over()) return true;
			else if(PacketCloneDD.overOpen()) 
			{
				UserSequences[SelectedSequence].PacketCloneMode = PacketCloneDD.SelStr;
				MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
				return true;
			}	
			
			if (SeqTransistionDD.over()) return true;
			else if(SeqTransistionDD.overOpen()) 
			{
				UserSequences[SelectedSequence].SeqTransitionFlags = SeqTransistionDD.SelStr;				
				return true;
			}
			
			if (PlayModeDD.over()) return true;
			else if(PlayModeDD.overOpen()) 
			{
				UserSequences[SelectedSequence].SeqPlayMode = PlayModeDD.SelStr;				
				return true;
			}
			
			//====================================================	
			if(TXTFSeqIntensity.over())
			{
				TXTFSeqIntensity.SelectField();	
				return true;
			}			
			//====================================================
			for (int i =0; i != SeqCheckBoxes.length; i++)
			{
				if (SeqCheckBoxes[i].overB())
				{
					println("SeqCheckBox "+i+" pressed"); 

					if(UserSequences[SelectedSequence].DataType != i)
					{
						UserSequences[SelectedSequence].DataType = i;
						UpdateSequence(SelectedSequence);
						UpdateSideBarButtonStates();
					}
					return true;
				}
			}	//end i for()	
			//====================================================
			if(SequenceSpeedObject.over() > 0)
			{
				println("SequenceSpeedObject "+SequenceSpeedObject.over());
				
				switch(SequenceSpeedObject.over())
				{
				case 1: //minus
					if(UserSequences[SelectedSequence].Speed > 1) UserSequences[SelectedSequence].Speed--;
					ObjTextField[SequenceSpeedObject.ObjID].Label = ""+UserSequences[SelectedSequence].Speed;
					break;
				case 2: //add
					if(UserSequences[SelectedSequence].Speed < device.MaxSpeed) UserSequences[SelectedSequence].Speed++;	
					ObjTextField[SequenceSpeedObject.ObjID].Label = ""+UserSequences[SelectedSequence].Speed;
					break;
				case 3:
					ObjTextField[SequenceSpeedObject.ObjID].SelectField();
					break;
				} //end switch
				return true;
			} //end 	
			//========================================================	
			if(SequenceChannelObject.over() > 0)
			{
				println("SequenceChannelObject "+SequenceChannelObject.over());
				
				switch(SequenceChannelObject.over())
				{
				case 1:
					if(UserSequences[SelectedSequence].DataSize > 1) UserSequences[SelectedSequence].DataSize--;
					ObjTextField[SequenceChannelObject.ObjID].Label = ""+UserSequences[SelectedSequence].DataSize;
					UpdateSequence(SelectedSequence);	//NOT SURE IF THIS IS BEST
					break;
				case 2:
					if(UserSequences[SelectedSequence].DataSize < device.Channels) UserSequences[SelectedSequence].DataSize++;	
					ObjTextField[SequenceChannelObject.ObjID].Label = ""+UserSequences[SelectedSequence].DataSize;
					UpdateSequence(SelectedSequence);	//NOT SURE IF THIS IS BEST
					break;
				case 3:
					ObjTextField[SequenceChannelObject.ObjID].SelectField();
					break;
				} //end switch
				return true;
			} //end	
			//========================================================	
			break;
		case 1: //TOOLS
			if(pressHandlerToolsMenu() == true) return true;
			break;
		case 2: //Frame Tools
			
			if(pressHandlerFrameTools() == true) return true;
			
			if(CopyFrameButton.over() && EnableGroupMode.Selected == false)
			{
				//copy the frame to a buffer with altert
				ShowNotification(10); //show notification value

				CopyBuffer = expand(CopyBuffer, UserSequences[SelectedSequence].DataSize); //expand to correct size
				arrayCopy(UserSequences[SelectedSequence].DataFrames[SelectedFrame], CopyBuffer, UserSequences[SelectedSequence].DataSize); //copy into storage buffer
				return true;
			}
			else if(PasteFrameButton.over() && EnableGroupMode.Selected == false)
			{
				//paste from buffer to current frame, with confirmation	
				arrayCopy(CopyBuffer, UserSequences[SelectedSequence].DataFrames[SelectedFrame], UserChannelAmt); //copy into storage buffer		

				GraphicLayoutUpdateIcons();	//change v2c from	//MenuTabs[0].refresh(); 
				MenuTabs[1].refresh();
				return true;
			}	
			break;		
		case 3: //Group Tools

			if(IconToolGroupIDDec.over())
			{
				println("IconToolGroupIDDec pressed");
				if(FunctionGroupIDNum == 0) FunctionGroupIDNum = 7;
				else FunctionGroupIDNum--;
				return true;
			}
			
			if(IconToolGroupIDInc.over())
			{
				println("IconToolGroupIDInc pressed");
				if(FunctionGroupIDNum == 7) FunctionGroupIDNum = 0;
				else FunctionGroupIDNum++;
				return true;
			}

			if(EnableGroupMode.over())
			{
				return true;
			}	
			
			if(MouseIconPlace.over()) { MouseIconRemove.Selected = false; return true; }
			if(MouseIconRemove.over()) { MouseIconPlace.Selected = false; return true; }
			if(MouseIconReset.over()) {  ResetLEDIcons(); return true; }
			
			if(GraphicPreviewPlayPause.over()) 
			{ 
				GraphicLayoutPreview = !GraphicLayoutPreview; 
				if(GraphicLayoutPreview == true) 
				{	
					println("Starting Software Sequence Preview");	
					loop();				
				}
				else 
				{ 
					println("Stopping Software Sequence Preview");		
					noLoop(); 
					MenuTabs[0].refresh();	
				}
				return true; 
			}	
			break;
		} //end switch	
		
		if(SequenceMenuButton.over())
		{
			println("Open Sequence Overlay Menu");
			InitializeSequenceSelect(0, 0);
			return true;
		}	
	} //end if(SelectedMenuTab == 0 || SelectedMenuTab == 1)
	
	//====================================================================================================================================  

	switch(SelectedMenuTab) //run tab specific stuff
	{
	case 0: //graphic layout ====================================================================================================================================  
		
		if (UserSequences[SelectedSequence].SeqMode == mLinked)
		{
			if(pressHandlerLinkedBuffer() == true) return true;
			return true;
		}

		//WAS commented out
		if(GradientDrawState > 0) //gradient startval draw
		{
			//also check if its within the workspace bounds
			// Disabled to prevent click ignores
			
			if(mouseXS >= cWorkspaceX && mouseXS <= (cWorkspaceX+cGLBufWidth) && mouseYS >= cWorkspaceY && mouseYS <= (cWorkspaceY+575)) 
			{      	
				if(GradientDrawInit == false) //set start click
				{
					GradientDrawStartX = mouseXS; //save start position
					GradientDrawStartY = mouseYS;
					GradientDrawInit = true;
				}
				else
				{
					//handle end click
					GradientDrawInit = false;
					GradientDrawEndX = mouseXS; //save start position
					GradientDrawEndY = mouseYS;			

					if(GradientDrawState == 1)	GenerateRadialGradient();
					else if(GradientDrawState == 2)	GenerateLinearGradient();	
				}
				return true; //leave
			} //end workspace bounds if()
		} //end GradientDrawState if()

		//================== END GradientDraw ===========================
		
		if(GraphicImageResize == true)
		{
			//if enabled, this is the only graphic layout(tools excluded) thing that can be pressed
			GraphicImageInitX = mouseXS;		
			GraphicImageInitY = mouseYS;

			if(ImageHandleTL.overGLBuf()) 
			{
				println("ImageHandleTL 1");
				ImageHandleTL.displayGLBuf();
				ImageDraggingState = 1;	
			}
			if(ImageHandleTR.overGLBuf()) 
			{
				println("ImageHandleTR 2");
				ImageHandleTR.displayGLBuf();
				ImageDraggingState = 2;			
			}		
			if(ImageHandleBR.overGLBuf())
			{
				println("ImageHandleBR 3");
				ImageHandleBR.displayGLBuf();
				ImageDraggingState = 3;		
			}		
			if(ImageHandleBL.overGLBuf()) 
			{
				println("ImageHandleBL 4");
				ImageHandleBL.displayGLBuf();
				ImageDraggingState = 4;	
			}
			if(ImageHandleCenter.overGLBuf()) 
			{
				println("ImageHandleCenter 5");
				ImageHandleCenter.displayGLBuf();
				ImageDraggingState = 5;	//center	
			}	
			return true;			
		} //end GraphicImageResize if()
		
		
		//This prevents icons from being clicked when they shouldb't be, will need updating
		if(UserSequences[SelectedSequence].SlideFlags[SelectedFrame] == 0 && GradientDrawState == 0 && mouseYS > cWorkspaceY && UserSequences[SelectedSequence].SeqMode != mLinked)
		{
			for (int i = 0; i != CurrentPixelUsage; i++)
			{
				try {
					if (PixelIcon[i].over() && PixelIcon[i].GroupID == ViewGroupIDNum)
					{
						println("LEDIcon Pressed: "+i);	
						
						if(MouseIconRemove.Selected == true)
						{
							//right click to remove a single icon in graphic layout - Manual mode	
							println("PixelIcon "+i+" removed");
							RemoveLEDIconNum = i;
							PixelIcon[i].GroupID = cGroupOutOfBounds;		//out of bounds number
							GraphicLayoutUpdateIcons();	
							return true;
						} //end configshape image check	
						else if(MouseIconPlace.Selected == true)
						{
							println("clicked an icon, drag it");
							
							return true;
						} //end configshape image check						
						else if(EnableGroupMode.Selected == true)
						{
							//assigning group ID	
							println("Attempting to assign Group ID");	
							PixelIcon[i].GroupID = (byte)FunctionGroupIDNum;	
							GraphicLayoutUpdateIcons();
							return true;
						}	
						else if(GraphicFuncPaintButton.Selected == true) PaintColorChannel(i);														
						else
						{
							//Icon has been selected normally
							println("USED "+i+" and "+PixelIcon[i].ChanID);
							OpenedColorLEDIconID = PixelIcon[i].ChanID;	
							ColorSelector.InitPosition(0,PixelIcon[i].ChanID,SelectedFrame);
						}
						return true;
					} //end if (PixelIcon[i].over())
				}
				catch(Exception e)
				{
					break;		
				} //end catch
			} //end PixelIcon for()	
			
			if(ConfigShape == 6 && MouseIconPlace.Selected == true) //check if manual shape mode and icon place enabled
			{	
				println("Building Icon with DefinedPixelUsage: "+DefinedPixelUsage+" : "+TotalColorChannels);
				
				TempDefinedPixelUsage = DefinedPixelUsage; //store variable
				//search all icons for any with out of bounds group IDs, those were removed, store the ID number and use to build new icon
				for (int i = 0; i != DefinedPixelUsage; i++) if(PixelIcon[i].GroupID == cGroupOutOfBounds) { TempDefinedPixelUsage = i; break; }
				
				//if(DefinedPixelUsage >= TotalColorChannels) break;
				if(TempDefinedPixelUsage >= TotalColorChannels) break; //this allows removed pixels to be repopulated
				
				//checks for out of bounds
				if(mouseXS < cGLBufx || mouseYS < cWorkspaceY || mouseYS > (cWorkspaceY+cGLBufViewH)) break;

				CalcLEDSize();
				PixelIcon[TempDefinedPixelUsage] = new LEDgraphic(TempDefinedPixelUsage, mouseXS-cGLBufx, mouseYS-cWorkspaceY, LEDSize);	
				
				redraw();
				MenuTabs[0].refresh();
				PixelIcon[TempDefinedPixelUsage].GroupID = (byte)ViewGroupIDNum;
				
				if(TempDefinedPixelUsage == DefinedPixelUsage)
				{
					//run this if it didn't find a missing/removed icon
					CurrentPixelUsage++; //does this matter?
					DefinedPixelUsage++;
				}		
				return true;
			} //end configshape if()		
		} //end if()
		break;//end graphic Layout ==================================================================================================================================== 

	case 1: //timeline layout
		//================================================================== 	
		if (UserSequences[SelectedSequence].SeqMode == mLinked) 
		{
			if(pressHandlerLinkedBuffer() == true) return true;
		}
		else if(UserSequences[SelectedSequence].SeqMode == mPOV) //===================================== mPOV Actions
		{		
			if (POVModeDD.over()) return true;
			else if(POVModeDD.overOpen()) 
			{
				println("Pressed POVModeDD DropDown "+POVModeDD.SelStr);				
				UserSequences[SelectedSequence].POVUsageMode = POVModeDD.SelStr;	//set in sequence object
				return true;
			}
			
			if(POVModeButton.over())
			{
				println("Pressed Open Image File Button");
				FileBrowserAction = 4; //POV file load
				selectInput("Select an Image or MOV/AVI file to load:", "fileSelected");
				return true;
			}			
			
			if(POVPlay.over())
			{
				println("POVPlay Pressed");
				PlayVideoFlag = true;
				loop();
				return true;
			}
			
			if(POVPause.over())
			{
				println("POVPause Pressed");
				PlayVideoFlag = false;
				noLoop(); 
				redraw();
				return true;
			}			
			
			
			/*
			Automatically set when file is loaded.....
			if(POVVideoModeCheckBox.over())
			{
				POVVideoModeCheckBox.Selected =! POVVideoModeCheckBox.Selected;
				println("POVVideoModeCheckBox clicked");
			}
			*/
			
			if(POVRestart.over())
			{
				println("POVRestart Pressed");		
				PlayVideoFlag = false;
				POVVidFrame = 0; //reset
				MovieFrameCount = 0;
				DrawPOVBuffer(); //utilize video frame for display through buffer
				POVVidFrame+=(UserSequences[SelectedSequence].SeqFrameAmount+1);	
				return true;
			}			
			
			for (int i =0; i != POVOptionButtons.length; i++)
			{
				if(POVOptionButtons[i].overB())
				{
					POVOptionButtons[UserSequences[SelectedSequence].POVConfigType].Selected = false;
					UserSequences[SelectedSequence].POVConfigType = i;
					POVOptionButtons[UserSequences[SelectedSequence].POVConfigType].Selected = true;
					
					UserSequences[SelectedSequence].POVConfigType = i;	
					
					println("POVConfigType Changed: "+POVGraphicBuffer.width+" : "+POVGraphicBuffer.height);
					
					if(UserSequences[SelectedSequence].POVVideoMode == true) { ShowNotification(27); return true; }
					
					try {
						if(!CheckPOVFileDimensions(POVGraphicBuffer.width, POVGraphicBuffer.height)) return true;
						LoadPOVFile();
					}
					catch(Exception e) {
						println("LoadPOVFile() caused error, data may be null"); 
						POVImg = POVGraphicBuffer;
						LoadPOVFile();
					}
					
					return true;
				}
			}//end for()
			return false;
		} //end if mPOV
		else if(UserSequences[SelectedSequence].SeqMode  == mTech)
		{
			if (TechnicalScrollVert.over() && SelectedMenuTab == 1 && ColorPickerOpen == false) { TechnicalScrollVert.selectSlider(); return true; }
			if (TechnicalScrollHoriz.over() && SelectedMenuTab == 1 && ColorPickerOpen == false) { TechnicalScrollHoriz.selectSlider(); return true; }
			
			//Start Cell Over()
			int currentOffset = 0;
			int tempPxLength = 0;
			
			for(int i = 0; i != TotalColorChannels; i++)
			{
				if (mouseXS >= 130 && mouseXS <= 260)
				{	
					if (mouseYS >= 65+(i*cTLChBufH) && mouseYS <= 65+(i*cTLChBufH)+cTLChBufH) 
					{      
						println("Clicked Technical Select: "+i);
						
						InitTechnicalChannelRadial(i);
						return true;	
					} 
				}	
			} //end for
			
			
			for(int i = 0; i != TotalColorChannels; i++)
			{
				currentOffset = 0;	
				for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
				{	
					tempPxLength = (UserSequences[SelectedSequence].TechTime[q][i] / 10)+10;

					if (mouseXS >= 260+currentOffset && mouseXS <= 260+currentOffset+tempPxLength)
					{	
						if (mouseYS >= 65+(i*cTLChBufH) && mouseYS <= 65+(i*cTLChBufH)+cTLChBufH) 
						{      
							println("Clicked Technical Cell "+i+"   "+q);
							
							SetSelectedFrame(q);	
							InitTechnicalSelectRadial(i, q);
							return true;	
						} 
					}
					currentOffset += tempPxLength;
				}
			}
			//end Cell Over()
			return false;
		} //end mTech
		else if(UserSequences[SelectedSequence].SeqMode  == mFilePlay)
		{
			if(FilePlayLoadButton.over())
			{
				FileBrowserAction = 8; //load play file
				selectInput("Select a File To Play:", "fileSelected");	
				return true;
			}		
		} //end mFilePlay
		
		//============================  ELSE IT IS NORMAL USAGE ======================================
		
		try {
			
			if(UserSequences[SelectedSequence].SeqMode != mPOV && UserSequences[SelectedSequence].SeqMode != mLinked)
			{		
				if (TimeLineScrollBar.over() && SelectedMenuTab == 1 && ColorPickerOpen == false)  TimeLineScrollBar.selectSlider();

				if(mouseXS >= cTLChBufX && mouseXS <= (cTLChBufX+cTLGraphBufW) && mouseYS >= 35 && mouseYS <= (cTLChBufY+cTLChBufViewH))
				{	
					if(mouseYS >= cTLChBufY && mouseYS <= (cTLChBufY+cTLChBufViewH))
					{
						for (int i =0; i != TLStartIndicators.length; i++)
						{	
							if (TLStartIndicators[i].over() && mouseYS < (cTLChBufY+cTLChBufViewH))   //uses custom calculated over() 
							{
								println("Indicator: "+i);
								DraggingIndicator = true;
								DraggedIndicatorID = i;
								MenuTabs[0].refresh(); //only update graphic layout, timeline already updating
								return true;
							}
						}
					}
					//==================================================================

					for (int i =0; i != TimeLineFrameButtons.length; i++) 
					{
						if(TimeLineFrameButtons[i].over())
						{
							println("TimeLineFrameButtons: "+i);
							SetSelectedFrame(i);
							return true;
						}
					}//end for()	
					
					//detects if a cell on the timeline buffer was pressed
					for (int i =0; i != TotalColorChannels; i++) //TimeLineFrameButtons.length
					{
						for (int q =0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1); q++) 
						{	
							if(mouseXS >= cTLChBufX+35+(q*TimeLineCellSize) && mouseXS <= cTLChBufX+35+((q+1)*TimeLineCellSize))
							{
								if(mouseYS >= (cTLChBufY+(i*cTLChBufH))-TLScrollValue && mouseYS <= (cTLChBufY+((i+1)*cTLChBufH))-TLScrollValue && mouseYS < (cTLChBufViewH+cTLChBufY) && mouseYS > cTLChBufY)
								{				
									println("Selected Cell, Frame: "+q+"   ColorChannel: "+i);								
									SetSelectedFrame(q+FrameScrollBarView);	
									OpenedColorLEDIconID = i;
									
									//duplicate from LED icon click
									if(GraphicFuncPaintButton.Selected == true) PaintColorChannel(i);									
									else ColorSelector.InitPosition(0,i,q);	
									return true;					
								}
							}
						} //end q for()
					}//end i for()
				}//end mouse if()	
			}	//end if not mLinked or mPOV	
		} //end try
		catch(Exception e) 
		{ 
			println("Exception, buttons not yet created");
		}   
		//==================================================
		try {
			if(UserSequences[SelectedSequence].SeqMode != mPOV && UserSequences[SelectedSequence].SeqMode != mLinked)
			{	
				for (int i =0; i != TimeLineLabelButtons.length; i++)
				{
					if(TimeLineLabelButtons[i].overTL() && mouseYS < (cTLChBufViewH+cTLChBufY) && mouseYS > cTLChBufY)
					{
						println("Clicked TimeLineLabelButtons "+i);
						OpenedColorLEDIconID = i;
						ColorSelector.InitPosition(0,i,SelectedFrame);		
						return true;
					}
				}//end for()
			}
		}//end try
		catch(Exception e) 
		{ 
			println("Exception, TL Label buttons not yet created");
		} 
		//==================================================	
		break;
	case 2: //Connection  ==================================================================================================================================== 
		
		if (IndexScrollBar.over())  IndexScrollBar.selectSlider();

		for (int i =0; i != ConnectionButtons.length; i++)
		{
			if (ConnectionButtons[i].over() && device.HardwareID != 0)
			{		
				//ConnectionButtons[i].Selected =! ConnectionButtons[i].Selected;

				switch(i)
				{
				case 0: //Upload Sequences and Index
					ConfirmBoxIDNum = 1; //for constant and function switch()						
					break;
				case 1: //Upload Configurations, which get saved to EEPROM
					ConfirmBoxIDNum = 12; //for constant and function switch()													
					break;
				case 2:  //Reset Index
					ConfirmBoxIDNum = 4; //for constant and function switch()											
					break;
				case 3:  //Open LiveMode/ USB Control
					//ConnectionTabState = 1;
					OverlayMenuID = 1;
					OpenLiveControlMenu(); //initializes Sliders and sends command to start USB Live Control
					break;
				case 4:  //Standalone Control
					OverlayMenuID = 3;
					break;
				case 5:  //Gamma Correction Tables
					OverlayMenuID = 5;
					break;						
				}  
				return true;
			}
		}//end for()

		if (TextFields[14].over()) { TextFields[14].SelectField(); return true; }	//global intensity

		if(IntensityOverrideCheckBox.over())  return true;
		
		if(IdleSequenceIcon.over())
		{
			println("IdleSequenceIcon Selected");
			InitializeSequenceSelect(2, 0); //method 2, no ID		
			return true;
		}
		
		if(HardwarePrevIcon.over())
		{
			println("HardwarePrevIcon Selected");
			InitializeSequenceSelect(3, 0); //method 3, no ID	
			return true;
		}			
		
		if (mouseXS >= (60+596) && mouseXS <= (60+596+cSeqTileW) && mouseYS >= cWorkspaceY+((5+((IndexMapPointer+1)*cSeqTileVertSpace))-(IndexScrollBar.Value*cSeqTileVertSpace)) &&  mouseYS <= (cWorkspaceY+cSeqTileH)+((5+((IndexMapPointer+1)*cSeqTileVertSpace))-(IndexScrollBar.Value*cSeqTileVertSpace)))     
		{
			println("Add Sequence Icon Selected");
			InitializeSequenceSelect(4,0);
			return true;
		}				
		else
		{
			for (int i = 0; i != 7; i++) // the 7 is because that is how many icons can be viewed on index at a time
			{ 
				if(i >= (IndexMapPointer+1)) break;
				
				if (mouseXS >= (60+596) && mouseXS <= (60+596+cSeqTileW) && mouseYS >= cWorkspaceY+(5+(i*cSeqTileVertSpace)) &&  mouseYS <= (cWorkspaceY+cSeqTileH)+((5+(i*cSeqTileVertSpace))))     
				{
					println("Sequence Icon Selected Index ID: "+i+" with "+IndexScrollBar.Value+" = "+(i+IndexScrollBar.Value));
					if(i==0 && IndexMapPointer == 0) InitializeSequenceSelect(4,0);
					else InitializeSequenceSelect(5,(i+IndexScrollBar.Value));
					return true;
				}				
			}
		}
		break; //end connections over()s
	case 3: //software    ==================================================================================================================================== 
		//check drop downs
		
		if (ShapeOptionsDD.over()) return true;
		else if(ShapeOptionsDD.overOpen()) 
		{
			println("Pressed ShapeOptionsDD DropDown "+ShapeOptionsDD.SelStr);	

			if(ConfigShape != (ShapeOptionsDD.SelStr+1) && IconLayoutAdvancedMode.Selected == false) 
			{
				ConfigShape = (ShapeOptionsDD.SelStr+1);
				MenuTabs[0].refresh();
				//GraphicLayoutBuild(0); //rebuild if new shape was selected
			}
			else ConfigShape = (ShapeOptionsDD.SelStr+1);
			return true;
		} //end ShapeOptionsDD.overOpen()
		
		//==================================================================================================

		for (int i =0; i != SoftwareCheckBox.length; i++)
		{
			if(SoftwareCheckBox[i].over())
			{
				println("SoftwareCheckBox["+i+"] clicked");			
				if(i < 3)
				{
					LEDSizeID = i; //update golbal GUI variable
					SetLEDSizeCheckBoxes();
					CalcLEDSize(); //update LEDSize variable
					
					//apply new size to all icons
					for (int q=0; q != PixelIcon.length;q++)	
					{
						try 
						{	
							PixelIcon[q].bSize = LEDSize; 
						}
						catch(Exception e) 
						{ 
							
						}
					}			
				} //end if()
				else if(i == 7)
				{
					//square override checkbox
					
					
				}
				else
				{
					//it is the spacing checkboxes
					LEDSpacingID = i-3; //update golbal GUI variable
					SetLEDSpacingCheckBoxes();
					//how to update right away? just let it .refresh?
				}
				
				MenuTabs[0].refresh();	//redraws and init's pixels, since they may have moved X-Y
				return true;				
			} //end over() if	
		} //end SoftwareCheckBox for()
		
		//==================================================================================================
		
		for (int i =0; i != SoftwareButtons.length; i++)
		{
			if (SoftwareButtons[i].over())
			{
				println("Pressed: "+i);
				switch(i)
				{
				case 0:
					FileBrowserAction = 2; //is save
					selectOutput("Select a file to Save:", "fileSelected");
					break;
				case 1:
					FileBrowserAction = 1; //is load
					selectInput("Select a file to Load:", "fileSelected");
					break;  
				case 2:
					launch(sketchPath("README.TXT"));
					break;
				case 3: //Load Shape Image				
					if((ShapeOptionsDD.SelStr+1) != 5) return true; //if not PixelMap mode, ignore load file press
					FileBrowserAction = 6;
					println("Pressed Load Pixel Map Button");
					selectInput("Select a Pixel Map file to load:", "fileSelected");	
					break;  
				case 4: //Edit User ID
					InitializeSequenceSelect(8,0);
					break;
				case 5: //Delete Sequence
					InitializeSequenceSelect(7,0);					
					break;
				case 6:
					link("http://www.NLEDshop.com/nledaurora");
					break;
				case 7: //Duplicate Sequence
					InitializeSequenceSelect(6,0);
					break;
				case 8: //Force Load Device File
					selectInput("Select a Device file to Load:", "fileSelected");
					FileBrowserAction = 3; //is load;			
					break;
				case 9: //Clear Sequences
					ConfirmBoxIDNum = 3;	
					break;	
				case 10: //Apply User Channel Amt
					if(PApplet.parseInt(TextFields[11].Label) == 0) return true;
					ConfirmBoxIDNum = 5;
					break;						
				case 11: //800 x 600
					surface.setSize(800, 600);							
					break;						
				case 12: //1024 x 768
					surface.setSize(1024, 768);
					break;		
				case 13: //1280 x 960
					surface.setSize(1280, 960);					
					break;	
				case 14: //Reset LED Icons
					ResetLEDIcons();
					break;	
				case 15: //Apply layout to group					
					//AddToLayout();
					ConfirmBoxIDNum = 13;
					break;					
				case 16: //Merge Groups	
					ConfirmBoxIDNum = 14;							
					break;	
				case 17: //Clear Group				
					ConfirmBoxIDNum = 15;	
					break;	
				}
				return true;
			} //end switch
		} //end for
		
		//==============================================================================================	

		if(PixelAmountObject.over() > 0)
		{
			println("PixelAmountObject "+PixelAmountObject.over());
			
			switch(PixelAmountObject.over())
			{
			case 1:
				if(PixelIconAmount > 1) PixelIconAmount--;
				ObjTextField[PixelAmountObject.ObjID].Label = ""+PixelIconAmount;
				break;
			case 2:
				if(PixelIconAmount < 0xFFFF) PixelIconAmount++;	
				ObjTextField[PixelAmountObject.ObjID].Label = ""+PixelIconAmount;
				break;
			case 3:
				ObjTextField[PixelAmountObject.ObjID].SelectField();
				break;
			} //end switch
			return true;
		} //end			
		
		
		if(IconLayoutAdvancedMode.over())
		{
			applyGUIProfileAdvancedLayout();
			return true;
		} //end IconLayoutAdvancedMode.over()
		
		if(LayoutGroupDec.over())
		{
			if(FunctionGroupIDNum == 0) FunctionGroupIDNum = 7;
			else FunctionGroupIDNum--;
			return true;
		}
		if(LayoutGroupInc.over())
		{	
			if(FunctionGroupIDNum == 7) FunctionGroupIDNum = 0;
			else FunctionGroupIDNum++;
			return true;
		}		
		
		//==============================================================================================	

		if (ImagePlaceButton.over())
		{
			selectInput("Select an image file to Load:", "fileSelected");
			FileBrowserAction = 5; //is load layout image	
			return true;		
		}				
		if (ImageRemoveButton.over())
		{
			GraphicImageEnabled = false;
			GraphicImageResize = false;
			MenuTabs[0].refresh();
			return true;
		}
		if (ImageResizeButton.over() && GraphicImageEnabled == true)
		{
			GraphicImageResize =! GraphicImageResize;//DEBUG

			MenuTabs[SelectedMenuTab].Selected = false;  
			SelectedMenuTab = 0;
			MenuTabs[0].Selected = true;
			MenuTabs[0].refresh();
			return true;
		}
		if (ImageResetButton.over())
		{
			GraphicImageY = 0;
			GraphicImageX = 0;
			GraphicLayoutUpdateIcons();
			return true;
		}

		//==============================================================================================
		if (TextFields[1].over()) { TextFields[1].SelectField(); return true; }
		if (TextFields[11].over()) { TextFields[11].SelectField(); return true; }
		
		break;    
	case 4: //hardware  ==================================================================================================================================== 

		if(DeviceWebpage.over())
		{
			link(device.WebpageURL);	
			return true;	
		}
		
		if(RequestConfigurations.over())
		{
			ConfirmBoxIDNum = 19;
			return true;
		}		

		if(EnterBootloaderButton.over())
		{
			ConfirmBoxIDNum = 9;		
			return true;
		}		
		
		if(OpenTCPButton.over())
		{
			thread("OpenTCP");
			return true;
		}		
		
		if(HardwareTabUploadConfigurations.over())
		{
			ConfirmBoxIDNum = 12; //for constant and function switch()	
			return true;
		}	
		
		for (int i =0; i != COMButtons.length; i++)
		{
			if(COMButtons[i].Selected == true && COMButtons[i].overB())
			{
				CloseCOMPort();	
				return true;	
			}//end if()
			else if(COMButtons[i].Selected == false && COMButtons[i].over())
			{
				//COMButtons[i].Selected = true;//force it to always false, otherwise over() changes it
				try
				{
					OpenCOMPort(Serial.list()[i]);
				}
				catch(Exception e)// else
				{
					println("Port Stopped");
					CloseCOMPort();
				}//end catch
				return true;	
			}	
		}//end for()	
		
		//================================= START CONFIGURATION MODULES GUI ELEMENTS=================================================================
		if (HardwareColSwapDD.over() && InputModule[2].Enabled == true) return true;
		else if(HardwareColSwapDD.overOpen()) 
		{
			println("Pressed HardwareColSwapDD DropDown "+HardwareColSwapDD.SelStr);
			return true;
		}		
		//==================================================================================================
		if (PixelChipsetDD.over() && InputModule[3].Enabled == true) return true;
		else if(PixelChipsetDD.overOpen()) 
		{
			println("Pressed PixelChipsetDD DropDown "+PixelChipsetDD.SelStr);
			FuncRecommendColorShift();
			return true;
		}	
		//==================================================================================================	
		if (LEDIndicatorModeADD.over() && InputModule[9].Enabled == true) return true;
		else if(LEDIndicatorModeADD.overOpen()) 
		{
			println("Pressed LEDIndicatorModeADD DropDown "+LEDIndicatorModeADD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (LEDIndicatorModeBDD.over() && InputModule[1].Enabled == true) return true;
		else if(LEDIndicatorModeBDD.overOpen()) 
		{
			println("Pressed LEDIndicatorModeBDD DropDown "+LEDIndicatorModeBDD.SelStr);
			return true;
		}			
		//==================================================================================================	
		if (DisplayModeDD.over() && InputModule[10].Enabled == true) return true;
		else if(DisplayModeDD.overOpen()) 
		{
			println("Pressed DisplayModeDD DropDown "+DisplayModeDD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (MasterModeDD.over() && InputModule[7].Enabled == true) return true;
		else if(MasterModeDD.overOpen()) 
		{
			println("Pressed MasterModeDD DropDown "+MasterModeDD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (AutoDetectDD.over() && InputModule[11].Enabled == true) return true;
		else if(AutoDetectDD.overOpen()) 
		{
			println("Pressed AutoDetectDD DropDown "+AutoDetectDD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (PWMProfileADD.over() && InputModule[22].Enabled == true) return true;
		else if(PWMProfileADD.overOpen()) 
		{
			println("Pressed PWMProfileADD DropDown "+PWMProfileADD.SelStr);
			return true;
		}	
		//==================================================================================================	
		if (IRRemoteModeDD.over() && InputModule[23].Enabled == true) return true;
		else if(IRRemoteModeDD.overOpen()) 
		{
			println("Pressed IRRemoteModeDD DropDown "+IRRemoteModeDD.SelStr);
			return true;
		}			
		//==================================================================================================	
		if (BaudRateDD.over() && InputModule[8].Enabled == true) return true;
		else if(BaudRateDD.overOpen()) 
		{
			println("Pressed BaudRateDD DropDown "+BaudRateDD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (DMXModesDD.over() && InputModule[6].Enabled == true) return true;
		else if(DMXModesDD.overOpen()) 
		{
			println("Pressed DMXModesDD DropDown "+DMXModesDD.SelStr);
			return true;
		}	
		//==================================================================================================	
		if (AccMeterAutoDetectDD.over() && InputModule[14].Enabled == true) return true;
		else if(AccMeterAutoDetectDD.overOpen()) 
		{
			println("Pressed AccMeterAutoDetectDD DropDown "+AccMeterAutoDetectDD.SelStr);
			return true;
		}
		//==================================================================================================	
		if (AccMeterAutoDetectModeDD.over() && InputModule[14].Enabled == true) return true;
		else if(AccMeterAutoDetectModeDD.overOpen()) 
		{
			println("Pressed AccMeterAutoDetectModeDD DropDown "+AccMeterAutoDetectModeDD.SelStr);
			return true;
		}		
		//==================================================================================================	
		if (AccMeterTapDD.over() && InputModule[15].Enabled == true) return true;
		else if(AccMeterTapDD.overOpen()) 
		{
			println("Pressed AccMeterTapDD DropDown "+AccMeterTapDD.SelStr);
			return true;
		}	
		//==================================================================================================	
		if (PowerDownTimeOutDD.over() && InputModule[16].Enabled == true) return true;
		else if(PowerDownTimeOutDD.overOpen()) 
		{
			println("Pressed PowerDownTimeOutDD DropDown "+PowerDownTimeOutDD.SelStr);
			return true;
		}			
		//==================================================================================================		
		if (PWMFreqADD.over() && InputModule[20].Enabled == true) return true;
		else if(PWMFreqADD.overOpen()) 
		{
			println("Pressed PWMFreqADD DropDown "+PWMFreqADD.SelStr);
			return true;
		}			
		//==================================================================================================		
		//==================================================================================================		
		if (StandAloneADD.over() && InputModule[21].Enabled == true) return true;
		else if(StandAloneADD.overOpen()) 
		{
			println("Pressed StandAloneADD DropDown "+StandAloneADD.SelStr);
			return true;
		}			
		//==================================================================================================		

		if (HardwareCheckBox[0].over() && InputModule[8].Enabled == true) return true;//16-bit serial checkbox, not always enabled via Status
		if (HardwareCheckBox[1].over() && InputModule[19].Enabled == true) return true; //Dual Communication Mode

		//==================================================================================================
		
		if(HardwareButtons[0].over() && InputModule[0].Enabled == true) return true;//Enable/Disable RS485

		if(HardwareButtons[1].over() && InputModule[1].Enabled == true) return true;	//16 or 8 bit DMX Transmission
		
		if(HardwareButtons[2].over() && InputModule[4].Enabled == true) return true;
		
		if(HardwareButtons[3].over() && InputModule[12].Enabled == true) return true;	//gamma	 

		if(HardwareButtons[4].over() && InputModule[14].Enabled == true) return true;		

		//==================================================================================================  
		
		if (TextFields[2].over() && InputModule[5].Enabled == true) { TextFields[2].SelectField(); return true; }//DMX Address
		if (TextFields[13].over() && InputModule[21].Enabled == true) { TextFields[13].SelectField(); return true; }//StandAlone Field A		
		
		break; //end hardware tab
	} //end main switch
	
	//==================================================================================================			

	println("========= MADE IT TO THE END WITH NO CONTACTS ===============");	
	
	//if clicked with open drop down and it wasn't on the dropdown, close the dropdown	
	if(GlobalDDOpen == true) { DropDownPointer.Selected = false;	GlobalDDOpen = false; }

	return false;
}//end mousePressed()


//============================================================================================

public class DeviceObj
{
	int HardwareID; //unique hardware ID number
	String Name;	//Stores the readable name for the controller as string
	int HardwareVersion;
	int FirmwareVersion;
	int FirmwareRevision;
	int BootloaderVersion;

	//Sequence defines
	int Channels; //maximum amount of channels
	int MaxSpeed;	
	int MaxIndexedSequences;
	int IndexMemoryModel;
	int MaxFrames;
	int MaxFramesGlobal;
	
	//Memory defines
	int DataSpace;
	int HWPVSpace;
	int HPVBlockSize;
	int SeqMemoryBlockSize; 
	int IndexBlockSize; 
	int CurrentBlockSize;
	int EraseBlockSize;

	boolean LockChannelAmt; //disallow per sequence data size, only device.channels
	int GammaCorrection;
	boolean LinkedSupport;  
	boolean Bit16Mode;	//flag to set 16-bit data mode
	boolean FillUpperData;
	boolean Bit16Processor;
	boolean Bit16LiveMode;
	
	int BasicVersion;
	int BasicMaxSequences; 
	int BasicSeqLength;
	int AccelerometerMode;

	int ArrayCastSize; //can't always use device channels, because of double duty for linked variables
	
//How are these loaded differently???????????????	
	int DMXModeAmt;
	String[] DMXModeLabels;
	int ListedChipsets;

	//Not loaded from Device Files
	int UserConfiguredIDNum; //set by user saved in firwmare	
	int UserIdleSequence;	//Held is save file, sent with index
	
	//scratch
	String ConfigFlagsStr;
	String ConfigBytesStr;
	
	String WebpageURL;
	String MemorySpaceString; //stores byte to kb/mb conversion string

	DeviceObj(String iName)
	{
		HardwareID = 0;
		Name = iName;
		HardwareVersion = 0;
		FirmwareVersion = 0;
		FirmwareRevision = 0;  
		Channels = 0;
		DataSpace = 0;
		BootloaderVersion = 0;
		UserConfiguredIDNum = 0;
		UserIdleSequence = 0;

		MaxFrames = 0;
		MaxFramesGlobal = 0;
	
		MaxIndexedSequences = 8; //default, will get set when device file is loaded
		
		EraseBlockSize = 0;
		HWPVSpace = 0;
		DMXModeAmt = 0;
		GammaCorrection = 0;
		LinkedSupport = false;
		Bit16Mode = false;
		DMXModeLabels = new String[1];   
	}
} //end object

//===================================================================================================

public class UserSequenceObj
{
	String UserID; //User String Description
	int SeqListNum; //ID numbers for referencing external arrays, NO LONGER USED COULD BE REMOVED
	int Length;
	int SeqFrameAmount;
	
	int Speed;
	int DataSize; //per sequence channel amount
	int SeqMode;	//Sequence Mode

	int[] StartValues;
	int[] DataFrameVar;
	int[] SlideValues;
	int[] SlideFlags; 
	int[][] TechFlags;
	int[][] TechTime;
	int[][] DataFrames; //Data Storage array

	//General
	int SequenceIntensity;
	int SeqTransSpeed;
	int PacketCloneMode;	
	int SeqPlayMode;  
	int SeqTransitionFlags;  
	int DataType; //0 Single, 1 RGB, 2 RGBW

	//Per Sequence Mode Special
	int gradientSteps;
	
	//POV  Variables
	int POVConfigType; //rotation of image, software side only
	int POVUsageMode;	//POV Flags like gap/grid
	boolean POVVideoMode; //true = video mode
	int POVFramesAmount;
		
	//GUI Vars - not saved
	int bWidth = cSeqTileW; //static values 
	int bHeight = cSeqTileH; //static values
	int xpos;
	int ypos;
	boolean Highlighted;

	//Non-Saved Function Only - For Index Building
	boolean LinkerUtilized;
	int assignedIDNum; 
	boolean IDassigned;
	int assignedLinkedIDNum;
	int mappedROMAdr;
	boolean StartValError; 
	PGraphics previewImage;

	UserSequenceObj(String iUserID, int iSeqListNum, int iDataSize)
	{
		UserID = iUserID;
		SeqListNum = iSeqListNum;
		DataSize = iDataSize;
		
		StartValues = new int[1];
		DataFrameVar = new int[1];
		SlideValues = new int[2];
		SlideFlags = new int[2];
		DataFrames = new int[2][1];;
		
		TechFlags = new int[2][1];;
		TechTime = new int[2][1];;
		
		SeqTransSpeed = 0;
		SeqPlayMode = 0;
		SeqTransitionFlags = 0;
		SeqFrameAmount = 1;
		PacketCloneMode = 0;
		
		POVVideoMode = false;
		
		DataSize = UserChannelAmt;
		SeqMode = mFade; //default
		DataType = 1;
		Speed = 1;
		Highlighted = false;
		SequenceIntensity = 100; //default value
		gradientSteps = 1;
	} //end constructor


	public void displayIconSmall(int xposB, int yposB)
	{
		//Special display() for Linked sequences
		noStroke();
		fill(cBorderColor);
		stroke(0);
		strokeWeight(2);
		if (Highlighted == true)  stroke(cColButtonsHL);
		rect(xposB, yposB, 110, 75);
		textSize(12);
		fill(0);
		text(UserID, xposB+5, yposB+15);
		
		if(SeqMode != mLinked)	text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  

		text("Mode: "+GetSeqModeString(), xposB+5, yposB+45); 		
		image(previewImage, xposB+5, yposB+50);
	}  

	
	public void displayIcon(int xposB, int yposB)
	{
		//Special display for Idle Sequence Icon
		noStroke();
		fill(cBorderColor);
		stroke(0);
		strokeWeight(2);
		if (Highlighted == true)  stroke(cColButtonsHL);
		// else noStroke();  
		rect(xposB, yposB, bWidth, bHeight);
		textSize(12);
		fill(0);
		text(UserID, xposB+5, yposB+15);
		
		if(SeqMode != mLinked)	text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  

		text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xposB+5, yposB+45); 		
		image(previewImage, xposB+5, yposB+65);
	}  	
	
	
	public String GetSeqModeString()
	{
		//Returns Sequence Mode in readable string
		if(SeqMode == mUSB) 
		return "USB";
		if(SeqMode == mSerial) 
		return "Serial";
		if(SeqMode == mDMX) 
		return "DMX";	

		return cModeString[SeqMode];
	}
		
		
	public void display()
	{
		//display to normal buffer		
		if (Highlighted == true)  stroke(cColButtonsHL);  
		else 	stroke(0);
		
		fill(cBorderColor);	
		strokeWeight(2);		
		rect(xpos, ypos, bWidth, bHeight);
		textSize(12);
		fill(0);
		text(UserID, xpos+5, ypos+15);

		if(SeqMode != mLinked)	text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xpos+5, ypos+30);  

		text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xpos+5, ypos+45); 
	
		try {
			image(previewImage, xpos+5, ypos+65);
			
		} 
		catch(Exception e) { }
	}  //end display() 


	public void bufferDisplayIconB(int xposB, int yposB)
	{
		//special display() for index buffer
		IndexScrollBuffer.fill(cBorderColor);
		IndexScrollBuffer.stroke(0);  
		IndexScrollBuffer.rect(xposB, yposB, bWidth, bHeight);
		IndexScrollBuffer.textSize(12);
		IndexScrollBuffer.fill(0);
		IndexScrollBuffer.text(UserID, xposB+5, yposB+15);
		IndexScrollBuffer.text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xposB+5, yposB+45); 	
		if(SeqMode != mLinked)	
		{
			IndexScrollBuffer.text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
			IndexScrollBuffer.image(previewImage, xposB+5, yposB+65, bWidth*0.9f, bHeight*0.2f);
		}
	} 

	
	public boolean over()
	{
		if ( mouseXS >= (xpos) && mouseXS <= (xpos+bWidth) && mouseYS >= (ypos) && mouseYS <= (bHeight+ypos)) 
		{      
			return true;
		} 
		else {
			return false;
		}
	}
}//end class


public void InitializeSequenceSelect(int passedVal, int passedID)
{
	println("InitializeSequenceSelect("+passedVal+", "+passedID+")");
	OverlayMenuID = 4; //Sequence Selection Menu
	SequenceSelectState = passedVal; //global variable for state of Sequence Select Menu
	GlobalSequenceSelectID = passedID;
	
	SliderPointer = SequenceSelectScrollBar;
	
	SequenceSelectScrollBar.xpos =(OverlayMenus[4].xpos+OverlayMenus[4].Width) - (SequenceSelectScrollBar.slWidth+5);
	SequenceSelectScrollBar.ypos = OverlayMenus[4].ypos+50;
	SequenceSelectScrollBar.Value = 0;
	//SequenceSelectScrollBar.Maximum = ceil((UserSequences.length)/4)-5; //it works but not perfectly
	if((UserSequences.length+1) >  25) SequenceSelectScrollBar.Maximum = 1+floor(((UserSequences.length) - 25) / 5);
	else SequenceSelectScrollBar.Maximum = 0;

	SequenceSelectClose.xpos = OverlayMenus[4].xpos+OverlayMenus[4].Width-60;
	SequenceSelectClose.ypos = OverlayMenus[4].ypos+15;

	SequenceSelectAdd.xpos = OverlayMenus[4].xpos+OverlayMenus[4].Width-200;
	SequenceSelectAdd.ypos = OverlayMenus[4].ypos+15;
	
	DrawUserSeqIconBuffer(9999); //update entire buffer
	
	switch(passedVal)
	{
	case 0:
		SequenceSelectMenuString = "Select a Sequence to Edit:";	
		break;
	case 1:
		SequenceSelectMenuString = "Select a Sequence for Linked Slot #"+(passedID+1)+":";	
		break;
	case 2:
		SequenceSelectMenuString = "Select a Sequence for the Idle Slot:";
		break;
	case 3:
		SequenceSelectMenuString = "Select a Sequence for Hardware Preview:";
		break;
	case 4:
		SequenceSelectMenuString = "Select a Sequence To Add to Index:";
		break;
	case 5:
		SequenceSelectMenuString = "Select a Sequence To Place in Index:";
		break;
	case 6:
		SequenceSelectMenuString = "Select a Sequence To Duplicate:";
		break;
	case 7:
		SequenceSelectMenuString = "Select a Sequence To Delete:";
		break;	
	case 8:
		SequenceSelectMenuString = "Select a Sequence To Edit User ID:";
		break;			
	} //end switch

	PlaceSequenceIconsMenu();	
} //end InitializeSequenceSelect()

//==========================================================================================

public void PlaceSequenceIconsMenu()
{
	int column = 0;
	int row = 0;	
	
	SequenceScrollVar = (SequenceSelectScrollBar.Value*5)+1;

	int i = 0;
	for (i = SequenceScrollVar; i != (SequenceScrollVar+25); i++)
	{	
		if(i == UserSequences.length) break;
		
		UserSequences[i].xpos = OverlayMenus[4].xpos+20+(column*cSeqTileHorizSpace);
		UserSequences[i].ypos = (OverlayMenus[4].ypos+50)+(row*cSeqTileVertSpace);
		column++;		
		if(column > 4)
		{
			column = 0;
			row++;
		}	
	} //end for

	if((i-SequenceScrollVar) < 25)
	{
		if(DMXSequenceIcon.Status == 0 && SequenceSelectState == 4 || SequenceSelectState == 5) 
		{
			DMXSequenceIcon.xpos = OverlayMenus[4].xpos+20+((column*cSeqTileHorizSpace));
			DMXSequenceIcon.ypos = (OverlayMenus[4].ypos+50)+(row*cSeqTileVertSpace);
			column++;		
			if(column > 4)
			{
				column = 0;
				row++;
			}	
		}
		if(SerialSequenceIcon.Status == 0 && SequenceSelectState == 4 || SequenceSelectState == 5) 
		{	
			SerialSequenceIcon.xpos = OverlayMenus[4].xpos+20+((column*cSeqTileHorizSpace));
			SerialSequenceIcon.ypos = (OverlayMenus[4].ypos+50)+(row*cSeqTileVertSpace);
		}
	}
} //end PlaceSequenceIconsMenu()

//============================================================================================

public void txtHandleTechTime()
{
	txtHandleGenericNumber();	
	UserSequences[SelectedSequence].TechTime[SelectedFrame][SelectedTechID] = PApplet.parseInt(textFieldPtr.Label);
	DrawTechnicalBuffer();
}

public void txtHandleMultiplier()
{
	txtHandleGenericNumber();
	MultiplierToolValue = PApplet.parseInt(textFieldPtr.Label)*10;
}

public void txtGradientSteps()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].gradientSteps = PApplet.parseInt(textFieldPtr.Label);
}

public void txtHandleChannels()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].DataSize = PApplet.parseInt(textFieldPtr.Label);

	UpdateSequence(SelectedSequence);	//NOT SURE IF THIS IS BEST
	
	MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
}

public void txtHandlePixelIcon()
{
	txtHandleGenericNumber();
	PixelIconAmount = PApplet.parseInt(textFieldPtr.Label);
}

public void txtHandleSequenceIntensity()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].SequenceIntensity = PApplet.parseInt(textFieldPtr.Label);
}

public void txtLinkedIteration()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].SlideValues[SelectedFrame] = PApplet.parseInt(textFieldPtr.Label);
}

public void txtHandleUserChannelAmt()
{
	txtHandleGenericNumber();
	ConfirmBoxIDNum = 5; //for constant and function switch()
}

public void txtHandleSeqSpeed()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].Speed = PApplet.parseInt(textFieldPtr.Label);
	MenuTabs[2].refresh();
}

public void txtHandleSlideValue()
{
	txtHandleGenericNumber();
	UserSequences[SelectedSequence].SlideValues[SelectedFrame] = PApplet.parseInt(textFieldPtr.Label);
	MenuTabs[1].refresh();
}

public void txtHandleUserIDField()
{
	UserSequences[SequenceIDNum].UserID = textFieldPtr.Label;
	//DrawUserSeqIconBuffer(SequenceIDNum);
	textFieldPtr.Label = "Enter Text";
	ShowNotification(19);
	MenuTabs[2].refresh();
}

public void txtHandleLiveControlAddress()
{
	txtHandleGenericNumber();
	//textFieldPtr.Label = ""+ControlSliders[int(TextFields[4].Label)-1].Value;
}

public void txtHandleLiveControlValue()
{
	txtHandleGenericNumber();
	ControlSliders[PApplet.parseInt(TextFields[4].Label)-1].Value = PApplet.parseInt(TextFields[5].Label);
	LiveControlUpdate = true;
}

public void txtHandleFrameSpeed()
{
	txtHandleGenericNumber();
	println("NO HANDLER CODE FOR FrameSpeed");
}

public void txtHandleColorPickerFields()
{
	if(PApplet.parseInt(textFieldPtr.Label) > ColorSelectorSliders[0].Maximum) textFieldPtr.Label = ""+ColorSelectorSliders[0].Maximum; //check if over maximum
	SliderPointer.Value = PApplet.parseInt(textFieldPtr.Label); //update slider through pointer

	ColorSelector.slRed = ColorSelectorSliders[0].Value;
	ColorSelector.slGreen = ColorSelectorSliders[1].Value;
	ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
	ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
}

public void txtHandleGenericNumber()
{
	if(textFieldPtr.InputMethod > 0)
	{
		if(PApplet.parseInt(textFieldPtr.Label) > textFieldPtr.maxValue) textFieldPtr.Label = ""+textFieldPtr.maxValue;
		else if(PApplet.parseInt(textFieldPtr.Label) < textFieldPtr.minValue)  textFieldPtr.Label = ""+textFieldPtr.minValue;
	}
	textFieldPtr.Selected = false;
}

//==========================================================================================================================

class TextFieldObject
{
	int ObjID;
	int xpos;
	int ypos;
	int Height;
	int Width;
	int Size;
	int minValue;
	int maxValue;
	int Status;
	
	//constructor
	TextFieldObject(int iObjID, int ixpos, int iypos, int iSize, int iminValue, int imaxValue)
	{
		ObjID = iObjID;
		xpos = ixpos;
		ypos = iypos; 
		Size = iSize;
		minValue = iminValue;
		maxValue = imaxValue;
		
		ObjButtonMinus[ObjID] = new  Button("-", xpos, ypos, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);  	
		ObjTextField[ObjID] = new TextField(""+minValue, xpos+30, ypos, (Size*2), 25, color(255), color(200, 40, 40), 1, minValue, maxValue, true, false, cTextFieldMethods[ObjID]);
		ObjButtonPlus[ObjID] = new  Button("+", xpos+Width+85, ypos, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);  
	}

	public void setStatus(int passedVal)
	{
		Status = passedVal;
		
		if(Status == 0)
		{
			ObjTextField[ObjID].Status = 0;
			ObjButtonPlus[ObjID].Status = 0;
			ObjButtonMinus[ObjID].Status = 0;
		}	
		else if(Status == 1)
		{
			ObjTextField[ObjID].Status = 1;
			ObjButtonPlus[ObjID].Status = 1;
			ObjButtonMinus[ObjID].Status = 1;
		}			
		else
		{
			ObjTextField[ObjID].Status = 2;
			ObjButtonPlus[ObjID].Status = 2;
			ObjButtonMinus[ObjID].Status = 2;
		}
	}
	
	public void display()
	{
		ObjTextField[ObjID].display();
		ObjButtonPlus[ObjID].display();
		ObjButtonMinus[ObjID].display();
	}

	public int value()
	{
		return PApplet.parseInt(ObjTextField[ObjID].Label);
	}
	
	
	public void setValue(String passedStr)
	{
		ObjTextField[ObjID].Label = passedStr;
	}
	
	
	public int over() 
	{
		//0 none, 1 minus, 2 plus, 3 text
		if (mouseXS >= xpos && mouseXS <= xpos+((Size*4)+10) && mouseYS >= ypos && mouseYS <= ypos+Size) 
		{    
			if(ObjButtonPlus[ObjID].over()) { ObjButtonPlus[ObjID].Selected = true; return 2; }
			if(ObjButtonMinus[ObjID].over()) { ObjButtonMinus[ObjID].Selected = true; return 1; }
			if(ObjTextField[ObjID].over()) return 3;//{ ObjTextField[ObjID].SelectField(); return 3; }
		} 
		return 0;
	} //end over()
} //end classs

//================================================================	

class TextFieldObjectL
{
	int ObjID;
	int xpos;
	int ypos;
	int Height;
	int Width;
	int Size;
	int minValue;
	int maxValue;
	
	//constructor
	TextFieldObjectL(int iObjID, int ixpos, int iypos, int iSize, int iminValue, int imaxValue)
	{
		ObjID = iObjID;
		xpos = ixpos;
		ypos = iypos; 
		Size = iSize;
		minValue = iminValue;
		maxValue = imaxValue;
		
		LObjButtonMinus[ObjID] = new  Button("-", xpos, ypos, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);  	
		LObjTextField[ObjID] = new TextField(""+minValue, xpos+30, ypos, (Size*2), 25, color(255), color(200, 40, 40), 1, minValue, maxValue, true, false, "txtLinkedIteration");
		LObjButtonPlus[ObjID] = new  Button("+", xpos+Width+85, ypos, 25, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false, true);  
	}

	
	public void display()
	{
		LObjTextField[ObjID].display();
		LObjButtonPlus[ObjID].display();
		LObjButtonMinus[ObjID].display();
	}

	
	public int value()
	{
		return PApplet.parseInt(LObjTextField[ObjID].Label);
	}
	
	
	public void setValue(String passedStr)
	{
		LObjTextField[ObjID].Label = passedStr;
	}	
	
	
	public int over() 
	{
		//0 none, 1 minus, 2 plus, 3 text
		if (mouseXS >= xpos && mouseXS <= xpos+((Size*4)+10) && mouseYS >= ypos && mouseYS <= ypos+Size) 
		{    
			if(LObjButtonPlus[ObjID].over()) { LObjButtonPlus[ObjID].Selected = true; return 2; }
			if(LObjButtonMinus[ObjID].over()) { LObjButtonMinus[ObjID].Selected = true; return 1; }
			if(LObjTextField[ObjID].over()) return 3;
		} 
		return 0;
	} //end over()		
} //end class

//=======================================================================================================================	

class OverlayMenu
{
	int ObjID;
	int xpos;
	int ypos;
	int Height;
	int Width;

	//constructor
	OverlayMenu(int iObjID, int ixpos, int iypos, int ibWidth, int ibHeight)
	{
		ObjID = iObjID;
		xpos = ixpos;
		ypos = iypos;  
		Width = ibWidth;
		Height = ibHeight;
	}

	public void display()
	{
		fill(cBorderColor);
		stroke(0);
		strokeWeight(4);
		//rect(xpos, ypos, Width, Height, 20); //moved into cases, in case of round

		switch(ObjID)
		{
		case 1: //live control Rects
			rect(xpos, ypos, Width, Height, 20);
			for (int i =0; i != 4; i++)  LiveControlCheckBox[i].display();    
			fill(0);   
			textSize(12);
			text("Single - RGB - RGBW:", LiveControlCheckBox[0].xpos-10, LiveControlCheckBox[0].ypos-5);   
			text("16 Bit Mode:",  LiveControlCheckBox[3].xpos-30, LiveControlCheckBox[3].ypos-5);   
			text("The amount of channels displayed\nis changed on the software tab",  LiveControlCheckBox[3].xpos+60, LiveControlCheckBox[3].ypos);   		
			
			try {
			for (int i = 0; i != LiveConTotalColChan; i++) ControlRects[i].display();
			}
			catch(Exception e) { }
			
			LiveControlClose.display();
			LiveControlToggle.display();	
			break;
		case 2: //live control sliders
			rect(xpos, ypos, Width, Height, 20);
			textSize(14);
			fill(cWorkspaceFont); 
			
			for (int i = 0; i != ControlSliders.length; i++) 
			{
				ControlSliders[i].display();  
				text((i+1)+"", ControlSliders[i].xpos-25, ControlSliders[i].ypos+14);
			}
			
			fill(0);   
			textSize(14);
			text("Selected\nChannel:", xpos+40, ypos+20); 
			text("Channel\nValue:", xpos+170, ypos+20); 

			LiveControlClose.display();		
			LiveControlToggle.display();
			LiveControlApply.display();	
			
			TextFields[4].display(); //selected channel
			TextFields[5].display(); //selected channel value 	
			break;	
		case 3: //live stand-alone control
			rect(xpos, ypos, Width, Height, 20);
			textSize(18);
			fill(cOverlayFontColor);
			
			text("Select Sequence:\n\n\n\nAlter Speed:\n\n\nFlash Stepping:\n\n\nFade Control:", 50, 125);
			text("Color Swap:", 50, 70);
			textSize(14);
			text("Start Stalled:", StandaloneCheckBox[1].xpos-90, StandaloneCheckBox[1].ypos+15);

			text("Pauses Sequence When Stepped", 200, 275);
			text("Sequence Number:", TextFields[7].xpos-40, TextFields[7].ypos-5);
			text("Value:", TextFields[9].xpos, TextFields[9].ypos-5);

			text("Value:", StandaloneSliders[1].xpos-45, StandaloneSliders[1].ypos+12); 
			text("(1 - 65535)",  TextFields[9].xpos-5, TextFields[9].ypos+45);
			text("Multiplier: "+StandaloneSliders[2].Value, StandaloneSliders[2].xpos-90, StandaloneSliders[2].ypos+12); 

			text("All Stand-Alone Commands can be ran from custom user created programs. Any language that can interface with serial ports can work. See Command Sheet for details", OverlayMenus[3].xpos+20, 500, 350, 350);
			
			for (int i =0; i != StandaloneSliders.length; i++) StandaloneSliders[i].display();
			for (int i =0; i != StandaloneButtons.length; i++) StandaloneButtons[i].display();
			StandaloneCheckBox[1].display();
			
			StandAloneClose.display();
			
			TextFields[7].display();
			TextFields[8].display();
			TextFields[9].display();     

			stroke(cBackgroundColor);
			strokeWeight(2);
			line(440, 40, 440, 600);
			
			line(660, 40, 660, 600);		
			
			line(OverlayMenus[3].xpos, 100, 440, 100);    
			line(OverlayMenus[3].xpos, 190, 440, 190);      
			line(OverlayMenus[3].xpos, 255, 660, 255);         
			line(OverlayMenus[3].xpos, 320, 440, 320);  
			line(OverlayMenus[3].xpos, 410, 440, 410); 
			
			//	line(100, 660, 256, 660);   
			
			line(440, 100, 660, 100); //below close button	
			StandAloneDD.display();  	
			break;	
		case 4: //Sequence Selection Menu
			rect(xpos, ypos, Width, Height, 20);
			SequenceSelectClose.display();
			SequenceSelectScrollBar.display();
			SequenceSelectAdd.display();		
			fill(0);   
			textSize(18);
			text(SequenceSelectMenuString, xpos+20, ypos+30);
			
			int i = 0;
			for (i = SequenceScrollVar; i != (SequenceScrollVar+25); i++) //25 is how many sequence tiles fit on the page
			{	
				if(i == UserSequences.length) break;				
				UserSequences[i].display();
			}	
			
			if((i-SequenceScrollVar) < 25)
			{
				if(DMXSequenceIcon.Status == 0 && SequenceSelectState == 4 || SequenceSelectState == 5) 
				{
					DMXSequenceIcon.displaySq();
				}
				if(SerialSequenceIcon.Status == 0 && SequenceSelectState == 4 || SequenceSelectState == 5) 
				{	
					SerialSequenceIcon.displaySq();
				}	
			}
			break;	
			
			
		case 5: //Gamma Correction
			rect(xpos, ypos, Width, Height, 20);
			GammaOverlayCloseButton.display();
			GammaLoadFileButton.display();
			GammaUploadButton.display();
			GammaUploadDefaultButton.display();
			
			
			//display default table		
			stroke(255);
			strokeWeight(2);
			noFill();
			rect(50,294,256,256);
			stroke(0);
			for(int q = 0; q!=255; q++) point(50+q,550-cDefaultGammaTable[q]);
			
			
			//User Loaded table	
			stroke(255);
			strokeWeight(2);
			noFill();
			rect(400,294,256,256);
			stroke(0);
			for(int q = 0; q!=255; q++) point(400+q,550-UserGammaTableArray[q]);
			
			//Display Text	
			fill(0);
			textSize(14);
			text("Default Gamma Correction", 50,285);
			text("User Gamma Correction", 400,285);		
			text("Linear Value", 70,570);		
			text("Linear Value", 420,570);		
			text("Intensity/\nBrightness", 320,415);	
			text("Gamma Correction: Adjusts the linear output values(0 - 255 / 0% - 100%) to compensate for the preceived brightness of LEDs. The software generates linear values to generate"+
			" colors, applying gamma correction can more accurately display colors as they are percieved by humans. Not all LED configurations will benefit from gamma correction, and enabling"+
			"gamma correction can cause intensities to be more 'jumpy' especially at lower values. Please search online for more information.", 40,70, 600,600);
			
			text("Gamma correction is applied with a commonly used lookup table, the user may create and upload their own tables. See 'assets' folder files for more info.",40,190,600,600);
			
			break;
		case 6://Technical  Channel Select
			ellipse(xpos, ypos, Width, Height);
			for(int q=0; q!= RadialMenuTechColorMode.length;q++)
			{
				RadialMenuTechColorMode[q].display();
			}

			fill(0);
			textSize(14);
			textAlign(CENTER);
			text("Technical\nChannel:\n"+(SelectedTechID+1), OverlayMenus[6].xpos,OverlayMenus[6].ypos+15);

			break;
		case 7://Technical Color Select
			ellipse(xpos, ypos, Width, Height);
			
			RadialTechFadeButton.display();
			RadialTechSolidButton.display();	
			TXTFTechTime.display();
			
			TechnicalColorStart.display();
			TechnicalColorEnd.display();
			
			fill(0);
			textSize(14);
			textAlign(CENTER);
			text("Length:\n(millisec.)", OverlayMenus[7].xpos,OverlayMenus[7].ypos+40);
			text("Start", OverlayMenus[7].xpos-45,OverlayMenus[7].ypos);
			text("End", OverlayMenus[7].xpos+42,OverlayMenus[7].ypos);
//DEBUG	
fill(255);		
text("Flag: "+UserSequences[SelectedSequence].TechFlags[SelectedFrame][SelectedTechID], OverlayMenus[7].xpos+100,OverlayMenus[7].ypos);		
			break;		
		} //end switch
	} //end display()

	public boolean over() 
	{
		if (mouseXS >= xpos && mouseXS <= xpos+Width && mouseYS >= ypos && mouseYS <= ypos+Height) 
		{      
			return true;
		} 
		else {
			return false;
		}
	} //end over()

	
	public boolean overEllipse() 
	{
		if (mouseXS >= xpos-(Width/2) && mouseXS <= xpos+(Width/2) && mouseYS >= ypos-(Height/2) && mouseYS <= ypos+(Height/2)) 
		{      
			return true;
		} 
		else {
			return false;
		}
	} //end over()	
	
	public void mousePressed()
	{

		switch(ObjID)
		{
		case 1: //live control Rects
			for (int i = 0; i != LiveControlCheckBox.length; i++) 
			{
				if (LiveControlCheckBox[i].over())
				{
					println("LiveControlCheckBox "+i+" pressed"); 
					if(i != 3)
					{
						LiveControlCheckBox[0].Selected = false; //single
						LiveControlCheckBox[1].Selected = false; //RGB
						LiveControlCheckBox[2].Selected = false; //RGBW
						LiveControlCheckBox[i].Selected = true;
						LiveConDataType = i;

						LiveConDataMult = 1; //single
						if (LiveConDataType == 1) LiveConDataMult  = 3;
						else if (LiveConDataType == 2) LiveConDataMult  =  4;
					}
					//else checkbox #3 already selected/toggled
					OpenLiveControlMenu();
					return;
				}
			}

			for (int i = 0; i != LiveConTotalColChan; i++) 
			{
				try {
					if(ControlRects[i].over())
					{
						println("Clicked Live Control Square: "+i); 
						ColorSelector.InitPosition(3,i,0);  
						return;//break;								
					}
				}
				catch(Exception e) { println("No ControlRect");}
			}    
			break;
		case 2: //live control sliders
			for (int i = 0; i != ControlSliders.length; i++) 
			{
				if (ControlSliders[i].over())
				{
					ControlSliders[i].selectSlider();
					TextFields[4].Label = ""+(i+1);
					TextFields[5].Label = ""+ControlSliders[i].Value;
				}
			}
			
			if(LiveControlApply.over())
			{
				txtHandleLiveControlValue(); //utilize this function
				LiveControlUpdate = true;
				return;
			}
			
			if (TextFields[4].over()) TextFields[4].SelectField();   //channel address
			if (TextFields[5].over()) TextFields[5].SelectField();  //channel address	
			break;	
		case 3: //stand-alone control
			if (StandAloneDD.over()) return;
			else if(StandAloneDD.overOpen()) 
			{
				println("Pressed StandAloneDD DropDown "+StandAloneDD.SelStr);				
				return;
			}

			//====================================================  
			
			if(StandAloneClose.over()) 
			{
				//StandAloneClose.Selected = true;
				//StandAloneClose.display();
				OverlayMenuID = 0;	
			}
			
			for (int i = 0; i != StandaloneButtons.length; i++) 
			{
				if(StandaloneButtons[i].over())
				{
					//StandaloneButtons[i].Selected = true;
					println("Pressed StandAlone Button "+i);
					int temp = 0;

					switch(i)
					{
					case 0: //send colorswap
						cmdByte = cmdColShift;
						cmdData[0] = StandAloneDD.SelStr;
						cmdData[1] = 0; 
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();
						break;
					case 1: //send Select Sequence
						cmdByte = cmdSelSeq; //select sequence and stall in one
						cmdData[0] = PApplet.parseInt(TextFields[7].Label);//sequence number
						cmdData[1] = 0; //starting frame, flash only
						if(StandaloneCheckBox[1].Selected == true)  cmdData[2] = 1;  //stall flag
						else  cmdData[2] = 0;  //stall flag
						cmdData[3] = 0;  //was ignore index flag
						RequestCommand();        
						break;       
					case 2: //Send Alter Speed
						temp = PApplet.parseInt(TextFields[8].Label);

						cmdByte = cmdSpeed;     
						cmdData[0] = (temp >> 8) & 0xFF; //MSB
						cmdData[1] = temp & 0xFF; //LSB;
						cmdData[2] = 0;
						cmdData[3] = 0;  
						RequestCommand();
						println("Speed Vals: "+temp+" : "+cmdData[0]+" : "+cmdData[1]+" : "+cmdData[2]);          
						break;     
					case 3: //Step Up
						cmdByte = cmdInstStep;
						cmdData[0] = 1; //1 for up, 0 for down
						cmdData[1] = 0; 
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();     
						break;
					case 4: //Step Down
						cmdByte = cmdInstStep;
						cmdData[0] = 0; //1 for up, 0 for down
						cmdData[1] = 0; 
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();             
						break;  
					case 5: //Send Fade Control
						temp = PApplet.parseInt(TextFields[9].Label);
						println("temp = "+temp);
						cmdByte = cmdFadeControl;
						cmdData[0] = (temp >> 8) & 0xFF; //MSB
						cmdData[1] = (temp & 0x00FF); //LSB   
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();
						break;        
					case 6: //Sequence Down
						cmdByte = cmdSeqUp;
						cmdData[0] = 1; //1 for up, 0 for down
						cmdData[1] = 0; 
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();         
						break;       
					case 7: //sequence Up
						cmdByte = cmdSeqDown;
						cmdData[0] = 0; //1 for up, 0 for down
						cmdData[1] = 0;
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();         
						break;    
					case 8: // Play/Pause
						cmdByte = cmdTogglePause;
						cmdData[0] = 0; //0 to toggle, 1 to pause, 2 to play
						cmdData[1] = 0;
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();           
						break; 
					case 9: //Speed+1
						cmdByte = cmdSpeedIncrease;
						cmdData[0] = 0; //0 is value of 1, anything else is +data[0]
						cmdData[1] = 0;
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();           
						break; 					
					case 10: //Speed-1
						cmdByte = cmdSpeedDecrease;
						cmdData[0] = 0; //0 is value of 1, anything else is -data[0]
						cmdData[1] = 0;
						cmdData[2] = 0;  
						cmdData[3] = 0;  
						RequestCommand();           
						break; 						
					}
				}
			}
			
			//====================================================     
			if(TextFields[7].over()) TextFields[7].SelectField();  //select sequence
			if(TextFields[8].over()) TextFields[8].SelectField();  //speed
			if(TextFields[9].over()) TextFields[9].SelectField();  //Fade Control
			//====================================================   
			if(StandaloneCheckBox[0].over()) StandaloneCheckBox[0].Selected =! StandaloneCheckBox[0].Selected;
			if(StandaloneCheckBox[1].over()) StandaloneCheckBox[1].Selected =! StandaloneCheckBox[1].Selected;
			//====================================================   
			for (int i = 0; i != StandaloneSliders.length; i++)  if (StandaloneSliders[i].over())  StandaloneSliders[i].selectSlider(); //set variables
			//====================================================     
			break;	
		case 4: //Sequence Selection Menu

			if(SequenceSelectClose.over()) 
			{
				OverlayMenuID = 0;	 //closes overlay menu
				return;
			}
			
			if (SequenceSelectScrollBar.over())  {SequenceSelectScrollBar.selectSlider(); return;}	
			
			for (int i = 1; i != UserSequences.length; i++) //check if over() sequenceIcon
			{
				if (UserSequences[i].over())
				{	
					println("Sequence ID Pressed "+i+" with state of "+SequenceSelectState);
					OverlayMenuID = 0; //closes overlay menu
					
					switch(SequenceSelectState)
					{
					case 0:
						//Select Sequence To Edit
						MeasureSequenceLength(SelectedSequence);//update sequence size when leaving?
						
						UserSequences[SelectedSequence].Highlighted = false;
						//DrawUserSeqIconBuffer(SelectedSequence); //draw previously selected SeqIcon to undo-highlight			
						UserSequences[i].Highlighted = true;

						SelectedSequence = i;
						LoadSequence();
						//DrawUserSeqIconBuffer(i);	//seems to be required
						//println("Removed a DrawUserSeqIconBuffer() here");	
						break;
					case 1:
						//Select a Sequence for Linked Slot #"+(passedID+1);
						UserSequences[SelectedSequence].SlideFlags[SelectedLinkedID] = i; //double duty array
						println("ID set to: "+UserSequences[SelectedSequence].SlideFlags[SelectedLinkedID]);
						break;
					case 2:
						//Select a Sequence for the Idle Slot";
						//No limitation on Sequence mode
						device.UserIdleSequence = i; //Set Idle Sequence to RAM, 0 is disabled		
						break;
					case 3:
						//Select a Sequence for Hardware Preview
						println("Over HardwarePreview Rect"); 
						RequestToSendPreview(i); //send preview with ID i

						break;
					case 4: //Select a Sequence To Add to Index:
						if((IndexedSequenceLength+UserSequences[i].Length) <= device.DataSpace)
						{
							IndexMapPointer++;
							IndexMapArray[IndexMapPointer] = i;
							DrawIndexScrollArea();					
						}
						else
						{	
							println("Sequence Would Overflow the memory");
							ShowNotification(4); //out of memory/overflow	
						}	
						break;
					case 5: //Select a Sequence To Place in Index:";
						IndexMapArray[GlobalSequenceSelectID] = i;
						DrawIndexScrollArea();	
						break;
					case 6:	//Sequence Duplicate
						SequenceIDNum = i;
						SoftwareButtons[7].Selected = false;  
						DuplicateSequence();
						ShowNotification(18);
						break;
					case 7: //Sequence Delete
						ConfirmBoxIDNum = 2;
						SequenceIDNum = i;
						break;	
					case 8: //Sequence Edit User ID:
						//emulate Textfield select
						TextFields[3].SelectField();
						TextFields[3].Label = UserSequences[i].UserID;
						SequenceIDNum = i;
						break;			
					} //end switch			
					
					return;			
				} // end if over()
			} //end for()
			

			if(SequenceSelectState == 4 || SequenceSelectState == 5)
			{
				if(DMXSequenceIcon.over()) //only allow DMX sequences on non-basic devices
				{
					println("Clicked DMXSequenceIcon"); 
					
					if(SequenceSelectState == 4 )
					{
						//add to index
						if((IndexedSequenceLength+cHeaderByteLen) <= device.DataSpace)
						{
							IndexMapPointer++;
							IndexMapArray[IndexMapPointer] = cIndexDMXID;				
						}
						else
						{	
						println("Sequence Would Overflow the memory");
						ShowNotification(4); //out of memory/overflow	
						}
					}
					else 	//SequenceSelectState = 5;
					{
					IndexMapArray[GlobalSequenceSelectID] = cIndexDMXID;								
					}
		
					DrawIndexScrollArea();	
					OverlayMenuID = 0; //closes overlay menu					
					return;			
				}

				if(SerialSequenceIcon.over()) //only allow serial sequences on non-basic devices
				{
					println("Clicked SerialSequenceIcon"); 
					if(SequenceSelectState == 4 )
					{
						//add to index					
						if((IndexedSequenceLength+cHeaderByteLen) <= device.DataSpace)
						{
							IndexMapPointer++;
							IndexMapArray[IndexMapPointer] = cIndexSerialID;				
						}
						else
						{	
						println("Sequence Would Overflow the memory");
						ShowNotification(4); //out of memory/overflow	
						}	
					}
					else 	//SequenceSelectState = 5;
					{
					IndexMapArray[GlobalSequenceSelectID] = cIndexSerialID;								
					}
					
					DrawIndexScrollArea();			
					OverlayMenuID = 0; //closes overlay menu
					return;
				} 
			}
			
			if(SequenceSelectAdd.over())
			{
				println("Attempting to Add Sequence "+UserSequences.length);
				if (UserSequences.length < cSoftwareMaxSequences+1) //Sequence 0 is never used or seen
				{
					AddSequence();
					OverlayMenuID = 0;
					return;
				}//end if()
				else
				{
					ShowNotification(20);
					return;
				}
			}
			break;
		case 5: //Gamma Correction

			if(GammaUploadDefaultButton.over())
			{	
				GammaUploadDefaultButton.Selected = true;	
				ConfirmBoxIDNum = 17;
				return;
			}
			
			if(GammaOverlayCloseButton.over())
			{	
				GammaOverlayCloseButton.Selected = true;	
				OverlayMenuID = 0;	 //closes overlay menu
				return;
			}
			
			if(GammaUploadButton.over())
			{	
				GammaUploadButton.Selected = true;	
				ConfirmBoxIDNum = 18;
				return;
			}		
			
			if(GammaLoadFileButton.over())
			{		
				GammaLoadFileButton.Selected = true;
				FileBrowserAction = 7;
				println("Pressed Load  Gamma Correction File Button");
				selectInput("Select a Gamma Correction file to load:", "fileSelected");	
				return;
			}
			
			break;		
		case 6:
			for(int q=0; q != RadialMenuTechColorMode.length;q++)
			{
				if(RadialMenuTechColorMode[q].over())
				{
					RadialMenuTechColorMode[0].Selected = false;
					RadialMenuTechColorMode[1].Selected = false;
					RadialMenuTechColorMode[2].Selected = false;
					RadialMenuTechColorMode[q].Selected = true;
					println("pressed tech color mode");
					//clear colormode flags

					//Apply to all frames of that SelectedTechID
					for (int z = 0; z != UserSequences[SelectedSequence].SeqFrameAmount+1; z++)
					{
					UserSequences[SelectedSequence].TechFlags[z][SelectedTechID] = UserSequences[SelectedSequence].TechFlags[z][SelectedTechID] & 0xF8; //clear color flags
					if(q == 0) UserSequences[SelectedSequence].TechFlags[z][SelectedTechID] = UserSequences[SelectedSequence].TechFlags[z][SelectedTechID];
					else if(q == 1) UserSequences[SelectedSequence].TechFlags[z][SelectedTechID] |= 0x01;
					else if(q == 2) UserSequences[SelectedSequence].TechFlags[z][SelectedTechID] |= 0x02;
						
					}		
					
					RadialMenuTechColorMode[getTechChanColorMode(SelectedTechID)].Selected = true; 
					DrawTechnicalBuffer();
					return;
				}
			}
			
			if(!overEllipse()) OverlayMenuID = 0; //close
			break;
		case 7: //Technical Color Select
			if(RadialTechSolidButton.over())
			{
				println("Pressed RadialTechSolidButton");
				RadialTechSolidButton.Selected = true;
				RadialTechFadeButton.Selected = false;
				UserSequences[SelectedSequence].TechFlags[SelectedFrame][SelectedTechID] &= 0xF7; //clear seqmode bit 
				DrawTechnicalBuffer();
				return;
			}
		
			if(RadialTechFadeButton.over())
			{
				println("Pressed RadialTechFadeButton");
				RadialTechFadeButton.Selected = true;
				RadialTechSolidButton.Selected = false;
				UserSequences[SelectedSequence].TechFlags[SelectedFrame][SelectedTechID] |= 0x08; //set seqmode bit 
				DrawTechnicalBuffer();
				return;				
			}
			
			if(TechnicalColorStart.over())
			{	
			ColorSelector.InitPosition(4,getTechChannelNum(SelectedTechID),SelectedTechFrame);	
			return;			
			}
			
			if(TechnicalColorEnd.over())
			{				
			ColorSelector.InitPosition(4,getTechChannelNum(SelectedTechID),SelectedTechFrame+1);	
			return;
			}

			if(TXTFTechTime.over()) { TXTFTechTime.SelectField(); return; } 
			
			if(!overEllipse()) OverlayMenuID = 0; //close
			break;	
		} //end switch
		
		if(ObjID == 1 || ObjID == 2)
		{
			if (LiveControlToggle.over())
			{
				println("Pressed Toggle Live Menu States");
				if(OverlayMenuID == 1) 
				{
					OverlayMenuID = 2; //Live control squares

					//Color Rect Selection is 16-bit only on 16-bit capable controllers
					cmdByte = cmdBulkLiveControl; //Live Control Connection
					cmdData[0] = 1; //Enable Live Control
					
					if(LiveControlCheckBox[3].Selected == true) cmdData[1] = 1; //16-bit mode
					else cmdData[1] = 0; //8-bit mode
					
					cmdData[2] = (UserChannelAmt >> 8) & 0xFF;  
					cmdData[3] = UserChannelAmt & 0xFF;  
					RequestCommand();  
				}
				else OverlayMenuID = 1;
			} 
			if (LiveControlClose.over()) 
			{
				OverlayMenuID = 0;
				CloseLiveControlMenu();
			} 
		} //end if	
	} //end mouse pressed
} //end overlayMenu class

//================

 //Movie Functions
 /*  
int getFrame() {    
  return ceil(moviePOV.time() * 30) - 1;
}

	void setFrame(int n) {
  moviePOV.play();
    
  // The duration of a single frame:
  float frameDuration = 1.0 / moviePOV.frameRate;
    
  // We move to the middle of the frame by adding 0.5:
  float where = (n + 0.5) * frameDuration; 
    
  // Taking into account border effects:
  float diff = moviePOV.duration() - where;
  if (diff < 0) {
    where += diff - 0.25 * frameDuration;
  }
    
  moviePOV.jump(where);
  moviePOV.pause();  
}  
 */
 
public int getLength() {
  return PApplet.parseInt(moviePOV.duration() * moviePOV.frameRate);
}

public void movieEvent(Movie m) 
{
	//println("movieEvent");
println("Loop: "+(MovieFrameCount+1)+"   with "+POVVidFrame);	
    moviePOV.read();
	POVImg = moviePOV;

	if(HoldMovieTranscribe == true)
	{
	println("Hold Movie Transcribing");
	return;		
	}
	
	LoadPOVFile(); //loads POVImg into DataFrames
	
	//Increment variables
	POVVidFrame+=(UserSequences[SelectedSequence].SeqFrameAmount+1);	
	MovieFrameCount++;
	
	if(MovieFrameCount == PApplet.parseInt(getLength()))
	{
		//done transcribing
		println("Done Transcribing");
		POVVidFrame = 0;
		MovieFrameCount = 0;
		//can not change state(ie: close) from streamer thread
		TranscribingFinished = true; //flag to run other functions in draw, otherwise freezes this thread
		HoldMovieTranscribe = true;
		redraw();
	} //end if()
} //end movieEvent

public void POVFileLoadFunc()
{
	println("POVFileLoadFunc()");
	HoldMovieTranscribe = false;
	
	if(SelectedFilePath.endsWith(".mov") ||SelectedFilePath.endsWith(".avi")) 
	{				
	//init variables
	POVVideoModeCheckBox.Selected = true;
	UserSequences[SelectedSequence].POVVideoMode = true; // save flag
	POVVidFrame = 0;
	MovieFrameCount = 0;
	HoldMovieTranscribe = true; //prevents it from saving data until eveything is cast and setup
	
	//init movie, have to let it start playing in order to pull info, need all those
	moviePOV = new Movie(this, SelectedFilePath);
	moviePOV.play();
	moviePOV.noLoop();			
	moviePOV.jump(0);
	moviePOV.pause();			
	
	println("Using POV Video Mode at Framerate: "+moviePOV.frameRate+"    Width: "+moviePOV.width+"  Height: "+moviePOV.height);					
	//save remaining frames to RAM

	if(!CheckPOVFileDimensions(moviePOV.width,moviePOV.height)) return; //if too large, return for now and show the notification	
	//also updates seqframeamount
	
	//Has to play the movie file in order to read()	
	UserSequences[SelectedSequence].POVFramesAmount = (UserSequences[SelectedSequence].SeqFrameAmount+1) * PApplet.parseInt(getLength());
	println("Frame Amt for video pov: "+UserSequences[SelectedSequence].POVFramesAmount+"    "+PApplet.parseInt(getLength()));

	
	//resize dataframes[][] - runs since seqframeamount and POVvidframes are different
	UserSequences[SelectedSequence].DataFrames = (int[][])expand(UserSequences[SelectedSequence].DataFrames, UserSequences[SelectedSequence].POVFramesAmount);
	for(int i = 0; i != UserSequences[SelectedSequence].POVFramesAmount; i++)
	{
	UserSequences[SelectedSequence].DataFrames[i] = new int[device.Channels];	
	}
	
	POVVidFrame = 0;
	MovieFrameCount = 0;
	HoldMovieTranscribe = false;
	moviePOV.jump(0);
	moviePOV.play();
	}
	else
	{
	//else wrong file type
	POVVideoModeCheckBox.Selected = false;	
	UserSequences[SelectedSequence].POVVideoMode = false;
	POVImg = loadImage(SelectedFilePath);
	
	if(!CheckPOVFileDimensions(POVImg.width,POVImg.height)) return; //if too large, return for now and show the notification		
				
	if(POVImg == null) { println("POVImg = null"); POVImg = createGraphics(1,1); } //make default/dummy image
		
	LoadPOVFile();
	}
}	//end POVFileLoadFunc()

//================================================================================================

public boolean CheckPOVFileDimensions(int passedW, int passedH)
{	
	println("CheckPOVFileDimensions() with "+passedW+"w & "+passedH+"h");

	int holdW = passedW;
	int holdH = passedH;
	
	//update, normally done in UpdateSequence.....		
	CurrentDataTypeMult = 1; //single
	if (UserSequences[SelectedSequence].DataType == 1) CurrentDataTypeMult  = 3;
	else if (UserSequences[SelectedSequence].DataType == 2) CurrentDataTypeMult  =  4;  				
					
		
	switch(UserSequences[SelectedSequence].POVConfigType)
	{
	case 0: //"First Pixel On The Left. Rows Are Displayed Top To Bottom." - "Width Is Amount Of Pixels, Height Is Frames."
		if(UserSequences[SelectedSequence].POVVideoMode == true) passedH = UserSequences[SelectedSequence].POVFramesAmount;
	
		if((passedW > (device.Channels / CurrentDataTypeMult)) || passedH > device.MaxFramesGlobal)
		{
		println("Error Loading, File Width or Height is too large of POVConfigType");

		//Post notification
		ShowNotification(26);
		return false;
		}
		
		if(UserSequences[SelectedSequence].POVVideoMode == true) passedH = holdH; //put back so doesn't change			
		UserSequences[SelectedSequence].SeqFrameAmount = passedH-1;
		UserSequences[SelectedSequence].DataSize = passedW * CurrentDataTypeMult;	
		break;
	case 1: //"First Pixel Is Bottom Left. Columns Are Displayed Left To Right." - "Height is Amount Of Pixels, Width is Frames"
	
		if(UserSequences[SelectedSequence].POVVideoMode == true) passedW = UserSequences[SelectedSequence].POVFramesAmount;
	
		if((passedH > (device.Channels / CurrentDataTypeMult)) || passedW > device.MaxFramesGlobal)
		{
		println("Error Loading, File Width or Height is too large of POVConfigType");

		//Post notification
		ShowNotification(26);
		return false;
		}
		
		if(UserSequences[SelectedSequence].POVVideoMode == true) passedW = holdW; //put back so doesn't change
		UserSequences[SelectedSequence].SeqFrameAmount = passedW-1;
		UserSequences[SelectedSequence].DataSize = passedH * CurrentDataTypeMult;			
		break;
	case 2: //"First Pixel Is On The Right. Rows Are Displayed Top To Bottom." - "Width Is Amount Of Pixels, Height Is Frames."

		if(UserSequences[SelectedSequence].POVVideoMode == true) passedH = UserSequences[SelectedSequence].POVFramesAmount;	
	
		if((passedW > (device.Channels / CurrentDataTypeMult)) || passedH > device.MaxFramesGlobal)
		{
		println("Error Loading, File Width or Height is too large of POVConfigType");

		//Post notification
		ShowNotification(26);
		return false;
		}

		if(UserSequences[SelectedSequence].POVVideoMode == true) passedH = holdH; //put back so doesn't change		
		UserSequences[SelectedSequence].SeqFrameAmount = passedH-1;
		UserSequences[SelectedSequence].DataSize = passedW * CurrentDataTypeMult;		
		break;
	case 3: //"First Pixel Is Top Left. Columns Are Displayed Left To Right." - "Height is Amount Of Pixels, Width is Frames"

		if(UserSequences[SelectedSequence].POVVideoMode == true) passedW = UserSequences[SelectedSequence].POVFramesAmount;	
	
		if((passedH > (device.Channels / CurrentDataTypeMult)) || passedW > device.MaxFramesGlobal)
		{
		println("Error Loading, File Width or Height is too large of POVConfigType");

		//Post notification
		ShowNotification(26);
		return false;
		}
		
		if(UserSequences[SelectedSequence].POVVideoMode == true) passedW = holdW; //put back so doesn't change
		UserSequences[SelectedSequence].SeqFrameAmount = passedW-1;
		UserSequences[SelectedSequence].DataSize = passedH * CurrentDataTypeMult;	
		break;		
	} //end switch	
	
	//update TotalColorChannels
	if (UserSequences[SelectedSequence].DataType == 0) TotalColorChannels = UserSequences[SelectedSequence].DataSize;
	else TotalColorChannels = UserSequences[SelectedSequence].DataSize / CurrentDataTypeMult;	
	
	UpdateSideBarButtonStates();
	ResizeSequenceFrameAmt(SelectedSequence);
	
	return true;	
} //end func


public void LoadPOVFile()
{
	//loads file, reads the data and moves it into dataframes[][]	
	int x = 0;

	CurrentPOVW = POVImg.width;		
	CurrentPOVH = POVImg.height;
	int tempColor;

	if(POVVideoModeCheckBox.Selected == false) println("Loading POV from width: "+POVImg.width+" : height: "+POVImg.height);
	if(POVVideoModeCheckBox.Selected == false) POVVidFrame = 0;

	//fill DataFrames based on POVConfigType
	switch(UserSequences[SelectedSequence].POVConfigType)
	{
	case 0: //"First Pixel On The Left. Rows Are Displayed Top To Bottom." - "Width Is Amount Of Pixels, Height Is Frames."

		for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
		{
			x = 0;
			for(int i = TotalColorChannels-1; i >= 0; i--)
			{
				tempColor = POVImg.get(i,q);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
				x+=3;
			} //end for()
		}//end for()
		break;
	case 1: //"First Pixel Is Bottom Left. Columns Are Displayed Left To Right." - "Height is Amount Of Pixels, Width is Frames"
		
		//UserSequences[SelectedSequence].SeqFrameAmount = CurrentPOVW-1;
		//UserSequences[SelectedSequence].DataSize = CurrentPOVH * CurrentDataTypeMult;		
		
		for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
		{
			x = 0;
			for (int i=0; i != TotalColorChannels;i++)
			{
				tempColor = POVImg.get(q,i); //swapped vs mode 0
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
				x+=3;
			} //end for()
		}//end for()	
		break;
	case 2: //"First Pixel Is On The Right. Rows Are Displayed Top To Bottom." - "Width Is Amount Of Pixels, Height Is Frames."

		//UserSequences[SelectedSequence].SeqFrameAmount = CurrentPOVH-1;
		//UserSequences[SelectedSequence].DataSize = CurrentPOVW * CurrentDataTypeMult;
		
		for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
		{
			x = 0;
			for (int i=0; i != TotalColorChannels;i++)
			{
				tempColor = POVImg.get(i,q);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
				x+=3;
			} //end for()
		}//end for()
		break;
	case 3: //"First Pixel Is Top Left. Columns Are Displayed Left To Right." - "Height is Amount Of Pixels, Width is Frames"
	
		//UserSequences[SelectedSequence].SeqFrameAmount = CurrentPOVW-1;
		//UserSequences[SelectedSequence].DataSize = CurrentPOVH * CurrentDataTypeMult;	
		
		//println("LoadPOV TotalColorChannels: "+TotalColorChannels+" : SeqFrameAmt: "+UserSequences[SelectedSequence].SeqFrameAmount);
		
		for (int q=0; q != (UserSequences[SelectedSequence].SeqFrameAmount+1);q++)
		{
			x = 0;
			for (int i=TotalColorChannels-1; i >= 0;i--)
			{
				tempColor = POVImg.get(q,i); //swapped vs mode 0
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
				UserSequences[SelectedSequence].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
				x+=3;
			} //end for
		}//end for
		break;		
	} //end switch
	
/* 
	//POVs use neither of these.....
	for (int q=0; q != UserSequences[SelectedSequence].DataSize;q++)
	{
		UserSequences[SelectedSequence].DataFrameVar[q] = 0;
		UserSequences[SelectedSequence].StartValues[q] = 0;			
	}
*/	

	if(POVVideoModeCheckBox.Selected == false) DrawPOVBuffer(); //update buffer
} //end func


//====================================================================================================================================

public boolean pressHandlerLinkedBuffer()
{
	//check if over drag and drop rects
	if (LinkedScrollBar.over())	{ LinkedScrollBar.selectSlider();  return true; }

	for (int i = 0; i != 5; i++)
	{
		if (mouseXS >= (60+cTLChBufX) && mouseXS <= (60+110+cTLChBufX) && mouseYS >= cWorkspaceY+((40+(i*cLinkedRoWHeight))-LinkedScrollBar.Value) &&  mouseYS <= (cWorkspaceY+70)+((45+(i*cLinkedRoWHeight))-LinkedScrollBar.Value))     
		{
			println("Clicked the Linked Icon! "+i+" : "+UserSequences[SelectedSequence].SeqFrameAmount);
			SelectedLinkedID = i+LinkedScrollBar.Value;
			InitializeSequenceSelect(1, SelectedLinkedID); //Sequence Selection Menu
			return true;
		}
	}//end for()	
	
	//==================================================================    
	
	int temp = 0;
	
	try 
	{
		//Cycles through the check boxes looking for a click
		// if a box is clicked it clears all 4 for that frame, then sets the clicked one and saves the result
		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1)*4; i++)
		{     
			if (LinkedCheckBox[i].over())
			{
				println("Over Linked Check Box: "+i+" : "+(i%4));

				temp = i+(LinkedScrollBar.Value*4);
				
				LinkedCheckBox[((i/4)*4)].Selected = false;  
				LinkedCheckBox[((i/4)*4)+1].Selected = false;  
				LinkedCheckBox[((i/4)*4)+2].Selected = false;  
				LinkedCheckBox[((i/4)*4)+3].Selected = false;  
				
				//Instant, Fast Fade Up/Down, Slow Fade Up/Down, ... , ... , ... , .... , PerSequence		
				switch((temp%4))
				{
				case 0:	//instant
					UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)] = 0;
					break;
				case 1: //fast fade
					UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)] = 1;	
					break;	
				case 3: //slow fade
					UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)] = 2;	
					break;
				case 2:	
				case 7: //per sequence
					UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)] = 7;
					break;							
				}
				
				if(LinkedTimerCheckBox[ceil(temp/4)].Selected == true) 
				{
					UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)] |= 0x80;	//set MSB							
				}
				
				println("Saved as: "+binary(UserSequences[SelectedSequence].DataFrameVar[ceil(temp/4)]));			
				return true;
			}
		}//end for()
		}
	catch(Exception e) {  }    	
	
	try 
	{
		for (int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1); i++)
		{
			if(LinkedTimerCheckBox[i].over())
			{
				temp = i+(LinkedScrollBar.Value);	
				
				if(LinkedTimerCheckBox[i].Selected == false)
				{
					UserSequences[SelectedSequence].DataFrameVar[temp] &= 0x7F;	//clear MSB		
				}
				else
				{
					UserSequences[SelectedSequence].DataFrameVar[temp] |= 0x80;	//set MSB		
				}
				
				println("Saved as: "+binary(UserSequences[SelectedSequence].DataFrameVar[temp]));
			} //end if()
		}//end for()
	}
	catch(Exception e) {  }     
	
	//============================================================================================================================
	
	try 
	{
		for (int i = 0; i != UserSequences[SelectedSequence].SeqFrameAmount+1; i++)
		{    	
			if(LinkedTextFieldObject[i].over() > 0)
			{
				SelectedFrame = i+LinkedScrollBar.Value;
				println("LinkedTextFieldObject["+i+"] "+LinkedTextFieldObject[i].over()+" Using : "+SelectedFrame);

				TextFieldActive = false; //incase it is selected or other is, it will clear it
				textFieldPtr.Selected = false;		
				
				switch(LinkedTextFieldObject[i].over())
				{
				case 1: //minus
					if(UserSequences[SelectedSequence].SlideValues[SelectedFrame] > LinkedTextFieldObject[i].minValue) UserSequences[SelectedSequence].SlideValues[SelectedFrame]--;
					LObjTextField[LinkedTextFieldObject[i].ObjID].Label = ""+UserSequences[SelectedSequence].SlideValues[SelectedFrame];	
					break;
				case 2: //add				
					if(UserSequences[SelectedSequence].SlideValues[SelectedFrame] < LinkedTextFieldObject[i].maxValue) UserSequences[SelectedSequence].SlideValues[SelectedFrame]++;
					LObjTextField[LinkedTextFieldObject[i].ObjID].Label = ""+UserSequences[SelectedSequence].SlideValues[SelectedFrame];	
					break;
				case 3:
					LObjTextField[LinkedTextFieldObject[i].ObjID].SelectField();
					break;
				} //end switch
				return true;
			} //end if()
		}	//end for()
	}
	catch(Exception e) {  }   
	
	return false;
}// end pressHandlerDraggingIcon()

//====================================================================================================================================

public boolean pressHandlerFrameButtonOptions()
{
	//UPDATE WITH ANY MORE USAGES THAT WON'T USE THE BUTTONS

	//When no buttons are shown
	if(AddFrame.over()) 	//===========================================================================================================
	{	
		println("AddFrame button pressed");
		
		if (UserSequences[SelectedSequence].SeqFrameAmount != (device.MaxFrames-1))  
		{
			UserSequences[SelectedSequence].SeqFrameAmount++;
			ResizeSequenceFrameAmt(SelectedSequence);
		}

		if (UserSequences[SelectedSequence].SeqMode == mLinked)
		{
			if(device.BasicVersion > 0 && device.LinkedSupport == true)
			{
				if(UserSequences[SelectedSequence].SeqFrameAmount > 8) 
				{
					UserSequences[SelectedSequence].SeqFrameAmount = 8;
					ShowNotification(14);
				}
			}
			InitLinkedBuffer();
			return true;
		} //end mLinked if()
		
		//puts the new frame into view
		if(UserSequences[SelectedSequence].SeqFrameAmount > 10) 
		{
			FrameScrollBarView++;	
			if(UserSequences[SelectedSequence].SeqFrameAmount > (FrameScrollBarView-10)) FrameScrollBarView = UserSequences[SelectedSequence].SeqFrameAmount-10;	
		}
		
		if (SelectedFrame < UserSequences[SelectedSequence].SeqFrameAmount)
		{  
			SetSelectedFrame(UserSequences[SelectedSequence].SeqFrameAmount);
		}
		else SetSelectedFrame(SelectedFrame);
		
		MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag  
		GraphicLayoutUpdateIcons();	//change v2c from	refresh
		return true;
	} //end add frame
	
	if(RemoveFrame.over()) 	//===========================================================================================================
	{	
		println("RemoveFrame button pressed");	
		
		if (UserSequences[SelectedSequence].SeqFrameAmount != 1)  UserSequences[SelectedSequence].SeqFrameAmount--; 
		
		FrameScrollBarView--;
		if(FrameScrollBarView < 0) FrameScrollBarView = 0;			
		
		if (SelectedFrame > UserSequences[SelectedSequence].SeqFrameAmount)
		{    
			SetSelectedFrame(UserSequences[SelectedSequence].SeqFrameAmount);
		}
		else SetSelectedFrame(SelectedFrame);
		
		if (UserSequences[SelectedSequence].SeqMode == mLinked) InitLinkedBuffer(); 

		MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag  
		GraphicLayoutUpdateIcons();	//change v2c from	refresh[0]
		return true;	
	} //end removeframe
	
	//===========================================================================================================
	
	if(IncFrameBar.over())
	{	
		AdjustFrameButtonView(1);
		return true;
	}
	
	if(DecFrameBar.over())
	{	
		AdjustFrameButtonView(0);
		return true;
	}
	
	//=================================================================

	if (UserSequences[SelectedSequence].SeqMode == mGradient)
	{
		for (int i = 0; i != GradientRects.length; i++) 
		{
			try {
				if (GradientRects[i].over())
				{
					println("Pressed Rect: "+i);
					SetSelectedFrame(i+FrameScrollBarView);
					ColorSelector.InitPosition(0,0,i); //Color All Gradient Usage
					
					MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag  
					GraphicLayoutUpdateIcons();	//change v2c from refresh
					return true; //was break;
				}
			}
			catch(Exception e) {
			}
		}
	}
	else
	{	
		for (int i = 0; i != FrameButtons.length; i++)
		{
			if (FrameButtons[i].over())
			{
				if(i+FrameScrollBarView > UserSequences[SelectedSequence].SeqFrameAmount) return false;				
				println("FrameButtons "+i+" pressed "); 

				SetSelectedFrame(i+FrameScrollBarView); 					
				GraphicLayoutUpdateIcons();	//change v2c from refresh
				return true; //was break;
			} //end if
		} //end for()
	}

	if(GroupIDDecf.over())
	{
		if(ViewGroupIDNum == 0) ViewGroupIDNum = 7;
		else ViewGroupIDNum--;
		GraphicLayoutUpdateIcons();
		return true;
	}
	
	if(GroupIDIncf.over())
	{
		if(ViewGroupIDNum == 7) ViewGroupIDNum = 0;
		else ViewGroupIDNum++;
		GraphicLayoutUpdateIcons();
		return true;
	}

	return false;
} //end pressHandlerFrameButtonOptions()

//====================================================================================================================================

public boolean pressHandlerToolsMenu()
{	

	if(StartValReset.over() && TimeLineBuffer != null)
	{
		ConfirmBoxIDNum = 16;
		return true;
	} //end if()

	if(GradientMultiplierObject.over() > 0)
	{
		println("GradientMultiplierObject "+GradientMultiplierObject.over()+"    "+MultiplierToolValue);
		
		switch(GradientMultiplierObject.over())
		{
		case 1:
			if(MultiplierToolValue > GradientMultiplierObject.minValue) MultiplierToolValue--;
			ObjTextField[GradientMultiplierObject.ObjID].Label = ""+((float)MultiplierToolValue/10);	
			break;
		case 2:
			if(MultiplierToolValue < (GradientMultiplierObject.maxValue*10)) MultiplierToolValue++;
			ObjTextField[GradientMultiplierObject.ObjID].Label = ""+((float)MultiplierToolValue/10);	
			break;
		case 3:
			ObjTextField[GradientMultiplierObject.ObjID].SelectField();
			break;
		} //end switch
		return true;
	} //end				
	

	if(GradientStepsObject.over() > 0)
	{
		//println("GradientStepsObject "+GradientStepsObject.over());	
		switch(GradientStepsObject.over())
		{
		case 1:
			if(UserSequences[SelectedSequence].gradientSteps > GradientStepsObject.minValue) UserSequences[SelectedSequence].gradientSteps--;
			ObjTextField[GradientStepsObject.ObjID].Label = ""+UserSequences[SelectedSequence].gradientSteps ;
			break;
		case 2:
			if(UserSequences[SelectedSequence].gradientSteps < GradientStepsObject.maxValue) UserSequences[SelectedSequence].gradientSteps++;	
			ObjTextField[GradientStepsObject.ObjID].Label = ""+UserSequences[SelectedSequence].gradientSteps;
			break;
		case 3:
			ObjTextField[GradientStepsObject.ObjID].SelectField();
			break;
		} //end switch
		return true;
	} //end			
	
	
	if (GradientGenerate.over())
	{
		GenerateGradient();
		return true;
	}		
	
	for (int i =0; i != PaintRects.length; i++)
	{
		if(PaintRects[i].over())
		{
			//if already selected open color picker, otherwiset just select color		
			if(PaintRectID == i)
			{
				println("Paint Rect Pressed - Choose Color");
				PaintColorPick = true;
				ColorPickerOpen = true;  
				ColorSelector.InitPosition(0,0,0);		
			}
			else
			{
				PaintRectID = i;
				//updates paint value with current value
				PaintColor[0] = PaintRects[PaintRectID].Red;
				PaintColor[1] = PaintRects[PaintRectID].Green;
				PaintColor[2] = PaintRects[PaintRectID].Blue;				
				PaintColor[3] = PaintRects[PaintRectID].White;
			}
		} //end if
	} //end for
	
	if (GraphicFuncPaintButton.over())
	{			
		if(UserSequences[SelectedSequence].SeqMode == mGradient) { ShowNotification(11); return true; }

		if(GraphicFuncPaintButton.Selected == true) println("Enable Painting");
		return true;
	}		
	else if (MainToolsColorGroup.over())
	{
		println("Apply Color to Group");

		if(UserSequences[SelectedSequence].SeqMode == mGradient) { ShowNotification(11); return true; }
		GraphicFuncPaintButton.Selected = false;		//compatible
		ColorSelector.InitPosition(2,0,0);	//color group	
		return true;
	}		
	else if (MainToolsAllSame.over())
	{
		println("Apply Color to All");
		GraphicFuncPaintButton.Selected = false;	//compatible		
		ColorSelector.InitPosition(1,0,SelectedFrame); //color all
		return true;
	}
	else if(MainToolsShowStartValues.over())
	{
		if(MainToolsShowStartValues.Selected == true) MainToolsShowStartValues.Label = "Hide Color Icons";
		else MainToolsShowStartValues.Label = "Show Color Icons";
		MenuTabs[0].refresh();
		return true;
	}
	else if(GradientDrawRadialButton.overB())
	{
		if(GradientDrawRadialButton.Selected == true)
		{
			GradientDrawRadialButton.Selected = false;	//compatible
			GradientDrawState = 0;
			return true;
		}
		
		GradientDrawRadialButton.Selected = true;
		GradientDrawLinearButton.Selected = false;
		GradientDrawState = 1;
		return true;
	}
	else if(GradientDrawLinearButton.overB())
	{
		if(GradientDrawLinearButton.Selected == true)
		{
			GradientDrawLinearButton.Selected = false;	//compatible
			
			GradientDrawState = 0;
			return true;
		}

		GradientDrawRadialButton.Selected = false;
		GradientDrawLinearButton.Selected = true;
		GradientDrawState = 2;
		return true;
	}
	return false;
} //end pressHandlerGraphicTools()

//====================================================================================================================================

public boolean pressHandlerMenuTabs()
{
	for (int i =0; i != MenuTabs.length; i++) //check menutabs
	{
		if (MenuTabs[i].over())
		{
			MenuTabs[SelectedMenuTab].Selected = false;  
			SelectedMenuTab = i;
			MenuTabs[i].Selected = true;
			println("Changed Menu Tabs, SelectedMenuTab ="+SelectedMenuTab);
			//make the SequenceScrollBar longer when on Tab 2(connection)

			MouseIconPlace.Selected = false;
			MouseIconRemove.Selected = false;
			MouseIconReset.Selected = false;

			//GraphicLayoutTools = false; //clear these just in case...
			GraphicFuncPaintButton.Selected = false; //clear the button, which is also the flag
			GradientDrawRadialButton.Selected = false; //clear button
			GradientDrawLinearButton.Selected = false; //clear button			
			GradientDrawState = 0;
			
			GraphicImageResize = false;
			//MenuTabs[0].refresh();
			
			if(MenuTabs[0].ReqRefresh || MenuTabs[1].ReqRefresh) MenuTabs[2].ReqRefresh = true; //this just makes sure if 0 or 1 are updated, 2 is updated as well....
			if (MenuTabs[i].ReqRefresh == true) { MenuTabs[i].refresh(); println("REFRESHED =========== "+i); }
			
			if(SelectedMenuTab == 4) thread("PortMonitorThread"); //start monitoring
			
			noLoop(); //incase it is playing video
			
			return true;
		}
	}
	return false;
}// end pressHandlerMenuTabs()


public boolean pressHandlerRightClick()
{
	//detects and removes sequences from index if right clicked
	println("X: "+mouseXS+" - Y: "+mouseYS);		
	
	if(SelectedMenuTab == cTabConnection)
	{
		println("Checking Index Icons");
		for (int i =0; i != IndexMapPointer+2; i++)
		{
			if (i <= IndexMapPointer)
			{
				if (mouseXS >= (60+596) && mouseXS <= (60+596+cSeqTileW) && mouseYS >= 35+((5+(i*cSeqTileVertSpace))-(IndexScrollBar.Value*cSeqTileVertSpace)) && mouseYS <= (35+cSeqTileH)+((5+(i*cSeqTileVertSpace))-(IndexScrollBar.Value*cSeqTileVertSpace)))     
				{
					println("Clicked Populated Connection SeqIcon "+i+"   IndexMapPointer: "+IndexMapPointer);
					
					IndexMapArray[i] = cIndexEmptyID; //blank/earse index location
					
					if(IndexMapPointer > i)
					{
						println("need to shift data down");
						
						for (int q = i; q != IndexMapPointer+1; q++)
						{
							println("shifting slot "+i+" to "+(i+1));
							
							if(q != device.MaxIndexedSequences)
							{	
								IndexMapArray[q] = IndexMapArray[q+1]; //blank/earse index location	
							}
							else IndexMapArray[q] = cIndexEmptyID; 
							//IndexID would have to be updated here if the number is used for anything
						}
					}
					IndexMapPointer--;
					
					DrawIndexScrollArea();
					break; //otherwise it would do it twice, easy fix
				}
			}
		} //end for()
		
		//Check Idle
		if(IdleSequenceIcon.over())
		{
			println("IdleSequenceIcon Right Clicked");
			device.UserIdleSequence = 0; //Clear Sequence Idle		
			return true;
		}		
	} //end ConnectionTabState if()

	//added
	ColorPickerOpen = false;
	GradientDrawInit = false;
	return true;		
}// end pressHandlerRightClick()


public boolean pressHandlerFrameTools()
{
	if (SelectedMenuTab == cTabGraphic || SelectedMenuTab == cTabTimeline) //Only ran if Graphic Layout or Timeline
	{

		//==================================================================		
		for (int i =0; i != FrameCheckBoxes.length; i++)
		{
			if (FrameCheckBoxes[i].over()) //don't allow if 0 or 1
			{
				println("FrameCheckBox "+i+" pressed"); 
				//Double duty for linked sequences
				UserSequences[SelectedSequence].SlideFlags[SelectedFrame] = UserSequences[SelectedSequence].SlideFlags[SelectedFrame] & 0xF8; //remove 3LSBs
				UserSequences[SelectedSequence].SlideFlags[SelectedFrame] = UserSequences[SelectedSequence].SlideFlags[SelectedFrame] | i;
				
				SetSlideDataTypeBoxStates(i+1); //0 is used to deselect & grey out 
				UpdateSideBarButtonStates();
				return true;
			}
		}
		//============================== FrameOptions drop down ========================================
		
		if (FrameSeqToolInsantDD.over()) return true;
		else if(FrameSeqToolInsantDD.overOpen()) 
		{
			println("Pressed FrameSeqToolInsantDD DropDown "+FrameSeqToolInsantDD.SelStr );
			
			switch(FrameSeqToolInsantDD.SelStr)
			{
			case 0://Instant
				UserSequences[SelectedSequence].SlideValues[SelectedFrame] = 0;
				UserSequences[SelectedSequence].SlideFlags[SelectedFrame] = 0x00; //Clears SlideFlags				
				break;
			case 1://Slide Up
				UserSequences[SelectedSequence].SlideValues[SelectedFrame] = 1;
				//Uses curent sequence DataType/ColorMode, the +1 is for function argument, 0 = disable
				UserSequences[SelectedSequence].SlideFlags[SelectedFrame] = unbinary("11000"+binary(PixelDataType,3)); //0x80+DIR+ColorMode				
				break; 
			case 2://Slide Down
				UserSequences[SelectedSequence].SlideValues[SelectedFrame] = 1;
				//Uses curent sequence DataType/ColorMode, the +1 is for function argument, 0 = disable
				UserSequences[SelectedSequence].SlideFlags[SelectedFrame] = unbinary("10000"+binary(PixelDataType,3)); //0x80+DIR+ColorMode		
				break;
			}//end switch			
			
			UpdateSideBarButtonStates();
			MenuTabs[0].refresh();
			MenuTabs[1].refresh();
			return true;
		}
		
		//==================================================================	
		
		if (FrameSeqToolTechDD.over()) return true;
		else if(FrameSeqToolTechDD.overOpen()) 
		{
			println("Pressed FrameSeqToolTechDD DropDown "+FrameSeqToolTechDD.SelStr );
			
			switch(FrameSeqToolTechDD.SelStr)
			{
			case 0://Ramp
		
				break;
			case 1://Solid
			
				break; 
			}//end switch			
			MenuTabs[1].refresh();
			return true;
		}
		
		//==================================================================	
				
		if (TextFields[0].over()) { TextFields[0].SelectField(); return true; }  //Slide Values		
		if (TextFields[6].over() && UserSequences[SelectedSequence].SeqMode == mTech) { TextFields[6].SelectField(); return true; }  //Frame Speed
		
	}//end   if (SelectedMenuTab == 0 || SelectedMenuTab == 1)
	return false;
}// end pressHandlerFrameTools()

//====================================================================================================================================== 

public boolean pressHandlerColorPickerOpen()
{
	if (ColorSelector.overPicker())
	{
		ColorSelector.PickColor();
		return true;
	}
	else if (ColorSelector.over())
	{
		for (int i =0; i != ColorSelectorSliders.length; i++)
		{
			if (ColorSelectorSliders[i].over())
			{
				println("ColorSelectSlider "+i);
				ColorSelectorSliders[i].selectSlider();
			}
		} //end for()
		if(TextFields[10].over()) TextFields[10].SelectField();

		if (ColorSelectorCancel.over())
		{
			ColorPickerOpen = false;
			return true;
		}
		if (ColorSelectorApply.over())
		{
			ApplyColorSelection();
		}
	}		
	else
	{	
		ColorPickerOpen = false; //clicked not on apply, cancel or a color point, must be outside of area, so close colorpicker
	}	
	return true;
} //end pressHandlerColorPickerOpen()


public void ApplyColorSelection()
{
	//move color data into whatever array it is suppose to go in
	//int tempVar = (UserSequences[SelectedSequence].SeqFrameAmount+1);
	ColorPickerOpen = false;

	if(TextFields[10].Selected == true)
	{
		TextFields[10].Selected = false; //unselect textfild in case
		
		if(!TextFields[10].Label.equals("")) 
		{
			//duplicated from input, textfield[10]
			if(PApplet.parseInt(TextFields[10].Label) > ColorSelectorSliders[0].Maximum) TextFields[10].Label = ""+ColorSelectorSliders[0].Maximum; //check if over maximum
			SliderPointer.Value = PApplet.parseInt(TextFields[10].Label); //update slider through pointer
			
			ColorSelector.slRed = ColorSelectorSliders[0].Value;
			ColorSelector.slGreen = ColorSelectorSliders[1].Value;
			ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
			ColorSelector.slWhite = ColorSelectorSliders[3].Value;
		}			
	}			

	if(GraphicFuncPaintButton.Selected == true || PaintColorPick == true)
	{
		//applies the Paint Color to Sliders, which is used to fill Icon
		PaintColor[0] = ColorSelectorSliders[0].Value;
		PaintColor[1] = ColorSelectorSliders[1].Value;
		PaintColor[2] = ColorSelectorSliders[2].Value;				
		PaintColor[3] = ColorSelectorSliders[3].Value;	
		
		//updates rect color for viewing
		PaintRects[PaintRectID].Red = PaintColor[0];
		PaintRects[PaintRectID].Green = PaintColor[1];
		PaintRects[PaintRectID].Blue = PaintColor[2];								
		PaintRects[PaintRectID].White = PaintColor[3];
		
		PaintColorPick = false;
		return; //won't add to pallete
	}
	//else if (SelectedMenuTab == 2 && OverlayMenuID == 1) //this gets checked first
	else if (ColorSelector.mode == 3) 
	{
		//USB Live Control, Color Rect Tab
		println("LiveConDataType: "+LiveConDataType);

		switch(LiveConDataType)
		{
		case 0: //single
			ControlSliders[ColorSelector.passedChan*LiveConDataMult].Value = ColorSelectorSliders[3].Value;
			break;
		case 1: //RGB
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)].Value = ColorSelectorSliders[0].Value;
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+1].Value = ColorSelectorSliders[1].Value;
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+2].Value = ColorSelectorSliders[2].Value;
			break;
		case 2: //RGBW
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)].Value = ColorSelectorSliders[0].Value;
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+1].Value = ColorSelectorSliders[1].Value;
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+2].Value = ColorSelectorSliders[2].Value;
			ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+3].Value = ColorSelectorSliders[3].Value;            
			break;
		}//end switch
		
		//update color rects				
		ControlRects[ColorSelector.passedChan].Red = ColorSelectorSliders[0].Value;
		ControlRects[ColorSelector.passedChan].Green = ColorSelectorSliders[1].Value;
		ControlRects[ColorSelector.passedChan].Blue = ColorSelectorSliders[2].Value;
		ControlRects[ColorSelector.passedChan].White = ColorSelectorSliders[3].Value;

		LiveControlUpdate = true;
	}				
	else if (ColorSelector.mode == 2) //means apply to group
	{
		println("Run Apply Color to Group");
		for (int q = 0; q != CurrentPixelUsage; q++)  
		{  
			if(PixelIcon[q].GroupID == ViewGroupIDNum)
			{
				println("LED Icon "+q+" is in group "+ViewGroupIDNum);
				
				switch(PixelDataType)
				{
				case 0: //Single
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[3].Value;
					break;
				case 1: //RGB
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+1] = ColorSelectorSliders[1].Value;
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+2] = ColorSelectorSliders[2].Value;
					break;
				case 2: //RGBW
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+1] = ColorSelectorSliders[1].Value;
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+2] = ColorSelectorSliders[2].Value;
					UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+3] = ColorSelectorSliders[3].Value;
					break;
				}//end switch
			}	
		} //end for()	
	}
	else if (ColorSelector.mode == 1 || UserSequences[SelectedSequence].SeqMode == mGradient) //means apply to all
	{
		println("Run Apply All with "+TotalColorChannels);
		for (int q = 0; q != TotalColorChannels; q++)  
		{  
			switch(PixelDataType)
			{
			case 0: //single
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[3].Value;
				break;
			case 1: //RGB
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+1] = ColorSelectorSliders[1].Value;
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+2] = ColorSelectorSliders[2].Value;
				break;
			case 2: //RGBW
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][q * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+1] = ColorSelectorSliders[1].Value;
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+2] = ColorSelectorSliders[2].Value;
				UserSequences[SelectedSequence].DataFrames[SelectedFrame][(q * CurrentDataTypeMult)+3] = ColorSelectorSliders[3].Value;
				break;
			}//end switch
		} //end for()
		
		//updates the GradientRects color
		if(UserSequences[SelectedSequence].SeqMode == mGradient)
		{
			//update colorrect objects for viewing
			GradientRects[SelectedFrame-FrameScrollBarView].Red = ColorSelectorSliders[0].Value;
			GradientRects[SelectedFrame-FrameScrollBarView].Green = ColorSelectorSliders[1].Value;					
			GradientRects[SelectedFrame-FrameScrollBarView].Blue = ColorSelectorSliders[2].Value;
			GradientRects[SelectedFrame-FrameScrollBarView].White = ColorSelectorSliders[3].Value;					
		}		
	}//end else	
	else if(ColorSelector.mode == 4)
	{
		//need to do a switch for single(which will use the white slider, and RGB/RGBW
		println("Filling Tech Color");
		
		switch(PixelDataType)
		{
		case 0: //single
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[3].Value;
			break;
		case 1: //RGB
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[0].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+1] = ColorSelectorSliders[1].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+2] = ColorSelectorSliders[2].Value;
			break;
		case 2: //RGBW
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[0].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+1] = ColorSelectorSliders[1].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+2] = ColorSelectorSliders[2].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+3] = ColorSelectorSliders[3].Value;
			break;
		}//end switch
		fillTechColorRects();
	}//end els
	else //mode = 0
	{
		//need to do a switch for single(which will use the white slider, and RGB/RGBW
		println("Filling Color Normally");
		
		switch(PixelDataType)
		{
		case 0: //single
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult] = ColorSelectorSliders[3].Value;
			break;
		case 1: //RGB
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult+1] = ColorSelectorSliders[1].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult+2] = ColorSelectorSliders[2].Value;
			break;
		case 2: //RGBW
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult] = ColorSelectorSliders[0].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult+1] = ColorSelectorSliders[1].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult+2] = ColorSelectorSliders[2].Value;
			UserSequences[SelectedSequence].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * CurrentDataTypeMult+3] = ColorSelectorSliders[3].Value;
			break;
		}//end switch
		
		//allows the LED icons to be used to edit the POV image
		if(UserSequences[SelectedSequence].SeqMode == mPOV) MenuTabs[1].refresh();//DrawPOVBuffer();
		GraphicLayoutUpdateIcons();	//change v2c from refresh[0]
	}//end else

		
	//color used, save to palette, checking that its not already present and rolling the buffer
	for (int i=0; i != paletteColors.length;i++)
	{
		if(paletteColors[i][0] == ColorSelectorSliders[0].Value && paletteColors[i][1] == ColorSelectorSliders[1].Value && paletteColors[i][2] == ColorSelectorSliders[2].Value && paletteColors[i][3] == ColorSelectorSliders[3].Value)
		{
			println("Color already on palette, not added");
			break; //leave loop if color found
		}

		if(i == 5) //rollover palette buffer
		{
			paletteColors[paletteColorsVar][0] = ColorSelectorSliders[0].Value;
			paletteColors[paletteColorsVar][1] = ColorSelectorSliders[1].Value;
			paletteColors[paletteColorsVar][2] = ColorSelectorSliders[2].Value;
			paletteColors[paletteColorsVar][3] = ColorSelectorSliders[3].Value;
			paletteColorsVar++;
			if(paletteColorsVar == 6) paletteColorsVar = 0; //rollover
		}
	} //end i for()

	//Decide what to rebuild or refresh.... or just do a single 
	redraw();
	
	switch(SelectedMenuTab)
	{
	case 0:
		if(ColorSelector.mode == 2 || ColorSelector.mode == 1 || UserSequences[SelectedSequence].SeqMode == mGradient)
		{
			//MenuTabs[0].refresh(); //refresh graphic layout right away.
			MenuTabs[1].refresh(); //refresh timeline next time its displayed  
		}
		else UpdateColorChannelBuffer(ColorSelector.passedChan);	//single update
		
		MenuTabs[0].refresh(); 
		//GraphicLayoutUpdateIcons();	//added v2c
		break;
	case 1:
		
		if(ColorSelector.mode == 1 || UserSequences[SelectedSequence].SeqMode == mGradient)
		{
			BuildGradientMenu();
			DrawTimeLineBuffer();
		}
		else if(UserSequences[SelectedSequence].SeqMode != mTech) UpdateColorChannelBuffer(ColorSelector.passedChan);	//single update
		else MenuTabs[1].refresh(); //refresh timeline next time its displayed  
		
		MenuTabs[0].refresh(); //refresh graphic layout next time its displayed 
		break;
	} //end switch 		
}//end 

//====================================================================================================================================== 

public boolean pressHandlerConfirmBox()
{	
	if(ConfirmBoxIDNum > 0) //if true/more than 0, means display message, otherwise no message
	{		
		if(ConfirmButtonYes.overB())
		{
			println("Pressed Yes on ID#: "+ConfirmBoxIDNum);
			println(cConfirmBoxText[ConfirmBoxIDNum]);
			
			redraw();
			
			int holdConfirmBoxIDNum = ConfirmBoxIDNum;
			ConfirmBoxIDNum = 0;
			
			switch(holdConfirmBoxIDNum)
			{
			case 0:
				//NO ID Number
				break;		
			case 1:
				RequestFullUpload();	
				break;		
			case 2: //delete sequence
				DeleteSequence();		
				break;		
			case 3: //clear sequences
				InitNoSequences();
				//break; //want to clear the Index as well
			case 4: // REset Index
				
				for (int q =0; q != IndexMapArray.length; q++) IndexMapArray[q] = cIndexEmptyID;
				IndexMapPointer = 1;   
				IndexScrollBar.Value = 0;
				DrawIndexScrollArea(); 		

				device.UserIdleSequence = 0; //Clear Sequence Idle		
				break;	
			case 5: //Update Via Textfield UserChannelAMt	
				if(device.BasicVersion > 0) 
				{
					ShowNotification(13);
				}
				else
				{	
					UserChannelAmt = PApplet.parseInt(TextFields[11].Label);
					if(UserChannelAmt > device.Channels)
					{
						UserChannelAmt = device.Channels;
						TextFields[11].Label = ""+UserChannelAmt;
					}

					MenuTabs[1].refresh(); 
					MenuTabs[0].refresh();
				}				
				TextFields[11].Selected = false; //clear highlighed field
				break;	
			case 6: //Memory Full Alert

				break;
			case 7: //Start Values Bad
				//choose to ignore
				UserIgnoredAlert = true;
				RequestFullUpload();
				break;	
			case 8: //firmware update

				break;
			case 9: //botloader mode
				cmdByte = cmdEnterBootloader; //new bootloader CMD
				cmdData[0] = 0;
				cmdData[1] = 0; 
				cmdData[2] = 0;  
				cmdData[3] = 0;  
				RequestCommand();
				delay(100); //why not, hate to do it though
				CloseCommunicationPort(); //close port, since it just dropped connection
				break;
			case 10: //different device save file
				try {
					LoadUserSequencesFile(SelectedFilePath);
				}
				catch(Exception e)	{
					ConfirmBoxIDNum = 6;	
				}
				break;
				
			case 12:		//send configurations
				if(device.BasicVersion == 2) RequestConfigurationUploadType2();
				else RequestConfigurationUpload(); //1 & 2
				break;	
			case 13: //add to group
				AddToLayout();
				break;	
				
			case 14: //merge/flatten groups			 					
				try {	
					for (int i = 0; i != DefinedPixelUsage; i++)	
					{
						PixelIcon[i].GroupID = FunctionGroupIDNum;
					} //end for()
				}
				catch(Exception e) { println("Couldn't merge all Icons");}	
				break;
			case 15: //clear group	
				
				try {	
					for (int i = 0; i != DefinedPixelUsage; i++)	
					{
						if(PixelIcon[i].GroupID == FunctionGroupIDNum) PixelIcon[i].GroupID = cGroupOutOfBounds; //hide icon
					} //end for()
				}
				catch(Exception e) { println("Catch at Clear Group");}					
				
				break;
			case 16: //Confirm Reset Start Values
				StartValReset.Selected = true;
				ResetStartValuesCommon(SelectedSequence);	
				ShowNotification(2); //show notification flag for reset start values
				//MenuTabs[0].refresh();	//refresh Graphic Layout
				GraphicLayoutUpdateIcons();	//changed v2c from refresh[0]				
				MenuTabs[1].refresh();	//refresh Graphic Layout	
				break;	
			case 17: //GammaUploadDefaultButton - Default
				RequestGammaTableUpload(0); //0=default
				break;	
			case 18: //GammaUploadButton - User data
				RequestGammaTableUpload(1); //1=user data
				break;	
			case 19: //Request configurations
				RequestDeviceConfigurations();
				break;					
			} //end switch

		}
		if(ConfirmButtonNo.overB())
		{
			println("Pressed No on");
			println(cConfirmBoxText[ConfirmBoxIDNum]);		
			
			redraw();
			
			switch(ConfirmBoxIDNum)
			{
			case 0:
				//NOT USED, means no message to display
				break;
			case 1:

				break;
			case 2:
				//EditUserIDFlag = false;
				//DuplicateSequenceFlag = false;
				SoftwareButtons[4].Selected = false;
				SoftwareButtons[7].Selected = false;		  
				//DeleteSequenceFlag = SoftwareButtons[5].Selected;		
				break;		
			case 3:
				
				break;
			case 4:
				
				break;
			case 5: //Update Via Textfield UserChannelAmt
				TextFields[11].Label = ""+UserChannelAmt;
				break;	
			case 6: //Memory Full Alert

				break;
			case 7: //Start Values Bad
				//chose to not ignore, brings user to tab and sequence
				UserSequences[SelectedSequence].Highlighted = false;
				SelectedSequence = confirmPassedID;
				UserSequences[SelectedSequence].Highlighted = true;
				
				MenuTabs[SelectedMenuTab].Selected = false;  
				SelectedMenuTab = 1;
				MenuTabs[SelectedMenuTab].Selected = true;		
							
				LoadSequence();
				break;		
			case 8: //firmware update

				break;
			case 9: //botloader mode

				break;	
			case 10: //different device save file
			
				break;
			case 16: //Confirm Reset Start Values

				break;		
			}	//end switch	
			ConfirmBoxIDNum = 0;
		}
		return true;
	}
	return false;
}//end pressHandlerConfirmBox()


//==============================================================================================================     

public void CheckStartVals(int passedSequence)
{
	//DUPLICATED FROM DrawTimeLineBuffer
	//sets the StartValError flag, run from RequestFullUpload()

	int tempFrameVar = 0;
	int RStart = 0;
	int GStart = 0;
	int BStart = 0;
	int WStart = 0;
	int CurrentStartR = 0;
	int CurrentStartG = 0;
	int CurrentStartB = 0;
	int CurrentStartW = 0;
	int CurrentEndR = 0;
	int CurrentEndG = 0;
	int CurrentEndB = 0;
	int CurrentEndW = 0;

	for (int i = 0; i != TotalColorChannels; i++)
	{
		//Figures Start Values Indicator Position
		if (UserSequences[passedSequence].SeqMode != mInstant)
		{
			switch(PixelDataType)
			{
			case 2: //RGBW
				WStart = UserSequences[passedSequence].StartValues[(i*CurrentDataTypeMult)+3]; 
			case 1: //RGB
				RStart = UserSequences[passedSequence].StartValues[(i*CurrentDataTypeMult)];
				GStart = UserSequences[passedSequence].StartValues[(i*CurrentDataTypeMult)+1];
				BStart = UserSequences[passedSequence].StartValues[(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				WStart = UserSequences[passedSequence].StartValues[(i*CurrentDataTypeMult)]; 
				break;	
			}	

			tempFrameVar = UserSequences[passedSequence].DataFrameVar[(i*CurrentDataTypeMult)];

			switch(PixelDataType)
			{
			case 2: //RGBW
				CurrentStartW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+3];
			case 1: //RGB
				CurrentStartR = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				CurrentStartG = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+1];
				CurrentStartB = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				CurrentStartW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				break;	
			}	  	  

			if (tempFrameVar < UserSequences[passedSequence].SeqFrameAmount) tempFrameVar++;
			else tempFrameVar = 0; //increment or wrap FrameVar

			switch(PixelDataType)
			{
			case 2: //RGBW
				CurrentEndW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+3];
			case 1: //RGB
				CurrentEndR = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				CurrentEndG = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+1]; 
				CurrentEndB = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)+2];
				break;
			case 0: //Single
				CurrentEndW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*CurrentDataTypeMult)];
				break;	
			}	 	  

			tempFrameVar = UserSequences[passedSequence].DataFrameVar[(i*CurrentDataTypeMult)];
			
			//println("=========================================================================");
			//detect bad start values or out of range colors
			switch(PixelDataType)
			{
			case 0: //Single
				if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[passedSequence].StartValError = true;
				break;	
			case 2: //RGBW
				if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[passedSequence].StartValError = true;
			case 1: //RGB
				if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) UserSequences[passedSequence].StartValError = true;
				if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) UserSequences[passedSequence].StartValError = true;
				if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) UserSequences[passedSequence].StartValError = true;			
				break;
			}					
		}
	} //end for()
} //end CheckStartVals

//==============================================================================================================     

public void MeasureSequenceLength(int SelSeq)
{
	//println("MeasureSequenceLength() with "+SelSeq);
	
	int SeqLength = cHeaderByteLen; //acount for header
	
//16bit and 8-bit should be working correctly
	
	
	if(UserSequences[SelSeq].SeqMode == mFade)
	{
	//Channel size: StartVals - DataFrameVars - DataFrames
	//Frame Size: 
		if(device.Bit16Mode == true)
		{
		SeqLength += (UserSequences[SelSeq].DataSize*2);	//StartVals - 16-bit
		SeqLength += UserSequences[SelSeq].DataSize;	//DataFrameVars	
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*(UserSequences[SelSeq].DataSize*2)); //dataframes - 16-bit
		}
		else
		{
		SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);		
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);//dataframes
		}
	}
	else if(UserSequences[SelSeq].SeqMode == mGradient)
	{
	//Channel size: StartVals - DataFrameVars - DataFrames
	//Frame Size: 	
		if(device.Bit16Mode == true)
		{
		SeqLength += (UserSequences[SelSeq].DataSize*2);	//StartVals - 16-bit
		SeqLength += UserSequences[SelSeq].DataSize;	//DataFrameVars			
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*4)*2;//dataframes - 16 bit
		}
		else
		{
		SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);		
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*4);//dataframes
		}
	}	
	else if(UserSequences[SelSeq].SeqMode == mInstant)
	{
	//Channel size: Startvals, DataFrameVars - DataFrames
	//Frame Size: 	SlideValues - SlideFlags	
		if(device.Bit16Mode == true)
		{
		SeqLength += (UserSequences[SelSeq].DataSize*2); //startvals - 16-bit
		SeqLength += UserSequences[SelSeq].DataSize;//DataFrameVars		
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * 2); //slidevalue and slideflags				
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*(UserSequences[SelSeq].DataSize*2)); //dataframes - 16-bit
		}	
		else
		{	
		SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);	//startvals & dataframevar		
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * 2); //slidevalue and slideflags	
		SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);//dataframes
		}
	}		
	else if(UserSequences[SelSeq].SeqMode == mTech)
	{
	//Channel size: DataFrameVars - DataFrames
	//Frame Size:  TechFlags - TechTime
	//SeqLength += (UserSequences[SelSeq].DataSize + UserSequences[SelSeq].DataSize);				//DataFrameVar
	
	/*
	DISABLED v.2c
	SeqLength += (UserSequences[SelSeq].DataSize);		//Start Values
	SeqLength += (UserSequences[SelSeq].SeqFrameAmount+1) * updateTechTotalColorChannel(SelSeq);	//8-bit techflags
	SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * updateTechTotalColorChannel(SelSeq)) * 2; //16-bit techtime
	SeqLength += (((UserSequences[SelSeq].SeqFrameAmount+1) * 2) * UserSequences[SelSeq].DataSize); //data frames, 2 per 
	*/
	}		
	else if(UserSequences[SelSeq].SeqMode == mPOV)
	{
	//Channel size:  DataFrames
	//Frame Size: 	
		if(device.Bit16Mode == true)
		{
		if(UserSequences[SelectedSequence].POVVideoMode == true)  SeqLength += (UserSequences[SelSeq].POVFramesAmount*(UserSequences[SelSeq].DataSize*2)); //16-bit
		else SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*(UserSequences[SelSeq].DataSize*2));	//16-bit
		}
		else
		{
		if(UserSequences[SelectedSequence].POVVideoMode == true)  SeqLength += (UserSequences[SelSeq].POVFramesAmount*UserSequences[SelSeq].DataSize);
		else SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);
		}
	}			
	else if(UserSequences[SelSeq].SeqMode == mFilePlay)
	{
	//Channel size:  
	//Frame Size: 
	if(device.Bit16Mode == true) SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*(UserSequences[SelSeq].DataSize*2) );
	else SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);	
	}		
	else if(UserSequences[SelSeq].SeqMode == mLinked)
	{
	//Channel size:  
	//Frame Size: 	
	SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * 4);
	}		
	//Else mSerial, mDMX, mUSB(???), they only send the header
	
	UserSequences[SelSeq].Length = SeqLength; //update to object

	println("MeasureSequenceLength() with "+SelSeq+"   Result: "+SeqLength);	
} //end func

//==============================================================================================================     

public void AddSequence()
{
	UserSequences = (UserSequenceObj[]) expand(UserSequences, UserSequences.length+1); //add sequence to end of objects
	
	println("AddSequence() - Length is now "+UserSequences.length);	
	
	UserSequences[UserSequences.length-1] = UserSequences[UserSequences.length-1] = new UserSequenceObj("User Added "+(UserSequences.length-1), (UserSequences.length-1), device.Channels); 

	UserSequences[UserSequences.length-1].DataFrameVar = new int[device.ArrayCastSize];
	UserSequences[UserSequences.length-1].StartValues = new int[device.Channels];
	UserSequences[UserSequences.length-1].SlideValues = new int[2];	//new sequences defaulted to 2 frames
	UserSequences[UserSequences.length-1].SlideFlags = new int[2];
	UserSequences[UserSequences.length-1].DataFrames = new int[2][device.Channels];   
	
	UserSequences[UserSequences.length-1].TechFlags = new int[2][cSoftwareMaxChans];  
	UserSequences[UserSequences.length-1].TechTime = new int[2][cSoftwareMaxChans];  	

	UserSequences[SelectedSequence].Highlighted = false;			
	SelectedSequence = (UserSequences.length-1);
	
	SelectedFrame = 0;
	SetSelectedFrame(SelectedFrame);
	
	UserSequences[SelectedSequence].Highlighted = true;
	
	UpdateSequence(SelectedSequence);
	UpdateSideBarButtonStates();
	
	//this detects if no pixelicons are defined yet(first sequence added) and will build them
	if(PixelIcon[0] == null) 
	{ 
	ConfigShape = 0; 
	GraphicLayoutBuild(0); 
	println("Defaulted Config Shape");
	}
} //end AddSequence()			

//==============================================================================================================     


public void ResizeSequenceFrameAmt(int SelSeq)
{
	println("ResizeSequences() with "+SelSeq);	

	int newFrameAmt = (UserSequences[SelSeq].SeqFrameAmount+1); //one higher for base 0
	
	//Channel Based Length
	//UserSequences[SelSeq].DataFrameVar = expand(UserSequences[SelSeq].DataFrameVar, NewUsrChnAmt);
	//UserSequences[SelSeq].StartValues = expand(UserSequences[SelSeq].StartValues, NewUsrChnAmt);
	
	//SeqFrameAmount based length
	//single dimension arrays expand fine
	UserSequences[SelSeq].SlideFlags = expand(UserSequences[SelSeq].SlideFlags, newFrameAmt);		
	UserSequences[SelSeq].SlideValues = expand(UserSequences[SelSeq].SlideValues, newFrameAmt);
		
	//multi dimensional are a bit trickier, expand declares it, but still need to define the new array
	UserSequences[SelSeq].DataFrames = (int[][])expand(UserSequences[SelSeq].DataFrames, newFrameAmt);
	
	for(int i = 0; i != UserSequences[SelSeq].DataFrames.length; i++)
	{
	if(UserSequences[SelSeq].DataFrames[i] == null)	//prevents data being overwitten if it doesn't need to be
		UserSequences[SelSeq].DataFrames[i] = new int[device.Channels];	//place empty data into array otherwise is null
	}	
	
	
	UserSequences[SelSeq].TechFlags = (int[][])expand(UserSequences[SelSeq].TechFlags, newFrameAmt);
	if(UserSequences[SelSeq].TechFlags[UserSequences[SelSeq].TechFlags.length-1] == null)	
	UserSequences[SelSeq].TechFlags[UserSequences[SelSeq].TechFlags.length-1] = new int[device.Channels];	//place empty data into array	
	
	UserSequences[SelSeq].TechTime = (int[][])expand(UserSequences[SelSeq].TechTime, newFrameAmt);
	if(UserSequences[SelSeq].TechTime[UserSequences[SelSeq].TechTime.length-1] == null)	
	UserSequences[SelSeq].TechTime[UserSequences[SelSeq].TechTime.length-1] = new int[device.Channels];		//place empty data into array

//Special Usage:
	//mLinked uses DataFrameVar as a frame amount rather than channel amount
	if(UserSequences[SelSeq].SeqMode == mLinked) UserSequences[SelSeq].DataFrameVar = expand(UserSequences[SelSeq].DataFrameVar, newFrameAmt);	
} //end resizeSequences()

//==============================================================================================================     

public void InitNoSequences()
{
	println("InitNoSequences()");
	UserSequences = new UserSequenceObj[1];
	for (int i =0; i != UserSequences.length; i++)
	{
		UserSequences[i] = new UserSequenceObj("EMPTY", i, 1);
		UserSequences[i].DataFrameVar = new int[1];
		UserSequences[i].StartValues = new int[1];
		UserSequences[i].SlideValues = new int[2];
		UserSequences[i].SlideFlags = new int[2];
		UserSequences[i].DataFrames = new int[2][1];  
			
		UserSequences[i].TechFlags = new int[2][1];  
		UserSequences[i].TechTime = new int[2][1];  
	} 
	SelectedSequence = 0;

	for (int i =0; i != IndexMapArray.length; i++) IndexMapArray[i] = cIndexEmptyID; //fill Index Map

	SequenceSelectScrollBar.Value = 0;	
	DrawUserSeqIconBuffer(9999);
} //end InitNoSequences()

//==============================================================================================================     

public void DuplicateSequence()
{
	println("DuplicateSequence() "+SequenceIDNum+" : "+UserSequences.length);

	UserSequences = (UserSequenceObj[]) expand(UserSequences, UserSequences.length+1);

	UserSequences[UserSequences.length-1] = new UserSequenceObj("User Added "+(UserSequences.length-1), (UserSequences.length-1), UserSequences[SequenceIDNum].DataSize); 

	int newFrameAmt = UserSequences[SequenceIDNum].SeqFrameAmount+1;
	
	UserSequences[UserSequences.length-1].DataFrameVar = new int[device.ArrayCastSize];
	UserSequences[UserSequences.length-1].StartValues = new int[device.Channels];
	UserSequences[UserSequences.length-1].SlideValues = new int[newFrameAmt]; //need to update as more frames are added
	UserSequences[UserSequences.length-1].SlideFlags = new int[newFrameAmt];
	
	if(UserSequences[SequenceIDNum].SeqMode == mTech) UserSequences[UserSequences.length-1].DataFrames = new int[newFrameAmt*2][device.Channels];
	else UserSequences[UserSequences.length-1].DataFrames = new int[newFrameAmt][device.Channels];
	
	UserSequences[UserSequences.length-1].TechFlags = new int[newFrameAmt][device.Channels];  
	UserSequences[UserSequences.length-1].TechTime = new int[newFrameAmt][device.Channels];  	
	
	for(int i = 0; i != UserSequences[SequenceIDNum].DataSize; i++) // was != device.channels
	{
		UserSequences[UserSequences.length-1].DataFrameVar[i] = UserSequences[SequenceIDNum].DataFrameVar[i];
		UserSequences[UserSequences.length-1].StartValues[i] = UserSequences[SequenceIDNum].StartValues[i];
	}

	for(int i = 0; i != (UserSequences[SequenceIDNum].SeqFrameAmount+1); i++)
	{
		UserSequences[UserSequences.length-1].SlideValues[i] = UserSequences[SequenceIDNum].SlideValues[i];
		UserSequences[UserSequences.length-1].SlideFlags[i] = UserSequences[SequenceIDNum].SlideFlags[i];	
		
		for(int q = 0; q != UserSequences[SequenceIDNum].DataSize; q++)
		{
			if(UserSequences[SequenceIDNum].SeqMode != mTech) UserSequences[UserSequences.length-1].DataFrames[i][q] = UserSequences[SequenceIDNum].DataFrames[i][q];
			//save tech flags and time
			UserSequences[UserSequences.length-1].TechFlags[i][q] = UserSequences[SequenceIDNum].TechFlags[i][q];
			UserSequences[UserSequences.length-1].TechTime[i][q] = UserSequences[SequenceIDNum].TechTime[i][q];						
		}//end q for()
	}//end i for()
	
	//mTech uses 2 data frames per, just do it separatly
	if(UserSequences[SequenceIDNum].SeqMode == mTech)
	{
		for(int i = 0; i != (UserSequences[SequenceIDNum].SeqFrameAmount+1)*2; i++)
		{
			for(int q = 0; q != UserSequences[SequenceIDNum].DataSize; q++)
			{
				 UserSequences[UserSequences.length-1].DataFrames[i][q] = UserSequences[SequenceIDNum].DataFrames[i][q];				
			}//end q for()
		}//end i for()
	}

	//Now duplicate single variables
	UserSequences[UserSequences.length-1].UserID = UserSequences[SequenceIDNum].UserID;
	UserSequences[UserSequences.length-1].SeqListNum = UserSequences[SequenceIDNum].SeqListNum;
	UserSequences[UserSequences.length-1].Length = UserSequences[SequenceIDNum].Length;
	UserSequences[UserSequences.length-1].SeqFrameAmount = UserSequences[SequenceIDNum].SeqFrameAmount;
	UserSequences[UserSequences.length-1].Speed = UserSequences[SequenceIDNum].Speed;
	UserSequences[UserSequences.length-1].DataSize = UserSequences[SequenceIDNum].DataSize;
	UserSequences[UserSequences.length-1].SeqMode = UserSequences[SequenceIDNum].SeqMode;
	UserSequences[UserSequences.length-1].DataType = UserSequences[SequenceIDNum].DataType;
	UserSequences[UserSequences.length-1].SeqPlayMode = UserSequences[SequenceIDNum].SeqPlayMode;
	UserSequences[UserSequences.length-1].SeqTransitionFlags = UserSequences[SequenceIDNum].SeqTransitionFlags;
	UserSequences[UserSequences.length-1].PacketCloneMode = UserSequences[SequenceIDNum].PacketCloneMode;
	UserSequences[UserSequences.length-1].SeqTransSpeed = UserSequences[SequenceIDNum].SeqTransSpeed; //no longer used?
	UserSequences[UserSequences.length-1].SequenceIntensity = UserSequences[SequenceIDNum].SequenceIntensity;
 	UserSequences[UserSequences.length-1].gradientSteps = UserSequences[SequenceIDNum].gradientSteps;
 	UserSequences[UserSequences.length-1].POVConfigType = UserSequences[SequenceIDNum].POVConfigType;
 	UserSequences[UserSequences.length-1].POVUsageMode = UserSequences[SequenceIDNum].POVUsageMode;
 	UserSequences[UserSequences.length-1].POVFramesAmount = UserSequences[SequenceIDNum].POVFramesAmount;
 	UserSequences[UserSequences.length-1].POVVideoMode = UserSequences[SequenceIDNum].POVVideoMode;
} //end func()

//==============================================================================================================     

public void DeleteSequence()
{
	//delete that sequence and move ones above downard
	//UserSequences[SequenceIDNum].dispose();
	println("DeleteSequence() "+SequenceIDNum+" : "+UserSequences.length);

	if (SequenceIDNum == 0 && UserSequences.length < 2) return;

	for (int i = SequenceIDNum; i < UserSequences.length; i++) 
	{
		try 
		{
			UserSequences[i] = UserSequences[i+1];
		}
		catch(Exception e) {
			println("Exception attempting to shift sequence objects down");
		}
	} //end q for()	
	
	//go through indexmap and what....... find the things
	//finds the deleted sequence ID in Index, and shifts everything above it downwards	
	for (int q = 0; q != device.MaxIndexedSequences; q++) 
	{
		if(IndexMapArray[q] == SequenceIDNum) 
		{
			IndexMapArray[q] = cIndexEmptyID;	
			for (int i = q; i != (device.MaxIndexedSequences-1); i++) 
			{
				//shift them down	
				IndexMapArray[i] = IndexMapArray[i+1]; 	
			}
		}		
	}
	
	//with everything shifted, updates the SequenceIDs into the Index
	for (int q = 0; q != device.MaxIndexedSequences; q++) 
	{	
		if(IndexMapArray[q] < cIndexEmptyID && IndexMapArray[q] > SequenceIDNum)
		{
			println("IndexMapArray: "+IndexMapArray[q]);
			IndexMapArray[q]--;
		}		
	} //end i for()
	
	UserSequences = (UserSequenceObj[])shorten(UserSequences); //now remove it from object list

	for (int i = 0; i != UserSequences.length; i++) 
	{	
	UserSequences[i].SeqListNum = i; //update ID numbers
	UserSequences[i].Highlighted = false; //couldn't just clear [SelectedSequence] so clear them all
	}
	
	//Linked sequences may have had a sequence deleted
	for (int q = 1; q != UserSequences.length; q++)
	{
	//println("Running "+i+"   seq: "+q);
		//checks if sequence is a linked and it must have already been utilized since it would have to be in the index map	
		if(UserSequences[q].SeqMode == mLinked)
		{	
		println("Found a linked with to check"+q);
			//Now go through the linked seq's stored ID numbers
			for (int yy = 0; yy != UserSequences[q].SeqFrameAmount+1; yy++)
			{
				if(UserSequences[q].SlideFlags[yy] == SequenceIDNum)
				{	
					println("One sequence to be removed from linked");
					UserSequences[q].SlideFlags[yy] = 0;
					ShowNotification(25); //Notifiy that linked sequence needs updating
				}	
				else if(UserSequences[q].SlideFlags[yy] > SequenceIDNum)
				{
				UserSequences[q].SlideFlags[yy]--;	
				}
			}//end for	
		} //end if		
	}	//end for()			

	//update Idle Sequence
	if(device.UserIdleSequence == SequenceIDNum) device.UserIdleSequence = 0; //clear idle sequence if deleted
	else if(device.UserIdleSequence > SequenceIDNum) device.UserIdleSequence--; //otherwise offset
		
	SelectedSequence = 1;
	UserSequences[SelectedSequence].Highlighted = true;

	LoadSequence();
	DrawUserSeqIconBuffer(9999); //update all image buffers since ID numbers have shifted
	MenuTabs[2].refresh(); //refresh index buffer next time it is viewed
} //end deletesequence()

//==============================================================================================================    

public void UpdateSequence(int passedID)
{
	println("UpdateSequence() "+passedID);

	CurrentDataTypeMult = 1; //single
	if (UserSequences[passedID].DataType == 1) CurrentDataTypeMult  = 3;
	else if (UserSequences[passedID].DataType == 2) CurrentDataTypeMult  =  4;  

	PixelDataType = UserSequences[passedID].DataType; //update variable to shorten actual name

	if (UserSequences[passedID].DataType == 0) TotalColorChannels = UserSequences[passedID].DataSize;
	else TotalColorChannels = UserSequences[passedID].DataSize / CurrentDataTypeMult;

	if(TotalColorChannels == 0) TotalColorChannels = 1; //fix in case of error?
	
	TimeLineBuffer = createGraphics(cTLGraphBufW, (TotalColorChannels*cTLChBufH));	

	//if in basic icon mode, rebuild the graphiclayout if channel amt changes	
	
	println("===============TotalColorChannels: "+TotalColorChannels+"    CurrentPixelUsage: "+CurrentPixelUsage+"   DefinedPixelUsage: "+DefinedPixelUsage);  	
	
	MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	MenuTabs[2].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	
	if(UserSequences[passedID].POVConfigType > 3) UserSequences[passedID].POVConfigType = 0; //fix if out of bounds
	
	//Set POV button states
	for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].Selected = false;
	POVOptionButtons[UserSequences[passedID].POVConfigType].Selected = true; 	

	//set size for later usage
	TimeLineScrollBar.Maximum = (TotalColorChannels*cTLChBufH) - cTLChBufViewH; //the -470 is the size of the scroll area, if not needed, won't allow scroll bar to move
	TimeLineScrollBar.Value = 0;

	//This is required if a gradient is expanded in channel size, it needs to fill all the dataframevar with the same
	//same code from HandleSequenceModeDropDown()
	if(UserSequences[passedID].SeqMode == mGradient)
	{
		for (int x = 0; x != UserSequences[SelectedSequence].SeqFrameAmount+1;x++) 
		{
			switch(PixelDataType)
			{
			case 0: //Single
				for (int i = 0; i != UserSequences[SelectedSequence].DataSize;i++)  UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
				break;		
			case 1: //RGB
				for (int i = 0; i < UserSequences[SelectedSequence].DataSize-2;i+=3)  
				{
					UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
					UserSequences[SelectedSequence].DataFrames[x][i+1] = UserSequences[SelectedSequence].DataFrames[x][1];
					UserSequences[SelectedSequence].DataFrames[x][i+2] = UserSequences[SelectedSequence].DataFrames[x][2];
				}
				break;
			case 2: //RGBW
				for (int i = 0; i < UserSequences[SelectedSequence].DataSize-3;i+=4)  
				{
					UserSequences[SelectedSequence].DataFrames[x][i] = UserSequences[SelectedSequence].DataFrames[x][0];
					UserSequences[SelectedSequence].DataFrames[x][i+1] = UserSequences[SelectedSequence].DataFrames[x][1];
					UserSequences[SelectedSequence].DataFrames[x][i+2] = UserSequences[SelectedSequence].DataFrames[x][2];
					UserSequences[SelectedSequence].DataFrames[x][i+3] = UserSequences[SelectedSequence].DataFrames[x][3];
				}		
				break;
			}	  
		}	
	}	

	MeasureSequenceLength(passedID);
	DrawUserSeqIconBuffer(passedID);
} //end func

//==============================================================================================================    

public void LoadSequence()
{
	//updates tabs that are open so set tab first
	//redraw TimeLineScroll Bar because of length issues is based on total color channel
	println("LoadSequence() "+SelectedSequence);

	//Reset GUI Elements
	SelectedFrame = 0;
	SetSelectedFrame(SelectedFrame);

	FrameScrollBarView = 0;
	TLScrollValue = 0; //reset value		
	noLoop(); //incase video is playing, cancel draw loop
	
	if(UserSequences[SelectedSequence].SeqMode == mLinked) InitLinkedBuffer(); //has to run before the below functions
	
	UpdateSideBarButtonStates();
	UpdateSequence(SelectedSequence);

	if(UserSequences[SelectedSequence].SeqMode == mGradient)  BuildGradientMenu();
	
	if(UserSequences[SelectedSequence].SeqMode == mPOV)
	{
		POVVidFrame = 0; //reset variable
		
		POVModeDD.SelStr = UserSequences[SelectedSequence].POVUsageMode;
		POVVideoModeCheckBox.Selected = UserSequences[SelectedSequence].POVVideoMode;	//update GUI element
			
		DrawPOVBuffer(); //use to build POVGraphicsBuffer
		POVImg = POVGraphicBuffer; //store rebuilt pixel image into POVImg
	}	
} //end func

//==============================================================================================================    

public void GenerateGradient()
{
	println("GenerateGradient()");  

	float LocationVar = (256 * (UserSequences[SelectedSequence].SeqFrameAmount+1)); //whats the 256 for? max frames? or pixels? its cylcle hold/factor - 255 does not work right!

	float StepFactorH = (float)UserSequences[SelectedSequence].gradientSteps;
	if(StepFactorH < 0) StepFactorH = StepFactorH * -1; //make positive number
	
	if(StepFactorH == 1)
	{
		//If step factor is 1, just reset instead.
		ResetStartValuesCommon(SelectedSequence);
		GraphicLayoutUpdateIcons();	//changed v2c from refresh[0]	
		MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 		
		return;
	}	
	
	StepFactorH = LocationVar  / StepFactorH;
	int FrameVarCurrent = 0; 
	int FrameVarNext = 1; 
	float StepFactor = 0; 
	
	println("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH); //DEBUG

	LocationVar = 0;

	switch(PixelDataType)
	{
	case 0: //single
		UserSequences[SelectedSequence].StartValues[0] = UserSequences[SelectedSequence].DataFrames[0][0];
		break;  
	case 1://rgb
		UserSequences[SelectedSequence].StartValues[0] = UserSequences[SelectedSequence].DataFrames[0][0];
		UserSequences[SelectedSequence].StartValues[1] = UserSequences[SelectedSequence].DataFrames[0][1];
		UserSequences[SelectedSequence].StartValues[2] = UserSequences[SelectedSequence].DataFrames[0][2];
		break;
	case 2: //rgbw
		UserSequences[SelectedSequence].StartValues[0] = UserSequences[SelectedSequence].DataFrames[0][0];
		UserSequences[SelectedSequence].StartValues[1] = UserSequences[SelectedSequence].DataFrames[0][1];
		UserSequences[SelectedSequence].StartValues[2] = UserSequences[SelectedSequence].DataFrames[0][2];
		UserSequences[SelectedSequence].StartValues[3] = UserSequences[SelectedSequence].DataFrames[0][3];
		break;
	}

	UserSequences[SelectedSequence].DataFrameVar[0] = 0;
	UserSequences[SelectedSequence].DataFrameVar[1] = 0;
	UserSequences[SelectedSequence].DataFrameVar[2] = 0;
	
/*
c1(current) - c2(next) = 155(difference) * StepFactor + c1
100 - 255 = 155 * 0.5 = 77 + 100 = 177
Fucking Simple................  
*/

	int HoldCurrent = 0;
	int HoldNext = 0;
	
//println("CurrentDataTypeMult: "+CurrentDataTypeMult+"     "+UserSequences[SelectedSequence].DataSize+"    "+TotalColorChannels);

	for (int i=CurrentDataTypeMult; i != UserSequences[SelectedSequence].DataSize; i++) //starts on ColorChanel 2, 1 is set to base values above
	{
		//println("Running channel: "+i);      

		if ((i%CurrentDataTypeMult) == 0)
		{
			//println("Running Color channel: "+i);  
			//only run this stuff once per ColorChannel
			LocationVar+= StepFactorH; //increment step, equiv

			if (LocationVar > 255)
			{
				LocationVar -= 256;    //difference remains  
				if (FrameVarNext == (UserSequences[SelectedSequence].SeqFrameAmount))
				{
					FrameVarNext = 0; 
					FrameVarCurrent = (UserSequences[SelectedSequence].SeqFrameAmount);
				}
				else
				{
					FrameVarNext++;
					FrameVarCurrent++;	
					
					if(FrameVarCurrent > UserSequences[SelectedSequence].SeqFrameAmount) FrameVarCurrent = 0;
				}
			} //end locationvar if
		}

		StepFactor = (float)LocationVar / 256; //== Factor Number to multiply by

		
		HoldCurrent = UserSequences[SelectedSequence].DataFrames[FrameVarCurrent][i];
		HoldNext = UserSequences[SelectedSequence].DataFrames[FrameVarNext][i];
		//println("i: "+i+"    Hold :"+HoldCurrent+" : "+HoldNext);


		//check same
		if (HoldCurrent == HoldNext) //check if same
		{ 
			//UserSequences[SelectedSequence].StartValues[i] = HoldCurrent; //OLD
			UserSequences[SelectedSequence].StartValues[i] = PApplet.parseInt(255*StepFactor); //Preload CycleHold usage
			
			//Fucked things up
			//if(UserSequences[SelectedSequence].StartValues[i] > 0xFF) UserSequences[SelectedSequence].StartValues[i] &= 0xFF;
			//println("Same    Chan: "+i+"     FrameVarCurrent: "+FrameVarCurrent+"    StepFactor: "+StepFactor+"   Using: "+(UserSequences[SelectedSequence].StartValues[i]));
		}  
		else if (HoldCurrent < HoldNext)  //check which is bigger
		{
			//next larger
			UserSequences[SelectedSequence].StartValues[i] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
		}
		else
		{
			//current Larger
			UserSequences[SelectedSequence].StartValues[i] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
		}
		UserSequences[SelectedSequence].DataFrameVar[i] = FrameVarCurrent;
		
		//println("StepFactor: "+StepFactor+" : Color: "+UserSequences[SelectedSequence].DataFrames[FrameVarNext][i]+" : Final:"+UserSequences[SelectedSequence].StartValues[i]+" : FrameVar: "+FrameVarCurrent+" : NextFrameVar: "+FrameVarNext);
	} //end for()
	

	//DETECT REVERSE OR FORWARD HERE		
	if(UserSequences[SelectedSequence].gradientSteps < 0)
	{
		//if reverse is thrown revese Framevars both types, start values
		int x = 0;
		int[] HoldChanSz = new int[device.Channels];	
		

		switch(PixelDataType)
		{
		case 0: //single
		
			arrayCopy(UserSequences[SelectedSequence].DataFrameVar, HoldChanSz, UserSequences[SelectedSequence].DataSize);
			x = UserSequences[SelectedSequence].DataSize - 1;  //-1 for base 0
			
			for(int i = 0; i != UserSequences[SelectedSequence].DataSize; i++)
			{
				//println(i+"    "+(x-i));		
				UserSequences[SelectedSequence].DataFrameVar[i] = HoldChanSz[x-i];
			}	
			
			//move start values			
			arrayCopy(UserSequences[SelectedSequence].StartValues, HoldChanSz, UserSequences[SelectedSequence].DataSize);//load hold register
			
			for(int i = 0; i != UserSequences[SelectedSequence].DataSize; i++) 
			{
				UserSequences[SelectedSequence].StartValues[i] = HoldChanSz[x-i];								
			} //end for()	
			
			break;  
		case 1://rgb

			arrayCopy(UserSequences[SelectedSequence].DataFrameVar, HoldChanSz, UserSequences[SelectedSequence].DataSize);
			x = TotalColorChannels - 1;  //-1 for base 0
			
			for(int i = 0; i != TotalColorChannels; i++)
			{
				//println(i+"    "+(x-i));		
				UserSequences[SelectedSequence].DataFrameVar[(i*3)] = HoldChanSz[((x-i)*3)];
				UserSequences[SelectedSequence].DataFrameVar[(i*3)+1] = HoldChanSz[((x-i)*3)+1];
				UserSequences[SelectedSequence].DataFrameVar[(i*3)+2] = HoldChanSz[((x-i)*3)+2];
			}				
			
			arrayCopy(UserSequences[SelectedSequence].StartValues, HoldChanSz, UserSequences[SelectedSequence].DataSize);//load hold register
			for(int i = 0; i != TotalColorChannels; i++) 
			{
			//println(i+"   "+(i*3)+"   "+((x-i)*3));
			UserSequences[SelectedSequence].StartValues[i*3] = HoldChanSz[((x-i)*3)];
			UserSequences[SelectedSequence].StartValues[(i*3)+1] = HoldChanSz[((x-i)*3)+1];
			UserSequences[SelectedSequence].StartValues[(i*3)+2] = HoldChanSz[((x-i)*3)+2];				
			}
			break;
		case 2: //rgbw

			break;
		} //end switch
	} //end reverse
	
	//graphic layout would not need to be updated
	//MenuTabs[0].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
	GraphicLayoutUpdateIcons();	//changed v2c from refresh[0]	
	MenuTabs[1].refresh(); //either refreshes it if being viewed, or sets the ReqRefresh flag 
}  //end func()

public int updateTechTotalColorChannel(int SelSeq)
{
	//Calculate TotalColorChannels, doesn't affect actual variable incase so doesn't mess up current sequence
	int channelCounter = 0;
	tempTotalColorChannels = 0;
	
	for (int i = 0; i != UserSequences[SelSeq].DataSize; i++)
	{
		
	switch((UserSequences[SelSeq].TechFlags[0][tempTotalColorChannels] & 0x03)) //all frames have same colormode
	{
	case 0:
	channelCounter++;
	break;		
	case 1:
	channelCounter += 3;	
	break;
	case 2:
	channelCounter += 4;	
	break;
	}	
	
	//Check if can hold
	if(channelCounter > UserSequences[SelSeq].DataSize)
	{
	//println("RAN with "+channelCounter+"      "+UserSequences[SelSeq].DataSize+"     "+i);
	
	//Undo channelCounter increase
	switch((UserSequences[SelSeq].TechFlags[0][tempTotalColorChannels] & 0x03)) //all frames have same colormode
	{
	case 0:
	channelCounter--;
	break;		
	case 1:
	channelCounter -= 3;	
	break;
	case 2:
	channelCounter -= 4;	
	break;
	}		
	
	UserSequences[SelSeq].TechFlags[0][tempTotalColorChannels] &= 0xF8; //set to single color mode
	
	while(channelCounter < UserSequences[SelSeq].DataSize)
	{
	channelCounter++;	
	tempTotalColorChannels++;		
	UserSequences[SelSeq].TechFlags[0][tempTotalColorChannels] &= 0xF8; //set to single color mode
	}

	//UserSequences[SelSeq].TechFlags[0][i] &= 0xEF; //clear enabled bit
	break;
	}	
	else 	tempTotalColorChannels++; 	//now Increment
	} //end for()	

	println("updateTechTotalColorChannel() returning "+tempTotalColorChannels);
	return tempTotalColorChannels;
} //end updateTechTotalColorChannel()

//=====================================================================================================================

public void fillTechColorRects()
{
	int tempChan = getTechChannelNum(SelectedTechID);
	
	switch(CurrentDataTypeMult)
	{
	case 1: //single
		TechnicalColorStart.White = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan];
		TechnicalColorEnd.White = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan];
		break;
	case 3: //RGB
		TechnicalColorStart.Red = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan];
		TechnicalColorStart.Green = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan+1];
		TechnicalColorStart.Blue = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan+2];	

		TechnicalColorEnd.Red = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan];
		TechnicalColorEnd.Green = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan+1];
		TechnicalColorEnd.Blue = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan+2];		
		break;
	case 4: //RGBW
		TechnicalColorStart.Red = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan];
		TechnicalColorStart.Green = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan+1];
		TechnicalColorStart.Blue = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan+2];
		TechnicalColorStart.White = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame][tempChan+3];

		TechnicalColorEnd.Red = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan];
		TechnicalColorEnd.Green = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan+1];
		TechnicalColorEnd.Blue = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan+2];
		TechnicalColorEnd.White = UserSequences[SelectedSequence].DataFrames[SelectedTechFrame+1][tempChan+3];		
		break;
	}//end switch	
} //end func

//=====================================================================================================================

public int getTechChannelNum(int passedID)
{
	int channelCounter = 0;

	for (int i = 0; i != passedID; i++)
	{
		//read tech flags for color mode
		switch((UserSequences[SelectedSequence].TechFlags[0][i] & 0x03)) //all frames have same colormode
		{
		case 0:
		channelCounter++;
		break;		
		case 1:
		channelCounter += 3;		
		break;
		case 2:
		channelCounter += 4;			
		break;
		}	
	} //end for()

	return channelCounter;
} //end func

//=====================================================================================================================

public int getTechChanColorMode(int passedChan)
{
	return (UserSequences[SelectedSequence].TechFlags[0][passedChan] & 0x0003);
}

//=====================================================================================================================

public void InitTechnicalSelectRadial(int passedID, int passedFrame)
{
	println("InitTechnicalSelectRadial("+passedID+", "+passedFrame+")");
	OverlayMenus[7].xpos = mouseXS;
	OverlayMenus[7].ypos = mouseYS;
	 
	RadialTechSolidButton.xpos = OverlayMenus[7].xpos - 25;
	RadialTechSolidButton.ypos = OverlayMenus[7].ypos - 60;
	
	RadialTechFadeButton.xpos = OverlayMenus[7].xpos - 45;
	RadialTechFadeButton.ypos = OverlayMenus[7].ypos - 35;
 	
	//Color rects
	TechnicalColorStart.xpos = OverlayMenus[7].xpos - 55;
	TechnicalColorStart.ypos = OverlayMenus[7].ypos + 2;
	TechnicalColorEnd.xpos = OverlayMenus[7].xpos + 30; //less the width
	TechnicalColorEnd.ypos = OverlayMenus[7].ypos + 2;
	
	TXTFTechTime.xpos = OverlayMenus[7].xpos - 25;
	TXTFTechTime.ypos = OverlayMenus[7].ypos + 2;

	///Fill from values
	TXTFTechTime.Label = ""+UserSequences[SelectedSequence].TechTime[SelectedFrame][passedID];
	RadialTechSolidButton.Selected = false;
	RadialTechFadeButton.Selected = false;
	
	SelectedTechID = passedID; //Color Channel ID Number
	SelectedTechFrame = (passedFrame*2);
	
	//updates sidebar GUI elements
	TextFields[6].Label = TXTFTechTime.Label;
	if((UserSequences[SelectedSequence].TechFlags[SelectedFrame][passedID] & 0x08) > 0) FrameSeqToolTechDD.SelStr = 0;
	else FrameSeqToolTechDD.SelStr = 1;
		
	
	//Edit DataMult and fill color rects
	PixelDataType = getTechChanColorMode(passedID);
	
	CurrentDataTypeMult = 1; //single
	if (getTechChanColorMode(passedID) == 1) CurrentDataTypeMult  = 3;
	else if (getTechChanColorMode(passedID) == 2) CurrentDataTypeMult  =  4;  

	fillTechColorRects();
	
	if((UserSequences[SelectedSequence].TechFlags[SelectedFrame][passedID] & 0x08) > 0) RadialTechFadeButton.Selected = true; 
	else RadialTechSolidButton.Selected = true;
		
	//Enable Overlay menu	
	OverlayMenuID = 7;
} //end func

//=====================================================================================================================

public void InitTechnicalChannelRadial(int passedID)
{
	println("InitTechnicalChannelRadial()");
	OverlayMenus[6].xpos = mouseXS;
	OverlayMenus[6].ypos = mouseYS;
	
	RadialMenuTechColorMode[0].xpos	= OverlayMenus[6].xpos - 30;
	RadialMenuTechColorMode[0].ypos	= OverlayMenus[6].ypos - 45;
	
	RadialMenuTechColorMode[1].xpos	= OverlayMenus[6].xpos - 55;
	RadialMenuTechColorMode[1].ypos = OverlayMenus[6].ypos - 20;
	
	RadialMenuTechColorMode[2].xpos	= OverlayMenus[6].xpos + 5;
	RadialMenuTechColorMode[2].ypos = OverlayMenus[6].ypos - 20;	
	
	RadialMenuTechColorMode[0].Selected = false;
	RadialMenuTechColorMode[1].Selected = false;
	RadialMenuTechColorMode[2].Selected = false;
	
	//TechFlags MSB: ENABLED - x - x - x - SeqMode - Color2 - Color1 - Color0
    //      000 - Single, 001 - RGB, 010 - RGBW
	//if((UserSequences[SelectedSequence].TechFlags[0][passedID] & 0x80) > 0)
	//{
	//channel is enabled
	
	RadialMenuTechColorMode[getTechChanColorMode(passedID)].Selected = true;	
	
	//} //end if()
	
	//Enable Overlay menu	
	SelectedTechID = passedID;
	OverlayMenuID = 6;
} //end func


public void FillTechDebug()
{
	println("FillTechDebug()");	

	for(int i = 0; i != (UserSequences[SelectedSequence].SeqFrameAmount+1); i++)
	{
		for (int q=0; q != TotalColorChannels;q++)
		{	
		UserSequences[SelectedSequence].TechTime[q][i] = 1000; //1 second	
		UserSequences[SelectedSequence].TechFlags[q][i] = 129; //set to RGB
		}
	}
	
	UserSequences[SelectedSequence].TechFlags[0][7] = 0; //set to RGB
	
	UserSequences[SelectedSequence].TechTime[0][0] = 2000; //1 second
	UserSequences[SelectedSequence].TechTime[0][1] = 1500; //1 second
	UserSequences[SelectedSequence].TechTime[0][2] = 1000; //1 second
	UserSequences[SelectedSequence].TechTime[0][3] = 500; //1 second

	UserSequences[SelectedSequence].TechFlags[0][0] = 130; //RGBW

	UserSequences[SelectedSequence].TechFlags[1][0] |= 0x08; //set to fade
	UserSequences[SelectedSequence].TechFlags[0][0] |= 0x08; //set to fade
	
	UserSequences[SelectedSequence].TechFlags[1][4] |= 0x08; //set to fade
	UserSequences[SelectedSequence].TechFlags[0][1] |= 0x08; //set to fade
	UserSequences[SelectedSequence].TechFlags[1][6] |= 0x08; //set to fade
				
//println(UserSequences[SelectedSequence].TechTime+"    "+UserSequences[SelectedSequence].TechFlags+"     "+UserSequences[SelectedSequence].DataFrames);
	
	
	for (int i=0; i != UserSequences[SelectedSequence].DataSize;i++)
	{
//	UserSequences[SelectedSequence].StartValues[i] = i+100;
//	UserSequences[SelectedSequence].DataFrameVar[i] = i+200;	
	}	

	
	for(int i = 0; i != TotalColorChannels; i++)
	{
	println(UserSequences[SelectedSequence].TechFlags[0][i]);
	}
	
	
	DrawTechnicalBuffer();
} //end debug func

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "NLEDAurora" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
